unit UAnova;

interface

uses Dialogs, SysUtils, UDMSegReg, URegres1, URegres2, USegRegUtils;

var AnovaFile, AnovaTmp     : textfile;
    NrOfDat, Spacing        : integer;    
    SumSq1, SumSq2, SumSq3  : real;
    TotSumSq                : real;
    AnovaFileName,
    AnovaTmpName            : string;
    TotalExpl, MessageShown : boolean;

procedure AnovaTable;
procedure Ftesting (Pu1, Pu2 : integer; XX : real; var Proba : real);
procedure Fdis (Nu1, Nu2 : integer; XX : real; var Prob : real);
procedure FdisE (Mu1, Mu2 : integer; XX : real; var Probi : real);
procedure WriteHeader;
procedure WriteData1 (Degr, Number, Space : integer;
                      Ftest, Proba, SumSqA, SumSqB, SumSqc : real;
                      Text1, Text2 : string);
procedure WriteData2 (Degr, Number, Space, Ktype : integer;
                      Ftest, Proba, SumSqA, SumSqB, SumSqc : real;
                      Text1 : string);

implementation



Procedure AnovaTable;
{-------------------}

var
FirstVar, AdjNr, Number               : integer;
Txt1, Txt2                            : string;
Success                               : boolean;
BreakPt1, BreakPt2, Prob, VarBPexpl,
Lin1unexp, BP1unexp, LinExpl, BPexpl,
Lin2unexp, BP2unexp, VarLinUnexp,
VarBPunexp, Ftest1, Ftest2            : real;

begin
with DMSegReg do
begin

  AnovaFileName:= ChangeFileExt(FileName,'.var');
  assignfile (AnovaFile, AnovaFileName);
  {$I-} reset (AnovaFile); {$I+}
  readln (AnovaFile,NrOfVar);
  readln (AnovaFile,NrOfDat);
  readln (AnovaFile,TotSumSq);                              {Total unexplained}
  if TotSumSq=0 then
  begin
    Showmessage ('There is no variation. Variance analysis is not done.');
    exit;
  end else
  begin
    AnovaTmpName:= 'Anova.tmp';
    assignfile (AnovaTmp,AnovaTmpName);
    rewrite (AnovaTmp);
    WriteHeader;
  end;
  readln (AnovaFile,Lin1unexp);                      {unexplained by lin. regr.}
  Spacing:=1;
  if NrOfDat>10 then Spacing:=2;
  if NrOfDat>100 then Spacing:=3;
  if NrOfVar<2 then
  begin
    LinExpl:=TotSumSq-Lin1unexp;                      {explained by lin. regr.}
    VarLinUnexp:=Lin1unexp/(NrOfDat-2);    {variance unexplained by lin. regr.}
    if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
       else Ftest1:=0.0001;

    Number:=NrOfDat-2;
    if Frac(Number)<>0 then Number:=Number+1;
    Ftesting (1, Number, Ftest1, Prob);
    if Signif1 then
    WriteData1 (1,NrOfDat-2,Spacing,Ftest1,Prob,LinExpl,Lin1unexp,VarLinUnexp,
                '  lin. regr. ','');
    readln (AnovaFile,BreakPt1);
    if Breakpt1<>-99999 then                            {There is a breakpoint}
    begin
      TotalExpl:=false;
      readln (AnovaFile,BP1unexp);                          {unexplained by BP}
      BPexpl:=Lin1unexp-BP1unexp;                       {extra explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-4);   {variance unexpl. by BP for Type 3/4}
      if Jtype=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-3);         {variance unexplained by BP}
      if Jtype in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-5);         {variance unexplained by BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      if Jtype in [3,4] then
      begin
        Number:=NrOfDat-4;
        Ftesting (2, Number, Ftest2, Prob);
        if Signif1 then
        WriteData2 (2,NrOfDat-2,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;
      if Jtype=5 then
      begin
        Number:=NrOfDat-3;
        Ftesting (1, Number, Ftest2, Prob);
        if Signif1 then
        WriteData2 (1,Number,Spacing,Jtype,Ftest2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;
      if Jtype in [2,6] then
      begin
        Number:=NrOfDat-3;
        Ftesting (3, Number, Ftest2, Prob);
        if Signif1 then
        WriteData2 (3,Number,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;

      TotalExpl:=true;

      BPexpl:=TotSumSq-BP1unexp;                        {total explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-4);   {variance unexpl. by BP for Type 3/4}
      if Jtype=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-3);         {variance unexplained by BP}
      if Jtype in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-5);         {variance unexplained by BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      if Jtype in [3,4] then
      begin
        Number:=NrOfDat-4;
        Ftest2:=Ftest2/2;
        Ftesting (2, Number, Ftest2, Prob);
        WriteData2 (2,NrOfDat-4,Spacing,Jtype,Ftest2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;
      if Jtype=5 then
      begin
        Number:=NrOfDat-3;
        Ftest2:=Ftest2/2;
        Ftesting (2, Number, Ftest2, Prob);
        WriteData2 (2,NrOfDat-3,Spacing,Jtype,Ftest2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;
      if Jtype in [2,6] then
      begin
        Number:=NrOfDat-5;
        Ftest2:=Ftest2/3;
        Ftesting (3, Number, Ftest2, Prob);
        WriteData2 (3,NrOfDat-5,Spacing,Jtype,Ftest2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,'  break-point');
      end;
    end; {if Breakpt1<>-99999 then}

  end else {if NrOfVar=2}
  begin
    readln (AnovaFile, FirstVar);
    readln (AnovaFile, BreakPt1);
    readln (AnovaFile, BP1unexp);                       {unexplained by 1st BP}
    readln (AnovaFile, Lin2unexp);         {Unexplained by lin. regr. 2nd var.}
    readln (AnovaFile, BreakPt2);
    BP2unexp:=0;
    if BreakPt2<>-99999 then
       readln (AnovaFile, BP2unexp);                    {unexplained by 2nd BP}

    if (BreakPt1<>-99999) and (BreakPt2<>-99999) then       {Both var. have BP}
    {-----------------------------------------------}
    begin
      LinExpl:=TotSumSq-Lin1unexp;                    {explained by lin. regr.}
      VarLinUnexp:=Lin1unexp/(NrOfDat-2);  {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=NrOfDat-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);              {F probability distribution}
      Txt1:= ' lin. regr. X';
      if FirstVar=2 then Txt1:=' lin. regr. Z';
      if Signif1 then
      WriteData1 (1,NrOfDat-2,Spacing,Ftest1,Prob,LinExpl,Lin1unexp,VarLinUnexp,
                  Txt1,'');

      TotalExpl:=false;
      BPexpl:=Lin1unexp-BP1unexp;                       {extra explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-5);   {variance unexpl. by BP for Type 3/4}
      if Jtype1=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-4);         {variance unexplained by BP}
      if Jtype1 in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-6);         {variance unexplained by BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt1:=' X-breakpoint';
      if FirstVar=2 then Txt1:=' Z-break-point';
      if Jtype1 in [3,4] then
      begin
        Number:=NrOfDat-5;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/3,Prob);
        if Signif1 then
        WriteData2 (3,NrOfDat-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1=5 then
      begin
        FdisE (2,NrOfDat-4,Ftest2/2,Prob);
        if Signif1 then
        WriteData2 (2,NrOfDat-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1 in [2,6] then
      begin
        FdisE (4,NrOfDat-6,Ftest2/4,Prob);
        if Signif1 then
        WriteData2 (4,NrOfDat-6,Spacing,Jtype,Ftest2/4,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;

      TotalExpl:=true;
      BPexpl:=TotSumSq-BP1unexp;                        {total explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-5);   {variance unexpl. by BP for Type 3/4}
      if Jtype1=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-4);         {variance unexplained by BP}
      if Jtype1 in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-6);         {variance unexplained by BP}
      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt1:=' X-breakpoint';
      if FirstVar=2 then Txt1:=' Z-break-point';
      AdjNr:=NrOfDat-4;
      if Jtype1 in [3,4] then
      begin
        FdisE (4,NrOfDat-5,Ftest2/3,Prob);
        WriteData2 (4,NrOfDat-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1=5 then
      begin
        Number:=NrOfDat-4;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        WriteData2 (3,NrOfDat-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
        AdjNr:=NrOfDat-3;
      end;
      if Jtype1 in [2,6] then
      begin
        Number:=NrOfDat-6;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (5,Number,Ftest2/3,Prob);
        WriteData2 (5,NrOfDat-6,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
        AdjNr:=NrOfDat-5;
      end;
      if Signif2 then writeln (AnovaTmp);
//Anova 2nd variable
      LinExpl:=BP1unexp-Lin2unexp;           {explained by lin. regr. 2nd var.}
      VarLinUnexp:=Lin2unexp/(AdjNr-2);    {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=AdjNr-2;
      if Frac(AdjNr)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);                {F probability distribution}
      Txt2:=' residuals on Z';
      if FirstVar=2 then Txt2:=' residuals on X';
      if Signif2 then
      WriteData1 (1,AdjNr-2,Spacing,Ftest1,Prob,LinExpl,Lin2unexp,VarLinUnexp,
                  ' lin. reg. of',Txt2);

      TotalExpl:=false;
      BPexpl:=Lin2unexp-BP2unexp;                   {extra explained by 2nd BP}
      VarBPunexp:=BP2unexp/(AdjNr-5);     {variance unexpl. by BP for Type 3/4}
      if Jtype2=5 then
         VarBPunexp:=BP2unexp/(AdjNr-4);       {variance unexplained by 2nd BP}
      if Jtype2 in [2,6] then
         VarBPunexp:=BP2unexp/(AdjNr-6);       {variance unexplained by 2nd BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt2:=' Z-breakpoint';
      if FirstVar=2 then Txt2:=' X-breakpoint';
      if Jtype2 in [3,4] then
      begin
        Number:=AdjNr-5;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        if Signif2 then
        WriteData2 (3,AdjNr-5,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2=5 then
      begin
        FdisE (2,AdjNr-4,Ftest2,Prob);
        if Signif2 then
        WriteData2 (2,AdjNr-4,Spacing,Jtype,Ftest2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2 in [2,6] then
      begin
        FdisE (4,AdjNr-6,Ftest2/3,Prob);
        if Signif2 then
        WriteData2 (3,AdjNr-6,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;

      TotalExpl:=true;
      BPexpl:=BP1unexp-BP2unexp;                        {total explained by BP}
      VarBPunexp:=BP2unexp/(AdjNr-5);     {variance unexpl. by BP for Type 3/4}
      if Jtype2=5 then
         VarBPunexp:=BP2unexp/(AdjNr-4);           {variance unexplained by BP}
      if Jtype2 in [2,6] then
         VarBPunexp:=BP2unexp/(AdjNr-6);           {variance unexplained by BP}
      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;
      Txt2:= ' Z-breakpoint';
      if FirstVar=2 then Txt2:=' X-breakpoint';
      if Jtype2 in [3,4] then
      begin
        FdisE (4,AdjNr-5,Ftest2/3,Prob);
        WriteData2 (4,AdjNr-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2=5 then
      begin
        Number:=AdjNr-4;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        WriteData2 (3,AdjNr-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2 in [2,6] then
      begin
        Number:=AdjNr-6;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (5,Number,Ftest2/4,Prob);
        WriteData2 (5,NrOfDat-6,Spacing,Jtype,Ftest2/4,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;

    end; {if (BreakPt1<>-99999) and (BreakPt2<>-99999) then}
    {------------------------------------------------------}

    if (BreakPt1=-99999) and (BreakPt2<>-99999) then     {1st var. linear only,}
    begin                                                {2nd with BP}
      LinExpl:=TotSumSq-Lin1unexp;                    {explained by lin. regr.}
      VarLinUnexp:=Lin1unexp/(NrOfDat-2);  {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=NrOfDat-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);                 {F probability distribution}
      Txt1:= ' lin. regr. X';
      if FirstVar=2 then Txt1:=' lin. regr. Z';
      if Signif1 then
      WriteData1 (1,NrOfDat-2,Spacing,Ftest1,Prob,LinExpl,Lin1unexp,VarLinUnexp,
                  Txt1,'');

      LinExpl:=Lin1unexp-Lin2unexp;           {explained by lin. regr. 2nd var.}
      AdjNr:=NrOfDat-1;
      VarLinUnexp:=Lin2unexp/(AdjNr-2);    {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=AdjNr-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);                {F probability distribution}
      Txt2:=' residuals on Z';
      if FirstVar=2 then Txt2:=' residuals on X';
      if Signif2 then
      WriteData1 (1,AdjNr-2,Spacing,Ftest1,Prob,LinExpl,Lin2unexp,VarLinUnexp,
                  ' lin. reg. of',Txt2);

      TotalExpl:=false;
      BPexpl:=Lin2unexp-BP2unexp;                   {extra explained by 2nd BP}
      VarBPunexp:=BP2unexp/(AdjNr-5);     {variance unexpl. by BP for Type 3/4}
      if Jtype2=5 then
         VarBPunexp:=BP2unexp/(AdjNr-4);       {variance unexplained by 2nd BP}
      if Jtype2 in [2,6] then
         VarBPunexp:=BP2unexp/(AdjNr-6);       {variance unexplained by 2nd BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt2:=' Z-breakpoint';
      if FirstVar=2 then Txt2:=' X-breakpoint';
      if Jtype2 in [3,4] then
      begin
        Number:=AdjNr-5;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        if Signif2 then
        WriteData2 (3,AdjNr-5,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2=5 then
      begin
        FdisE (2,Number,Ftest2,Prob);
        if Signif2 then
        WriteData2 (2,AdjNr-4,Spacing,Jtype,Ftest2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2 in [2,6] then
      begin
        FdisE (4,AdjNr-6,Ftest2/3,Prob);
        if Signif2 then
        WriteData2 (3,AdjNr-6,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;

      TotalExpl:=true;
      BPexpl:=BP1unexp-BP2unexp;                        {total explained by BP}
      VarBPunexp:=BP2unexp/(AdjNr-5);     {variance unexpl. by BP for Type 3/4}
      if Jtype2=5 then
         VarBPunexp:=BP2unexp/(AdjNr-4);           {variance unexplained by BP}
      if Jtype2 in [2,6] then
         VarBPunexp:=BP2unexp/(AdjNr-6);           {variance unexplained by BP}
      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;
      Txt2:= ' Z-breakpoint';
      if FirstVar=2 then Txt2:=' X-breakpoint';
      if Jtype2 in [3,4] then
      begin
        FdisE (4,AdjNr-5,Ftest2/3,Prob);
        WriteData2 (4,AdjNr-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2=5 then
      begin
        Number:=AdjNr-4;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        WriteData2 (3,AdjNr-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
      if Jtype2 in [2,6] then
      begin
        Number:=AdjNr-6;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (5,Number,Ftest2/4,Prob);
        WriteData2 (5,NrOfDat-6,Spacing,Jtype,Ftest2/4,Prob,BPexpl,BP2unexp,
                    VarBPunexp,Txt2);
      end;
    end;{if (BreakPt1=-99999) and (BreakPt2<>-99999) then}
    {----------------------------------------------------}

    if (BreakPt1<>-99999) and (BreakPt2=-99999) then        {1st var. with BP,}
    begin                                                     {2nd linear only}
      LinExpl:=TotSumSq-Lin1unexp;                    {explained by lin. regr.}
      VarLinUnexp:=Lin1unexp/(NrOfDat-2);  {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=NrOfDat-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);              {F probability distribution}
      Txt1:= ' lin. regr. X';
      if FirstVar=2 then Txt1:=' lin. regr. Z';
      if Signif1 then
      WriteData1 (1,NrOfDat-2,Spacing,Ftest1,Prob,LinExpl,Lin1unexp,VarLinUnexp,
                  Txt1,'');

      TotalExpl:=false;
      BPexpl:=Lin1unexp-BP1unexp;                       {extra explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-5);   {variance unexpl. by BP for Type 3/4}
      if Jtype1=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-4);         {variance unexplained by BP}
      if Jtype1 in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-6);         {variance unexplained by BP}

      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt1:=' X-breakpoint';
      if FirstVar=2 then Txt1:=' Z-break-point';
      if Jtype1 in [3,4] then
      begin
        Number:=NrOfDat-5;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/3,Prob);
        if Signif1 then
        WriteData2 (3,NrOfDat-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1=5 then
      begin
        FdisE (2,NrOfDat-4,Ftest2/2,Prob);
        if Signif1 then
        WriteData2 (2,NrOfDat-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1 in [2,6] then
      begin
        FdisE (4,NrOfDat-6,Ftest2/4,Prob);
        if Signif1 then
        WriteData2 (4,NrOfDat-6,Spacing,Jtype,Ftest2/4,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;

      TotalExpl:=true;
      BPexpl:=TotSumSq-BP1unexp;                        {total explained by BP}
      VarBPunexp:=BP1unexp/(NrOfDat-5);   {variance unexpl. by BP for Type 3/4}
      if Jtype1=5 then
         VarBPunexp:=BP1unexp/(NrOfDat-4);         {variance unexplained by BP}
      if Jtype1 in [2,6] then
         VarBPunexp:=BP1unexp/(NrOfDat-6);         {variance unexplained by BP}
      if VarBPunexp>0 then Ftest2:=BPexpl/VarBPunexp
         else Ftest2:=0.000001;

      Txt1:=' X-breakpoint';
      if FirstVar=2 then Txt1:=' Z-break-point';
      AdjNr:=NrOfDat-4;
      if Jtype1 in [3,4] then
      begin
        FdisE (4,NrOfDat-5,Ftest2/3,Prob);
        WriteData2 (4,NrOfDat-5,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
      end;
      if Jtype1=5 then
      begin
        Number:=NrOfDat-4;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (3,Number,Ftest2/2,Prob);
        WriteData2 (3,NrOfDat-4,Spacing,Jtype,Ftest2/2,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
        AdjNr:=NrOfDat-3;
      end;
      if Jtype1 in [2,6] then
      begin
        Number:=NrOfDat-6;
        if Frac(Number)<>0 then Number:=Number+1;
        Fdis (5,Number,Ftest2/3,Prob);
        WriteData2 (5,NrOfDat-6,Spacing,Jtype,Ftest2/3,Prob,BPexpl,BP1unexp,
                    VarBPunexp,Txt1);
        AdjNr:=NrOfDat-5;
      end;
      if Signif2 then writeln (AnovaTmp);
//Anova 2nd variable
      LinExpl:=BP1unexp-Lin2unexp;           {explained by lin. regr. 2nd var.}
      VarLinUnexp:=Lin2unexp/(AdjNr-2);    {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=AdjNr-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);                {F probability distribution}
      Txt2:=' residuals on Z';
      if FirstVar=2 then Txt2:=' residuals on X';
      if Signif2 then
      WriteData1 (1,AdjNr-2,Spacing,Ftest1,Prob,LinExpl,Lin2unexp,VarLinUnexp,
                  ' lin. reg. of',Txt2);
    end; {if (BreakPt1<>-99999) and (BreakPt2=-99999) then}
    {-----------------------------------------------------}

    if (BreakPt1=-99999) and (BreakPt2=-99999) then   {both var. only linear}
    begin
      LinExpl:=TotSumSq-Lin1unexp;                    {explained by lin. regr.}
      VarLinUnexp:=Lin1unexp/(NrOfDat-2);  {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=NrOfDat-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);              {F probability distribution}
      Txt1:= ' lin. regr. X';
      if FirstVar=2 then Txt1:=' lin. regr. Z';
      WriteData1 (1,NrOfDat-2,Spacing,Ftest1,Prob,LinExpl,Lin1unexp,VarLinUnexp,
                  Txt1,'');
      writeln (AnovaTmp);
      LinExpl:=Lin1unexp-Lin2unexp;           {explained by lin. regr. 2nd var.}
      AdjNr:=NrOfDat-1;
      VarLinUnexp:=Lin2unexp/(AdjNr-2);    {variance unexplained by lin. regr.}
      if VarLinUnexp>0 then Ftest1:=LinExpl/VarLinUnexp
         else Ftest1:=0.0001;
      Number:=AdjNr-2;
      if Frac(Number)<>0 then Number:=Number+1;
      Fdis (1,Number,Ftest1,Prob);                {F probability distribution}
      Txt2:=' residuals on Z';
      if FirstVar=2 then Txt2:=' residuals on X';
      WriteData1 (1,AdjNr-2,Spacing,Ftest1,Prob,LinExpl,Lin2unexp,VarLinUnexp,
                  ' lin. reg. of',Txt2);
    end; {if (BreakPt1=-99999) and (BreakPt2=-99999) then}
    {----------------------------------------------------}

  end; {if NrOfVar<2 then else}

  writeln (AnovaTmp);
  write   (AnovaTmp, ' -----------------------------------------');
  writeln (AnovaTmp, '---------------------------');

  writeln (AnovaTmp, '#');
  writeln (AnovaTmp, ' See also http://www.waterlog.info/pdf/anova.pdf');

  closefile (AnovaFile);
  deletefile (AnovaFileName);
  closefile (AnovaTmp);
  success:=renamefile (AnovaTmpName,AnovaFileName);
  if not success then showmessage ('A file could not be renamed');

end; {with DMSegReg do}

end; {AnovaTable}
{---------------}


procedure Ftesting (Pu1, Pu2 : integer; XX : real; var Proba : real);
var Prob1, Prob2 : real;
begin
  if (Frac(Pu1/2)=0) then
     Fdis (Pu1,Pu2,XX,Proba)
  else
  begin
    if Pu1>2 then
    begin
      Fdis (Pu1-1,Pu2,XX,Prob1);
      Fdis (Pu1+1,Pu2,XX,Prob2);
      Proba:=(Prob1+Prob2)/2;
    end;
    if Pu1<2 then
    begin
      Fdis (Pu1+1,Pu2,XX,Prob1);
      Fdis (Pu1+3,Pu2,XX,Prob2);
      Proba:=Prob1-0.5*(Prob2-Prob1);
    end;
  end;
  if Proba>99.9 then Proba:=99.9;
  if Proba<0.1 then Proba:=0.1;
end; {Ftesting}


procedure Fdis (Nu1, Nu2: integer; XX : real; var Prob : real);
{-------------------------------------------------------------}
Var jj : integer;
    AA, BB, Added, Aux3, AuxN, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
//  if (Frac(Nu1/2)<>0) and (Frac(Nu2/2)<>0) then Nu2:=Nu2+1;
                         //when both are uneven DF2 is increased by 1;
  Tau := Nu2/(Nu2+Nu1*XX);
  if Tau<0 then Tau:=0.00001;
  setlength (Term,2);
  Term[1]:=Nu1*(Nu1+2)/8;                        //factor of Tau
  Aux3:=Term[1]*sqr(Tau);                        //Third term
  Factor:=1+Nu1*Tau/2+Aux3;                      //Sum of first three terms
  jj:=1;
  Added:=4;
  while (Added<Nu2-3) do
  begin
    jj:=jj+1;
    setlength (Term,jj+2);
    Term[jj]:=Term[jj-1]*(Nu1+Added)/(Added+2);
    AA:=(jj+1)*ln(Tau);
    AA:=exp(AA);
    AuxN:=Term[jj]*AA;                           //next term
    Factor:=Factor+AuxN;                         //Summation of terms
    Added:=Added+2;
  end; {while (Added<Nu2-3) and (jj<200) do}
  if Tau<1 then
  begin
    BB := (Nu1/2)*ln(1-Tau);
    BB := exp(BB);
  end
  else
    BB := 0;
  if Nu2=4 then Factor:=Factor-Aux3;
  if Nu2=2 then Factor:=1;
  if Nu2=1 then Factor:=0.6375;
  Prob := 100*BB*Factor;
//  if Prob>100.001 then Prob:=Prob-100;
  if Prob>99.9 then Prob:=99.9;
  if Prob<0.1 then Prob:=0.1;
end;
{end of Fdis}
{-----------}


procedure FdisE (Mu1, Mu2: integer; XX : real; var Probi : real);
{---------------------------------------------------------------}
Var jj : integer;
    AA, Added, Aux1, Aux2, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
    Tau := Mu2/(Mu2+Mu1*XX);
    setlength (Term,3);
    Term[1]:=Mu2*(Mu2+2)/8;                        //factor of Tau
    Aux1:=Term[1]*sqr(1-Tau);                        //Third term
    Aux2:=Mu2*(1-tau)/2;
    Factor:=1+Aux2+Aux1;                      //Sum of first three terms
    jj:=1;
    Added:=4;
    while (Added<Mu1-3) and (jj<300) do
    begin
      jj:=jj+1;
      setlength (Term,jj+2);
      Term[jj]:=Term[jj-1]*(Mu2+Added)/(Added+2);
      AA:=(jj+1)*ln((1-Tau));
      AA:=exp(AA);
      Aux2:=Term[jj]*AA;                           //next term
      Factor:=Factor+Aux2;                         //Summation of terms
      Added:=Added+2;
    end; {while (Added<Mu1-3) and (jj<300) do}
    if Tau<1 then
    begin
      AA := (Mu2/2)*ln(Tau);
      AA := exp(AA);
    end
    else
      AA := 0;
    if Mu1=4 then Factor:=Factor-Aux1;
    if Mu1=2 then Factor:=1;
    if Mu1=1 then Factor:=0.6375;
    Probi := 100*(1-AA*Factor);
//  if Probi>100.001 then Probi:=Probi-100;
  if Probi>99.9 then Probi:=99.9;
end;{end of FdisE}
{------------}



procedure WriteHeader;
{--------------------}

begin
      if DMSegReg.Option<3 then
      writeln (AnovaTmp, ' Variance Analysis, ANOVA table, Regression Type:',
                           JType:2)
      else
      writeln (AnovaTmp, ' Variance Analysis, ANOVA table, Regression Types:'+
                         ' 1st Type:',JType1:2,', 2nd Type:',JType2:2);
      writeln (AnovaTmp, ' File Name : ',AnovaFileName);
      writeln (AnovaTmp);
      writeln (AnovaTmp, ' Sum[(Y-Av.Y)sq.] =', TotSumSq:12:3,
                         '  (total sum of squares of deviations)');
      writeln (AnovaTmp);
      writeln (AnovaTmp, ' Total nr. of data  =', NrOfDat:8);
      writeln (AnovaTmp, ' Degrees of freedom =', NrOfDat-1:8);
      writeln (AnovaTmp);
      writeln (AnovaTmp, ' Sum of squares      Degrees of          '+
                         '                Probability/');
      writeln (AnovaTmp, ' of deviations        freedom     Variance'+
                         '     F-Test    Significance');
      writeln (AnovaTmp, ' -----------------------------------------'+
                         '---------------------------');

end; {WriteHeader;}
{-----------------}



procedure WriteData1 (Degr, Number, Space : integer;
                      Ftest, Proba, SumSqA, SumSqB, SumSqc : real;
                      Text1, Text2 : string);
{----------------------------------------------------------------}

begin

    writeln (AnovaTmp, ' explained by');
    if Text2='' then
    begin
      write (AnovaTmp, Text1,'                                 ');
      writeln (AnovaTmp,' F(',Degr:1,',',Number:Space,')=');
    end;
    if Text2<>'' then
    begin
      writeln (AnovaTmp, Text1);
      write (AnovaTmp, Text2,'                               ');
      writeln (AnovaTmp,' F(',Degr:1,',',Number:Space,')=');
    end;
    write (AnovaTmp, SumSqA:12:3,'              ',Degr:1,SumSqA/Degr:15:3);
    if Proba>99.9 then Proba:=99.9;
    writeln (AnovaTmp, Ftest:12:3,Proba:13:1,' %');
    writeln (AnovaTmp);
    writeln (AnovaTmp, ' remaining');
    writeln (AnovaTmp, ' unexplained');
    writeln (AnovaTmp, SumSqB:12:3,'        ',Number:7,SumSqC:15:3);

end;  {end of WriteData1}
{-----------------------}



procedure WriteData2 (Degr, Number, Space, Ktype : integer;
                      Ftest, Proba, SumSqA, SumSqB, SumSqC : real;
                      Text1 : string);
{---------------------------------------------------------------}
var AnovaConf : real;
begin

    writeln (AnovaTmp);

    if TotalExpl then
       writeln (AnovaTmp, ' total expl. by')
    else
       writeln (AnovaTmp, ' extra expl. by');
    write (AnovaTmp, Text1,'                                 ');
    writeln (AnovaTmp,' F(',Degr:1,',',Number:Space,')=');
    write (AnovaTmp, SumSqA:12:3,'              ',Degr:1,SumSqA/Degr:15:3);
    if Proba>99.9 then Proba:=99.9;
    if Alfa=1.75 then AnovaConf:=90
       else if Alfa=2.1 then AnovaConf:=95
            else AnovaConf:=98;

    if not MessageShown then if Proba<AnovaConf-1 then
    begin
       showmessage ('Please check the Anova table: the significance of the'+
                   ' extra explanation by the breakpoint is less than that'+
                   ' given in the input tabsheet. Although the regression type'+
                   ' obeys the specified significance, the effect of the'+
                   ' introduction of the breakpoint is not overwhelming.');
       MessageShown:=true;
    end;

    writeln (AnovaTmp, Ftest:12:3,Proba:13:1,' %');
    writeln (AnovaTmp);

    if not TotalExpl then
    begin
      writeln (AnovaTmp, ' remaining');
      writeln (AnovaTmp, ' unexplained');
      writeln (AnovaTmp, SumSqB:12:3,'        ',Number:7,SumSqC:15:3);
    end;

end;  {end of WriteData2}
{-----------------------}


end.

