unit URegres1;

interface

uses  SysUtils, Dialogs, USegRegForm, UDMSegReg, USegRegUtils;

var {regr1}

BPx             : array [1..100] of real;
P               : array [1..30] of real;
A               : array [1..12] of real;
Q, R, Xav, Yav  : array [1..2] of real;

BPxOpt, Cexp0, Cexp1,
Cexp2, Cexp3, Cexp4,
Cexp5, Cexp6, DeltaX,
Factor, SRYsqT, Alfa,
SRXsqT                : real;

Itype, Jtype, Ftype, Htype,
MethodI, MethodF, Mode    : byte;

SBP, SA, SKA, SGA, SDA,
StdYbp, Ybp, QT, Q1, Q2,
StdBP1, StdBP2, SAK, SAG  : real;             {for RegAux}
StdYrSq, AvXt, StdAtSq,
SumRedXsq                 : real;             {for type 2 in paramet1}

OutFile, VarFile          : textfile;

Out1, Out2, Out3, Out4, Out5,
Out6, Out7, Out8, Out9, Out10 : string;        {for parameters}

NotFit, Signif1 : boolean;

procedure Regr1;
procedure RegIni (var BP, Cexp : real; var Itype, Kmethod : byte);
procedure RegAux (var Itype, KMethod : byte; BP : real);
procedure Header1;
procedure Paramet1 (var BP : real; Ftype : byte);
procedure Formats (var JJ : byte);
procedure Reg1Final;

implementation


procedure Regr1;
{--------------}
var i : integer;

begin

  with DMSegReg do
  begin
      Factor:=1.1;
      if (NrOfData>20) and (NrOfData<30) then Factor:=1.05;
      if (NrOfData>=30) and (NrOfData<50) then Factor:=1.02;
      if (NrOfData>=50) and (NrOfData<100) then Factor:=1.01;
      if (NrOfData>=100) then Factor:=1.0;

      Xmin := 1000000;
      Xmax := -1000000;
      for i:=0 to NrOfData-1 do
      begin
        Setlength (Tvalue,i+1);
        if (Option=2) then
        begin
          Tvalue[i]:=Xvalue[i];
          Xvalue[i]:=Zvalue[i];
        end;
        if Xvalue[i]<Xmin then Xmin := Xvalue[i];
        if Xvalue[i]>Xmax then Xmax := Xvalue[i];
      end;

      NotFit:=false;
      if Xmax-Xmin<0.001 then
      begin
        Showmessage ('The database is not fit for regression analysis.'+
                     ' There is no variation in X-values.'+
                       ' Please correct the input file.');
        NotFit:=true;
        exit;
      end;

      DeltaX := (Xmax-Xmin)/100;

    { Setting 100 values of trial breakpoints }
      for i:=1 to 99 do
          BPx[i+1] := Xmin+i*DeltaX;

    { Regression for type 1, breakpoint = Xmin }
      BPx[1] := Xmin;
      Jtype := 1;
      MethodI := 0;
      RegIni (BPx[1], Cexp1, Jtype, MethodI);
      BPxOpt := Xmin;
      Cexp3 := Factor*Cexp1;
      if SegRegForm.PrefX3RadioButton.checked then Cexp3:=Cexp1;
      if not SegRegForm.ExclX3RadioButton.Checked then
      begin
      { Regressions for type 3, method 1, at various breakpoints}
        MethodI := 1;
        if SegRegForm.PrefX3RadioButton.Checked then Cexp3:=Cexp1;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BPx[i], Cexp0, Itype, MethodI);
        { First determination maximum explanation with X }
          if (Cexp0>Cexp3) and (BPx[i]>Xmin) then
          begin
            BPxOpt := BPx[i];
            Cexp3 := Cexp0;
            Jtype := 3;
            MethodF := 1;
          end;
        end;

      { Regressions for type 3, method 2, at various breakpoints}
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Second determination maximum explanation with X }
          if (Cexp0>Cexp3) and (BPx[i]>Xmin) then
          begin
            BPxOpt := BPx[i];
            Cexp3 := Cexp0;
            Jtype := 3;
            MethodF := 2;
          end;
        end;
      end {if not SegRegForm.ExclX3RadioButton.Checked then}
      else Cexp3:=Factor*Cexp1;

      if not SegRegForm.ExclX4RadioButton.Checked then
      begin
      { Regressions for type 4, method 1, at various breakpoints}
        MethodI := 1;
        Cexp4 := Cexp3;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Third determination maximum explanation with X }
          if (Cexp0>Cexp4) and (BPx[i]>Xmin) then
          begin
            BPxOpt := BPx[i];
            Cexp4 := Cexp0;
            Jtype := 4;
            MethodF := 1;
          end;
        end;

      { Regressions for type 4, method 2, at various breakpoints}
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Fourth determination maximum explanation with X }
          if (Cexp0>Cexp4) and (BPx[i]>Xmin) then
          begin
            BPxOpt := BPx[i];
            Cexp4 := Cexp0;
            Jtype := 4;
            MethodF := 2;
          end;
        end;
      end {if not SegRegForm.ExclX4RadioButton.Checked then}
      else Cexp4:=Cexp3;

      if not SegRegForm.ExclX5RadioButton.Checked then
      begin
      { Regressions for type 5, at various breakpoints}
        MethodI := 0;
        Cexp5 := 1.1*Factor*Cexp4;
//        Cexp5 := Cexp4;
        for i:=1 to 100 do
        begin
           Itype := 5;
           RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Fifth determination maximum explanation with X }
           if (Cexp0>Cexp5) and (BPx[i]>Xmin) then
           begin
              BPxOpt := BPx[i];
              Cexp5 := Cexp0;
              Jtype := 5;
           end;
        end;
      end {if not SegRegForm.ExclX5RadioButton.Checked then}
      else Cexp5:=Cexp4;
      if not SegRegForm.ExclX2RadioButton.Checked then
      begin
      { Regressions for type 2, method 1, at various breakpoints}
        MethodI := 1;
        Cexp2 := 1.1*Factor*Cexp5;
//        Cexp2 := Cexp5;
        for i:=1 to 100 do
        begin
           Itype:=20;                                {provisional type 2}
           RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Sixth determination maximum explanation with X }
           if (Itype=2) then
           if (Cexp0>Cexp2) then
           begin
              BPxOpt := BPx[i];
              Cexp2 := Cexp0;
              Jtype := 2;
              MethodF := 1;
           end;
        end;

      { Regressions for type 2, method 2, at various breakpoints}
        MethodI := 2;
        for i:=1 to 100 do
        begin
           Itype := 20;                             {provisional type 2}
           RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Seventh determination maximum explanation with X }
           if (IType=2) then
           if (Cexp0>Cexp2) then
           begin
              BPxOpt := BPx[i];
              Cexp2 := Cexp0;
              Jtype := 2;
              MethodF := 2;
           end;
        end;
      end {if not SegRegForm.ExclX2RadioButton.Checked then}
      else Cexp2:=Cexp5;

      if not SegRegForm.ExclX6RadioButton.Checked then
      begin
      { Regressions for type 6, at various breakpoints}
        MethodI := 0;
        Cexp6 := 1.2*Factor*Cexp2;
//        Cexp6 := Cexp2;
        for i:=1 to 100 do
        begin
           Itype := 60;                               {provisional type 6}
           RegIni (BPx[i], Cexp0, Itype, MethodI);
        { Eighth determination maximum explanation with X }
           if (IType=6) and (Cexp0>Cexp6) then
           begin
              BPxOpt := BPx[i];
              Cexp6 := Cexp0;
              Jtype := 6
           end;
        end;
      end; {if not SegRegForm.ExclX6RadioButton.Checked then}

{      Uiteindelijke berekening, bepaling parameters, schrijven
       van de resultaten in de output file }
        FileName := ChangeFileExt (FileName,'.out');
        AssignFile (OutFile,FileName);
        rewrite (OutFile);
        FileName := ChangeFileExt (FileName,'.var');
        AssignFile (VarFile,FileName);
        rewrite (VarFile);
        Mode := 1;
        Header1;
        Mode := 2;
        Header1;
        Itype := 1;
        Signif1:=true;
        Paramet1 (Xmin,Itype);
        if Jtype>1 then
        begin
          Mode:=3;
          Header1;
          Paramet1 (BPxOpt,Jtype);
        end;
      { Schrijven van de summary en de residuals}
        Reg1Final;

   end; {with DMSegReg do}

   if (DMSegReg.Option=2) then with DMSegReg do
      for i:=0 to NrOfData-1 do
          Xvalue[i]:=Tvalue[i];
   closefile (OutFile);
   closefile (VarFile);

end; {procedure Regr1}
{--------------------}


procedure RegIni (var BP, Cexp : real; var Itype, Kmethod : byte);
{----------------------------------------------------------------}
label 20, 22;
var
    EY, Ybp1, Ybp2            : real;
    Flag, J, Key              : byte;
    i                         : integer;

    R1abs, R2abs, R1Low, R2Low, R1high, R2high, Yav1, Yav2, YavDiff : real;
    StDevYdiff, DiffYavLow, StDevYav1, StDevYav2, Yav1Low, Yav1High : real;
    Yav2Low, Yav2High, Denom, SR1, SR2, Rdiff, RdiffLow, Frac       : real;
    StdY1bpSq, StdY2bpSq, StdY1bp, StdY2bp , Xbp1, Xbp2             : real;
    Ybp1High, Ybp2High, Ybp1Low, Ybp2Low {, BPLow, BPhigh, Cor}     : real;


begin
  with DMSegReg do
  begin

        Flag := 0;
20:     for j:=1 to 2 do Q[j]:=0;
        for j:=1 to 12 do A[j]:=0;
        for j:=1 to 30 do P[j]:=0;

        for i:=0 to NrOfData-1 do
        begin
           J:=1;
           if Xvalue[i]>=BP then J:=2;
           A[J]:=A[J]+1;                         {number of data >BP and <BP}
           A[J+2]:=A[J+2]+Yvalue[i];             {Sum of Y}
           A[J+4]:=A[J+4]+Xvalue[i];             {Sum of X}
           A[J+6]:=A[J+6]+Yvalue[i]*Yvalue[i];   {Sum of Y sq.}
           A[J+8]:=A[J+8]+Xvalue[i]*Xvalue[i];   {Sum of X sq.}
           A[J+10]:=A[J+10]+Yvalue[i]*Xvalue[i]; {Sum of YX products}
        end;

        if (BP>Xmin) and (Flag=0) then
           if (A[1]<3) or (A[2]<3) then
           begin
              BP := Xmin;
              Flag := 1;
              Itype := 1;
              goto 20;
           end;

        for J:=1 to 2 do
        begin
           if A[J]<3 then goto 22;
           P[J+2]:=A[J+2]/A[J];                        { Av.Y }
           P[J+4]:=A[J+4]/A[J];                        { Av.X }
           P[J+6]:=A[J+6]-A[J]*P[J+2]*P[J+2];          { Red. sum Y sq. }
           if P[J+6]<0 then P[J+6]:=0;
           P[J+8]:=A[J+8]-A[J]*P[J+4]*P[J+4];          { Red. sum X sq. }
           if P[J+8]<0 then P[J+8]:=0;
           P[J+10]:=A[J+10]-A[J]*P[J+2]*P[J+4];        { Red. sum Y.X }
           if P[J+8]<=0 then
              P[J+12]:=0
           else
              P[J+12]:=P[J+10]/P[J+8];                 { Regr. coeff. }
           if (P[J+6]<=0) or (P[J+8]<=0) then
              P[J+14]:=0
           else
              P[J+14]:=P[J+10]/sqrt(P[J+6]*P[J+8]);    { Corr. coeff. }
           P[J+16]:=P[J+14]*P[J+14];                   { Corr. coeff. sq. }
           P[J+18]:=P[J+2]-P[J+12]*P[J+4];             { Y (X=0) }
           if P[J+6]>=0 then
              P[J+20]:=sqrt(P[J+6]/(A[J]-1))           { St. dev. of Y }
           else
              P[J+20]:=1000000;
           P[J+22]:=(1-P[J+16])*P[J+6];                { Sum Y-dev sq. }
           if P[J+22]<0 then
              P[J+24]:=1000000
           else
              P[J+24]:=sqrt(P[J+22]/(A[J]-1));         { St. dev. of Y-dev. }
           if P[J+8]<0 then
              P[J+26]:=1000000
           else
              P[J+26]:=sqrt(P[J+8]/(A[J]-1));          { St. dev. of X }
           if P[J+22]<0 then
              P[J+28]:=1000000
           else                                        { St. dev. of R.C. }
              if P[J+8]<=0 then
                 P[J+28]:=1000000
              else
                 P[J+28]:=sqrt(P[J+22]/((A[J]-2)*P[J+8]));
22:     end; {for J:=1 to 2 do}

        YAV[1] := P[3];
        YAV[2] := P[4];
        XAV[1] := P[5];
        XAV[2] := P[6];
        R[1] := P[13];
        R[2] := P[14];

        if Itype=0 then R[2] := 0;
        if Itype<2 then SRYsqT := P[8];
        if Itype<2 then SRXsqT := P[10];

        if Itype=20 then                          { Type 2 provisional }
           if KMethod=1 then
           begin
              Ybp1 := R[1]*(BP-Xav[1]) + Yav[1];
              if BP<>Xav[2] then
                 R[2] := (Ybp1-Yav[2])/(BP-Xav[2])
              else Itype:=1;
           end else
           if KMethod=2 then
           begin
              Ybp2 := R[2]*(BP-Xav[2]) + Yav[2];
              if BP<>Xav[1] then
                 R[1] := (Ybp2-Yav[1])/(BP-Xav[1])
              else Itype:=1;
           end;

        if Itype=3 then
        begin
           R[1]:=0;
           if KMethod=1 then Yav[1]:=R[2]*(BP-Xav[2])+Yav[2];
           if KMethod=2 then
              if Xav[2]<>BP then
                 R[2] := (Yav[2]-Yav[1])/(Xav[2]-BP)
              else
                 R[2] := 0;
        end;

        if Itype=4 then
        begin
           R[2] := 0;
           if KMethod=1 then  Yav[2]:=R[1]*(BP-P[5])+Yav[1];
           if KMethod=2 then
              if BP<>P[5] then
                 R[1] := (Yav[2]-Yav[1])/(BP-P[5])
              else
                 R[1] := 0;
        end;

        if Itype=5 then  {making both regr. coeff. zero}
        begin
           R[1] := 0;
           R[2] := 0;
        end;

        R1abs := abs(R[1]);
        R2abs := abs(R[2]);
        R1Low := R1abs - Alfa*SKA;    {SKA=st.err. of regr.coeff. R1}
        R2Low := R2abs - Alfa*SGA;    {SGA=st.err. of regr.coeff. R2}
        R1high := R1abs + Alfa*SKA;
        R2high := R2abs + Alfa*SGA;

        if Itype=60 then
        begin
          if (R1Low<0) and (R1High>0) then R[1]:=0;
          if (R2Low<0) and (R2High>0) then R[2]:=0;
        end;

      { Bepaling residuals en coeff. of expl. (Cexp)}
        for i:=0 to NrOfData-1 do
        begin
          J:=1;
          if Xvalue[i]>=BP then J:=2;
          EY :=  R[J]*(Xvalue[i]-Xav[J])+Yav[J];       { Expected value }
          Q[J] := Q[J]+(Yvalue[i]-EY)*(Yvalue[i]-EY);  { Sum.Sq. of Dev. }
        end;
        Cexp := 1-(Q[1]+Q[2])/SRYsqT;                  { Coeff. of Expl. }

        if (Itype<2) and (P[10]<0) then Cexp := 0;
        if (Itype>5) and ((P[9]=0) or (P[10]=0)) then Cexp := 0;
        if (P[9]=0) and (P[10]=0) then Cexp := 0;

      { Performing a series of test for types > 1}
        if Itype>1 then
        begin
         { Determining crossing and standard error of BP, Ybp, slope}

           RegAux (Itype,KMethod,BP);

         { Determination of various parameters }
           Yav1 := P[3];
           Yav2 := P[4];
           YavDiff := abs(P[3]-P[4]);
           if (A[1]>0) and (A[2]>0) then
              StDevYdiff := sqrt(P[21]*P[21]/A[1]+P[22]*P[22]/A[2])
           else
              StDevYdiff := 0;
           DiffYavLow := YavDiff - Alfa*StDevYdiff;
           if A[1]>0 then
              StDevYav1 := P[21]/sqrt(A[1])
           else
              StDevYav1 := 0;
           if A[2]>0 then
              StDevYav2 := P[22]/sqrt(A[2])
           else
              StDevYav2 := 0;
           Yav1Low := Yav1-Alfa*StDevYav1;
           Yav1High := Yav1+Alfa*StDevYav1;
           Yav2Low := Yav2-Alfa*StDevYav2;
           Yav2High := Yav2+Alfa*StDevYav2;
           Denom := (A[1]-2)*P[10];
           if Denom>0 then
              SR1 := Q[1]/Denom                 { St.Dev. <BP of Y deviations }
           else
              SR1 := 1000000;
           Denom := (A[2]-2)*P[9];
           if Denom>0 then
              SR2 := Q[2]/Denom
           else
              SR2 := 1000000;                   { St.Dev. >BP of Y deviations }

           Frac := 0.10*(A[1]+A[2]);
           if Frac<5 then Frac:=5;

            { Check op regr. coeff. van Type 3}
              if Itype=3 then
              begin
                 if (R1Low<0) and (R2Low>0) then
                 begin
                    if (A[1]>=Frac) and (A[2]>=Frac) then
                       Itype := 3
                    else
                       Cexp := 0;
                 end else
                     Cexp := 0;
              end;

           { Check regr. coeff. Type 4}
              if Itype=4 then
              begin
                 if (R1Low>0) and (R2Low<0) then
                 begin
                    if (A[1]>=Frac) and (A[2]>=Frac) then
                       Itype := 4
                    else
                       Cexp := 0;
                 end else
                     Cexp := 0;
               end;

            { Check Type 5 using several criteria }
              if (Itype=5) and ((R1Low<0) and (R2Low<0)) then
              begin
                 if (DiffYavLow>0) and ((A[1]>=Frac) and (A[2]>=Frac)) then
                    Itype := 5
                 else
                    Cexp := 0;
              end;

           R1Low := R1abs - Alfa*SKA;    {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;    {SGA=st.err. of regr.coeff. R2}

         { Bepaling van Type 2 op basis van significantie van regr. coeff. }
           if Itype=20 then
           begin
              Rdiff := abs(R[1]-R[2]);
              SDA := sqrt(sqr(SKA)+sqr(SGA));
              RdiffLow := Rdiff - Alfa*SDA;
              if (R1Low>0) and (R2Low>0) and (RdiffLow>0) then
              begin
                 if (R[1]>0) and (R[2]<0) then
                    if (A[1]>=Frac) and (A[2]>=Frac) then Itype:=2;
                 if (R[1]<0) and (R[2]>0) then
                    if (A[1]>=Frac) and (A[2]>=Frac) then Itype:=2;
                 if ((R[1]>0) and (R[2]>0)) or
                    ((R[1]<0) and (R[2]<0)) then
                       if (R[1]>1.2*R[2]) or (R[2]>1.2*R[1]) then
                           if (A[1]>=Frac) and (A[2]>=Frac) then Itype:=2;
              end;
           end;                             { end of condition Itype=20 for 2 }

            { Bepaling Type 6 op basis van verschllende criteria}
              if (Itype=60) then
              begin
                 Key := 0;
                 Ybp1 := R[1]*(BP-Xav[1])+Yav[1];
                 Ybp2 := R[2]*(BP-Xav[2])+Yav[2];
                 StdY1bpSq := SR1+(SKA*SKA)*(BP-Xav[1])*(BP-Xav[1]);
                 StdY1bp := sqrt(StdY1bpSq);
                 StdY2bpSq := SR2+(SGA*SGA)*(BP-Xav[2])*(BP-Xav[2]);
                 StdY2bp := sqrt(StdY2bpSq);
                 Ybp1High := Ybp1+Alfa*StdY1bp;
                 Ybp1Low := Ybp1-Alfa*StdY1bp;
                 Ybp2High := Ybp2+Alfa*StdY2bp;
                 Ybp2Low := Ybp2-Alfa*StdY2bp;
                 if R[1]<>0 then Xbp1 := (Ybp1-Yav[1])/R[1]+Xav[1]
                 else Xbp1:=1000000;
                 if R[2]<>0 then Xbp2 := (Ybp2-Yav[2])/R[2]+Xav[2]
                 else Xbp2:=1000000;
                 if (Ybp1Low>Ybp2High) or (Ybp1High<Ybp2Low) then
                    Key := 1;
(*
                 if Ybp1>Ybp2 then
                    if Ybp1-Ybp2>0.1*Ybp2 then Key:=1;
                 if Ybp2>Ybp1 then
                    if Ybp2-Ybp1>0.1*Ybp1 then Key:=1;
*)
                 if (Key=1) then
                 if (A[1]>=Frac) and (A[2]>=Frac) then Itype := 6;

             end;
        end; {condition Itype>1}
  end; {with DMSegReg do}

end; {procedure RegIni}
{---------------------}


procedure RegAux (var Itype, KMethod : byte; BP : real);
{----------------------------------------------------------------------------}
{ to determine Crossing and st. err. of BP, Ybp, and slope }

var RK, RG, SXK, SXG, SYK, SYG, SigmaSq, StdevAsq  : real;
var PZ, SinvR1, SinvR2, Term1, Term2  : real;
var StdBP1, StdBP2 : real;
begin
        RK:=R[1]*R[1];                    { regr. coeff. square < BP }
        RG:=R[2]*R[2];                    { idem > BP }
        if (A[1]>1) then
           SYK := P[7]/((A[1]-1)*A[1])        { st. dev. sq. Av.Y < BP }
        else
           SYK := 1000000;
        if (A[2]>1) then
           SYG := P[8]/((A[2]-1)*A[2])        { st. dev. sq. Av.Y > BP }
        else
           SYG := 1000000;
        if (A[1]>2) then
           SXK := P[9]/((A[1]-1)*A[1])        { st. dev. sq. Av.X < BP }
        else
           SXK := 1000000;
        if (A[2]>2) then
           SXG := P[10]/((A[2]-1)*A[2])       { st. dev. sq. Av.X > BP }
        else
           SXG := 1000000;
        PZ := (P[4]-P[3])*(P[4]-P[3]);      { (Av.Y> - Av.Y<) square }
        SAK := 1000000;
        if (A[1]>2) and (P[9]<>0) then
           SAK := Q[1]/((A[1]-2)*P[9]);     { st.err.regr.coeff. sq. R1 < BP }
        SAG := 1000000;
        if (A[2]>2) and (P[10]<>0) then
           SAG := Q[2]/((A[2]-2)*P[10]);    { st.err.regr.coeff. sq. R2 > BP }

        SKA := sqrt(SAK);
        SGA := sqrt(SAG);

{Calculating standard deviation of Y at BP}
        QT := Q[1]+Q[2];
        SigmaSq:=(QT)/((A[1]+A[2])*(A[1]+A[2]-4));
        AvXt:=(A[1]*P[5]+A[2]*P[6])/(A[1]+A[2]);    {AvXt = AvX of all data}
        StDevASq:=0;
        if ((A[1]+A[2]-4)*SRXsqT)<>0 then
           StDevAsq:=(QT)/((A[1]+A[2]-4)*SRXsqT);
        StdYbp:=sqrt(SigmaSq+((AvXt-BP)*(AvXt-BP)*(StDevAsq)));

{ Berekening standaard error van Y (X=BP) als snijpunt van de hellende lijn
  met X = BP }
        SBP:=0;
        StdBP1:=0;
        StdBP2:=0;
        if ((Itype=3) or (Itype=2)) and (A[2]>2) then
           StdBP1:=sqrt(QT/((A[2]-1)*A[2])+((P[6]-Bp)*(P[6]-Bp)*(SGA*SGA)));
        if ((Itype=4) or (Itype=2)) and (A[1]>2) then
           StdBP2:=sqrt(QT/((A[1]-1)*A[1])+(P[5]-Bp)*(P[5]-Bp)*(SKA*SKA));
        if (Itype=3) and (KMethod=1) then SYK := sqr(StdBP1);
        if (Itype=4) and (KMethod=1) then SYG := sqr(StdBP2);

        if (Itype=2) then                                     { for type 2 }
        begin
          Aux1:=(SAK+SAG)/sqr(sqr(R[1]-R[2]));
          Aux2:=R[1]*P[5]-P[3]-R[2]*P[6]+p[4];
          Aux3:=1/sqr(R[1]-R[2]);
          Aux4:=sqr(R[1])*SXK+sqr(P[5])*SAK+SYK;
          Aux5:=sqr(R[2])*SXG+sqr(P[6])*SAG+SYG;
          SBP:=Aux1*Aux2+Aux3*(Aux4+Aux5);
          if SBP>0 then
          begin
             SBP:=sqrt(Aux1*Aux2+Aux3*(Aux4+Aux5));
             if (STdBP1>0) and (StdBP1<SBP) then SBP:=StdBP1;
          end else
             SBP:=0;
        end; {if Itype=2}

        if Itype=3 then
        begin
          Term1:= P[6]+(P[3]-P[4])/(P[14]-SGa);
          StdBP1:=BP-Term1;
        end;

        if Itype=4 then
        begin
          if P[13]-SKA<>0 then
             Term2:= P[5]+(P[4]-P[3])/(P[13]-SKA)
          else
             Term2 := 1000000;
          StdBp2:=Term2-BP;
        end;

        if Itype=3 then                                       { for type 3 }
        begin
          term1 := 1/(R[2]+SGA);
          term2 := 1/(R[2]-SGA);
          SinvR2 := abs(term1-term2)/2;             { st. err. (1/R2) > BP }
          SinvR2 := SinvR2*SinvR2;
          SBP := 0;
          if (RG>0) then
             SBP := sqrt(SXG+PZ*SinvR2+(SYK+SYG)/RG);   { st. err. BP }
          if (STdBP1>0) and (StdBP1<SBP) then SBP:=StdBP1;
          SA := SGA;                                    { st. err. R2 >BP }
        end; {if Itype=3}

        if (Itype=4) then                                    { for type 4 }
        begin
          if R[1]+SKA<>0 then
             term1 := 1/(R[1]+SKA)
          else
             term1:=1000000;
          if R[1]-SKA<>0 then
          term2 := 1/(R[1]-SKA)
          else
             term2 := 1000000;
          SinvR1 := abs(term1-term2)/2;             { st. err. (1/R1) < BP }
          SinvR1 := SinvR1*SinvR1;
          SBP := 0;
          if (RK>0) then
             SBP := sqrt(SXK+PZ*SinvR1+(SYK+SYG)/RK);       { st. err. BP }
          if (STdBP2>0) and (StdBP2<SBP) Then SBP:=StdBP2;
          SA := SKA;
        end;  {if Itype=4}

        if (Itype=6) then
        begin
          if P[13]=P[14] then P[13]:=1.01*P[14];
          Aux1:=(SAK+SAG)/sqr(sqr(P[13]-P[14]));
          Aux2:=P[13]*P[5]-P[3]-P[14]*P[6]+p[4];
          Aux3:=1/sqr(P[13]-P[14]);
          Aux4:=sqr(P[13])*SXK+sqr(P[5])*SAK+SYK;
          Aux5:=sqr(P[14])*SXG+sqr(P[6])*SAG+SYG;
          SBP:=Aux1*Aux2+Aux3*(Aux4+Aux5);
          if SBP>0 then
             SBP:=sqrt(Aux1*Aux2+Aux3*(Aux4+Aux5))
          else
             SBP:=0;
        end; {if Itype=6}

end; {procedure RegAux}
{---------------------}


procedure Header1;
{------------------------------}
{Writing headers in output file}

var HlpFile : string;
    i, Confid  : integer;
    Block : array of string;
    Empty : boolean;

begin
  with DMSegReg do
  begin

{ Eerste kop in de output file }
    if Mode=1 then
    begin
        if DMSegReg.Option=0 then
        begin
          writeln (OutFile, ' Results of program SegReg for the segmented'+
                            ' linear regression of Y upon X.');
          writeln (OutFile, ' Y is the dependent variable.');
        end else
        if DMSegReg.Option=1 then
        begin
          writeln (OutFile, ' Results of program SegReg for the segmented'+
                            ' linear regression of Y upon X.');
          writeln (OutFile, ' X is the first of two independent variables.');
        end else
        begin
          writeln (OutFile, ' Results of program SegReg for the segmented'+
                            ' linear regression of Y upon Z.');
          writeln (OutFile, ' Z is the second of two independent variables.');
        end;
      writeln (OutFile, ' There can be different types of functions'+
                        ' ranging from type 0 to type 6');
      writeln (OutFile, ' and (for types 2, 3 and 4) two methods of'+
                        ' calculation.');
      writeln (OutFile, ' The types and methods are determined with the'+
                        ' procedure of best fit.');
      writeln (OutFile, ' For explanations, use the symbols function in the'+
                        ' output scroll menu.');
      writeln (OutFile);
      HlpFile := ChangeFileExt (DMSegReg.FileName,'.out');
      writeln (OutFile, ' Name of this output file:  ',HlpFile);
      HlpFile := ChangeFileExt (DMSegReg.FileName,'.inp');
      writeln (OutFile, ' Name of input file used :  ',HlpFile);
      writeln (OutFile);
      writeln (OutFile,' ',Title1);
      writeln (OutFile,' ',Title2);
      if Alfa<1.8 then Confid := 90
      else
        if Alfa<2.2 then Confid := 95
        else
          Confid := 98;
writeln (OutFile, ' Minimum confidence % : ',Confid);

      setlength (Block,7);
      for i:=1 to 6 do Block[i]:='';
      Empty:=true;
      if SegRegForm.ExclX2RadioButton.Checked then
      begin
        Block[1]:=' 2 ';
        Empty:=false;
      end;
      if SegRegForm.ExclX3RadioButton.Checked then
      begin
        Block[2]:=' 3 ';
        Empty:=false;
      end;
      if SegRegForm.ExclX4RadioButton.Checked then
      begin
        Block[3]:=' 4 ';
        Empty:=false;
      end;
      if SegRegForm.ExclX5RadioButton.Checked then
      begin
        Block[4]:=' 5 ';
        Empty:=false;
      end;
      if SegRegForm.ExclX6RadioButton.Checked then
      begin
        Block[5]:=' 6 ';
        Empty:=false;
      end;

      if not Empty then
      begin
         if Option<2 then
            writeln (OutFile,' X-type excluded:',Block[1],Block[2],
                                        Block[3],Block[4],Block[5],Block[6])
         else
            writeln (OutFile,' Z-type excluded:',Block[1],Block[2],
                                      Block[3],Block[4],Block[5],Block[6]);
      end;

      Empty:=true;
      if SegRegForm.PrefX2RadioButton.Checked then
      begin
        Block[1]:=' 2 ';
        Empty:=false;
      end;
      if SegRegForm.PrefX3RadioButton.Checked then
      begin
        Block[2]:=' 3 ';
        Empty:=false;
      end;
      if SegRegForm.PrefX4RadioButton.Checked then
      begin
        Block[3]:=' 4 ';
        Empty:=false;
      end;
      if SegRegForm.PrefX5RadioButton.Checked then
      begin
        Block[4]:=' 5 ';
        Empty:=false;
      end;
      if SegRegForm.PrefX6RadioButton.Checked then
      begin
        Block[5]:=' 6 ';
        Empty:=false;
      end;

      if not Empty then
      begin
         if Option<2 then
            writeln (OutFile,' X-type preferred:',Block[1],Block[2],
                                      Block[3],Block[4],Block[5],Block[6])
         else
            writeln (OutFile,' Z-type preferred:',Block[1],Block[2],
                                      Block[3],Block[4],Block[5],Block[6]);
      end;

      writeln (OutFile);

    end; {if Mode=1}

{ Tweede kop in de output file }
    if Mode=2 then
    begin
        if Option<2 then
        begin
          writeln (OutFile,' Regression of Y upon X without breakpoint'+
                           ' (BPx=Xmin).');
          if Option=1 then
             writeln (OutFile,' The first (X) of two independent variables is'+
                              ' used.')
          else
             writeln (OutFile,' X is the independent variable.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPx)'+
                           '    number of data        Av.Y          Av.X');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC      Y(X=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.X');
        end else
        begin
          writeln (OutFile,' Regression of Y upon Z without breakpoint'+
                           ' (BPz=Zmin).');
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPz)'+
                           '    number of data        Av.Y          Av.Z');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC      Y(Z=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.Z');
        end;
    end; { if Mode=2 }

    if (Mode=3) and (BPxOpt>Xmin) then
    begin
      writeln (OutFile);
        if Option<2 then
        begin
          writeln (OutFile, ' Results of regression of Y upon X with optimal'+
                            ' breakpoint (BPx)');
          if Option=1 then
             writeln (OutFile,' The first (X) of two independent variables is'+
                              ' used.')
          else
             writeln (OutFile,' X is the independent variable.');
          writeln (OutFile, ' The table below gives the following series of'+
                            ' values respectively:');
          writeln (OutFile, '    Breakpoint(BPx)    number of data        '+
                            'Av.Y          Av.X');
          writeln (OutFile, '    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                            '      St.Dev.RC       Y(X=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.X');
          writeln (OutFile, ' for the data with X-values smaller and greater'+
                            '  than BPx followed');
         writeln (OutFile, ' by the function parameters.');
        end else
        begin
          writeln (OutFile, ' Results of regression of Y upon Z with optimal'+
                            ' breakpoint (BPz)');
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used.');
          writeln (OutFile, ' The table below gives the following series of'+
                            ' values respectively:');
          writeln (OutFile, '    Breakpoint(BPz)    number of data        '+
                            'Av.Y          Av.Z');
          writeln (OutFile, '    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                            '      St.Dev.RC       Y(Z=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.Z');
          writeln (OutFile, ' for the data with X-values smaller and greater'+
                            ' than BPz followed');
         writeln (OutFile, ' by the function parameters.');
        end;
    end; { if (Mode=3) and (BPxOpt>Xmin) }

  end; {with DMSeReg do}
end; {Header1}
{------------}



procedure paramet1 (var BP : real; Ftype : byte);
{-----------------------------------------------}
{to perform statistical calculations with final
 breakpoint; to determine final parameters }

label 22;
var
    EY, Ybp1, Ybp2            : real;
    J                         : byte;
    i                         : integer;

    R1Low, R2Low, R1High, R2High,
    Yav1, Yav2, YavDiff, StDevDiff : real;
    StDevYdiff, Denom, Cexp       : real;

    Fr1, Fr2, Yin1, Yin2, Ymax    : real;    {for type 3, 4}
    SN, PP1, PP2, PP, SYI1, SYI2  : real;    {for type 3, 4}
    Sign1, Sign2                  : byte;    {for type 3, 4}
    XavT, StY1bp, StY2bp, SRT     : real;    {for type 6}
    R1abs, R2abs, RP              : real;    {for type 6}

begin

  with DMSegReg do
  begin

        for j:=1 to 2 do Q[j]:=0;
        for j:=1 to 12 do A[j]:=0;

        for i:=0 to NrOfData-1 do
        begin
           J:=1;
           if Xvalue[i]>=BP then J:=2;
           A[J]:=A[J]+1;                         {number of data >BP and <BP}
           A[J+2]:=A[J+2]+Yvalue[i];             {Sum of Y}
           A[J+4]:=A[J+4]+Xvalue[i];             {Sum of X}
           A[J+6]:=A[J+6]+Yvalue[i]*Yvalue[i];   {Sum of Y sq.}
           A[J+8]:=A[J+8]+Xvalue[i]*Xvalue[i];   {Sum of X sq.}
           A[J+10]:=A[J+10]+Yvalue[i]*Xvalue[i]; {Sum of YX products}
        end;

        for J:=1 to 2 do
        begin
           if A[J]<3 then goto 22;
           P[J+2]:=A[J+2]/A[J];                        { Av.Y }
           P[J+4]:=A[J+4]/A[J];                        { Av.X }
           P[J+6]:=A[J+6]-A[J]*P[J+2]*P[J+2];          { Red. sum Y sq. }
           if P[J+6]<0 then P[J+6]:=0;
           P[J+8]:=A[J+8]-A[J]*P[J+4]*P[J+4];          { Red. sum X sq. }
           if P[J+8]<0 then P[J+8]:=0;
           P[J+10]:=A[J+10]-A[J]*P[J+2]*P[J+4];        { Red. sum Y.X }
           if P[J+8]=0 then
              P[J+12]:=0
           else
              P[J+12]:=P[J+10]/P[J+8];                 { Regr. coeff. }
           if (P[J+6]=0) or (P[J+8]=0) then
              P[J+14]:=0
           else
              P[J+14]:=P[J+10]/sqrt(P[J+6]*P[J+8]);    { Corr. coeff. }
           P[J+16]:=sqr(P[J+14]);                      { Corr. coeff. sq. }
           P[J+18]:=P[J+2]-P[J+12]*P[J+4];             { Y (X=0) }
           if P[J+6]>=0 then
              P[J+20]:=sqrt(P[J+6]/(A[J]-1))           { St. dev. of Y }
           else
              P[J+20]:=1000000;
           P[J+22]:=(1-P[J+16])*P[J+6];                { Sum Y-dev sq. }
           if P[J+22]<0 then
              P[J+24]:=1000000
           else
              P[J+24]:=sqrt(P[J+22]/(A[J]-1));         { St. dev. of Y-dev. }
           if P[J+8]<0 then
              P[J+26]:=1000000
           else
              P[J+26]:=sqrt(P[J+8]/(A[J]-1));          { St. dev. of X }
           if P[J+22]<0 then
              P[J+28]:=1000000
           else                                        { St. dev. of R.C. }
              if P[J+8]<=0 then
                 P[J+28]:=1000000
              else
                 P[J+28]:=sqrt(P[J+22]/((A[J]-2)*P[J+8]));
22:      end; {for J:=1 to 2 do}

{  calculation of parameters }
        YAV[1] := P[3];
        YAV[2] := P[4];
        XAV[1] := P[5];
        XAV[2] := P[6];
        R[1] := P[13];
        R[2] := P[14];
        R1Low := abs(R[1])-Alfa*P[29];
        R2Low := abs(R[2])-Alfa*P[30];
        R1High := abs(R[1])+Alfa*P[29];
        R2High := abs(R[2])+Alfa*P[30];

        if (Ftype=1) and (R2Low<0) then Signif1:=false;
        if (Ftype=1) and (Jtype=1) and (R2Low<0) then
        begin
          Jtype := 0;
          R[2] := 0;
        end;
        if Ftype>1 then Signif1:=true;

        if (A[1]>0) and (A[2]>0) then
           StDevYdiff := sqrt(sqr(P[21])/A[1]+sqr(P[22])/A[2])
        else
           StDevYdiff := 0;

        if Ftype=2 then                          { Type 2 }
           if MethodF=1 then
           begin
              Ybp := R[1]*(BP-Xav[1]) + Yav[1];
              R[2] := (Ybp-Yav[2])/(BP-Xav[2]);
           end else
           if MethodF=2 then
           begin
              Ybp := R[2]*(BP-Xav[2]) + Yav[2];
              R[1] := (Ybp-Yav[1])/(BP-Xav[1]);
           end;

        if Ftype=3 then
        begin
           R[1]:=0;
           if MethodF=1 then Yav[1]:=R[2]*(BP-Xav[2])+Yav[2];
           if MethodF=2 then
              if Xav[2]<>BP then
                 R[2] := (Yav[2]-Yav[1])/(Xav[2]-BP)
              else
                 R[2] := 0;
        end;

        if Ftype=4 then
        begin
           R[2] := 0;
           if MethodF=1 then  Yav[2]:=R[1]*(BP-P[5])+Yav[1];
           if MethodF=2 then
              if BP<>P[5] then
                 R[1] := (Yav[2]-Yav[1])/(BP-P[5])
              else
                 R[1] := 0;
        end;

        if Ftype=5 then
        begin
           R[1] := 0;
           R[2] := 0;
        end;

        if Ftype=6 then
        begin
          if (R1Low<0) and (R1High>0) then R[1]:=0;
          if (R2Low<0) and (R2High>0) then R[2]:=0;
          Htype:=1;
          if (R[1]=0) or (R[2]=0) then Htype:=2;
          if (A[1]>2) and (P[9]<>0) then
             SAK := Q[1]/((A[1]-2)*P[9]);     { st.err.regr.coeff. sq. R1 < BP }
          if (A[2]>2) and (P[10]<>0) then
             SAG := Q[2]/((A[2]-2)*P[10]);    { st.err.regr.coeff. sq. R2 > BP }
          SKA := sqrt(SAK);
          SGA := sqrt(SAG);
          if (R[1]>0) and (R[2]>0) then
          begin
            StDevDiff:=sqrt(SKA+SGA);
            if abs(R[1]-R[2])<alfa*StDevDiff then
               if SKA>=SGA then R[2]:=R[1]
            else
               R[1]:=R[2];
            if abs(R[1]-R[2])<alfa*StDevDiff then Htype:=3;
          end;
          if (R[1]<0) and (R[2]<0) then
          begin
            StDevDiff:=sqrt(SKA+SGA);
            if abs(R[1]-R[2])<alfa*StDevDiff then
               if SKA>=SGA then R[2]:=R[1]
            else
               R[1]:=R[2];
            if abs(R[1]-R[2])<alfa*StDevDiff then Htype:=3;
          end;
        end;

      { Bepaling residuals en coeff. of expl. (QT)}
        for i:=0 to NrOfData-1 do
        begin
          J:=1;
          if Xvalue[i]>=BP then J:=2;
          EY :=  R[J]*(Xvalue[i]-Xav[J])+Yav[J];       { Expected value }
          Q[J] := Q[J]+sqr(Yvalue[i]-EY);              { Sum. Sq. of Dev. }
        end;
        Cexp := 1-(Q[1]+Q[2])/SRYsqT;                    {Coeff of Explanation}

{Remembering data for BP=0}
        if Ftype=1 then
        begin
          AvXt:=P[6];
          SumRedXSq:=NrOfData*sqr(P[28]);
        end;

{ Writing results }
        if (BP>Xmin) then
        begin
          writeln (VarFile, BP:12:3);
          writeln (VarFile, Q[1]+Q[2]:12:3);
        end;

        J:=1;
        Formats (J);
        if (BP>Xmin) or (Ftype=3) then
        begin
           writeln (OutFile);
           if (Option<2) then
           begin
              writeln (OutFile,' Data with X < BPx :');
              writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
           end else
           begin
              writeln (OutFile,' Data with Z < BPz :');
              writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
           end;
           writeln (OutFile, Out4, Out5, Out6, Out7);
           writeln (OutFile, Out8, Out9, Out10);
        end;

        J:=2;
        Formats (J);
        if (Option<2) then
        begin
          if (BP>Xmin) or (Ftype=3) then
              writeln (OutFile, ' Data with X > BPx :')
          else writeln (OutFile);
          writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
        end else
        begin
          if (BP>Xmin) or (Ftype=3) then
              writeln (OutFile, ' Data with Z > BPz :')
          else writeln (OutFile);
          writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
        end;
        writeln (OutFile, Out4, Out5, Out6, Out7);
        writeln (OutFile, Out8, Out9, Out10);
        if (BP=Xmin) then
        begin
           writeln (VarFile, ' 1');
           writeln (VarFile, NrOfData:5);
           Out1 := format('%12.3e',[P[8]]);        { Red. Sum. Y sq. }
           writeln (VarFile,Out1);
           Out2 := format('%12.3e',[P[24]]);       { Sum. Y-dev. sq. }
           writeln (VarFile,Out2);
           if (Jtype<2) then writeln (VarFile, ' -99999');
        end;

       { Determining standard error of BP, Ybp, slope}
        RegAux (Ftype, MethodF, BP);

        if (Ftype=2) then
        begin
          writeln (OutFile);
          writeln (OutFile, ' Parameters for function type 2 and method');
          if (Option<2) then
          begin
             if (MethodF=1) then
                writeln (OutFile,'     Slope > BPx        St.Err.Slope'+
                                 '        method');
             if (MethodF=2) then
                writeln (OutFile,'     Slope < BPx        St.Err.Slope'+
                                  '        method');
             if (MethodF=1) then
             begin
               Out1 := format('%13.3e',[R[2]]);
               Out2 := format('%21.3e',[SGA]);
             end;
             if (MethodF=2) then
             begin
               Out1 := format('%13.3e',[R[1]]);
               Out2 := format('%21.3e',[SKA]);
             end;
             writeln (OutFile, Out1, Out2, MethodF:13);
             writeln (OutFile,'     Y at BPx            St.Err.BPx'+
                              '       Expl.Coeff.');
          end; {if Option<2}

          if (Option>1) then
          begin
             if (MethodF=1) then
                writeln (OutFile,'     Slope > BPz        St.Err.Slope'+
                                 '        method');
             if (MethodF=2) then
                writeln (OutFile,'     Slope < BPz        St.Err.Slope'+
                                  '        method');
             if (MethodF=1) then
             begin
               Out1 := format('%13.3e',[R[2]]);
               Out2 := format('%21.3e',[SGA]);
             end;
             if (MethodF=2) then
             begin
               Out1 := format('%13.3e',[R[1]]);
               Out2 := format('%21.3e',[SKA]);
             end;
             writeln (OutFile, Out1, Out2, MethodF:13);
             writeln (OutFile,'     Y at BPx            St.Err.BPx'+
                              '       Expl.Coeff.');
          end; {if Option>1}
          Out1 := format('%13.3e',[Ybp]);
          Out2 := format('%21.3e',[Sbp]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
          writeln (OutFile,'    St.Err.Ybp');
          Out1 := format('%13.3e',[StdYbp]);
          writeln (OutFile, Out1);
        end; {if Ftype=2}

        if (Ftype=3) or (Ftype=4) then
        begin
           if (Q[1]>0) and (A[1]>1) then
              Q1:=sqrt(Q[1]/(A[1]-1))                 {St Dev Yresidual < BP}
           else
              Q1:=Q[1];
           if (Q[2]>0) and (A[2]>1) then
              Q2:=sqrt(Q[2]/(A[2]-1))                 {St Dev Yresidual > BP}
           else
              Q2:=Q[2];

           FR1:=A[1]/NrOfData;
           FR2:=A[2]/NrOfData;
           YIN1:=FR1*(YAV[2]-YAV[1]);                         {Y increase}
           SIGN1 := 0;
           if (YIN1>0) and (Ftype=4) then
           begin
              if (R[1]>0) then Ymax := R[1]*(BP-Xmin) + Yav[2];
              FR1:=A[2]/NrOfData;
              YIN1:=FR1*(Ymax-YAV[2]) + (1-FR1)*(Ymax-YAV[1]);
              SIGN1 := 1;
           end;
           YIN2:=FR2*(YAV[1]-YAV[2]);                           {Y increase}
           SIGN2 := 0;
           if (YIN2<0) and (Ftype=3) then
           begin
              if (R[2]>0) then Ymax := R[2]*(Xmax-BP) + Yav[1];
              FR2 := A[1]/NrOfData;
              YIN2:=FR2*(Ymax-YAV[1]) + (1-FR2)*(Ymax-YAV[2]);
              SIGN2 := 1;
           end;
           SN:=A[1]*A[2]/sqr(NrOfData);
           SN:=SN/NrOfData;
           PP1:=0;
           if (SIGN1=0) then
              if (A[1]>0) then PP1:=sqr(P[21])/A[1];
           if (SIGN1=1) then
              if (A[2]>0) then PP1:=sqr(P[22])/A[2];
           PP2:=0;
           if (SIGN2=0) then
              if (A[2]>0) then PP2:=sqr(P[22])/A[2];
           if (SIGN2=1) then
              if (A[1]>0) then PP2:=sqr(P[21])/A[1];
           PP:=PP1+PP2;
           SYI1:=SN*sqr(YAV[2]-YAV[1])+sqr(A[1]/NrOfData)*PP;  {St Dev increase}
           if (SIGN1=1) then
              SYI1:=SN*sqr(YAV[2]-YAV[1])+sqr(A[2]/NrOfData)*PP;
           SYI2:=SN*sqr(YAV[1]-YAV[2])+sqr(A[2]/NrOfData)*PP;
           if (SIGN2=1) then
              SYI2:=SN*sqr(YAV[1]-YAV[2])+sqr(A[1]/NrOfData)*PP;
           SYI1:=sqrt(SYI1);
           SYI2:=sqrt(SYI2);
           SN:=sqrt(SN);

           if (Ftype=3) then
           begin
              writeln (OutFile);
              writeln (OutFile, ' Parameters for function type 3 and method',
                                  MethodF:3);
              if (SIGN2=0) then
              begin
                 if (Option<2) then
                    writeln (OutFile, '   Slope > BPx              Ybp',
                                      '              N>/Nt      increase Yi');
                 if (Option=2) then
                    writeln (OutFile, '   Slope > BPz              Ybp',
                                      '              N>/Nt      increase Yi');
              end else
              begin
                 if (Option<2) then
                    writeln (OutFile, '   Slope > BPx              Ybp',
                                      '              N</Nt      increase Yi');
                 if (Option=2) then
                    writeln (OutFile, '   Slope > BPz              Ybp',
                                      '              N</Nt      increase Yi');
              end;
              Out1 := format('%13.3e',[R[2]]);
              Out2 := format('%21.3e',[Yav[1]]);
              Out3 := format('%17.3e',[FR2]);
              Out4 := format('%14.3e',[Yin2]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (SIGN2=0) then
              begin
                 if (Option<2) then
                    writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                 if (Option=2) then
                    writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                     '      St.Err.N>/Nt    St.Err.Yi');
              end else
              begin
                 if (Option<2) then
                    writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                     '      St.Err.N</Nt    St.Err.Yi');
                 if (Option=2) then
                    writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                     '      St.Err.N</Nt    St.Err.Yi');
              end;
              Out1 := format('%13.3e',[SA]);
              Out2 := format('%21.3e',[SBP]);
              Out3 := format('%17.3e',[SN]);
              Out4 := format('%14.3e',[SYi2]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (MethodF=1) then
              begin
                if (Option<2) then
                   writeln (OutFile, '   St.Dev.Yr < BPx     St.Dev.Yr > BPx'+
                                     '    St.Dev.Ybp');
                if (Option=2) then
                   writeln (OutFile, '   St.Dev.Yr < BPz     St.Dev.Yr > BPz'+
                                     '    St.Dev.Ybp');
                Out1 := format('%13.3e',[Q1]);
                Out2 := format('%21.3e',[Q2]);
                Out3 := format('%17.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);
              end else
              begin
                if (Option<2) then
                   writeln (OutFile, '   St.Dev.Yr > BPx     St.Dev.Yr < BPx'+
                                     '    St.Dev.Ybp');
                if (Option=2) then
                   writeln (OutFile, '   St.Dev.Yr > BPz     St.Dev.Yr < BPz'+
                                     '    St.Dev.Ybp');
                Out1 := format('%13.3e',[Q2]);
                Out2 := format('%21.3e',[Q1]);
                Out3 := format('%17.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);
              end;
              if (Option<2) then
                 writeln (OutFile, '   Slope < BPx         St.Err.Slope<BPx',
                                   '   Expl.Coeff.');
              if (Option=2) then
                 writeln (OutFile, '   Slope < BPz         St.Err.Slope<BPz',
                                   '   Expl.Coeff.');
              Out1 := format('%13.3e',[R[1]]);
              Out2 := format('%21.3e',[SKA]);
              Out3 := format('%17.3e',[Cexp]);
              writeln (OutFile, Out1, Out2, Out3);
           end; {if (Ftype=3) then}

           if (Ftype=4) then
           begin
              writeln (OutFile);
              writeln (OutFile, ' Parameters for function type 4 and method',
                                  MethodF:3);
              if (SIGN1=0) then
              begin
                 if (Option<2) then
                    writeln (OutFile, '   Slope < BPx              Ybp',
                                      '              N</Nt      increase Yi');
                 if (Option=2) then
                    writeln (OutFile, '   Slope < BPz             Ybp',
                                      '              N</Nt      increase Yi');
              end else
              begin
                 if (Option<2) then
                    writeln (OutFile, '   Slope < BPx              Ybp',
                                      '              N>/Nt      increase Yi');
                 if (Option=2) then
                    writeln (OutFile, '   Slope < BPz              Ybp',
                                      '              N>/Nt      increase Yi');
              end;
              Out1 := format('%13.3e',[R[1]]);
              Out2 := format('%21.3e',[Yav[2]]);
              Out3 := format('%17.3e',[FR1]);
              Out4 := format('%14.3e',[Yin1]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (SIGN1=0) then
              begin
                 if (Option<2) then
                    writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                     '      St.Err.N</Nt    St.Err.Yi');
                 if (Option=2) then
                    writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                     '      St.Err.N</Nt    St.Err.Yi');
              end else
              begin
                 if (Option<2) then
                    writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                 if (Option=2) then
                    writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                     '      St.Err.N>/Nt    St.Err.Yi');
              end;
              Out1 := format('%13.3e',[SA]);
              Out2 := format('%21.3e',[SBP]);
              Out3 := format('%17.3e',[SN]);
              Out4 := format('%14.3e',[SYi1]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (MethodF=2) then
              begin
                if (Option<2) then
                   writeln (OutFile, '   St.Dev.Yr < BPx     St.Dev.Yr > BPx'+
                                     '    St.Dev.Ybp');
                if (Option=2) then
                   writeln (OutFile, '   St.Dev.Yr < BPz     St.Dev.Yr > BPz'+
                                     '    St.Dev.Ybp');
                Out1 := format('%13.3e',[Q1]);
                Out2 := format('%21.3e',[Q2]);
                Out3 := format('%17.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);
              end else
              begin
                if (Option<2) then
                   writeln (OutFile, '   St.Dev.Yr > BPx     St.Dev.Yr < BPx'+
                                     '    St.Dev.Ybp');
                if (Option=2) then
                   writeln (OutFile, '   St.Dev.Yr > BPz     St.Dev.Yr < BPz'+
                                     '    St.Dev.Ybp');
                Out1 := format('%13.3e',[Q2]);
                Out2 := format('%21.3e',[Q1]);
                Out3 := format('%17.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);
              end;
              if (Option<2) then
                 writeln (OutFile, '   Slope > BPx         St.Err.Slope>BPx',
                                   '   Expl.Coeff.');
              if (Option=2) then
                 writeln (OutFile, '   Slope > BPz         St.Err.Slope>BPz',
                                   '   Expl.Coeff.');
              Out1 := format('%13.3e',[R[2]]);
              Out2 := format('%21.3e',[SGA]);
              Out3 := format('%17.3e',[Cexp]);
              writeln (OutFile, Out1, Out2, Out3);
           end; {if (Ftype=4) then}

        end; {if Ftype=3 or Ftype=4}

        if Ftype=5 then
        begin
          writeln (OutFile);
          writeln (OutFile, ' Parameters for function type 5 :');
          if Option<2 then
             writeln (OutFile, '    Slope < BPx       St.Err.Slope<BPx'+
                               '   StDevDiffYav.      St.Err.BP')
          else
             writeln (OutFile, '    Slope < BPz       St.Err.Slope<BPz'+
                               '   StDevDiffYav.');
          Out1 := format('%13.3e',[R[1]]);
          Out2 := format('%21.3e',[SKA]);
          Out3 := format('%17.3e',[StDevYdiff]);
          writeln (OutFile, Out1, Out2, Out3);
          if Option<2 then
             writeln (OutFile, '    Slope > BPx       St.Err.Slope>BPx'+
                               '    Expl.Coeff.')
          else
             writeln (OutFile, '    Slope > BPz       St.Err.Slope>BPz'+
                               '    Expl.Coeff.');
          Out1 := format('%13.3e',[R[2]]);
          Out2 := format('%21.3e',[SGA]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
        end; {if Ftype=5 then}

        if Ftype=6 then
        begin
          XavT:=(A[1]*Xav[1]+A[2]*Xav[2])/(A[1]+A[2]);
          Ybp1:=R[1]*(BP-Xav[1])+Yav[1];
          Ybp2:=R[2]*(BP-Xav[2])+Yav[2];
          Denom:=NrOfData*(NrOfData-2);
          SRT:=(Q[1]+Q[2])/Denom;
          StY1bp:=sqrt(SRT+(sqr(SKA)*sqr(BP-XavT)));
          StY2bp:=sqrt(SRT+(sqr(SGA)*sqr(BP-XavT)));
          writeln (OutFile);
          writeln (OutFile, ' Parameters for function type 6 :');
          writeln (OutFile, '       Y1bp              St.Err.Y1bp'+
                            '      St.Err.BP');
          Out1 := format('%13.3e',[Ybp1]);
          Out2 := format('%21.3e',[StY1bp]);
          Out3 := format('%17.3e',[SBP]);
          writeln (OutFile, Out1, Out2, Out3);
          writeln (OutFile, '       Y2bp              St.Err.Y2bp'+
                            '      Expl.Coeff.');
          Out1 := format('%13.3e',[Ybp2]);
          Out2 := format('%21.3e',[StY2bp]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
        end; {if Ftype=6 then}

        if (BP>Xmin) or (Ftype=3) then writeln (OutFile);

  end; { with DMSegReg do}

end; { paramet1 }
{---------------}


procedure Formats (var JJ : byte);
{--------------------------------}

begin

     Out1 := format('%22.3e',[A[JJ]]);           { Nr of data }
     Out2 := format('%17.3e',[P[JJ+2]]);         { Av Y }
     Out3 := format('%14.4e',[P[JJ+4]]);         { Av X }
     Out4 := format('%13.3e',[P[JJ+12]]);        { Regr. Coeff. }
     Out5 := format('%21.3e',[P[JJ+16]]);        { Corr. Coeff. Sq. }
     Out6 := format('%17.3e',[P[JJ+28]]);        { St Dev Regr. Coeff }
     Out7 := format('%14.3e',[P[JJ+18]]);        { Y at X=0 }
     Out8 := format('%13.3e',[P[JJ+20]]);        { St Dev of Y }
     Out9 := format('%21.3e',[P[JJ+24]]);        { St Dev of Y-dev }
     Out10 := format('%17.3e',[P[JJ+26]]);       { St Dev of X }

end; {Formats}
{------------}


procedure Reg1Final;
{------------------}
var
    i       : integer;
    Ycalc   : array of real;
    Ak, Ag, AvYk, AvYg, AvXk, AvXg, C1, C2 : real;
    R1abs, R2abs, R1Low, R2Low, BPLow, BPhigh : real; {for type 6}

begin
  with DMSegReg do
  begin

        BPLow := BPxOpt-Alfa*SBP;
        BPhigh := BPxOpt+Alfa*SBP;
        if not (Jtype=5) and not (Jtype=6) then
        if (BPLow<Xmin) or (BPhigh>Xmax) then
        Showmessage ('The confidence interval of the breakpoint is very'+
                     ' wide. The breakpoint may be insignificant.');

        writeln (OutFile);
        if (Option<2) then
           writeln (OutFile,' SUMMARY OF THE Y-X REGRESSION.')
        else
           writeln (OutFile,' SUMMARY OF THE Y-Z REGRESSION.');

        if Jtype=0 then
           writeln (OutFile, ' Function type : 0  - a horizontal'+
                             ' regression line, no breakpoint found.');
        if Jtype=1 then
           writeln (OutFile, ' Function type : 1  - a single'+
                             ' regression line, no breakpoint found.');
        if Jtype=2 then
        begin
           writeln (OutFile, ' Function type : 2  - two connected segments'+
                             ' with lines of different slope.');
           writeln (OutFile, ' Calc. method  :',MethodF:2);
        end;
        if Jtype=3 then
        begin
           writeln (OutFile, ' Function type : 3  - first a'+
                             ' horizontal segment, then sloping.');
           writeln (OutFile, ' Calc. method  :',MethodF:2);
        end;
        if Jtype=4 then
        begin
           writeln (OutFile, ' Function type : 4  - first a'+
                             ' sloping segment, then horizontal.');
           writeln (OutFile, ' Calc. method  :',MethodF:2);
        end;
        if Jtype=5 then
           writeln (OutFile, ' Function type : 5  - two segments',
                             ' with horiz. lines at diff. levels.');
        if Jtype=6 then
        begin
           if Htype=1 then
           writeln (OutFile, ' Function type : 8  - two disconnected,'+
                             ' sloping segments.');
           if Htype=2 then
           writeln (OutFile, ' Function type : 6  - two disconnected,'+
                             ' segments, one horizontal.');
           if Htype=3 then
           writeln (OutFile, ' Function type : 7  - two disconnected,'+
                             ' parallel segments.');
        end;

        writeln (OutFile, ' See help functions on Intro tabsheet');

        Ak := R[1];
        Ag := R[2];
        AvXk := Xav[1];
        AvXg := Xav[2];
        AvYk := Yav[1];
        AvYg := Yav[2];

        if (Jtype=0) then Ag := 0;
        if (Jtype=2) then
        begin
          if MethodF=1 then
          begin
            Ybp := Ak*(BPxOpt-AvXk) + AvYk;
            Ag := (Ybp-AvYg)/(BPxOpt-AvXg);
        end else
            Ybp := Ag*(BPxOpt-AvXg) + AvYg;
            Ak := (Ybp-AvYk)/(BPxOpt-AvXk);
        end;
        if (Jtype=3) then
        begin
          Ak:=0;
          if (MethodF=2) then
              Ag:=(Yav[2]-Yav[1])/(Xav[2]-BPxOpt)
          else
              AvYk:=R[2]*(BPxOpt-Xav[2])+Yav[2];
        end;
        if (Jtype=4) then
        begin
          Ag:=0;
          if (MethodF=2) then
              Ak:=(Yav[2]-Yav[1])/(BPxOpt-Xav[1])
          else
             AvYg:=R[1]*(BPxOpt-Xav[1])+Yav[1];
        end;
        if (Jtype=5) then
        begin
           Ak := 0;
           Ag := 0;
        end;
        if (Jtype=6) then
        begin
           RegAux (Jtype,MethodF,BPxOpt); {determining st. err. of regr. coeff.}
           R1abs := abs(R[1]);
           R2abs := abs(R[2]);
           R1Low := R1abs - Alfa*SKA;    {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;    {SGA=st.err. of regr.coeff. R2}
           if R1Low<0 then Ak:=0;
           if R2Low<0 then Ag:=0;
        end;

      { Regression constant }
        C1 := AvYk - Ak*AvXk;
        C2 := AvYg - Ag*AvXg;

        writeln (OutFile);
        if Option<2 then
        begin
          if Jtype<2 then
          begin
            writeln (OutFile, ' The regression equation is:  Y = A.X + C');
            writeln (OutFile);
            if (Jtype=0) then A[2]:=0;
            Out1 := format('%10.3e',[Ag]);
            Out2 := format('%10.3e',[C2]);
            writeln (OutFile,'      A = ',Out1,'     C = ',Out2);
          end else
          begin
            Out1 := format('%11.4e',[BPxOpt]);
            writeln (OutFile,' Optimal breakpoint of X (BPx) :',Out1);
            writeln (OutFile);
            writeln (OutFile,' There are two regression equations:');
            writeln (OutFile);
            writeln (OutFile,' when X is smaller than BPx:  Y = AsX + Cs');
            writeln (OutFile,' when X is greater than BPx:  Y = AgX + Cg');
            writeln (OutFile);
            Out1 := format('%10.3e',[Ak]);
            Out2 := format('%10.3e',[Ag]);
            writeln (OutFile,'     As = ',Out1,'       Ag = ',Out2);
            Out1 := format('%10.3e',[C1]);
            Out2 := format('%10.3e',[C2]);
            writeln (OutFile,'     Cs = ',OUT1,'       Cg = ',OUT2);
          end;
        end else
        begin
          if Jtype<2 then
          begin
            writeln (OutFile, ' The regression equation is:  Y = A.Z + C');
            writeln (OutFile);
            if (Jtype=0) then A[2]:=0;
            Out1 := format('%10.3e',[Ag]);
            Out2 := format('%10.3e',[C2]);
            writeln (OutFile,'      A = ',Out1,'     C = ',Out2);
          end else
          begin
            Out1 := format('%11.4e',[BPxOpt]);
            writeln (OutFile,' Optimal breakpoint of Z (BPz) :',Out1);
            writeln (OutFile);
            writeln (OutFile,' There are two regression equations:');
            writeln (OutFile);
            writeln (OutFile,' when Z is smaller than BPz:  Y = AsZ + Cs');
            writeln (OutFile,' when Z is greater than BPz:  Y = AgZ + Cg');
            writeln (OutFile);
            Out1 := format('%10.3e',[Ak]);
            Out2 := format('%10.3e',[Ag]);
            writeln (OutFile,'     As = ',Out1,'       Ag = ',Out2);
            Out1 := format('%10.3e',[C1]);
            Out2 := format('%10.3e',[C2]);
            writeln (OutFile,'     Cs = ',Out1,'       Cg = ',Out2);
          end;
        end;

        writeln (OutFile);
        if Option<2 then
           writeln (OutFile,' Serial        Yobs          X         Ycalc')
        else
           writeln (OutFile,' Serial        Yobs          Z         Ycalc');
        writeln (OutFile,' ----------------------------------------------');

        for i:=0 to NrOfData-1 do
        begin
          SetLength(Ycalc,i+1);
          if (Xvalue[i]<BPxOpt) then
             Ycalc[i]:=R[1]*Xvalue[i]+C1
          else
             Ycalc[i]:=R[2]*Xvalue[i]+C2;
        end;

        for i:=0 to NrOfData-1 do
        begin
          Out1 := format('%12.3e',[Yvalue[i]]);
          Out2 := format('%12.4e',[Xvalue[i]]);
          Out3 := format('%12.3e',[Ycalc[i]]);
          writeln (OutFile,i+1:4,'      ',Out1,Out2,Out3);
        end;

  end; {with DMSegReg do}

end; {Reg1Final}
{--------------}


end.



