unit URegres2;

interface

uses  SysUtils, Dialogs, USegRegForm, UDMSegReg, USegRegUtils, URegres1;

var
  Yres1, Yres2, Ycalc, HlpVal : array of real;
  BP1, BP2 : array [1..101] of real;
  Zmin, Zmax, Umin, Umax, BP1Opt, BP2Opt, BPopt1, BPopt2, CexpX, CexpZ   : real;
  CexpX1, CexpX2, CexpX3, CexpX4, CexpX5, CexpX6, CexpX7, CexpX8, CexpX9 : real;
  CexpZ1, CexpZ2, CexpZ3, CexpZ4, CexpZ5, CexpZ6, CexpZ7, CexpZ8, CexpZ9 : real;
  DeltaU, RedSumYsq, SumYdevSq, R2Low : real;
  JXtype, JZtype, Jtype1, Jtype2      : byte;
  MethodX, MethodZ, Method1, Method2  : byte;
  Mode1, Mode2, Mode3, Mode4, Phase   : byte;
  DoIt, Signif2                       : boolean;

procedure Regr2;
procedure DoRegIniX;
procedure DoRegIniZ;
procedure Header2;
procedure Paramet2 (BP : real; Ftype : byte);
procedure Reg2Final;


implementation


procedure Regr2;
{--------------}

var i : integer;
    DeltaZ, TmpValue : real;

begin

  with DMSegReg do
  begin

        Factor:=1.1;
        if (NrOfData>20) and (NrOfData<30) then Factor:=1.08;
        if (NrOfData>=30) and (NrOfData<50) then Factor:=1.05;
        if (NrOfData>=50) and (NrOfData<100) then Factor:=1.01;
        if (NrOfData>=100) then Factor:=1.0;
        Xmin := 1000000;
        Xmax := -1000000;
        Zmin := 1000000;
        Zmax := -1000000;
        for i:=0 to NrOfData-1 do
        begin
          if Xvalue[i]<Xmin then Xmin := Xvalue[i];
          if Xvalue[i]>Xmax then Xmax := Xvalue[i];
          if Zvalue[i]<Zmin then Zmin := Zvalue[i];
          if Zvalue[i]>Zmax then Zmax := Zvalue[i];
        end;

        NotFit:=false;
        if (Xmax-Xmin<0.001) or (Zmax-Zmin<0.001) then
        begin
          Showmessage ('The database is not fit for regression analysis.'+
                       ' There is no variation in X or Z-values.'+
                       ' Please correct the input file.');
          NotFit:=true;
          exit;
        end;

        DeltaX := (Xmax-Xmin)/100;
        DeltaZ := (Zmax-Zmin)/100;
     { Setting 100 values of trial breakpoints for X and Z}
        for i:=1 to 99 do
        begin
          BP1[i+1] := Xmin+i*DeltaX;
          BP2[i+1] := Zmin+i*DeltaZ;
        end;
        BPOpt1 := Xmin;
        BPOpt2 := Zmin;

        Mode3 := 0;
        DoRegIniX;                                  {werken met X waarden}
        if NotFit then exit;

        for i:=0 to NrOfdata-1 do                   {switch values}
        begin
          TmpValue := Xvalue[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := TmpValue;
        end;
        TmpValue:=Xmin;
        Xmin:=Zmin;
        Zmin:=TmpValue;
        TmpValue:=Xmax;
        Xmax:=Zmax;
        Zmax:=TmpValue;

        DoRegIniZ;                                   {werken met Z waarden}
        if NotFit then exit;

        for i:=0 to NrOfdata-1 do                   {restore initial values}
        begin
          TmpValue  := Zvalue[i];
          Zvalue[i] := Xvalue[i];
          Xvalue[i] := TmpValue;
        end;
        TmpValue:=Zmin;
        Zmin:=Xmin;
        Xmin:=TmpValue;
        TmpValue:=Zmax;
        Zmax:=Xmax;
        Xmax:=TmpValue;

        Mode1 := 0;
        FileName := ChangeFileExt (FileName,'.out');
        AssignFile (OutFile,FileName);
        rewrite (OutFile);
        Header2;

  { Bepaling of de residuals worden berekend van X of Z }
        if (CexpX>CexpZ) then
        begin
           Jtype1 := JXtype;
           BPOpt1 := BP1Opt;
           Method1 := MethodX;
           Umax := Xmax;
           Umin := Xmin;
           DeltaU := DeltaX;
           Mode1 := 1;                             { First X, then Z }
        end else
        begin
           Jtype1 := JZtype;
           BPopt1 := BP2Opt;
           Method1 := MethodZ;
           Umax := Zmax;
           Umin := Zmin;
           DeltaU := DeltaZ;
           Mode1 := 2;                            { First Z, then X }
        end;

{ Uiteindelijke berekening regressie van Y op X or Z,
  schrijven van de parameters in de output file
  (Mode2=0, first group of output data) }
        Mode2:=0;
        Header2;
        Itype := 1;
        DoIt:=true;
        Signif1:=true;
        Signif2:=true;
        if Mode1=2 then                     {switch values if Z is used first}
           for i:=0 to NrOfdata-1 do
           begin
             TmpValue := Xvalue[i];
             Xvalue[i] := Zvalue[i];
             Zvalue[i] := TmpValue;
           end;

        Phase:=1;
        Paramet2 (Umin,Itype);
        if R2Low<0 then Signif1:=false;
                                                     { for ANOVA table }
        FileName := ChangeFileExt (FileName,'.var');
        AssignFile (VarFile,FileName);
        rewrite (VarFile);
        writeln (VarFile, NrOfVar:5);
        writeln (VarFile, NrOfData:5);
        Out1 := format('%12.3e',[RedSumYsq]);
        writeln (VarFile,Out1);
        Out2 := format('%12.3e',[SumYdevSq]);
        writeln (VarFile,Out2);
        writeln (VarFile, Mode1:5);
        if (Jtype1>1) then
           writeln (VarFile, BPopt1:10:3)
        else
           writeln (VarFile, ' -99999');

        if Jtype1>1 then
        begin
          Mode2:=1;
          MethodF:=Method1;
          Header2;
          Paramet2 (BPOpt1,Jtype1);

        end;
        if Mode1=2 then                            {reset values}
           for i:=0 to NrOfdata-1 do
           begin
             TmpValue := Xvalue[i];
             Xvalue[i] := Zvalue[i];
             Zvalue[i] := TmpValue;
           end;

{Regressie zonder breekpunt van de independent variables}

        Mode3 := 1;
        if Mode1=1 then for i:=0 to NrOfdata-1 do            {switch values}
        begin
          setlength (YCalc,i+1);
          Ycalc[i]  := Yvalue[i];
          Yvalue[i] := Xvalue[i];
          setlength (HlpVal,i+1);
          HlpVal[i] := Xvalue[i];
          Xvalue[i] := Zvalue[i];
        end;

        if Mode1=2 then for i:=0 to NrOfdata-1 do            {switch values}
        begin
          setlength (YCalc,i+1);
          Ycalc[i]  := Yvalue[i];
          Yvalue[i] := Zvalue[i];
          setlength (HlpVal,i+1);
          HlpVal[i] := Zvalue[i];
          Zvalue[i] := Xvalue[i];
        end;

        Header2;
        Itype:=1;
        DoIt:=false;
        Phase := 2;
        Paramet2 (Zmin,Itype);

        if Mode1=1 then for i:=0 to NrOfdata-1 do             {restore values}
        begin
          Yvalue[i] := Ycalc[i];
          Zvalue[i] := Xvalue[i];
          Xvalue[i] := HlpVal[i];
        end;
        if Mode1=2 then for i:=0 to NrOfdata-1 do             {restore values}
        begin
          Yvalue[i] := Ycalc[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := HlpVal[i];
        end;

        Mode4 := Mode3;
        Mode3 := 0;
        DoIt:=true;

{Berekenen regressie van de residuals op Z of X}
        for i:=0 to NrOfdata-1 do
        begin                                       { Change Y values }
          TmpValue := Yvalue[i];
          Yvalue[i] := Yres1[i];
          Yres1[i] := TmpValue;
        end;
        if Mode1=1 then                             {first X, then Z}
        begin
          for i:=0 to NrOfdata-1 do                 {Change X and Z values}
          begin
            TmpValue := Zvalue[i];
            Zvalue[i] := Xvalue[i];
            Xvalue[i] := TmpValue;
          end;
          for i:=1 to 100 do
          begin
            TmpValue:=BP1[i];
            BP1[i] := BP2[i];
            BP2[i] := TmpValue;
          end;
          TmpValue:=Xmin;
          Xmin:=Zmin;
          Zmin:=TmpValue;
          TmpValue:=Xmax;
          Xmax:=Zmax;
          Zmax:=TmpValue;
        end;

        if Mode1=1 then                              { First X, then Z }
        begin
         SegRegForm.ExclX2RadioButton.Checked :=
             SegRegForm.ExclZ2RadioButton.Checked;
          SegRegForm.ExclX3RadioButton.Checked :=
             SegRegForm.ExclZ3RadioButton.Checked;
          SegRegForm.ExclX4RadioButton.Checked :=
             SegRegForm.ExclZ4RadioButton.Checked;
          SegRegForm.ExclX5RadioButton.Checked :=
             SegRegForm.ExclZ5RadioButton.Checked;
          SegRegForm.ExclX6RadioButton.Checked :=
             SegRegForm.ExclZ6RadioButton.Checked;
         SegRegForm.PrefX2RadioButton.Checked :=
             SegRegForm.PrefZ2RadioButton.Checked;
          SegRegForm.PrefX3RadioButton.Checked :=
             SegRegForm.PrefZ3RadioButton.Checked;
          SegRegForm.PrefX4RadioButton.Checked :=
             SegRegForm.PrefZ4RadioButton.Checked;
          SegRegForm.PrefX5RadioButton.Checked :=
             SegRegForm.PrefZ5RadioButton.Checked;
          SegRegForm.PrefX6RadioButton.Checked :=
             SegRegForm.PrefZ6RadioButton.Checked;
        end;

        DoRegIniX;                                    {werken met residuals}

        Mode2 := 2;
        Header2;
        Itype := 1;
        DoIt:=false;
        Phase := 3;
        Jtype2:=JXtype;
        Paramet2 (Xmin,Itype);
        if R2Low<0 then Signif2:=false;
                                                        { for ANOVA table }
        Out1 := format('%12.3e',[RedSumYsq]);
        writeln (VarFile,Out1);
        Out2 := format('%12.3e',[SumYdevSq]);
        writeln (VarFile,Out2);

        if JXtype>1 then
        begin
          Mode2:=3;
          MethodF:=MethodX;
          Method2:=MethodX;
          BPopt2:=BP1Opt;
          Header2;
          Paramet2 (BPOpt2,Jtype2);
        end;
                                                        { for ANOVA table }
        if (JXtype>1) then
        begin
           writeln (VarFile, BPopt2:10:3);
           Out1 := format ('%12.3e',[Q[1]+Q[2]]);
           writeln (VarFile, Out1);
        end else
           writeln (VarFile, ' -99999');

        for i:=0 to NrOfdata-1 do                   {reset Y and Yresidual}
        begin
          TmpValue := Yres1[i];
          Yres1[i] := Yvalue[i];
          Yvalue[i] := TmpValue;
        end;
        if Mode1=1 then                     {revert to original X and Z values}
        begin
          for i:=0 to NrOfdata-1 do
          begin
            TmpValue := Xvalue[i];
            Xvalue[i] := Zvalue[i];
            Zvalue[i] := TmpValue;
          end;
          for i:=1 to 100 do
          begin
            TmpValue:=BP2[i];
            BP2[i] := BP1[i];
            BP1[i] := TmpValue;
          end;
          TmpValue:=Zmin;
          Zmin:=Xmin;
          Xmin:=TmpValue;
          TmpValue:=Zmax;
          Zmax:=Xmax;
          Xmax:=TmpValue;
        end;

      { Schrijven van de summary en de residuals}
        Reg2Final;

  end; {with DMSegReg do}
  closefile (OutFile);
  closefile (VarFile);

end; {procedure Regr2}
{--------------------}



procedure DoRegIniX;
{------------------}
var i : integer;

begin
    { Regression for type 1, breakpoint = Xmin }
      BP1[1] := Xmin;
      JXtype := 1;
      MethodX := 0;
      RegIni (BP1[1], Cexp0, JXtype, MethodX);
      CexpX1:=Cexp0;
      CexpX := Cexp0;
      BP1Opt := Xmin;

      if not SegRegForm.ExclX3RadioButton.Checked then
      begin
      { Regressions for X, type 3, method 1, at various breakpoints }
        MethodI := 1;
        CexpX3 := Factor*CexpX1;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 1st determination of maximum explanation with X }
          if (Cexp0>CexpX3) and (BP1[i]>Xmin) then
          begin
            BP1Opt := BP1[i];
            CexpX3 := Cexp0;
            CexpX := Cexp0;
            JXtype := 3;
            MethodX := 1;
          end;
        end;

      { Regressions for X, type 3, method 2, at various breakpoints }
        MethodI:= 2;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 2nd determination of maximum explanation with X }
          if (Cexp0>CexpX3) and (BP1[i]>Xmin) then
          begin
            BP1Opt := BP1[i];
            CexpX3 := Cexp0;
            CexpX := Cexp0;
            JXtype := 3;
            MethodX := 2;
          end;
        end;
      end {if not SegRegForm.ExclX3RadioButton.Checked then}
      else CexpX3:=CexpX1;

      if not SegRegForm.ExclX4RadioButton.Checked then
      begin
      { Regressions for X, type 4, method 1, at various breakpoints }
        MethodI := 1;
        CexpX4 := CexpX3;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 3rd determination of maximum explanation with X }
          if (Cexp0>CexpX4) and (BP1[i]>Xmin) then
          begin
            BP1Opt := BP1[i];
            CexpX4 := Cexp0;
            CexpX := Cexp0;
            JXtype := 4;
            MethodX := 1;
          end;
        end;

      { Regressions for X, type 4, method 2, at various breakpoints }
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 4th determination of maximum explanation with X }
          if (Cexp0>CexpX4) and (BP1[i]>Xmin) then
          begin
            BP1Opt := BP1[i];
            CexpX4 := Cexp0;
            CexpX := Cexp0;
            JXtype := 4;
            MethodX := 2;
           end;
        end;
      end {if not SegRegForm.ExclX4RadioButton.Checked then}
      else CexpX4:=CexpX3;

      if not SegRegForm.ExclX5RadioButton.Checked then
      begin
      { Regressions for X, type 5, at various breakpoints }
        MethodI := 0;
        CexpX5 := 1.1*Factor*CexpX4;
        for i:=1 to 100 do
        begin
          Itype := 5;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 5th determination of maximum explanation with X }
          if (Cexp0>CexpX5) and (BP1[i]>Xmin) then
          begin
            BP1Opt := BP1[i];
            CexpX5 := Cexp0;
            CexpX := Cexp0;
            JXtype := 5;
          end;
        end;
      end {if not SegRegForm.ExclX5RadioButton.Checked then}
      else CexpX5:=CexpX4;

      if not SegRegForm.ExclX2RadioButton.Checked then
      begin
      { Regressions for X, type 2, method 1, at various breakpoints }
        MethodI := 1;
        CexpX2 := 1.1*Factor*CexpX5;
        for i:=1 to 100 do
        begin
          Itype:=20;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 6th determination of maximum explanation with X }
          if (Itype=2) and (Cexp0>CexpX2) then
          begin
            BP1Opt := BP1[i];
            CexpX2 := Cexp0;
            CexpX := Cexp0;
            JXtype := 2;
            MethodX := 1;
          end;
        end;

      { Regressions for X, type 2, method 2, at various breakpoints }
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 20;
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 7th determination of maximum explanation with X }
          if (Itype=2) and (Cexp0>CexpX2) then
          begin
            BP1Opt := BP1[i];
            CexpX2 := Cexp0;
            CexpX := Cexp0;
            JXtype := 2;
            MethodX := 2;
          end;
        end;
      end {if not SegRegForm.ExclX2RadioButton.Checked then}
      else CexpX2:=CexpX5;

      if not SegRegForm.ExclX6RadioButton.Checked then
      begin
      { Regressions for X, type 6, at various breakpoints }
        MethodI := 0;
        CexpX6 := 1.2*Factor*CexpX2;
        for i:=1 to 100 do
        begin
          Itype := 60;                               {provisional type 6}
          RegIni (BP1[i], Cexp0, Itype, MethodI);
        { 8th determination of maximum explanation with X }
          if (IType=6) and (Cexp0>CexpX6) then
          begin
            BP1Opt := BP1[i];
            CexpX6 := Cexp0;
            CexpX := Cexp0;
            if SegRegForm.PrefX6RadioButton.Checked then
                 JXtype := 6
            else if CexpX9>0.25 then JXtype := 6;
          end;
        end;
      end; {if not SegRegForm.ExclX6RadioButton.Checked then}

end; {procedure DoRegIniX}
{------------------------}



procedure DoRegIniZ;
{------------------}

var i : integer;

begin
    { Regression for type 1, breakpoint = Zmin }
      BP2[1] := Zmin;
      JZtype := 1;
      MethodZ := 1;
      RegIni (BP2[1], Cexp0, JZtype, MethodZ);
      CexpZ1 := Cexp0;
      CexpZ := Cexp0;
      BP2Opt := Zmin;

      if not SegRegForm.ExclZ3RadioButton.Checked then
      begin
      { Regressions for Z, type 3, method 1, at various breakpoints }
        MethodI := 1;
        CexpZ3 := Factor*CexpZ1;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 1st determination of maximum explanation with Z }
          if (Cexp0>CexpZ3) and (BP2[i]>Xmin) then
          begin
            BP2Opt := BP2[i];
            CexpZ3 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 3;
            MethodZ := 1;
          end;
        end;

      { Regressions for Z, type 3, method 2, at various breakpoints }
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 3;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 2nd determination of maximum explanation with Z }
          if (Cexp0>CexpZ3) and (BP2[i]>Xmin) then
          begin
            BP2Opt := BP2[i];
            CexpZ3 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 3;
            MethodZ := 2;
          end;
        end;
      end {if not SegRegForm.ExclZ3RadioButton.Checked then}
      else CexpZ3:=CexpZ1;

      if not SegRegForm.ExclZ4RadioButton.Checked then
      begin
      { Regressions for Z, type 4, method 1, at various breakpoints }
        MethodI := 1;
        CexpZ4 := CexpZ3;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 3rd determination of maximum explanation with Z }
          if (Cexp0>CexpZ4) and (BP2[i]>Xmin) then
          begin
            BP2Opt := BP2[i];
            CexpZ4 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 4;
            MethodZ := 1;
          end;
        end;

      { Regressions for Z, type 4, method 2, at various breakpoints }
        MethodI := 2;
        for i:=1 to 100 do
        begin
          Itype := 4;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 4th determination of maximum explanation with Z }
          if (Cexp0>CexpZ4) and (BP2[i]>Xmin) then
          begin
            BP2Opt := BP2[i];
            CexpZ4 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 4;
            MethodZ := 2;
          end;
        end;
      end {if not SegRegForm.ExclZ4RadioButton.Checked then}
      else CexpZ4:=CexpZ3;

      if not SegRegForm.ExclZ5RadioButton.Checked then
      begin
      { Regressions for Z, type 5, at various breakpoints }
        MethodI := 0;
        CexpZ5 := 1.1*Factor*CexpZ4;
        for i:=1 to 100 do
        begin
          Itype := 5;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 5th determination of maximum explanation with Z }
          if (Cexp0>CexpZ5) and (BP2[i]>Xmin) then
          begin
            BP2Opt := BP2[i];
            CexpZ5 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 5;
          end;
        end;
      end {if not SegRegForm.ExclZ5RadioButton.Checked then}
      else CexpZ5:=CexpZ4;

      if not SegRegForm.ExclZ2RadioButton.Checked then
      begin
      { Regressions for Z, type 2, method 1, at various breakpoints }
        MethodI := 1;
        CexpZ2 := 1.1*Factor*CexpZ5;
        for i:=1 to 100 do
        begin
          Itype:=20;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 6th determination of maximum explanation with Z }
          if (Itype=2) and (Cexp0>CexpZ2) then
          begin
            BP2Opt := BP2[i];
            CexpZ2 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 2;
            MethodZ := 1;
          end;
        end;

      { Regressions for Z, type 2, method 2, at various breakpoints }
        MethodI := 2;
        for i:=1 to 100 do
        begin
          IType := 20;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 7th determination of maximum explanation with Z }
          if (Itype=2) and (Cexp0>CexpZ2) then
          begin
            BP2Opt := BP2[i];
            CexpZ2 := Cexp0;
            CexpZ := Cexp0;
            JZtype := 2;
            MethodZ := 2;
          end;
        end;
      end {if not SegRegForm.ExclZ2RadioButton.Checked then}
      else CexpZ2:=CexpZ5;

      if not SegRegForm.ExclZ6RadioButton.Checked then
      begin
      { Regressions for Z, type 6, at various breakpoints }
        MethodI := 0;
        CexpZ6 := 1.2*Factor*CexpZ2;
        for i:=1 to 100 do
        begin
          IType := 60;
          RegIni (BP2[i], Cexp0, Itype, MethodI);
        { 8th determination of maximum explanation with Z }
          if (Itype=6) and (Cexp0>CexpZ6) then
          begin
            BP2Opt := BP2[i];
            CexpZ6 := Cexp0;
            CexpZ := Cexp0;
            if SegRegForm.PrefZ6RadioButton.Checked then
                 JZtype := 6
            else if CexpZ9>0.25 then JZtype := 6;
          end;
        end;
      end; {if not SegRegForm.ExclZ6RadioButton.Checked then}

end; {procedure DoRegIniZ}
{------------------------}



procedure Header2;
{----------------}

var HlpFile  : string;
    Confid   : integer;
    Block    : string;
begin
  with DMSegReg do
  begin

{ 1st header in output file }
    if Mode1=0 then
    begin
      writeln (OutFile, ' Results of program SEGREG2 for the segmented'+
                        ' linear regression of');
      writeln (OutFile, ' Y upon X and Z with X-breakpoint BP1 and'+
                        ' Z-breakpoint BPz.');
      writeln (OutFile, ' The regression sequences are either:');
      writeln (OutFile, ' - Y upon X followed by the residuals YXr upon Z, or');
      writeln (OutFile, ' - Y upon Z followed by the residuals YXr upon X,');
      writeln (OutFile, ' whichever gives the best statistical explanation.');
      writeln (OutFile, ' There can be different types of functions'+
                        ' ranging from type 0 to type 6');
      writeln (OutFile, ' and (for types 2, 3 and 4) two methods of'+
                        ' calculation.');
      writeln (OutFile, ' The types and methods are determined with the'+
                        ' procedure of best fit.');
      writeln (OutFile, ' For explanations, use the symbols function in the'+
                        ' output scroll menu.');
      writeln (OutFile);
      writeln (OutFile, ' Name of this output file:  ',FileName);
      HlpFile := ChangeFileExt (DMSegReg.FileName,'.inp');
      writeln (OutFile, ' Name of input file used :  ',HlpFile);
      writeln (OutFile);
      writeln (OutFile,' ',Title1);
      writeln (OutFile,' ',Title2);
      if Alfa<1.8 then Confid := 90
      else
        if Alfa<2.2 then Confid := 95
        else
          Confid := 98;
      writeln (OutFile, ' Minimum confidence % : ',Confid);

      if SegRegForm.PrefX2RadioButton.Checked then Block:=' 2 '
      else
      if SegRegForm.PrefX3RadioButton.Checked then Block:=' 3 '
      else
      if SegRegForm.PrefX4RadioButton.Checked then Block:=' 4 '
      else
      if SegRegForm.PrefX5RadioButton.Checked then Block:=' 5 '
      else
      if SegRegForm.PrefX6RadioButton.Checked then Block:=' 6 '
      else Block:= ' Best of all';
      if SegRegForm.PrefComboBox.ItemIndex>0 then
         writeln (OutFile,' X-type preferred:',Block);
      if SegRegForm.PrefZ2RadioButton.Checked then Block:=' 2 '
      else
      if SegRegForm.PrefZ3RadioButton.Checked then Block:=' 3 '
      else
      if SegRegForm.PrefZ4RadioButton.Checked then Block:=' 4 '
      else
      if SegRegForm.PrefZ5RadioButton.Checked then Block:=' 5 '
      else
      if SegRegForm.PrefZ6RadioButton.Checked then Block:=' 6 '
      else Block:= ' Best of all';
      if SegRegForm.PrefComboBox.ItemIndex>0 then
         writeln (OutFile,' Z-type preferred:',Block);
      if SegRegForm.ExclX2RadioButton.Checked then Block:=' 2 '
      else
      if SegRegForm.ExclX3RadioButton.Checked then Block:=' 3 '
      else
      if SegRegForm.ExclX4RadioButton.Checked then Block:=' 4 '
      else
      if SegRegForm.ExclX5RadioButton.Checked then Block:=' 5 '
      else
      if SegRegForm.ExclX6RadioButton.Checked then Block:=' 6 '
      else
      Block:=' None';

      if SegRegForm.ExclComboBox.ItemIndex>0 then
         writeln (OutFile,' X-type excluded:',Block);
      if SegRegForm.ExclZ2RadioButton.Checked then Block:=' 2 '
      else
      if SegRegForm.ExclZ3RadioButton.Checked then Block:=' 3 '
      else
      if SegRegForm.ExclZ4RadioButton.Checked then Block:=' 4 '
      else
      if SegRegForm.ExclZ5RadioButton.Checked then Block:=' 5 '
      else
      if SegRegForm.ExclZ6RadioButton.Checked then Block:=' 6 '
      else
      Block:=' None';
      if SegRegForm.ExclComboBox.ItemIndex>0 then
         writeln (OutFile,' Z-type excluded:',Block);

      writeln (OutFile);

    end; {Mode1=0}

{ 2nd header in output file, Mode1>0 and Mode2=0 and (Mode3=0)}
      if (Mode1=1) and (Mode2=0) and (Mode3=0) then
      begin
          writeln (OutFile,' Regression of Y upon X without breakpoint'+
                           ' (BPx=Xmin).');
          writeln (OutFile,' The first (X) of two independent variables is'+
                           ' used firstly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPx)'+
                           '    number of data        Av.Y          Av.X');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Y(X=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.X');
          writeln (OutFile);
      end; {Mode1=1 and Mode2=0 and Mode3=0}

      if (Mode1=2) and (Mode2=0) and (Mode3=0) then
      begin
          writeln (OutFile,' Regression of Y upon Z without breakpoint'+
                           ' (BPz=Zmin).');
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used firstly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPz)'+
                           '    number of data        Av.Y          Av.Z');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Y(Z=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.Z');
          writeln (OutFile);
      end; {Mode1=2 and Mode2=0 and Mode3=0 }

{ 3nd header in output file, Mode2=1 and (Mode3=0)}
      if (Mode1=1) and (Mode2=1) and (Mode3=0) then
      begin
          writeln (OutFile);
          writeln (OutFile,' Regression of Y on X with optimal'+
                           ' breakpoint (BPx).');
          writeln (OutFile,' The first (X) of two independent variables is'+
                           ' used firstly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPx)'+
                           '    number of data        Av.Y          Av.X');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Y(Z=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.Z');
          writeln (OutFile,' for the data with X-values smaller and greater'+
                           ' than BPx followed');
          writeln (OutFile, ' by the function parameters.');
          writeln (OutFile);
      end; {if Mode1=1 and Mode2=1 and (Mode3=0)}

      if (Mode1=2) and (Mode2=1) and (Mode3=0) then
      begin
          writeln (OutFile);
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used firstly.');
          writeln (OutFile,' The table below gives the following series of'+
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPz)    number of data        '+
                           'Av.Y          Av.Z');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Y(Z=0)');
          writeln (OutFile,'      St.Dev.Y           St.Dev.Yr'+
                           '         St.Dev.X');
          writeln (OutFile,' for the data with Z-values smaller and greater'+
                           ' than BPz followed');
          writeln (OutFile,' by the function parameters.');
          writeln (OutFile);
      end; { if Mode1=2 and Mode2=1 then }

{ 4th header in output file, Mode2=1 }
      if (Mode3=1) then
      begin
        writeln (OutFile);
        if Mode1=1 then
        begin
        writeln (OutFile,' Regression of X upon Z without breakpoint'+
                         ' (BPz=Zmin).');
        writeln (OutFile,' This analyzes the relation between the'+
                         ' independent variables.');
        writeln (OutFile,' The table below gives the following series of' +
                         ' values respectively:');
        writeln (OutFile,'    Breakpoint(BPz)'+
                         '    number of data        Av.X          Av.Z');
        writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                         '      St.Dev.RC       X(Z=0)');
        writeln (OutFile,'      St.Dev.X           St.Dev.Zr'+
                         '         St.Dev.Z');
        end;
        if Mode1=2 then
        begin
        writeln (OutFile,' Regression of Z upon X without breakpoint'+
                         ' (BPx=Xmin).');
        writeln (OutFile,' This analyzes the relation between the'+
                         ' independent variables.');
        writeln (OutFile,' The table below gives the following series of' +
                         ' values respectively:');
        writeln (OutFile,'    Breakpoint(BPx)'+
                         '    number of data        Av.Z          Av.X');
        writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                         '      St.Dev.RC       Z(X=0)');
        writeln (OutFile,'      St.Dev.Z           St.Dev.Xr'+
                         '         St.Dev.X');
        end;
        writeln (OutFile);
      end; {Mode3=1}

{ 5th header in output file, Mode2=2 }
      if (Mode1=1) and (Mode2=2) then
      begin
          writeln (OutFile);
          writeln (OutFile,' Regression of Y residuals (Yr) on Z without'+
                           ' breakpoint (BPz=Zmin).');
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used secondly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPz)'+
                           '    number of data        Av.Yr         Av.Z');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Yr(Z=0)');
          writeln (OutFile,'      St.Dev.Yr          St.Dev.Yrr'+
                           '         St.Dev.Z');
          writeln (OutFile);
      end; {Mode1=1 and Mode2=2}

      if (Mode1=2) and (Mode2=2) then
      begin
          writeln (OutFile);
          writeln (OutFile,' Regression of Y residuals (Yr) upon X without'+
                           ' breakpoint (BPx=Xmin).');
          writeln (OutFile,' The first (X) of two independent variables is'+
                           ' used secondly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPx)'+
                           '    number of data        Av.Yr         Av.X');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Yr(X=0)');
          writeln (OutFile,'      St.Dev.Yr          St.Dev.Yrr'+
                           '         St.Dev.X');
          writeln (OutFile);
      end; {Mode1=2 and Mode2=2}

{ 6th header in output file, Mode2=3 }
      if (Mode1=1) and (Mode2=3) then
      begin
          writeln (OutFile);
          writeln (OutFile,' Regression of Y residuals (Yr) on Z with optimal'+
                           ' breakpoint (BPz).');
          writeln (OutFile,' The second (Z) of two independent variables is'+
                           ' used secondly.');
          writeln (OutFile,' The table below gives the following series of' +
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPz)'+
                           '    number of data        Av.Yr         Av.Z');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Yr(Z=0)');
          writeln (OutFile,'      St.Dev.Yr          St.Dev.Yrr'+
                           '         St.Dev.Z');
          writeln (OutFile,' for the data with Z-values smaller and greater'+
                           ' than BPz followed');
          writeln (OutFile,' by the function parameters.');
          writeln (OutFile);
      end; {if Mode1=1 and Mode2=3}

      if (Mode1=2) and (Mode2=3) then
      begin
          writeln (OutFile);
          writeln (OutFile,' Regression of Y residuals (Yr) on X with optimal'+
                           ' breakpoint (BPx)');
          writeln (OutFile,' The first (X) of two independent variables is'+
                           ' used secondly.');
          writeln (OutFile,' The table below gives the following series of'+
                           ' values respectively:');
          writeln (OutFile,'    Breakpoint(BPx)    number of data        '+
                           'Av.Yr         Av.X');
          writeln (OutFile,'    Regr.Coeff.(RC)    Corr.Coeff.Sq.'+
                           '      St.Dev.RC       Yr(X=0)');
          writeln (OutFile,'      St.Dev.Yr          St.Dev.Yrr'+
                           '         St.Dev.X');
          writeln (OutFile,' for the data with Z-values smaller and greater'+
                           ' than BPz followed');
          writeln (OutFile,' by the function parameters.');
          writeln (OutFile);
      end; { if Mode1=2 and Mode2=3 then }

  end; {with DMSeReg do}

end; {procedure Header2;}
{-----------------------}



procedure Paramet2 (BP : real; Ftype : byte);
{-------------------------------------------}
{to perform statistical calculations with final
 breakpoint; to determine final parameters }

label 22;
var
    HighR1,HighR2,LowR1,LowR2,
    EY, Ybp1, Ybp2            : real;
    Flag, J                   : byte;
    i                         : integer;

    R1Low, R2Low, R1High, R2High,
    Yav1, Yav2, YavDiff, 
    StDevYdiff, Denom, Cexp       : real;

    Fr1, Fr2, Yin1, Yin2, Ymax    : real;    {for type 3, 4}
    SN, PP1, PP2, PP, SYI1, SYI2  : real;    {for type 3, 4}
    Sign1, Sign2                  : byte;    {for type 3, 4}
    XavT, StY1bp, StY2bp, SRT, RP : real;    {for type 6}
    R1abs, R2abs                  : real;    {for type 6}
begin

  with DMSegReg do
  begin

        for j:=1 to 2 do Q[j]:=0;
        for j:=1 to 12 do A[j]:=0;

        for i:=0 to NrOfData-1 do
        begin
           J:=1;
           if Xvalue[i]>=BP then J:=2;
           A[J]:=A[J]+1;                         {number of data >BP and <BP}
           A[J+2]:=A[J+2]+Yvalue[i];             {Sum of Y}
           A[J+4]:=A[J+4]+Xvalue[i];             {Sum of X}
           A[J+6]:=A[J+6]+Yvalue[i]*Yvalue[i];   {Sum of Y sq.}
           A[J+8]:=A[J+8]+Xvalue[i]*Xvalue[i];   {Sum of X sq.}
           A[J+10]:=A[J+10]+Yvalue[i]*Xvalue[i]; {Sum of YX products}
        end;

        for J:=1 to 2 do
        begin
           if A[J]<3 then goto 22;
           P[J+2]:=A[J+2]/A[J];                        { Av.Y }
           P[J+4]:=A[J+4]/A[J];                        { Av.X }
           P[J+6]:=A[J+6]-A[J]*P[J+2]*P[J+2];          { Red. sum Y sq. }
           if P[J+6]<0 then P[J+6]:=0;
           P[J+8]:=A[J+8]-A[J]*P[J+4]*P[J+4];          { Red. sum X sq. }
           if P[J+8]<0 then P[J+8]:=0;
           P[J+10]:=A[J+10]-A[J]*P[J+2]*P[J+4];        { Red. sum Y.X }
           if P[J+8]=0 then
              P[J+12]:=0
           else
              P[J+12]:=P[J+10]/P[J+8];                 { Regr. coeff. }
           if (P[J+6]=0) or (P[J+8]=0) then
              P[J+14]:=0
           else
              P[J+14]:=P[J+10]/sqrt(P[J+6]*P[J+8]);    { Corr. coeff. }
           P[J+16]:=sqr(P[J+14]);                      { Corr. coeff. sq. }
           P[J+18]:=P[J+2]-P[J+12]*P[J+4];             { Y (X=0) }
           if P[J+6]>=0 then
              P[J+20]:=sqrt(P[J+6]/(A[J]-1))           { St. dev. of Y }
           else
              P[J+20]:=1000000;
           P[J+22]:=(1-P[J+16])*P[J+6];                { Sum Y-dev sq. }
           if P[J+22]<0 then
              P[J+24]:=1000000
           else
              P[J+24]:=sqrt(P[J+22]/(A[J]-1));         { St. dev. of Y-dev. }
           if P[J+8]<0 then
              P[J+26]:=1000000
           else
              P[J+26]:=sqrt(P[J+8]/(A[J]-1));          { St. dev. of X }
           if P[J+22]<0 then
              P[J+28]:=1000000
           else                                        { St. dev. of R.C. }
              if P[J+8]<=0 then
                 P[J+28]:=1000000
              else
                 P[J+28]:=sqrt(P[J+22]/((A[J]-2)*P[J+8]));
22:      end; {for J:=1 to 2 do}

{  calculation of parameters }
        YAV[1] := P[3];
        YAV[2] := P[4];
        XAV[1] := P[5];
        XAV[2] := P[6];
        R[1] := P[13];
        R[2] := P[14];
        RedSumYsq := P[8];
        SumYdevSq := P[24];
        R1Low := abs(R[1])-Alfa*P[29];
        R2Low := abs(R[2])-Alfa*P[30];
        R1High := abs(R[1])+Alfa*P[29];
        R2High := abs(R[2])+Alfa*P[30];
        if (Phase=1) and (Ftype=1) and (Jtype1=1) and (R2Low<0) then
        begin
          Jtype1 := 0;
          Ftype := 0;
          R[2] :=0;
        end;
        if (Phase=3) and(Ftype=1) and (Jtype2=1) and (R2Low<0) then
        begin
          Jtype2 := 0;
          Ftype := 0;
          R[2] :=0;
        end;
        if (A[1]>0) and (A[2]>0) then
           StDevYdiff := sqrt(sqr(P[21])/A[1]+sqr(P[22])/A[2])
        else
           StDevYdiff := 0;

        if Ftype=2 then
           if MethodF=1 then
           begin
              Ybp := R[1]*(BP-Xav[1]) + Yav[1];
              R[2] := (Ybp-Yav[2])/(BP-Xav[2]);
           end else
           if MethodF=2 then
           begin
              Ybp := R[2]*(BP-Xav[2]) + Yav[2];
              R[1] := (Ybp-Yav[1])/(BP-Xav[1]);
           end;

        if Ftype=3 then
        begin
           R[1]:=0;
           if MethodF=1 then Yav[1]:=R[2]*(BP-Xav[2])+Yav[2];
           if MethodF=2 then
              if Xav[2]<>BP then
                 R[2] := (Yav[2]-Yav[1])/(Xav[2]-BP)
              else
                 R[2] := 0;
        end;

        if Ftype=4 then
        begin
           R[2] := 0;
           if MethodF=1 then  Yav[2]:=R[1]*(BP-P[5])+Yav[1];
           if MethodF=2 then
              if BP<>P[5] then
                 R[1] := (Yav[2]-Yav[1])/(BP-P[5])
              else
                 R[1] := 0;
        end;

        if Ftype=5 then
        begin
           R[1] := 0;
           R[2] := 0;
        end;

        if Ftype=6 then
        begin
          if (R1Low<0) and (R1High>0) then R[1]:=0;
          if (R2Low<0) and (R2High>0) then R[2]:=0;
        end;

{ Bepaling residuals en coeff. of expl. (QT)}
        for i:=0 to NrOfData-1 do
        begin
          J:=1;
          if Xvalue[i]>=BP then J:=2;
          EY :=  R[J]*(Xvalue[i]-Xav[J])+Yav[J];             { Expected value }
          if DoIt then
          begin
            setlength (Yres1,i+1);
            Yres1[i] := Yvalue[i]-EY;
          end;
          setlength (Yres2,i+1);
          Yres2[i] := Yvalue[i]-EY;
          Q[J] := Q[J]+sqr(Yvalue[i]-EY);                  { Sum. Sq. of Dev. }
        end;
        if (Ftype<2) then SRYsqT:=P[8];
        Cexp := 1-(Q[1]+Q[2])/SRYsqT;                    {Coeff of Explanation}

{Remembering data for BP=0}
        if Ftype=1 then
        begin
          AvXt:=P[6];
          SumRedXSq:=NrOfData*sqr(P[28]);
        end;

{ Writing results }

        J:=1;
        Formats (J);
        if (Ftype>1) and (Mode3=0) then
        begin
           if (Mode1<2) then
           begin
             if Mode2<2 then
             begin
               writeln (OutFile,' Data with X < BPx :');
               writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
             end else
             begin
               writeln (OutFile,' Data with Z < BPz :');
               writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
             end;
           end else
           begin
             if Mode2<2 then
             begin
               writeln (OutFile,' Data with Z < BPz :');
               writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
             end else
             begin
               writeln (OutFile,' Data with X < BPx :');
               writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
             end;
           end;
           writeln (OutFile, Out4, Out5, Out6, Out7);
           writeln (OutFile, Out8, Out9, Out10);
        end;

        J:=2;
        Formats (J);
        if (Mode1<2) or (Mode3=1) then
        begin
          if Mode2<2 then
          begin
            if Ftype>1 then writeln (OutFile, ' Data with X > BPx :');
            if Mode3=0 then
               writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3)
            else
            begin
               if Mode1=1 then writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
               if Mode1=2 then writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
            end;
          end else
          begin
            if Ftype>1 then writeln (OutFile, ' Data with Z > BPz :');
            writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
          end;
        end else
        begin
          if Mode2<2 then
          begin
            if Ftype>1 then writeln (OutFile, ' Data with Z > BPz :');
            writeln (OutFile,' BPz=',BP:7:2,Out1,Out2,Out3);
          end else
          begin
            if Ftype>1 then writeln (OutFile, ' Data with X > BPx :');
            writeln (OutFile,' BPx=',BP:7:2,Out1,Out2,Out3);
          end;
        end;
        writeln (OutFile, Out4, Out5, Out6, Out7);
        writeln (OutFile, Out8, Out9, Out10);

{ Parameters MET breekpunt }
      if ((Mode3=0) and (Mode2=1)) or (Mode2=3) then
      begin

        RegAux (Ftype, MethodF, BP);

        writeln (OutFile);
        if (Ftype=2) then
        begin
          writeln (OutFile, ' Parameters for function type 2 and method');
          if (Mode1<2) then
          begin
             if (MethodF=1) then
                writeln (OutFile,'     Slope > BPx        St.Err.slope'+
                                 '        Method');
             if (MethodF=2) then
                writeln (OutFile,'     Slope < BPx        St.Err.slope'+
                                  '        Method');
             if (MethodF=1) then
             begin
               Out1 := format('%13.3e',[R[2]]);
               Out2 := format('%21.3e',[SGA]);
             end;
             if (MethodF=2) then
             begin
               Out1 := format('%13.3e',[R[1]]);
               Out2 := format('%21.3e',[SKA]);
             end;
             writeln (OutFile, Out1, Out2, MethodF:13);
             writeln (OutFile,'     Y at BPx            St.Err.BPx'+
                              '       Expl.Coeff.');
          end; {if Mode1<2}

          if (Mode1>1) then
          begin
             if (MethodF=1) then
                writeln (OutFile,'     Slope > BPz        St.Err.Slope'+
                                 '        Method');
             if (MethodF=2) then
                writeln (OutFile,'     Slope < BPz        St.Err.Slope'+
                                  '        Method');
             if (MethodF=1) then
             begin
               Out1 := format('%13.3e',[R[2]]);
               Out2 := format('%21.3e',[SGA]);
             end;
             if (MethodF=2) then
             begin
               Out1 := format('%13.3e',[R[1]]);
               Out2 := format('%21.3e',[SKA]);
             end;
             writeln (OutFile, Out1, Out2, MethodF:13);
             writeln (OutFile,'     Y at BPz            St.Err.BPz'+
                              '       Expl.Coeff.');
          end; {if Mode1>1}
          Out1 := format('%13.3e',[Ybp]);
          Out2 := format('%21.3e',[Sbp]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
          writeln (OutFile,'    St.Err.Ybp');
          Out1 := format('%13.3e',[StdYBP]);
          writeln (OutFile, Out1);

        end; {if Ftype=2}

        if (Ftype=3) or (Ftype=4) then
        begin
           if (Q[1]>0) and (A[1]>1) then
              Q1:=sqrt(Q[1]/(A[1]-1))                   {St Dev Yresidual < BP}
           else
              Q1:=Q[1];
           if (Q[2]>0) and (A[2]>1) then
              Q2:=sqrt(Q[2]/(A[2]-1))                   {St Dev Yresidual > BP}
           else
              Q2:=Q[2];

           FR1:=A[1]/NrOfData;
           FR2:=A[2]/NrOfData;
           YIN1:=FR1*(YAV[2]-YAV[1]);                              {Y increase}
           SIGN1 := 0;
           if (YIN1>0) and (Ftype=4) then
           begin
              if (R[1]>0) then Ymax := R[1]*(BP-Xmin) + Yav[2];
              FR1:=A[2]/NrOfData;
              YIN1:=FR1*(Ymax-YAV[2]) + (1-FR1)*(Ymax-YAV[1]);
              SIGN1 := 1;
           end;
           YIN2:=FR2*(YAV[1]-YAV[2]);                              {Y increase}
           SIGN2 := 0;
           if (YIN2<0) and (Ftype=3) then
           begin
              if (R[2]>0) then Ymax := R[2]*(Xmax-BP) + Yav[1];
              FR2 := A[1]/NrOfData;
              YIN2:=FR2*(Ymax-YAV[1]) + (1-FR2)*(Ymax-YAV[2]);
              SIGN2 := 1;
           end;
           SN:=A[1]*A[2]/sqr(NrOfData);
           SN:=SN/NrOfData;
           PP1:=0;
           if (SIGN1=0) then
              if (A[1]>0) then PP1:=sqr(P[21])/A[1];
           if (SIGN1=1) then
              if (A[2]>0) then PP1:=sqr(P[22])/A[2];
           PP2:=0;
           if (SIGN2=0) then
              if (A[2]>0) then PP2:=sqr(P[22])/A[2];
           if (SIGN2=1) then
              if (A[1]>0) then PP2:=sqr(P[21])/A[1];
           PP:=PP1+PP2;
           PP1:=(P[23]+P[24])/((A[1]+A[2]-2)*(A[1]+A[2]));          {St Dev BP}
           PP2:=(P[23]+P[24])/((A[1]+A[2]-2)*(A[1]+A[2]));          {St Dev BP}
           SYI1:=SN*sqr(YAV[2]-YAV[1])+sqr(A[1]/NrOfData)*PP;  {St Dev increase}
           if (SIGN1=1) then
              SYI1:=SN*sqr(YAV[2]-YAV[1])+sqr(A[2]/NrOfData)*PP;
           SYI2:=SN*sqr(YAV[1]-YAV[2])+sqr(A[2]/NrOfData)*PP;
           if (SIGN2=1) then
              SYI2:=SN*sqr(YAV[1]-YAV[2])+sqr(A[1]/NrOfData)*PP;
           SYI1:=sqrt(SYI1);
           SYI2:=sqrt(SYI2);
           SN:=sqrt(SN);

           if (Ftype=3) then
           begin
              writeln (OutFile, ' Parameters for function type 3 and method',
                                  MethodF:3);
              if (SIGN2=0) then
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope > BPx              Ybp',
                                       '             N>/Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope > BPz              Ybp',
                                       '             N>/Nt       Increase Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope > BPz              Ybp',
                                       '             N>/Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope > BPx            Ybp',
                                       '             N>/Nt       Increase Yi');
                end;
              end else
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope > BPx              Ybp',
                                       '             N</Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope > BPz              Ybp',
                                      '             N</Nt       Increase Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope > BPz              Ybp',
                                       '             N</Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope > BPx              Ybp',
                                       '             N</Nt       Increase Yi');
                end;
              end;
              Out1 := format('%13.3e',[R[2]]);
              Out2 := format('%21.3e',[Yav[1]]);
              Out3 := format('%17.3e',[FR2]);                   {Fraction > BP}
              Out4 := format('%14.3e',[Yin2]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (SIGN2=0) then
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                      '      St.Err.N>/Nt    St.Err.Yi');
                end;
              end else
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                      '      St.Err.N</Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                      '      St.Err.N</Nt    St.Err.Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope>BPz       St.Err.BPz',
                                      '      St.Err.N</Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope>BPx       St.Err.BPx',
                                      '      St.Err.N</Nt    St.Err.Yi');
                end;
              end;
              Out1 := format('%13.3e',[SA]);
              Out2 := format('%21.3e',[SBP]);
              Out3 := format('%17.3e',[SN]);
              Out4 := format('%14.3e',[SYi2]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (MethodF=1) then
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr < BPx       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr < BPz       St.Dev.Ybp');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr < BPz       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr < BPx       St.Dev.Ybp');
                end;
                Out1 := format('%13.3e',[Q1]);
                Out2 := format('%21.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2);

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope < BPx        St.Err.Slope<BPx',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope < BPz        St.Err.Slope<BPz',
                                      '   Expl.Coeff.');
                end else
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope < BPz        St.Err.Slope<BPz',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope < BPx        St.Err.Slope<BPx',
                                      '   Expl.Coeff.');
                end;
                Out1 := format('%13.3e',[R[1]]);
                Out2 := format('%21.3e',[SKA]);
                Out3 := format('%17.3e',[Cexp]);
                writeln (OutFile, Out1, Out2, Out3);

              end else    {else if MethodF=2}
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr > BPx       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr > BPz       St.Dev.Ybp');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr > BPz       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr > BPx       St.Dev.Ybp');
                end;
                Out1 := format('%13.3e',[Q2]);
                Out2 := format('%21.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2);

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope < BPx        St.Err.Slope<BPz',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope < BPz        St.Err.Slope<BPz',
                                      '   Expl.Coeff.');
                end else
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope < BPz        St.Err.Slope<BPz',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope < BPx        St.Err.Slope<BPx',
                                      '   Expl.Coeff.');
                end;
                Out1 := format('%13.3e',[R[1]]);
                Out2 := format('%21.3e',[SKA]);
                Out3 := format('%17.3e',[Cexp]);
                writeln (OutFile, Out1, Out2, Out3);

              end; {if MethodF=2}
           end; {if (Ftype=3) then}

           if (Ftype=4) then
           begin
              writeln (OutFile, ' Parameters for function type 4 and method',
                                  MethodF:3);
              if (SIGN1=0) then
              begin
                if Mode1<3 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope < BPx              Ybp',
                                       '             N</Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope < BPz              Ybp',
                                       '             N</Nt       Increase Yi');
                 end else
                 begin
                   if (Mode1<2) then
                      writeln (OutFile, '   Slope < BPz              Ybp',
                                        '             N</Nt       Increase Yi');
                   if (Mode1=2) then
                      writeln (OutFile, '   Slope < BPx              Ybp',
                                      '             N</Nt       Increase Yi');
                end;
              end else {Yincrease>0}
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope < BPx              Ybp',
                                       '             N>/Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope < BPz              Ybp',
                                       '             N>/Nt       Increase Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   Slope < BPz              Ybp',
                                       '             N>/Nt       Increase Yi');
                  if (Mode1=2) then
                     writeln (OutFile, '   Slope < BPx              Ybp',
                                       '             N>/Nt       Increase Yi');
                end;
              end;
              Out1 := format('%13.3e',[R[1]]);
              Out2 := format('%21.3e',[Yav[2]]);
              Out3 := format('%17.3e',[FR1]);                   {Fraction > BP}
              Out4 := format('%14.3e',[Yin1]);
              writeln (OutFile, Out1, Out2, Out3, Out4);
              if (SIGN1=0) then
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                      '      St.Err.N</Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                      '      St.Err.N</Nt    St.Err.Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                      '      St.Err.N</Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                      '      St.Err.N</Nt    St.Err.Yi');
                end;

              end else
              begin
                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                      '      St.Err.N>/Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                      '      St.Err.N>/Nt    St.Err.Yi');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile,'  St.Err.Slope<BPz       St.Err.BPz',
                                      '      St.Err.N>/Nt    St.Err.Yi');
                  if (Mode1=2) then
                     writeln (OutFile,'  St.Err.Slope<BPx       St.Err.BPx',
                                     '      St.Err.N>/Nt    St.Err.Yi');
                end;
              end;
              Out1 := format('%13.3e',[SA]);
              Out2 := format('%21.3e',[SBP]);
              Out3 := format('%17.3e',[SN]);
              Out4 := format('%14.3e',[SYi1]);
              writeln (OutFile, Out1, Out2, Out3, Out4);

              if (MethodF=2) then
              begin

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr < BPx       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr < BPz       St.Dev.Ybp');
                  end else
                  begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr < BPz       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr < BPx       St.Dev.Ybp');
                end;
                Out1 := format('%13.3e',[Q1]);
                Out2 := format('%21.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope > BPx        St.Err.Slope>BPx',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope > BPz        St.Err.Slope>BPz',
                                      '   Expl.Coeff.');
                end else
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope > BPz        St.Err.Slope>BPz',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope > BPx        St.Err.Slope>BPx',
                                      '   Expl.Coeff.');
                end;
                Out1 := format('%13.3e',[R[2]]);
                Out2 := format('%21.3e',[SGA]);
                Out3 := format('%17.3e',[Cexp]);
                writeln (OutFile, Out1, Out2, Out3);

              end else     {else if MethodF=2}
              begin

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr > BPx       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr > BPz       St.Dev.Ybp');
                end else
                begin
                  if (Mode1<2) then
                     writeln (OutFile, '   St.Dev.Yr > BPz       St.Dev.Ybp');
                  if (Mode1=2) then
                     writeln (OutFile, '   St.Dev.Yr > BPx       St.Dev.Ybp');
                end;
                Out1 := format('%13.3e',[Q2]);
                Out2 := format('%21.3e',[StdYbp]);
                writeln (OutFile, Out1, Out2, Out3);

                if Mode4<1 then
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope > BPx        St.Err.Slope>BPx',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope > BPz        St.Err.Slope>BPz',
                                      '   Expl.Coeff.');
                end else
                begin
                  if (Mode1<2) then
                    writeln (OutFile, '   Slope > BPz        St.Err.Slope>BPz',
                                      '   Expl.Coeff.');
                  if (Mode1=2) then
                    writeln (OutFile, '   Slope > BPx        St.Err.Slope>BPx',
                                      '   Expl.Coeff.');
                end;
                Out1 := format('%13.3e',[R[2]]);
                Out2 := format('%21.3e',[SGA]);
                Out3 := format('%17.3e',[Cexp]);
                writeln (OutFile, Out1, Out2, Out3);

              end; {if MethodF=2}

           end; {if (Ftype=4) then}

        end; {if Ftype=3 or Ftype=4}

        if Ftype=5 then
        begin
          writeln (OutFile, ' Parameters for function type 5 :');
          if Mode1<2 then
             writeln (OutFile, '    Slope < BPx       St.Err.Slope<BPx'+
                               '   StDevDiffYav.')
          else
             writeln (OutFile, '    Slope < BPz       St.Err.Slope<BPz'+
                               '   StDevDiffYav.');
          Out1 := format('%13.3e',[R[1]]);
          Out2 := format('%21.3e',[SKA]);
          Out3 := format('%17.3e',[StDevYdiff]);
          writeln (OutFile, Out1, Out2, Out3);
          if Mode4<1 then
          begin
            if Mode<2 then
              writeln (OutFile,  '    Slope > BPx       St.Err.Slope>BPx'+
                                 '    Expl.Coeff.')
            else
               writeln (OutFile, '    Slope > BPz       St.Err.Slope>BPz'+
                                 '    Expl.Coeff.');
          end else
          begin
            if Mode1<2 then
               writeln (OutFile, '    Slope > BPx       St.Err.Slope>BPx'+
                                 '    Expl.Coeff.')
          else
               writeln (OutFile, '    Slope > BPz       St.Err.Slope>BPz'+
                                 '    Expl.Coeff.')
          end;
          Out1 := format('%13.3e',[R[2]]);
          Out2 := format('%21.3e',[SGA]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
        end; {if Ftype=5 then}

        if Ftype=6 then
        begin
          XavT:=(A[1]*Xav[1]+A[2]*Xav[2])/(A[1]+A[2]);
          Ybp1:=R[1]*(BP-Xav[1])+Yav[1];
          Ybp2:=R[2]*(BP-Xav[2])+Yav[2];
          Denom:=NrOfData*(NrOfData-2);
          SRT:=(Q[1]+Q[2])/Denom;
          StY1bp:=sqrt(SRT+(sqr(SKA)*sqr(BP-XavT)));
          StY2bp:=sqrt(SRT+(sqr(SGA)*sqr(BP-XavT)));
          writeln (OutFile, ' Parameters for function type 6 :');
          writeln (OutFile, '       Y1bp              St.Err.Y1bp');
          Out1 := format('%13.3e',[Ybp1]);
          Out2 := format('%21.3e',[StY1bp]);
          writeln (OutFile, Out1, Out2);
          writeln (OutFile, '       Y2bp              St.Err.Y2bp'+
                            '       Expl.Coeff.');
          Out1 := format('%13.3e',[Ybp2]);
          Out2 := format('%21.3e',[StY2bp]);
          Out3 := format('%17.3e',[Cexp]);
          writeln (OutFile, Out1, Out2, Out3);
        end; {if Ftype=6 then}

     end; {if Mode2=1 or Mode2=3}

  end; { with DMSegReg do}

end; {procedure paramet2}
{-----------------------}


procedure Reg2Final;
{------------------}

var
    i : integer;
    CexpT, TmpValue, Average, AuxValue : real;
    Ak11, Ag11, AvXk11, AvXg11, AvYk11, AvYg11 : real;
    Ak12, Ag12, AvXk12, AvXg12, AvYk12, AvYg12 : real;
    Ak21, Ag21, AvXk21, AvXg21, AvYk21, AvYg21 : real;
    Ak22, Ag22, AvXk22, AvXg22, AvYk22, AvYg22 : real;
    Ybp11, Ybp12, Ybp21, Ybp22, C11, C12, C21, C22 : real;
    R1abs, R2abs, R1Low, R2Low        : real; {for type 6}

begin
  with DMSegReg do
  begin

      writeln (OutFile);
      if Mode1=1 then
         writeln (OutFile,' SUMMARY OF THE Y-X-Z REGRESSION.')
      else
         writeln (OutFile,' SUMMARY OF THE Y-Z-X REGRESSION.');

      if Mode1=1 then
      begin
        if Jtype1=0 then
           writeln (OutFile, ' Y-X  Function type : 0  - a horizontal'+
                             ' regression line, no breakpoint found.');
        if Jtype1=1 then
           writeln (OutFile, ' Y-X  Function type : 1  - a single'+
                             ' regression line, no breakpoint found.');
        if Jtype1=2 then
           writeln (OutFile, ' Y-X  Function type : 2  - two connected'+
                             ' segements with lines of different slope.');
        if Jtype1=3 then
           writeln (OutFile, ' Y-X  Function type : 3  - first a'+
                             ' horizontal segment, then sloping.');
        if Jtype1=4 then
           writeln (OutFile, ' Y-X  Function type : 4  - first a'+
                             ' sloping segment, then horizontal.');
        if Jtype1=5 then
           writeln (OutFile, ' Y-X  Function type : 5  - two segments',
                             ' with horiz. lines at diff. levels.');
        if Jtype1=6 then
           writeln (OutFile, ' Y-X  Function type : 6  - two disconnected,'+
                             ' sloping segments.');
        if Jtype2=0 then
           writeln (OutFile, ' YXr-Z Function type: 0  - a horizontal'+
                             ' regression line, no breakpoint found.');
        if Jtype2=1 then
           writeln (OutFile, ' YXr-Z Function type: 1  - a single'+
                             ' regression line, no breakpoint found.');
        if Jtype2=2 then
           writeln (OutFile, ' YXr-Z Function type: 2  - two connected'+
                             ' segments with lines of different slope.');
        if Jtype2=3 then
           writeln (OutFile, ' YXr-Z Function type: 3  - first a'+
                             ' horizontal segment, then sloping.');
        if Jtype2=4 then
           writeln (OutFile, ' YXr-Z Function type: 4  - first a'+
                             ' sloping segment, then horizontal.');
        if Jtype2=5 then
           writeln (OutFile, ' YXr-Z Function type: 5  - two segments',
                             ' with horiz. lines at diff. levels.');
        if Jtype2=6 then
           writeln (OutFile, ' YXr-Z Function type: 6  - two disconnected,'+
                             ' sloping segments.');
      end else
      begin
        if Jtype1=0 then
           writeln (OutFile, ' Y-Z  Function type : 0  - a horizontal'+
                             ' regression line, no breakpoint found.');
        if Jtype1=1 then
           writeln (OutFile, ' Y-Z  Function type : 1  - a single'+
                             ' regression line, no breakpoint found.');
        if Jtype1=2 then
           writeln (OutFile, ' Y-Z  Function type : 2  - two connected'+
                             ' segments with lines of different slope.');
        if Jtype1=3 then
           writeln (OutFile, ' Y-Z  Function type : 3  - first a'+
                             ' horizontal segment, then sloping.');
        if Jtype1=4 then
           writeln (OutFile, ' Y-Z  Function type : 4  - first a'+
                             ' sloping segment, then horizontal.');
        if Jtype1=5 then
           writeln (OutFile, ' Y-Z  Function type : 5  - two segments',
                             ' with horiz. lines at diff. levels.');
        if Jtype1=6 then
           writeln (OutFile, ' Y-Z  Function type : 6  - two disconnected,'+
                             ' sloping segments.');
        if Jtype2=0 then
           writeln (OutFile, ' YZr-X Function type: 0  - a horizontal'+
                             ' regression line, no breakpoint found.');
        if Jtype2=1 then
           writeln (OutFile, ' YZr-X Function type: 1  - a single'+
                             ' regression line, no breakpoint found.');
        if Jtype2=2 then
           writeln (OutFile, ' YZr-X Function type: 2  - two connected'+
                             ' segments with lines of different slope.');
        if Jtype2=3 then
           writeln (OutFile, ' YZr-X Function type: 3  - first a'+
                             ' horizontal segment, then sloping.');
        if Jtype2=4 then
           writeln (OutFile, ' YZr-X Function type: 4  - first a'+
                             ' sloping segment, then horizontal.');
        if Jtype2=5 then
           writeln (OutFile, ' YZr-X Function type: 5  - two segments',
                             ' with horiz. lines at diff. levels.');
        if Jtype2=6 then
           writeln (OutFile, ' YZr-X Function type: 6  - two disconnected,'+
                             ' sloping segments.');
      end; {if Mode1=1 then, else if Mode1=2 then}
      if Mode1=1 then
      begin
        if (Jtype1=3) or (Jtype1=4) then
           writeln (OutFile, ' Y-X   Calc. method :',Method1:2);
        if (Jtype2=3) or (Jtype2=4) then
           writeln (OutFile, ' YXr-Z Calc. method :',Method2:2);
      end else
      begin
        if (Jtype1=3) or (Jtype1=4) then
           writeln (OutFile, ' Y-Z   Calc. method :',Method1:2);
        if (Jtype2=3) or (Jtype2=4) then
           writeln (OutFile, ' YZr-X Calc. method :',Method2:2);
      end;

      writeln (OutFile, ' (See help functions on Intro tabsheet)');

      writeln (Outfile);
      Out1 := format('%11.4e',[BPopt1]);
      Out2 := format('%11.4e',[BPopt2]);
      if Mode1=1 then
      begin
       writeln (OutFile,' The optimal breakpoint of X (BPx) is :',Out1);
       writeln (OutFile,' The optimal breakpoint of Z (BPz) is :',Out2);
      end else
      begin
       writeln (OutFile,' The optimal breakpoint of Z (BPz) is :',Out1);
       writeln (OutFile,' The optimal breakpoint of X (BPx) is :',Out2);
      end;

      writeln (Outfile);
      writeln (OutFile, ' There are four regression equations:');
      writeln (OutFile);
      if Mode1=1 then
      begin
      writeln (Outfile, ' when  X<BPx  and  Z<BPz :    Y = As.X + Bs.Z + Css');
      writeln (Outfile, ' when  X<BPx  and  Z>BPz :    Y = As.X + Bg.Z + Csg');
      writeln (Outfile, ' when  X>BPx  and  Z<BPz :    Y = Ag.X + Bs.Z + Cgs');
      writeln (Outfile, ' when  X>BPx  and  Z>BPz :    Y = Ag.X + Bg.Z + Cgg');
      end else
      begin
      writeln (Outfile, ' when  Z<BPz  and  X<BPx :    Y = As.Z + Bs.X + Css');
      writeln (Outfile, ' when  Z<BPz  and  X>BPx :    Y = As.Z + Bg.X + Csg');
      writeln (Outfile, ' when  Z>BPz  and  X<BPx :    Y = Ag.Z + Bs.X + Cgs');
      writeln (Outfile, ' when  Z>BPz  and  X>BPx :    Y = Ag.z + Bg.X + Cgg');
      end;
                   {settings, otherwise the compiler warns}
      Ak11:=0;
      Ag11:=0;
      Ak12:=0;
      Ag12:=0;
      Ak21:=0;
      Ag21:=0;
      Ak22:=0;
      Ag22:=0;

     { Determining the regression coefficients (A,B) and constants (C) }
      if Mode1=1 then
      begin
        RegIni (BPopt1, Cexp0, Jtype1, Method1);                  {use X and Y}
        Ak11 := R[1];
        Ag11 := R[2];
        AvXk11 := Xav[1];
        AvXg11 := Xav[2];
        AvYk11 := Yav[1];
        AvYg11 := Yav[2];
        if Jtype1=0 then
        begin
          Ag11:=0;
          AvYg11:=0;
        end;
        if Jtype1<2 then
        begin
          Ak11:=0;
          AvYk11:=0;
        end;
        if (Jtype1=2) then
          if Method1=1 then
          begin
            Ybp11 := Ak11*(BPopt1-AvXk11) + AvYk11;
            Ag11 := (Ybp11-AvYg11)/(BPopt1-AvXg11);
          end else
          begin
            Ybp11 := Ag11*(BPopt1-AvXg11) + AvYg11;
            Ak11 := (Ybp11-AvYk11)/(BPopt1-AvXk11);
          end;
        if (Jtype1=3) then
        begin
           Ak11:=0;
           if (Method1=2) then
               Ag11:=(AvYg11-AvYk11)/(AvXg11-BPopt1)
           else
              AvYk11:=Ag11*(BPopt1-AvXg11)+AvYg11;
        end;
        if (Jtype1=4) then
        begin
          Ag11:=0;
          if (Method1=2) then
              Ak11:=(AvYg11-AvYk11)/(BPopt1-AvXk11)
          else
              AvYg11:=Ak11*(BPopt1-AvXk11)+AvYk11;
        end;
        if (Jtype1=5) then
        begin
           Ak11 := 0;
           Ag11 := 0;
        end;
        if (Jtype1=6) then
        begin
           RegAux (Jtype1,Method1,BPopt1); {determining st. err. of regr. coeff.}
           R1abs := abs(R[1]);
           R2abs := abs(R[2]);
           R1Low := R1abs - Alfa*SKA;           {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;           {SGA=st.err. of regr.coeff. R2}
           if R1Low<0 then Ak11:=0;
           if R2Low<0 then Ag11:=0;
        end;

        for i:=0 to NrOfdata-1 do                              {convert values}
        begin
          TmpValue := Yvalue[i];
          Yvalue[i] := Yres1[i];
          Yres1[i] := TmpValue;
          TmpValue := Xvalue[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := TmpValue;
        end;
        TmpValue:=Xmin;
        Xmin:=Zmin;
        Zmin:=TmpValue;
        RegIni (BPopt2, Cexp0, Jtype2, Method2);          {use Z and Yresidual}
        Ak12 := R[1];
        Ag12 := R[2];
        AvXk12 := Xav[1];
        AvXg12 := Xav[2];
        AvYk12 := Yav[1];
        AvYg12 := Yav[2];
        if Jtype1=0 then
        begin
          Ag12:=0;
          AvYg12:=0;
        end;
        if Jtype2<2 then
        begin
          Ak12:=0;
          AvYk12:=0;
        end;
        if (Jtype2=2) then
          if Method2=1 then
          begin
            Ybp12 := Ak12*(BPopt2-AvXk12) + AvYk12;
            Ag12 := (Ybp12-AvYg12)/(BPopt2-AvXg12);
          end else
          begin
            Ybp12 := Ag12*(BPopt2-AvXg12) + AvYg12;
            Ak12 := (Ybp12-AvYk12)/(BPopt2-AvXk12);
          end;
        if (Jtype2=3) then
        begin
           Ak12:=0;
           if (Method2=2) then
               Ag12:=(AvYg12-AvYk12)/(AvXg12-BPopt2)
           else
              AvYk12:=Ag12*(BPopt2-AvXg12)+AvYg12;
        end;
        if (Jtype2=4) then
        begin
          Ag12:=0;
          if (Method2=2) then
              Ak12:=(AvYg12-AvYk12)/(BPopt2-AvXk12)
          else
              AvYg12:=Ak12*(BPopt2-AvXk12)+AvYk12;
        end;
        if (Jtype2=5) then
        begin
           Ak12 := 0;
           Ag12 := 0;
        end;
        if (Jtype2=6) then
        begin
           RegAux (Jtype2,Method2,BPopt2);{determining st. err. of regr. coeff.}
           R1abs := abs(R[1]);
           R2abs := abs(R[2]);
           R1Low := R1abs - Alfa*SKA;           {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;           {SGA=st.err. of regr.coeff. R2}
           if R1Low<0 then Ak12:=0;
           if R2Low<0 then Ag12:=0;
        end;
      { Regression constants }
        C11:=AvYk11+AvYk12-Ak11*AvXk11-Ak12*AvXk12;     {X<BP, Z<BP}
        C12:=AvYk11+AvYg12-Ak11*AvXk11-Ag12*AvXg12;     {X<BP, Z>BP}
        C21:=AvYg11+AvYk12-Ag11*AvXg11-Ak12*AvXk12;     {X>BP, Z<BP}
        C22:=AvYg11+AvYg12-Ag11*AvXg11-Ag12*AvXg12;     {X>BP, Z>BP}
        for i:=0 to NrOfdata-1 do                               {revert values}
        begin
          TmpValue := Yvalue[i];
          Yvalue[i] := Yres1[i];
          Yres1[i] := TmpValue;
          TmpValue := Xvalue[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := TmpValue;
        end;
        TmpValue:=Xmin;
        Xmin:=Zmin;
        Zmin:=TmpValue;
      end else {mode1:=2}
      begin                                              {mode1=2, use Z and Y}
        for i:=0 to NrOfdata-1 do                              {convert values}
        begin
          TmpValue := Xvalue[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := TmpValue;
        end;
        TmpValue:=Xmin;
        Xmin:=Zmin;
        Zmin:=TmpValue;
        RegIni (BPopt1, Cexp0, Jtype1, Method1);                  {use Z and Y}
        Ak21 := R[1];
        Ag21 := R[2];
        AvXk21 := Xav[1];
        AvXg21 := Xav[2];
        AvYk21 := Yav[1];
        AvYg21 := Yav[2];
        if Jtype1=0 then
        begin
          Ag21:=0;
          AvYg21:=0;
        end;
        if Jtype1<2 then
        begin
          Ak21:=0;
          AvYk21:=0;
        end;
        if Jtype1=2 then
          if Method1=1 then
          begin
            Ybp21 := Ak21*(BPopt1-AvXk21) + AvYk21;
            Ag21 := (Ybp21-AvYg21)/(BPopt1-AvXg21);
          end else
          begin
            Ybp21 := Ag21*(BPopt1-AvXg21) + AvYg21;
            Ak21 := (Ybp21-AvYk21)/(BPopt1-AvXk21);
          end;
        if (Jtype1=3) then
        begin
           Ak21:=0;
           if (Method1=2) then
               Ag21:=(AvYg21-AvYk21)/(AvXg21-BPopt1)
           else
              AvYk21:=Ag21*(BPopt1-AvXg21)+AvYg21;
        end;
        if (Jtype1=4) then
        begin
          Ag21:=0;
          if (Method1=2) then
              Ak21:=(AvYg21-AvYk21)/(BPopt1-AvXk21)
          else
             AvYg21:=Ak21*(BPopt1-AvXk21)+AvYk21;
        end;
        if (Jtype1=5) then
        begin
           Ak21 := 0;
           Ag21 := 0;
        end;
        if (Jtype1=6) then
        begin
           RegAux (Jtype1,Method1,BPopt1);{determining st. err. of regr. coeff.}
           R1abs := abs(R[1]);
           R2abs := abs(R[2]);
           R1Low := R1abs - Alfa*SKA;    {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;    {SGA=st.err. of regr.coeff. R2}
           if R1Low<0 then Ak21:=0;
           if R2Low<0 then Ag21:=0;
        end;

        for i:=0 to NrOfdata-1 do                       {convert X and Z values}
        begin
          TmpValue := Xvalue[i];
          Xvalue[i] := Zvalue[i];
          Zvalue[i] := TmpValue;
        end;
        TmpValue:=Xmin;
        Xmin:=Zmin;
        Zmin:=TmpValue;

        for i:=0 to NrOfdata-1 do                            {convert Y values}
        begin
          TmpValue := Yvalue[i];
          Yvalue[i] := Yres1[i];
          Yres1[i] := TmpValue;
        end;

        RegIni (BPopt2, Cexp0, Jtype2, Method2);          {use X and Yresidual}
        Ak22 := R[1];
        Ag22 := R[2];
        AvXk22 := Xav[1];
        AvXg22 := Xav[2];
        AvYk22 := Yav[1];
        AvYg22 := Yav[2];
        if Jtype2=0 then
        begin
          Ag22:=0;
          AvYg22:=0;
        end;
        if Jtype2<2 then
        begin
          Ak22:=0;
          AvYk22:=0;
        end;
        if (Jtype2=2) then
          if Method2=1 then
          begin
            Ybp22 := Ak22*(BPopt2-AvXk22) + AvYk22;
            Ag22 := (Ybp22-AvYg22)/(BPopt2-AvXg22);
          end else
          begin
            Ybp22 := Ag22*(BPopt2-AvXg22) + AvYg22;
            Ak22 := (Ybp22-AvYk22)/(BPopt2-AvXk22);
          end;
        if (Jtype2=3) then
        begin
           Ak22:=0;
           if (Method2=2) then
               Ag22:=(AvYg22-AvYk22)/(AvXg22-BPopt2)
           else
              AvYk22:=Ag22*(BPopt2-AvXg22)+AvYg22;
        end;
        if (Jtype2=4) then
        begin
          Ag22:=0;
          if (Method2=2) then
              Ak22:=(AvYg22-AvYk22)/(BPopt2-AvXk22)
          else
              AvYg22:=Ak22*(BPopt2-AvXk22)+AvYk22;
        end;
        if (Jtype2=5) then
        begin
           Ak22 := 0;
           Ag22 := 0;
        end;
        if (Jtype2=6) then
        begin
           RegAux (Jtype2,Method2,BPopt2);{determining st. err. of regr. coeff.}
           R1abs := abs(R[1]);
           R2abs := abs(R[2]);
           R1Low := R1abs - Alfa*SKA;    {SKA=st.err. of regr.coeff. R1}
           R2Low := R2abs - Alfa*SGA;    {SGA=st.err. of regr.coeff. R2}
           if R1Low<0 then Ak22:=0;
           if R2Low<0 then Ag22:=0;
        end;
      { Regression constants }   {first Z <-> 21, then X <-> 22}
        C11:=AvYk21+AvYk22-Ak21*AvXk21-Ak22*AvXk22;     {Z<BP, X<BP}
        C12:=AvYk21+AvYg22-Ak21*AvXk21-Ag22*AvXg22;     {Z<BP, X>BP}
        C21:=AvYg21+AvYk22-Ag21*AvXg21-Ak22*AvXk22;     {Z>BP, X<BP}
        C22:=AvYg21+AvYg22-Ag21*AvXg21-Ag22*AvXg22;     {Z>BP, X>BP}
        for i:=0 to NrOfdata-1 do                            {revert Y values}
        begin
          TmpValue := Yres1[i];
          Yres1[i] := Yvalue[i];
          Yvalue[i] := TmpValue;
        end;
      end;

      writeln (OutFile);
      if Mode1=1 then
      begin
      Out1 := format('%11.3e',[Ak11]);
      Out2 := format('%11.3e',[Ak12]);
      Out3 := format('%11.3e',[Ag11]);
      Out4 := format('%11.3e',[Ag12]);
        writeln (OutFile, '      As =',Out1, '        Bs =',Out2);
        writeln (OutFile, '      Ag =',Out3, '        Bg =',Out4);
      end else
      begin
      Out1 := format('%11.3e',[Ak21]);
      Out2 := format('%11.3e',[Ak22]);
      Out3 := format('%11.3e',[Ag21]);
      Out4 := format('%11.3e',[Ag22]);
        writeln (OutFile, '      As =',Out1, '        Bs =',Out2);
        writeln (OutFile, '      Ag =',Out3, '        Bg =',Out4);
      end;
      Out5 := format('%11.3e',[C11]);
      Out6 := format('%11.3e',[C12]);
      Out7 := format('%11.3e',[C21]);
      Out8 := format('%11.3e',[C22]);
      writeln (OutFile, '     Css =',Out5, '       Csg =',Out6);
      writeln (OutFile, '     Cgs =',Out7, '       Cgg =',Out8);

      for i:=0 to NrOfData-1 do
      begin
        if (Mode1=1) then
        begin
          if (Xvalue[i]<BPopt1) and (Zvalue[i]<BPopt2) then
              Ycalc[i]:=Ak11*Xvalue[i]+Ak12*Zvalue[i]+C11;
          if (Xvalue[i]<BPopt1) and (Zvalue[i]>BPopt2) then
              Ycalc[i]:=Ak11*Xvalue[i]+Ag12*Zvalue[i]+C12;
          if (Xvalue[i]>BPopt1) and (Zvalue[i]<BPopt2) then
              Ycalc[i]:=Ag11*Xvalue[i]+Ak12*Zvalue[i]+C21;
          if (Xvalue[i]>BPopt1) and (Zvalue[i]>BPopt2) then
              Ycalc[i]:=Ag11*Xvalue[i]+Ag12*Zvalue[i]+C22;
        end else
        begin
          if (Zvalue[i]<BPopt1) and (Xvalue[i]<BPopt2) then
              Ycalc[i]:=Ak21*Zvalue[i]+Ak22*Xvalue[i]+C11;
          if (Zvalue[i]<BPopt1) and (Xvalue[i]>BPopt2) then
              Ycalc[i]:=Ak21*Zvalue[i]+Ag22*Xvalue[i]+C12;
          if (Zvalue[i]>BPopt1) and (Xvalue[i]<BPopt2) then
              Ycalc[i]:=Ag21*Zvalue[i]+Ak22*Xvalue[i]+C21;
          if (Zvalue[i]>BPopt1) and (Xvalue[i]>BPopt2) then
              Ycalc[i]:=Ag21*Zvalue[i]+Ag22*Xvalue[i]+C22;
        end;
      end;

      AuxValue:=0;
      Average:=0;
      for i:=0 to NrOfData-1 do
      begin
        TmpValue:=sqr(Yvalue[i]-Ycalc[i]);
        AuxValue:=AuxValue+TmpValue;
        Average:=Average+Yvalue[i];
      end;
      Average:=Average/NrOfData;
      TmpValue:=0;
      for i:=0 to NrOfData-1 do
          TmpValue:=TmpValue+sqr(Yvalue[i]-Average);
      CexpT := 1-(AuxValue/TmpValue);
      Out1  := format('%10.3e',[CexpT]);

      writeln (outFile);
      writeln (OutFile, ' The overall coefficient of explanation is:',Out1);
      writeln (OutFile);

    if Mode1=1 then
    begin
      writeln (OutFile, ' Serial        Yobs         X          YXr          Z'+
                        '          Ycalc');
      writeln (OutFile, ' ----------------------------------------------------'+
                        '---------------');
    end else
    begin
      writeln (OutFile, ' Serial        Yobs         Z          YZr          X'+
                        '         Ycalc');
      writeln (OutFile, ' ----------------------------------------------------'+
                        '---------------');
    end;

//The following needs to be made straightforward (simplified)}
    if Mode1=1 then
    begin
      for i:=0 to NrOfData-1 do
      begin
        Out1 := format('%12.3e',[Yvalue[i]]);
        Out2 := format('%12.3e',[Xvalue[i]]);
        Out3 := format('%12.3e',[Yres1[i]]);
        Out4 := format('%12.3e',[Zvalue[i]]);
        Out5 := format('%12.3e',[YCalc[i]]);
        writeln (OutFile,i+1:4,'     ',Out1,Out2,Out3,Out4,Out5)
      end;
    end else
    begin
      for i:=0 to NrOfData-1 do
      begin
        Out1 := format('%12.3e',[Yvalue[i]]);
        Out2 := format('%12.3e',[Xvalue[i]]);
        Out3 := format('%12.3e',[Yres1[i]]);
        Out4 := format('%12.3e',[Zvalue[i]]);
        Out5 := format('%12.3e',[YCalc[i]]);
        writeln (OutFile,i+1:4,'     ',Out1,Out4,Out3,Out2,Out5);
      end;
    end;

  end; {with DMSegReg do}

end; {procedure Reg2Final}
{------------------------}


end.

