unit USegRegForm;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ShellApi, StdActns, ActnList, Menus, StdCtrls, ExtCtrls,
  Grids, ComCtrls, Clipbrd, jpeg;

type
  TSerialArrayE = array of TEdit;
  TValuesArrayE = array of TEdit;
  TSegRegForm = class(TBaseForm)
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    Edit: TMenuItem;
    Copy: TMenuItem;
    Cut: TMenuItem;
    Paste: TMenuItem;
    InputOpenDialog: TOpenDialog;
    InputSaveDialog: TSaveDialog;
    PageControl1: TPageControl;
    IntroTabSheet: TTabSheet;
    Figures_TabSheet: TTabSheet;
    Types_Image: TImage;
    InputTabSheet: TTabSheet;
    EditDelete1: TEditDelete;
    IntroMemo: TMemo;
    FileExit1: TFileExit;
    FileNameEdit: TEdit;
    Title2Edit: TEdit;
    OutputOpenDialog: TOpenDialog;
    InputSaveAction: TAction;
    InputOpenAction: TAction;
    OutputOpenAction: TAction;
    FileNameLabel: TLabel;
    Title1Label: TLabel;
    Title2Label: TLabel;
    InputOpenButton: TButton;
    InputSaveButton: TButton;
    InputOpenMenu: TMenuItem;
    PrefComboBox: TComboBox;
    FileItem: TMenuItem;
    OutputOpenMenu: TMenuItem;
    InputSaveMenu: TMenuItem;
    ProgramExit: TMenuItem;
    Title1Edit: TEdit;
    NrOfDataLabel: TLabel;
    NrOfDataEdit: TEdit;
    WeightComboBox: TComboBox;
    HelpOpenButton: TButton;
    HelpMemo: TMemo;
    ExtraMemo: TMemo;
    GraphOpenDialog: TOpenDialog;
    GraphOpenMenu: TMenuItem;
    GraphOpenAction: TAction;
    GraphicsTabSheet: TTabSheet;
    SeeGraphButton: TButton;
    GraphImage: TImage;
    PictureImage: TImage;
    OutputTabSheet: TTabSheet;
    OutputMemo: TMemo;
    ChoicesPanel: TPanel;
    GraphicsRadioGroup: TRadioGroup;
    Y_XRadioButton: TRadioButton;
    YXr_ZRadioButton: TRadioButton;
    Calc_ObsRadioButton: TRadioButton;
    Y_ZRadioButton: TRadioButton;
    GoButton: TButton;
    MakeGraphButton: TButton;
    SaveGraphButton: TButton;
    SaveBlWhButton: TButton;
    GraphSaveDialog: TSaveDialog;
    StringGrid1: TStringGrid;
    AnovaButton: TButton;
    ResultButton: TButton;
    GraphSaveMenu: TMenuItem;
    GraphSaveAction: TAction;
    HelpGroupBox: TGroupBox;
    TypesButton: TButton;
    TestsButton: TButton;
    SequenceButton: TButton;
    MethodsButton: TButton;
    BackButton: TButton;
    TypesMemo: TMemo;
    TestsMemo: TMemo;
    SequenceMemo: TMemo;
    MethodsMemo: TMemo;
    X_ZRadioButton: TRadioButton;
    SymbolsButton: TButton;
    OutputReadDialog: TOpenDialog;
    SelectButton: TButton;
    CalcObs_Button: TButton;
    OptionComboBox: TComboBox;
    PasteMemo: TMemo;
    PasteButton: TButton;
    ClearButton: TButton;
    ConfComboBox: TComboBox;
    ConfLabel: TLabel;
    NrOfVarComboBox: TComboBox;
    GraphicsButton: TButton;
    OutputReadAction: TAction;
    WaitMemo: TMemo;
    ExclComboBox: TComboBox;
    Exclude1Panel: TPanel;
    Exclude1RadioGroup: TRadioGroup;
    ExclX2RadioButton: TRadioButton;
    ExclX3RadioButton: TRadioButton;
    ExclX4RadioButton: TRadioButton;
    ExclX5RadioButton: TRadioButton;
    ExclX6RadioButton: TRadioButton;
    Exclude2Panel: TPanel;
    Exlude2RadioGroup: TRadioGroup;
    ExclZ2RadioButton: TRadioButton;
    ExclZ3RadioButton: TRadioButton;
    ExclZ4RadioButton: TRadioButton;
    ExclZ5RadioButton: TRadioButton;
    ExclZ6RadioButton: TRadioButton;
    PrefXPanel: TPanel;
    PrefXRadioGroup: TRadioGroup;
    PrefX2RadioButton: TRadioButton;
    PrefX3RadioButton: TRadioButton;
    PrefX4RadioButton: TRadioButton;
    PrefX5RadioButton: TRadioButton;
    PrefX6RadioButton: TRadioButton;
    PrefZPanel: TPanel;
    PrefZRadioGroup: TRadioGroup;
    PrefZ2RadioButton: TRadioButton;
    PrefZ3RadioButton: TRadioButton;
    PrefZ4RadioButton: TRadioButton;
    PrefZ5RadioButton: TRadioButton;
    PrefZ6RadioButton: TRadioButton;
    Figures_Button: TButton;
    Conf_Button: TButton;
    Methods_Button: TButton;
    Conf_Image: TImage;
    Conf_Memo: TMemo;
    Methods_Image: TImage;
    BPButton: TButton;
    MoreInfoButton: TButton;
    ConfButton: TButton;
    BlockButton: TButton;
    PartMemo: TMemo;
    InputImage: TImage;
    {Start}
    procedure FormCreate(Sender: TObject);
    procedure IntroTabSheetShow(Sender: TObject);
    procedure TypesButtonClick(Sender: TObject);
    procedure TestsButtonClick(Sender: TObject);
    procedure SequenceButtonClick(Sender: TObject);
    procedure MethodsButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure MoreInfoButtonClick(Sender: TObject);
    {Figures}
    procedure Figures_ButtonClick(Sender: TObject);
    procedure Conf_ButtonClick(Sender: TObject);
    procedure Methods_ButtonClick(Sender: TObject);
    {Input}
    procedure InputTabSheetShow(Sender: TObject);
    procedure InputOpenActionExecute(Sender: TObject);
    procedure NrOfDataEditExit(Sender: TObject);
    procedure NrOfVarComboBoxChange(Sender: TObject);
    procedure OptionComboBoxChange(Sender: TObject);
    procedure ConfComboBoxChange(Sender: TObject);
    procedure HelpOpenButtonClick(Sender: TObject);
    function  StringToFloat(Str : string) : double;
    procedure StringGrid1SetEditText(Sender: TObject; ACol,
                        ARow: Integer; const Value: String);
    procedure HandlePasteMultiCell(Sender: TObject; ACol,
                        ARow: Integer; const Value: String);
    procedure PasteButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure InputSaveActionExecute(Sender: TObject);
    {Output}
    procedure OutputTabSheetShow(Sender: TObject);
    procedure OutputOpenActionExecute(Sender: TObject);
    procedure AnovaButtonClick(Sender: TObject);
    procedure SymbolsButtonClick(Sender: TObject);
    procedure GraphicsButtonClick(Sender: TObject);
    procedure OutputTabSheetExit(Sender: TObject);
    {graphics}
    procedure GraphicsTabSheetShow(Sender: TObject);
    procedure GraphOpenActionExecute(Sender: TObject);
    procedure MakeGraphButtonClick(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure ConfButtonClick(Sender: TObject);
    procedure BlockButtonClick(Sender: TObject);
    procedure CalcObs_ButtonClick(Sender: TObject);
    procedure BPbuttonClick(Sender: TObject);
    procedure GraphSaveActionExecute(Sender: TObject);
    procedure SaveBlWhButtonClick(Sender: TObject);
    procedure OutputReadActionExecute(Sender: TObject);
    {Close}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    NoSave, InputOpened,
    Import, Color, Removed, 
    GraphOpened, OutputOpened,
    ConfBelt, ConfBlock       : boolean;
    InitNrOfData, Finish      : integer;
    InitNrOfVar, RefNr        : integer;
    InitDir, AuxFile          : string;
    procedure EnterData (var Finish : integer);
    function SetAndVerifySaveName : boolean;
    procedure UncheckRadioButtons;
    procedure DoCalculations;
    procedure ShowGraphics1;                      {without BP}
    procedure ShowGraphics2;                      {with BP}
    procedure SetInitialDir (AuxDir:string);
  public
    { Public declarations }
  end;

var
  SegRegForm: TSegRegForm;

implementation

uses UDMSegReg, URegres1, URegres2, UAnova, UFinishForm, USegRegUtils,
     UsymbolsForm, UHelpForm, UInfoForm;

{$R *.dfm}


{----------------------------------------------------------------------
 START
 ----------------------------------------------------------------------}


procedure TSegRegForm.FormCreate(Sender: TObject);
begin
  inherited;
      PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
      getdir (0,InitDir);
      SetInitialDir (InitDir);
      InputOpened := false;
      OutputOpened := false;
      GraphOpened := false;
      FileNameLabel.Visible := false;
      FileNameEdit.Visible := false;
      Color:=true;
      ConfBelt:=true;
      ConfBlock:=true;
      LX := posX2-posX1;
      LY := posY2-posY1;
      Left := 100;
      If screen.width > 860 then
            width := 860
      else if screen.width < width then
      begin
            Left:=5;
            width := screen.width-5;
      end;
end;{TSegRegForm.FormCreate}


{----------------------------------------------------------------------
 INTRO
 ----------------------------------------------------------------------}


procedure TSegRegForm.IntroTabSheetShow(Sender: TObject);
begin
  inherited;
  {hier wordt de IntroMemo getoond}
  StatusText ('Click on the Input tab to proceed.');
  InputSaveMenu.Enabled := false;
  GraphSaveMenu.Enabled := false;
  IntroMemo.Visible := true;
  TestsMemo.Visible := false;
  Testsmemo.Visible := false;
  SequenceMemo.Visible := false;
  MethodsMemo.Visible := false;
  MoreInfoButton.Visible := false;
end;


procedure TSegRegForm.TypesButtonClick(Sender: TObject);
begin
  inherited;
  IntroMemo.Visible := false;
  TypesMemo.Visible := true;
  Testsmemo.Visible := false;
  SequenceMemo.Visible := false;
  MethodsMemo.Visible := false;
  MoreInfoButton.Visible := false;
  MoreInfoForm.Hide;
end;


procedure TSegRegForm.TestsButtonClick(Sender: TObject);
begin
  inherited;
  IntroMemo.Visible := false;
  TypesMemo.Visible := false;
  Testsmemo.Visible := true;
  SequenceMemo.Visible := false;
  MethodsMemo.Visible := false;
  MoreInfoButton.Visible := true;
end;


procedure TSegRegForm.SequenceButtonClick(Sender: TObject);
begin
  inherited;
  IntroMemo.Visible := false;
  TypesMemo.Visible := false;
  Testsmemo.Visible := false;
  SequenceMemo.Visible := true;
  MethodsMemo.Visible := false;
  MoreInfoButton.Visible := false;
  MoreInfoForm.Hide;
end;


procedure TSegRegForm.MethodsButtonClick(Sender: TObject);
begin
  inherited;
  IntroMemo.Visible := false;
  TypesMemo.Visible := false;
  Testsmemo.Visible := false;
  SequenceMemo.Visible := false;
  MethodsMemo.Visible := true;
  MoreInfoButton.Visible := false;
  MoreInfoForm.Hide;
end;


procedure TSegRegForm.BackButtonClick(Sender: TObject);
begin
  inherited;
  IntroMemo.Visible := true;
  TypesMemo.Visible := false;
  Testsmemo.Visible := false;
  SequenceMemo.Visible := false;
  MethodsMemo.Visible := false;
  MoreInfoButton.Visible := false;
  MoreInfoForm.Hide;
end;


procedure TSegRegForm.MoreInfoButtonClick(Sender: TObject);
begin
  inherited;
  MoreInfoForm.Show;
end;


{----------------------------------------------------------------------
 Figures
 ----------------------------------------------------------------------}


procedure TSegRegForm.Figures_ButtonClick(Sender: TObject);
begin
  inherited;
  Types_Image.Visible := true;
  Conf_Image.Visible := false;
  Conf_Memo.Visible := false;
  Methods_Image.Visible := false;
end;


procedure TSegRegForm.Conf_ButtonClick(Sender: TObject);
begin
  inherited;
  Types_Image.Visible := false;
  Conf_Image.Visible := true;
  Conf_Memo.Visible := true;
  Methods_Image.Visible := false;
end;


procedure TSegRegForm.Methods_ButtonClick(Sender: TObject);
begin
  inherited;
  Types_Image.Visible := false;
  Conf_Image.Visible := false;
  Conf_Memo.Visible := false;
  Methods_Image.Visible := true;
end;


{----------------------------------------------------------------------
 INPUT
 ----------------------------------------------------------------------}


procedure TSegRegForm.InputTabSheetShow(Sender: TObject);
begin
  inherited;
      StatusText('Enter data or use "Open" to edit existing data.' +
            ' Then use "Save-Calculate".');
      HelpMemo.Hide;
      InputSaveMenu.Enabled := true;
      InputSaveButton.Visible := true;
      Import := false;
      OutputMemo.Visible := false;
      GraphicsButton.Visible := false;
      SymbolsButton.Visible := false;
      BPbutton.Visible :=false;
      HelpForm.Hide;
      AnovaButton.Visible := false;
      GraphImage.Visible := false;
      PictureImage.Visible:=false;
      GraphOpened :=false;
      SaveGraphButton.Visible := false;
      SaveBlWhButton.Visible := false;
      SelectButton.Visible := false;
      if not InputOpened then
      begin
        FileNameLabel.Visible:=false;
        FileNameEdit.Visible:=false;
        InitNrOfData:=15;
        DMSegReg.NrOfVar := 1;
        DMSegReg.NrOfData:=15;
        Finish := 15;
        StringGrid1.RowCount := 15;
        Title1Edit.Text:='';
        Title2Edit.Text:='';
        setlength (DMSegReg.Yvalue,16);
        setlength (DMSegReg.Xvalue,16);
        setlength (DMSegReg.Zvalue,16);
        EnterData(Finish);
        exit;
      end else
        StringGrid1.RowCount := DMSegReg.NrOfData+1;
      DMSegReg.NrOfVar:=InitNrOfVar;
      StringGrid1.ColCount := DMSegReg.NrOfVar+2;
      StringGrid1.ColWidths[0] := 45;
      StringGrid1.ColWidths[1] := 75;
      StringGrid1.ColWidths[2] := 75;
      if DMSegReg.NrOfVar=2 then
         StringGrid1.ColWidths[3] := 75;
      UncheckRadioButtons;

end; {TSegRegForm.InputTabSheetShow}
{----------------------------------}



procedure TSegRegForm.StringGrid1SetEditText(Sender: TObject; ACol,
                      ARow: Integer; const Value: String);
{-----------------------------------------------------------------}
var MultiPaste:boolean;
begin
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are no data to be pasted or some of the data'+
                     ' are invalid.');
        InputTabsheet.Show;
        exit;
      end;
    end;
  end;
  Import:=true;
  NrOfDataEditExit(Sender);
  setlength (DMSegReg.FileLine,6);
  Import := false;
  InputOpened := true;

end; {TSegRegForm.StringGrid1SetEditText}
{---------------------------------------}



procedure TSegRegForm.HandlePasteMultiCell(Sender: TObject; ACol,
                      ARow: Integer; const Value: String);
{---------------------------------------------------------------}
// only accepts numbers to be pasted into the grid
  var
   i, m, j, Kr, StartCol, StartRow: integer;
   c: char ;
   Result : boolean;

begin
  m := Length(Value);
  (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
  StartCol := ACol;
  StartRow := ARow;
  i := 1;
  Kr := 2;
  while i <= m do begin
// loop through the characters of the Value string
    c := Value[i];
    j := Integer(c);
    if j = 9 then
    begin // tab: Move to next column
      ACol := ACol + 1 ;
      if i < m then // empty the cell if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else if j = 13 then
    begin // CR - is followed by LF
         // Move to next row, jump back to startcolumn
      StringGrid1.RowCount:=Kr;
      Kr:=Kr+1;
      ARow := ARow + 1 ;
      ACol := startcol ;
      i := i + 1 ; // skip the LF
      if i < m then // empty the cell it if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else // add the character to the string in the cell if a number
    if c in [DecimalSeparator,'-',#48,#49,#50,#51,#52,#53,#54,#55,#56,#57] then
        (Sender as TStringGrid).Cells[ACol,ARow] :=
          ConCat((Sender as TStringGrid).Cells[ACol,ARow], c);
    i := i + 1 ;
  end;
  StringGrid1.FixedCols:=1;
  StringGrid1.FixedRows:=1;
  StringGrid1.RowCount:=StringGrid1.RowCount+StartRow-1;
  with DMSegReg do
  begin
    NrOfData:=StringGrid1.RowCount-1;
    if NrOfData<InitNrOfData then
    begin
      Result := Question('The number of data is less than the original'+
                ' number. Do you want to maintain the original number?');
      if Result then
      begin
        NrOfData:=InitNrOfData;
        StringGrid1.RowCount:=InitNrOfData+1;
      end else
        if RefNr>NrOfData then RefNr:=NrOfData;
    end;
    NrOfDataEdit.Text:=IntToStr(NrOfData);
    for i:=1 to NrOfData do StringGrid1.Cells[0,i]:=IntToStr(i);
    NrOfValues:=NrOfData;
    Finish:=NrOfData;
    NrOfVar:=StringGrid1.ColCount-2;
    InitNrOfVar:=NrOfVar;
    NrOfVarComboBox.ItemIndex:=NrOfVar-1;
    if NrOfData>InitNrOfData then setlength (SerialNr,NrOfData+1);
    if NrOfData>InitNrOfData then setlength (YValue,NrOfData+1);
    if NrOfData>InitNrOfData then setlength (XValue,NrOfData+1);
    for i:=0 to NrOfData-1 do
    begin
      SerialNr[i]:=StrToInt(StringGrid1.Cells[0,i+1]);
      YValue[i]:=StringToFloat(StringGrid1.Cells[1,i+1]);
      XValue[i]:=StringToFloat(StringGrid1.Cells[2,i+1]);
      if NrOfVar=2 then
      begin
        if NrOfData>InitNrOfData then setlength (ZValue,i+1);
           ZValue[i]:=StringToFloat(StringGrid1.Cells[3,i+1])
      end;
    end; {for i:=0 to NrOfData-1 do}
    setlength (ToBeRemoved,NrOfData+1);
    for i:=0 to NrOfData-1 do ToBeRemoved[i]:=false;
    if NrOfvar=2 then StringGrid1.Cells[3,0] := '    Z';
    StringGrid1.ColCount := 2+NrOfVar;
    StringGrid1.Width := 55 + (NrOfVar+1)*75;
    if DMSegReg.NrOfData>12 then
       StringGrid1.Width := 75 + (NrOfVar+1)*75;
     if NrOfVar=2 then StringGrid1.ColWidths[3] := 75;
  end; {with DMSegReg do}
  InitNrOfData:=DMSegReg.NrOfData;
end; {TSegRegForm.HandlePasteMultiCell}
{-------------------------------------}



procedure TSegRegForm.PasteButtonClick(Sender: TObject);
{------------------------------------------------------}
begin
  inherited;
  PasteMemo.Visible := not PasteMemo.Visible;
  if PasteMemo.Visible then
  begin
     PasteButton.Caption := 'Close paste';
     StringGrid1.Visible := false;
     ClearButton.Enabled := false;
     HelpOpenButton.Enabled := false;
     InputSaveButton.Enabled := false;
     InputOpenButton.Enabled := false;
  end
  else
  begin
     PasteButton.Caption := 'Paste help';
     StringGrid1.Visible := true;
     ClearButton.Enabled := true;
     HelpOpenButton.Enabled := true;
     InputSaveButton.Enabled := true;
     InputOpenButton.Enabled := true;
  end;
end; {TSegRegForm.PasteButtonClick}
{---------------------------------}



procedure TSegRegForm.ClearButtonClick(Sender: TObject);
var Result : boolean;
begin
  inherited;
  Result := DMSegReg.Question('The data will be cleared, are you sure?');
  if Result then
  begin
    FormCreate(Sender);
    InputTabsheetShow(Sender);
  end;
end; {TSegRegForm.ClearButtonClick}
{---------------------------------}



procedure TSegRegForm.EnterData(var Finish : integer);
{----------------------------------------------------}
var k: integer;
begin
      NrOfDataEdit.Text:=IntToStr(DMSegReg.NrOfData);
      StringGrid1.ColCount := DMSegReg.NrOfVar + 2;
      StringGrid1.RowCount := Finish+1;
      SetLength(DMSegReg.ToBeRemoved,Finish);
      NrOfVarComboBox.ItemIndex:=DMSegReg.NrOfVar-1;
      StringGrid1.EditorMode := true;
      SetLength(DMSegReg.Zvalue,Finish+1);
      SetLength(DMSegReg.SerialNr,Finish+1);
      For k := 0 to Finish do with DMSegReg do
      begin
        if not InputOpened then
        begin
          StringGrid1.RowHeights[k] := 20;
          if k=0 then
          begin
             StringGrid1.Cells[0,k] :='Serial';
             StringGrid1.Cells[1,k] := '    Y';
             StringGrid1.Cells[2,k] := '    X';
             if NrOfVar=2 then
               StringGrid1.Cells[3,k] := '    Z';
          end else
          begin
            StringGrid1.Cells[0,k] := IntToStr(k);
            StringGrid1.Cells[1,k] := '0';
            StringGrid1.Cells[2,k] := '0';
            if NrOfVar=2 then
              StringGrid1.Cells[3,k] := '0';
          end;
        end else
        begin
          if (k=0) then
          begin
            if NrOfVar=2 then
              StringGrid1.Cells[3,k] := '    Z'
          end else
          begin
            StringGrid1.Cells[0,k] := IntToStr(DMSegReg.SerialNr[k-1]);
            if k<=RefNr then
               StringGrid1.Cells[1,k] := FloatToStr(DMSegReg.Yvalue[k-1])
            else StringGrid1.Cells[1,k] :='';
            if k<=RefNr then
               StringGrid1.Cells[2,k] := FloatToStr(DMSegReg.Xvalue[k-1])
            else StringGrid1.Cells[2,k] :='';
            StringGrid1.Cells[3,k] := '1';
            if NrOfVar=2 then
            begin
              if k<= RefNr then
                 StringGrid1.Cells[3,k] := FloatToStr(DMSegReg.Zvalue[k-1])
              else StringGrid1.Cells[2,k] :='';
                 StringGrid1.Cells[4,k] := '1';
            end;
            DMSegReg.ToBeRemoved[k-1] := false;
          end;
        end;
      end;

      if Removed then for k := 1 to Finish do with DMSegReg do
      begin
            StringGrid1.Cells[0,k] := IntToStr(DMSegReg.SerialNr[k-1]);
               StringGrid1.Cells[1,k] := FloatToStr(Yvalue[k-1]);
               StringGrid1.Cells[2,k] := FloatToStr(Xvalue[k-1]);
               StringGrid1.Cells[3,k] := '1';
            if DMSegReg.NrOfVar=2 then
               StringGrid1.Cells[3,k] := FloatToStr(Zvalue[k-1]);
      end;

      if DMSegReg.NrOfVar=2 then
         StringGrid1.ColWidths[3] := 75;
      StringGrid1.Width := 55 + (DmSegReg.NrOfVar+1)*75;
      if DMSegReg.NrOfData>12 then
         StringGrid1.Width := 75 + (DmSegReg.NrOfVar+1)*75;
      InitNrOfData:= DMSegReg.NrOfData;
      DMSegReg.TmpNrOfData := InitNrOfData;
end; {TSegRegForm.EnterData}
{--------------------------}


{ see also InputOpenActionExecute in the MenuItems at the end}


procedure TSegRegForm.NrOfDataEditExit(Sender: TObject);
{------------------------------------------------------}
var NumDat, k: integer; HlpStr : string;
begin
  inherited;
    if NrOfDataEdit.Text = '' then exit;
    Try
         NumDat := StrToInt(NrOfDataEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The number of data is not a valid integer');
        exit;
      end;
    end;
    if NumDat<10 then
    begin
      Showmessage (' The minimum number of data is 10');
      exit;
    end;
    if not Import and (NumDat>InitNrOfData) then
    begin
       Showmessage (' Add data in the last cells at the end of the column');
       for k:=1 to InitNrOfData do with DMSegReg do
       begin
         if k>Numdat then SetLength(SerialNr,k+1);
         if k>NumDat then SetLength (Yvalue,k+1);
         if k>NumDat then SetLength (Xvalue,k+1);
         if DMSegReg.NrOfVar=2 then if k>NumDat then SetLength (Zvalue,k+1);
         SerialNr[k-1]:= StrToInt(StringGrid1.Cells[0,k]);
         Yvalue[k-1]:= StringToFloat(StringGrid1.Cells[1,k]);
         Xvalue[k-1]:= StringToFloat(StringGrid1.Cells[2,k]);
         if DMSegReg.NrOfVar=2 then
            Zvalue[k-1]:= StringToFloat(StringGrid1.Cells[3,k]);
       end; {for k:=1 to InitNrOfData do with DMSegReg do}
       if NumDat>InitNrOfData then
       begin
         SetLength(DMSegReg.SerialNr,NumDat+1);
         SetLength(DMSegReg.Yvalue,NumDat+1);
         SetLength(DMSegReg.Xvalue,NumDat+1);
         SetLength(DMSegReg.Zvalue,NumDat+1);
       end;
       for k:=InitNrOfData+1 to NumDat do
       begin
         DMSegReg.SerialNr[k-1]:= k;
         HlpStr:=floattostr (DMSegReg.Yvalue[k-1]);
//         if Hlpstr='' then DMSegReg.Yvalue[k-1]:= 0;
         HlpStr:=floattostr (DMSegReg.Xvalue[k-1]);
//         if Hlpstr='' then DMSegReg.Xvalue[k-1]:= 0;
         if DMSegReg.NrOfVar>1 then
         begin
           HlpStr:=floattostr (DMSegReg.Xvalue[k-1]);
//           if Hlpstr='' then DMSegReg.Zvalue[k-1]:= 0;
         end;
       end; {for k:=InitNrOfData+1 to NumDat do}
       RefNr:= DMSegReg.NrOfData;
       DMSegReg.NrOfData := NumDat;
       StringGrid1.RowCount := NumDat;
       InitNrOfData := NumDat;
       Finish := NumDat;
       EnterData(Finish);
    end;
    if not Import and (NumDat<InitNrOfData) then
       Showmessage (' To remove data make the relevant data cells empty');
    if not Import and (NumDat>InitNrOfData) then
       Showmessage (' To remove data make the relevant data cells empty');
end; {TSegRegForm.NrOfDataEditExit}
{---------------------------------}


procedure TSegRegForm.NrOfVarComboBoxChange(Sender: TObject);
{-----------------------------------------------------------}
begin
  inherited;
     if NrOfVarComboBox.ItemIndex<1 then DMSegReg.NrOfVar:=1
     else DMSegReg.NrOfVar:=2;
     StringGrid1.ColCount := 2+DMSegReg.NrOfVar;
     if DMSegReg.NrOfVar=2 then
     begin
       StringGrid1.ColWidths[3] := 75;
       StringGrid1.Width := 555 + 3*75;
       if DMSegReg.NrOfData>12 then
          StringGrid1.Width := 75+ 3*75;
       InputImage.Visible:=false;
     end;
     if DMSegReg.NrOfVar=2 then setlength (DMSegReg.ZValue,DMSEgReg.NrOfData+1);
     if not Import then EnterData (Finish);
     InputTabsheet.Show;
end; {TSegRegForm.NrOfVarComboBoxChange}
{--------------------------------------}



procedure TSegRegForm.OptionComboBoxChange(Sender: TObject);
{----------------------------------------------------------}
begin
  inherited;
  if OptionComboBox.ItemIndex<1 then
  begin
    DMSegReg.Option:=3;
    DMSegReg.NrOfVar:=2;
    if PrefComboBox.ItemIndex<1 then
    begin
      PrefComboBox.Text:='            Preference: best of all';
      PrefXPanel.Visible:=false;
      PrefZPanel.Visible:=false;
    end else
    begin
      ExclComboBox.ItemIndex:=0;
      ExclComboBox.Text:='         Exclusion: not applicable';
      PrefXRadioGroup.Caption:='   X variable   ';
      PrefXPanel.Left:=472;
      PrefXPanel.Visible:=true;
      PrefZPanel.Left:=616;
      PrefZPanel.Visible:=true;
    end;
    if ExclComboBox.ItemIndex<1 then
    begin
      PrefComboBox.Text:='            Preference: best of all';
      Exclude1Panel.Visible:=false;
      Exclude2Panel.Visible:=false;
    end else
    begin
      PrefComboBox.Text:='           Preference: not applicable';
      Exclude1RadioGroup.Caption:='  X variable ';
      Exclude1Panel.Left:=544;
      Exclude1Panel.Visible:=true;
      Exclude2Panel.Visible:=false;
    end;
  end else
  if OptionComboBox.ItemIndex=1 then
  begin
    DMSegReg.Option:=1;
    DMSegReg.NrOfVar:=1;
    if PrefComboBox.ItemIndex<1 then
    begin
      ExclComboBox.Text:='      No exclusion of regression types';
      PrefXPanel.Visible:=false;
      PrefZPanel.Visible:=false;
    end else
    begin
      ExclComboBox.ItemIndex:=0;
      ExclComboBox.Text:='         Exclusion: not applicable';
      PrefXRadioGroup.Caption:='   X variable   ';
      PrefXPanel.Left:=544;
      PrefXPanel.Visible:=true;
      PrefZPanel.Visible:=false;
    end;
    if ExclComboBox.ItemIndex<1 then
    begin
      PrefComboBox.Text:='            Preference: best of all';
      Exclude1Panel.Visible:=false;
      Exclude2Panel.Visible:=false;
    end else
    begin
      PrefComboBox.Text:='           Preference: not applicable';
      Exclude1RadioGroup.Caption:='  X variable ';
      Exclude1Panel.Left:=544;
      Exclude1Panel.Visible:=true;
      Exclude2Panel.Visible:=false;
    end;
  end else
  begin
    DMSegReg.Option:=2;
    DMSegReg.NrOfVar:=1;
    if PrefComboBox.ItemIndex<1 then
    begin
      PrefXPanel.Visible:=false;
      PrefZPanel.Visible:=false;
    end else
    begin
      ExclComboBox.ItemIndex:=0;
      PrefXRadioGroup.Caption:='   Z variable   ';
      PrefXPanel.Left:=544;
      PrefXPanel.Visible:=true;
      PrefZPanel.Visible:=false;
    end;
    if ExclComboBox.ItemIndex<1 then
    begin
      Exclude1Panel.Visible:=false;
      Exclude2Panel.Visible:=false;
    end else
    begin
      PrefComboBox.ItemIndex:=0;
      Exclude1RadioGroup.Caption:='  Z variable ';
      Exclude1Panel.Left:=544;
      Exclude1Panel.Visible:=true;
      Exclude2Panel.Visible:=false;
    end;
  end;
end; {TMainForm.OptionComboBoxChange}
{-----------------------------------}



procedure TSegRegForm.ConfComboBoxChange(Sender: TObject);
{--------------------------------------------------------}
begin
  inherited;
  if ConfComboBox.ItemIndex<1 then Alfa:=1.75;
  if ConfComboBox.ItemIndex=1 then Alfa:=2.1;
  if ConfComboBox.ItemIndex=2 then Alfa:=2.5;
end; {TSegRegForm.ConfComboBoxChange}
{-----------------------------------}



procedure TSegRegForm.HelpOpenButtonClick(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  HelpMemo.Visible := not HelpMemo.Visible;
  if HelpMemo.Visible then
  begin
     HelpOpenButton.Caption := 'Close symbols';
     StringGrid1.Visible := false;
     ClearButton.Enabled := false;
     PasteButton.Enabled := false;
     InputSaveButton.Enabled := false;
     InputOpenButton.Enabled := false;
  end
  else
  begin
     HelpOpenButton.Caption := 'Symbols help ';
     StringGrid1.Visible := true;
     ClearButton.Enabled := true;
     PasteButton.Enabled := true;
     InputSaveButton.Enabled := true;
     InputOpenButton.Enabled := true;
  end;
end; {TSegRegForm.HelpButtonClick}
{--------------------------------}



procedure TSegRegForm.UncheckRadioButtons;
{----------------------------------------}
begin
    SegRegForm.ExclX2RadioButton.Checked := false;
    SegRegForm.ExclX3RadioButton.Checked := false;
    SegRegForm.ExclX4RadioButton.Checked := false;
    SegRegForm.ExclX5RadioButton.Checked := false;
    SegRegForm.ExclX6RadioButton.Checked := false;
    SegRegForm.ExclZ2RadioButton.Checked := false;
    SegRegForm.ExclZ3RadioButton.Checked := false;
    SegRegForm.ExclZ4RadioButton.Checked := false;
    SegRegForm.ExclZ5RadioButton.Checked := false;
    SegRegForm.ExclZ6RadioButton.Checked := false;
    SegRegForm.PrefX2RadioButton.Checked := false;
    SegRegForm.PrefX3RadioButton.Checked := false;
    SegRegForm.PrefX4RadioButton.Checked := false;
    SegRegForm.PrefX5RadioButton.Checked := false;
    SegRegForm.PrefX6RadioButton.Checked := false;
    SegRegForm.PrefZ2RadioButton.Checked := false;
    SegRegForm.PrefZ3RadioButton.Checked := false;
    SegRegForm.PrefZ4RadioButton.Checked := false;
    SegRegForm.PrefZ5RadioButton.Checked := false;
    SegRegForm.PrefZ6RadioButton.Checked := false;
end; {procedure UncheckRadioButtons}
{----------------------------------}



function TSegRegForm.SetAndVerifySaveName;
{----------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSaveDialog.Execute then
      begin DMSegReg.FileName := InputSaveDialog.Files.Strings[0];
            If FileExists(DMSegReg.FileName)
            then  Result := DMSegReg.
                         Question('The file already exists, overwrite?')
            else  Result := true;
      end
      else NoSave:=true;
end; {TSegRegForm.SetAndVerifySaveName}
{-------------------------------------}


{ See InputSaveActionExecute in the MenuItems group at the end}


procedure TSegRegForm.DoCalculations;
{-----------------------------------}

begin

  WaitMemo.Visible:=true;
  WaitMemo.Lines.Clear;
  WaitMemo.Lines.Add(' Saving data .....');
  Sleep(500);
  WaitMemo.Lines.Add(' Progress 25% ....');

  if DMSegReg.NrOfData > 2000 then
  begin
    Sleep(500);
    WaitMemo.Lines.Add(' Many data ......');
    WaitMemo.Lines.Add(' This takes time ...');
  end;

  DecimalSeparator:='.';
  if (DMSegReg.NrOfVar=1) then
  begin
    Regr1;
    if NotFit then
    begin
      WaitMemo.Visible:=false;
      exit;
    end;
  end;
  if (DMSegReg.NrOfVar=2) then
  begin
    Regr2;
    if NotFit then
    begin
      WaitMemo.Visible:=false;
      exit;
    end;
  end;
  WaitMemo.Lines.Add(' Calculating ....');
  Sleep(500);
  WaitMemo.Lines.Add(' Anova table ....');
  MessageShown:=false;
  AnovaTable;
  Sleep(500);
  GraphSaveAction.Enabled := true;
  WaitMemo.Lines.Add(' Progress 75% ...');
  Sleep(500);
  if (DMSegReg.NrOfVar=1) then
     begin
      if PrefX2RadioButton.Checked then if URegres1.Jtype<>2 then
         Showmessage ('Type 2 is preferred but statistically not acceptable');
      if PrefX3RadioButton.Checked then if URegres1.Jtype<>3 then
         Showmessage ('Type 3 is preferred but statistically not acceptable');
      if PrefX4RadioButton.Checked then if URegres1.Jtype<>4 then
         Showmessage ('Type 4 is preferred but statistically not acceptable');
      if PrefX5RadioButton.Checked then if URegres1.Jtype<>5 then
         Showmessage ('Type 5 is preferred but statistically not acceptable');
    end;
  if (DMSegReg.Option=3) then with DMSegReg do
  begin
    ReadXZCode;
    if XZCode='X' then
    begin
      if PrefX2RadioButton.Checked then if URegres2.Jtype1<>2 then
         Showmessage ('Type 2 is preferred for X but it is statistically'+
                      ' not acceptable');
      if PrefX3RadioButton.Checked then if URegres2.Jtype1<>3 then
         Showmessage ('Type 3 is preferred for X but it is statistically'+
                      ' not acceptable');
      if PrefX4RadioButton.Checked then if URegres2.Jtype1<>4 then
         Showmessage ('Type 4 is preferred for X but it is statistically'+
                      ' not acceptable');
      if PrefX5RadioButton.Checked then if URegres2.Jtype1<>5 then
         Showmessage ('Type 5 is preferred for X but it is statistically'+
                      ' not acceptable');
      if PrefZ2RadioButton.Checked then if URegres2.Jtype2<>2 then
         Showmessage ('Warning 2 - Type 2 is preferred for Z but it is'+
                      ' statistically not acceptable');
      if PrefZ3RadioButton.Checked then if URegres2.Jtype2<>3 then
         Showmessage ('Warning 2 - Type 3 is preferred for Z but it is'+
                      ' statistically not acceptable');
      if PrefZ4RadioButton.Checked then if URegres2.Jtype2<>4 then
         Showmessage ('Warning 2 - Type 4 is preferred for Z but it is'+
                      ' statistically not acceptable');
      if PrefZ5RadioButton.Checked then if URegres2.Jtype2<>5 then
         Showmessage ('Warning 2 - Type 5 is preferred for Z but it is'+
                      ' statistically not acceptable');
    end {if XZcode='X'} else  {if XZcode='Z'}
    begin
      if PrefZ2RadioButton.Checked then if URegres2.Jtype1<>2 then
         Showmessage ('Type 2 is preferred for Z but it is statistically'+
                      ' not acceptable');
      if PrefZ3RadioButton.Checked then if URegres2.Jtype1<>3 then
         Showmessage ('Type 3 is preferred for Z but it is statistically'+
                      ' not acceptable');
      if PrefZ4RadioButton.Checked then if URegres2.Jtype1<>4 then
         Showmessage ('Type 4 is preferred for Z but it is statistically'+
                      ' not acceptable');
      if PrefZ5RadioButton.Checked then if URegres2.Jtype1<>5 then
         Showmessage ('Type 5 is preferred for Z but it is statistically'+
                      ' not acceptable');
      if PrefX2RadioButton.Checked then if URegres2.Jtype2<>2 then
         Showmessage ('Warning 2 - Type 2 is preferred for X but it is'+
                      ' statistically not acceptable');
      if PrefX3RadioButton.Checked then if URegres2.Jtype2<>3 then
         Showmessage ('Warning 2 - Type 3 is preferred for X but it is'+
                      ' statistically not acceptable');
      if PrefX4RadioButton.Checked then if URegres2.Jtype2<>4 then
         Showmessage ('Warning 2 - Type 4 is preferred for X but it is'+
                      ' statistically not acceptable');
      if PrefX5RadioButton.Checked then if URegres2.Jtype2<>5 then
         Showmessage ('Warning 2 - Type 5 is preferred for X but it is'+
                      ' statistically not acceptable');
    end;
  end;

end; {TSegRegForm.DoCalculations}
{-------------------------------}

{---------------------------------------------------------------------
 End of Input, start of OUTPUT
----------------------------------------------------------------------}

procedure TSegRegForm.OutputTabSheetShow(Sender: TObject);
begin
  inherited;
        StatusText ('The output file can be inspected');
        InputSaveMenu.Enabled := false;
        GraphSaveMenu.Enabled := false;
        GraphImage.Visible := false;
        PictureImage.Visible:=false;
        GraphOpened := false;
        SaveGraphButton.Visible := false;
        SaveBlWhButton.Visible := false;
        SelectButton.Visible := false;
        BPbutton.Visible := false;
        HelpForm.Hide;
        if not OutputOpened then
        begin
          OutputMemo.Visible := false;
          AnovaButton.Visible := false;
          SymbolsButton.Visible :=false;
          GraphicsButton.Visible := false;
        end;
end; {TSegRegForm.OutputTabSheetShow}


{ see also OutputOpenActionExecute in the Menu Items at the end}


procedure TSegRegForm.AnovaButtonClick(Sender: TObject);
var k : integer;
    OutputOK : boolean;
begin
  inherited;
  OutputTabsheet.Hide;
  if AnovaButton.Caption='Anova table' then
  begin
    AnovaButton.Caption := 'Close Anova';
    DMSegReg.FileName := ChangeFileExt (DMSegReg.FileName,'.var');
    DMSegReg.ReadOutputLines (DMSegReg.FileName,OutputOK,'.var');
    if not OutputOk then exit;
    OutputMemo.Lines.Clear;
    for k:=1 to DMSegReg.NrOfLines do
        OutputMemo.Lines.Add(DMSegReg.OutLine[k-1]);
    SymbolsButton.Visible := false;
    SymbolsForm.Hide;
    GraphicsButton.Visible := false;
    OutputTabsheet.Show;
  end else
  begin
    AnovaButton.Caption := 'Anova table';
    SymbolsButton.Caption := 'Symbols';
    DMSegReg.FileName := ChangeFileExt (DMSegReg.FileName,'.out');
    DMSegReg.ReadOutputLines (DMSegReg.FileName,OutputOK,'.out');
    OutputMemo.Lines.Clear;
    for k:=1 to DMSegReg.NrOfLines do
      OutputMemo.Lines.Add(DMSegReg.OutLine[k-1]);
    SymbolsButton.Visible := true;
    GraphicsButton.Visible := true;
  end;
  OutputTabsheet.Show;
end; {TMainForm.AnovaButtonClick}



procedure TSegRegForm.SymbolsButtonClick(Sender: TObject);
begin
  inherited;
  SymbolsForm.Show;
end;



procedure TSegRegForm.OutputTabSheetExit(Sender: TObject);
{var i:integer;}
begin
  inherited;
  SymbolsForm.Hide;
end; {TSegRegForm.OutputTabSheetExit}

{-----------------------------------------------------------------------
 End of Output, start of Graphics
 -----------------------------------------------------------------------}

procedure TSegRegForm.GraphicsTabSheetShow(Sender: TObject);
begin
  inherited;
    InputSaveMenu.Enabled := false;
    Statustext ('Graphics presentations of output data can be seen and saved');
    if not GraphOpened then
    begin
      GraphSaveMenu.Enabled := false;
      SaveGraphButton.Visible := false;
      SaveBlWhButton.Visible := false;
      SelectButton.Visible := false;
      BPbutton.Visible :=false;
      HelpForm.Hide;
    end;
end; {TSegRegForm.GraphicsTabSheetShow}


procedure TSegRegForm.MakeGraphButtonClick(Sender: TObject);
begin
  inherited;
  showmessage ('Determine folder and file name for graph creation');
  OutputOpenActionExecute (Sender);
end;


{ see also OutputReadActionExecute and GraphOpenActionExecute
  in the MenuItems group at the end}


procedure TSegRegForm.GoButtonClick(Sender: TObject);
begin
  inherited;

    if ConfButton.Caption='Restore conf. belt' then
    begin
      ConfButton.Caption:='Remove conf. belt';
      ConfBelt:=true;
    end;
    if BlockButton.Caption='Restore conf. block' then
    begin
      BlockButton.Caption:='Remove conf. block';
      ConfBlock:=true;
    end;

    if DMSegReg.Code=' Fun' then CalcObs_Button.Visible:=true
    else CalcObs_Button.Visible:=false;

     if Y_XRadioButton.Checked then GraphType:=1
     else if YXr_ZRadioButton.Checked then GraphType:=2
     else if Calc_ObsRadioButton.Checked then GraphType:=3
     else if Y_ZRadioButton.Checked then GraphType:=4
     else if X_ZRadioButton.Checked then GraphType:=5
     else
     begin
       Showmessage (' The desired type of graph could not be assessed');
       exit;
     end;
     if DMSegReg.Code=' Fun' then GraphType:=0;
     if GraphType=1 then
     begin
       AvXall:=AvXall1;
       StdAall :=StdAall1;
       StdYRall := StdYRall1;
       ConfButton.Visible:=true;
     end;
     if GraphType=2 then
     begin
       AvXall:=AvXall2;
       StdAall :=StdAall2;
       StdYRall := StdYRall2;
       ConfButton.Visible:=true;
     end;
     if GraphType=3 then ConfButton.Visible:=false;
     DMSegReg.ReadOutputData;
     SelectData;
     MaxMin;
     Legends;
     GraphOpened := true;
     BPbutton.Visible :=false;
     BPbutton.Left := 128;
     if GraphType>0 then SelectButton.Visible := true;
     if not SelectButton.Visible then BPbutton.Left := 244;
     HelpForm.Hide;
     ChoicesPanel.Visible := false;
     SaveGraphButton.Visible := true;
     SaveBlWhButton.Visible := true;
     GraphSaveMenu.Enabled := true;
     BlockButton.Visible:=false;
     if RegrType in [2,3,4] then BlockButton.Visible:=true;
     CalcObs_Button.Visible:=true;
     if RegrType<2 then CalcObs_Button.Visible:=false;
     if RegrType<2 then Showgraphics1            {BP=0}
     else Showgraphics2;                         {BP>0}
end; {TSegRegForm.GoButtonClick}



procedure TSegRegForm.SelectButtonClick(Sender: TObject);
begin
  inherited;
  GraphImage.Visible := false;
  PictureImage.Visible:=false;
  GraphSaveMenu.Enabled := false;
  SaveGraphButton.Visible := false;
  SaveBlWhButton.Visible := false;
  BPbutton.Visible :=false;
  HelpForm.Hide;
  SelectButton.Visible := false;
  ChoicesPanel.Visible := true;
  ConfButton.Visible:=false;
  BlockButton.Visible:=false;
  CalcObs_Button.Visible:=false;
  DMSegReg.ReadOutputData;           {Is this necessary ??}
end;



procedure TSegRegForm.ConfButtonClick(Sender: TObject);
begin
  inherited;
  if ConfButton.Caption='Remove conf. belt' then
  begin
     Confbelt:=false;
     ConfButton.Caption:='Restore conf. belt';
  end else
  begin
     Confbelt:=true;
     ConfButton.Caption:='Remove conf. belt';
  end;
  DMSegReg.ReadOutputData;
  MaxMin;
  if RegrType<2 then Showgraphics1            {BP=0}
  else Showgraphics2;                         {BP>0}
end;



procedure TSegRegForm.BlockButtonClick(Sender: TObject);
begin
  inherited;
  if BlockButton.Caption='Remove conf. block' then
  begin
     ConfBlock:=false;
     BlockButton.Caption:='Restore conf. block';
  end else
  begin
     ConfBlock:=true;
     BlockButton.Caption:='Remove conf. block';
  end;
  DMSegReg.ReadOutputData;
  MaxMin;
  if RegrType<2 then Showgraphics1            {BP=0}
  else Showgraphics2;                         {BP>0}
end;



procedure TSegRegForm.CalcObs_ButtonClick(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  DMSegReg.ReadOutputData;
  if CalcObs_Button.Caption='See regres. graph' then
  begin
    ConfButton.Visible:=true;
    MaxMin;
    GraphIndex:=0;
    GraphType:=0;
    Legends;
    RegrType:=PrevRegrType;
    if PrevRegrType in [2,3,4] then
       BlockButton.Visible:=true
    else
       BlockButton.Visible:=false;
    if PrevRegrType in [2,3,4] then BlockButton.Visible:=true;
    if PrevRegrType in [2,3,4,5,6] then CalcObs_Button.Visible:=true;
    CalcObs_Button.Caption:='See calc-obs graph';
    if RegrType<2 then ShowGraphics1
    else ShowGraphics2;
  end else
  begin
    PrevRegrType:=RegrType;
    ConfButton.Visible:=false;
    BlockButton.Visible:=false;
    CalcObs_Button.Caption:='See regres. graph';
    GraphType:=3;                      {plot of Yobs versus Ycalc}
    GraphIndex:=18;
    SelectData;
    MaxMin;
    Legends;
    Showgraphics1;                     {BP=0}
  end;
end; {CalcObs_ButtonClick}
{------------------------}


procedure TSegRegForm.BPbuttonClick(Sender: TObject);
begin
  inherited;
  HelpForm.Show;
end;


procedure TSegRegForm.ShowGraphics1;         {BP=0}
{----------------------------------}
var ii, Start              : integer;
    DumReal                : real;
    XdatRel,YdatRel        : real;
    RelYdat,RelXdat        : integer;
    Legend1, Legend2, OutE : string;
    Plot1RelY,Plot1RelX    : real;
    Plot2RelY,Plot2RelX    : real;
    Plot3RelY,Plot3RelX    : real;
    Plot4RelY,Plot4RelX    : real;
    Plot5RelY,Plot5RelX    : real;
    Plot6RelY,Plot6RelX    : real;
    Plot7RelY,Plot7RelX    : real;
    Plot8RelY,Plot8RelX    : real;
    Plot9RelY,Plot9RelX    : real;
    Plot10RelY,Plot10RelX    : real;
    Plot11RelY,Plot11RelX    : real;
    Plot12RelY,Plot12RelX    : real;

    RelPlot1Y,RelPlot1X    : integer;
    RelPlot2Y,RelPlot2X    : integer;
    RelPlot3Y,RelPlot3X    : integer;
    RelPlot4Y,RelPlot4X    : integer;
    RelPlot5Y,RelPlot5X    : integer;
    RelPlot6Y,RelPlot6X    : integer;
    RelPlot7Y,RelPlot7X    : integer;
    RelPlot8Y,RelPlot8X    : integer;
    RelPlot9Y,RelPlot9X    : integer;
    RelPlot10Y,RelPlot10X  : integer;
    RelPlot11Y,RelPlot11X  : integer;
    RelPlot12Y,RelPlot12X  : integer;
    NameStr, Confid        : string;
    myRect : TRect;
begin

  Parameters1;
  if ((Xmax=Xmin) or (Ymax=Ymin)) then
  begin
    ShowMessage ('Graph could not be made due to absence of data');
    exit;
  end;
  BPbutton.Visible := true;
  BPbutton.Left := 128;
  if not SelectButton.Visible then BPbutton.Left := 244;

  With GraphImage.Canvas do with DMSegReg do
  begin
    Font.Size := 12;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,465);
    FillRect (myRect);
    Textout (45,4,Title1);
    Font.Size := 10;
    TextOut (20,PosY2+49,'Program SegReg at www.waterlog.info/segreg.htm');
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    myRect:= Rect(20,21,605,445);
    FillRect (myRect);
    Font.Color := clWhite;       {for the text}
    if not Color then Font.Color := clblack;
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    if not Color then Pen.Color := clblack;
    Pen.Width := 1;

    Font.Size := 10;
    Textout (45,22,Title2);

    moveto (PosX1,PosY2);        {the axis line}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    Textout (515,PosY2+25,LegendX);
    TextOut (PosX1,50,LegendY);

    Font.Size := 8;
    Start := 0;
    if ScaleY>10 then Start := ScaleY-10;
    for ii:=Start to ScaleY do                        { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {e.g. '%3.1f' for 1 decimal, 3 digits, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                    { horizontal axis }
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    Font.Size := 10;
                                                     {plotting of data}
    Pen.Width:=1;
    Pen.Color := clAqua;
    if not Color then Pen.Color := clblack;
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    for ii:=0 to DMSegReg.NrOfData-1 do
    begin
      if MaxY<>MinY then
         YdatRel := LY*(YData[ii]-MinY)/(MaxY-MinY)
      else
         YdatRel := YData[ii]-MinY;
      RelYdat := PosY2-round(YdatRel);
      if MaxX<>MinX then
         XdatRel := LX*(XData[ii]-MinX)/(MaxX-MinX)
      else
        XdatRel := XData[ii]-MinX;
      RelXdat := PosX1 + round(XdatRel);
      ellipse (RelXdat-2,RelYdat-2,RelXdat+2,RelYdat+2);
(*
//This makes squares
      moveto (relxdat-1,relydat-1);
      lineto (relxdat-1,relydat+1);
      moveto (relxdat-1,relydat+1);
      lineto (relxdat+1,relydat+1);
      moveto (relxdat+1,relydat+1);
      lineto (relxdat+1,relydat-1);
      moveto (relxdat+1,relydat-1);
      lineto (relxdat-1,relydat-1);
*)
    end;
                                   {plotting conf.belt around straight line}
    if (GraphIndex<18) and ConfBelt then
    begin
      Pen.Style :=psDash;
      Pen.Color := clYellow;
      if not Color then Pen.Color := clblack;

      Plot1RelY := LY*(Y3-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X3-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y4-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X4-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);
      Plot3RelY := LY*(Y5-MinY)/(MaxY-MinY);
      RelPlot3Y := PosY2-round(Plot3RelY);
      Plot3RelX := LX*(X5-MinX)/(MaxX-MinX);
      RelPlot3X := PosX1+round(Plot3RelX);
      Plot4RelY := LY*(Y6-MinY)/(MaxY-MinY);
      RelPlot4Y := PosY2-round(Plot4RelY);
      Plot4RelX := LX*(X6-MinX)/(MaxX-MinX);
      RelPlot4X := PosX1+round(Plot4RelX);
      Plot5RelY := LY*(Y7-MinY)/(MaxY-MinY);
      RelPlot5Y := PosY2-round(Plot5RelY);
      Plot5RelX := LX*(X7-MinX)/(MaxX-MinX);
      RelPlot5X := PosX1+round(Plot5RelX);
      Plot6RelY := LY*(Y8-MinY)/(MaxY-MinY);
      RelPlot6Y := PosY2-round(Plot6RelY);
      Plot6RelX := LX*(X8-MinX)/(MaxX-MinX);
      RelPlot6X := PosX1+round(Plot6RelX);
      Plot7RelY := LY*(Y9-MinY)/(MaxY-MinY);
      RelPlot7Y := PosY2-round(Plot7RelY);
      Plot7RelX := LX*(X9-MinX)/(MaxX-MinX);
      RelPlot7X := PosX1+round(Plot7RelX);
      Plot8RelY := LY*(Y10-MinY)/(MaxY-MinY);
      RelPlot8Y := PosY2-round(Plot8RelY);
      Plot8RelX := LX*(X10-MinX)/(MaxX-MinX);
      RelPlot8X := PosX1+round(Plot8RelX);
      Plot9RelY := LY*(Y11-MinY)/(MaxY-MinY);
      RelPlot9Y := PosY2-round(Plot9RelY);
      Plot9RelX := LX*(X11-MinX)/(MaxX-MinX);
      RelPlot9X := PosX1+round(Plot9RelX);
      Plot10RelY := LY*(Y12-MinY)/(MaxY-MinY);
      RelPlot10Y := PosY2-round(Plot10RelY);
      Plot10RelX := LX*(X12-MinX)/(MaxX-MinX);
      RelPlot10X := PosX1+round(Plot10RelX);
      Plot11RelY := LY*(Y13-MinY)/(MaxY-MinY);
      RelPlot11Y := PosY2-round(Plot11RelY);
      Plot11RelX := LX*(X13-MinX)/(MaxX-MinX);
      RelPlot11X := PosX1+round(Plot11RelX);
      Plot12RelY := LY*(Y14-MinY)/(MaxY-MinY);
      RelPlot12Y := PosY2-round(Plot12RelY);
      Plot12RelX := LX*(X14-MinX)/(MaxX-MinX);
      RelPlot12X := PosX1+round(Plot12RelX);

      Moveto (RelPlot1X,RelPlot1Y);
      Lineto (RelPlot2X,RelPlot2Y);
      Moveto (RelPlot2X,RelPlot2Y);
      Lineto (RelPlot9X,RelPlot9Y);
      Moveto (RelPlot9X,RelPlot9Y);
      Lineto (RelPlot10X,RelPlot10Y);
      Moveto (RelPlot10X,RelPlot10Y);
      Lineto (RelPlot3X,RelPlot3Y);
      Moveto (RelPlot3X,RelPlot3Y);
      Lineto (RelPlot4X,RelPlot4Y);

      Moveto (RelPlot5X,RelPlot5Y);
      Lineto (RelPlot6X,RelPlot6Y);
      Moveto (RelPlot6X,RelPlot6Y);
      Lineto (RelPlot11X,RelPlot11Y);
      Moveto (RelPlot11X,RelPlot11Y);
      Lineto (RelPlot12X,RelPlot12Y);
      Moveto (RelPlot12X,RelPlot12Y);
      Lineto (RelPlot7X,RelPlot7Y);
      Moveto (RelPlot7X,RelPlot7Y);
      Lineto (RelPlot8X,RelPlot8Y);
      if Alfa<1.8 then Confid := '90'
      else
        if Alfa<2.2 then Confid := '95'
        else
          Confid := '98';
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;
      TextOut(400,50,Confid+'% confidence belt is shown');
    end;

    Pen.Width:=1;
    if DMSegReg.NrOfData>1000  then pen.Width:=2;
    if DMSegReg.NrOfData>2000  then pen.Width:=3;

    if GraphIndex<18 then                                     {line plot}
    begin
      Pen.Style := psSolid;
      Pen.Color := clWhite;
      if not Color then Pen.Color := clblack;

      Plot1RelY := LY*(Y1-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X1-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y2-MinY)/(MaxY-MinY);
      if Plot2RelY<0 then Plot2RelY := 0;
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X2-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);
      Moveto (RelPlot1X,RelPlot1Y);
      Lineto (RelPlot2X,RelPlot2Y);
      Font.Color := clAqua;
      if not Color then Font.Color := clblack;
      if RegrType=0 then TextOut (400,35,'Type 0, no relation detected');
      if RegrType=1 then TextOut (400,35,'Type 1, no breakpoint found');
    end;

    if GraphIndex=18 then
    begin                            {plotting calc/obs straight line}
      Pen.Style := psSolid;
      Pen.Color := clWhite;
      Plot1RelY := LY*(Y1-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X1-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y2-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X2-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);
      Moveto (RelPlot1X,RelPlot1Y);
      Lineto (RelPlot2X,RelPlot2Y);
      Font.Color:=claqua;
      TextOut (440,35,'Yobs versus Ycalc');
      Font.Color:=clWhite;
      if not Color then Font.Color := clblack;
      TextOut (420,50,'The line Yobs=Ycalc is shown');
      Font.Color:=clMoneyGreen;
      if GraphType<2 then
         OutE:= format('%8.3f',[ExplCoeff])
      else
         OutE:= format('%8.3f',[ExplCoeffT]);
      OutE:='Expl. coeff '+OutE;
      TextOut (440,65,OutE);
    end;

    if (GraphIndex=21) or (GraphIndex=22) then
    begin
      Brush.Color := $8B0000;
      Legend1 := 'Corr. Coeff. sq.';
      str(corr:6:3,Legend2);
      TextOut (440,30,Legend1);
      TextOut (460,44,Legend2);
    end;

    GraphImage.Visible:=true;
  end; {With GraphImage.Canvas do}

end; {TSegRegForm.ShowGraphics1}
{------------------------------}


procedure TSegRegForm.ShowGraphics2;         {BP>0}
{----------------------------------}
var
  ii, Start                : integer;
  RelYdat,RelXdat          : integer;
  DumReal                  : real;
  YdatRel,XdatRel          : real;
  Plot1RelY,Plot1RelX      : real;
  Plot2RelY,Plot2RelX      : real;
  Plot3RelY,Plot3RelX      : real;
  Plot4RelY,Plot4RelX      : real;
  Plot5RelY,Plot5RelX      : real;
  Plot6RelY,Plot6RelX      : real;
  Plot7RelY,Plot7RelX      : real;
  Plot8RelY,Plot8RelX      : real;
  Plot9RelX,Plot9RelY      : real;
  Plot10RelX,Plot10RelY    : real;
  Plot11RelX,Plot11RelY    : real;
  Plot12RelX,Plot12RelY    : real;
  Plot13ARelX,Plot13ARelY    : real;
  Plot15ARelX,Plot15ARelY    : real;
  RelPlot1Y,RelPlot1X    : integer;
  RelPlot2Y,RelPlot2X    : integer;
  RelPlot3Y,RelPlot3X    : integer;
  RelPlot4Y,RelPlot4X    : integer;
  RelPlot5Y,RelPlot5X    : integer;
  RelPlot6Y,RelPlot6X    : integer;
  RelPlot7Y,RelPlot7X    : integer;
  RelPlot8Y,RelPlot8X    : integer;
  RelPlot9Y,RelPlot9X    : integer;
  RelPlot10Y,RelPlot10X  : integer;
  RelPlot11Y,RelPlot11X  : integer;
  RelPlot12Y,RelPlot12X  : integer;
  RelPlot13AY,RelPlot13AX  : integer;
  RelPlot15AY,RelPlot15AX  : integer;

  NameStr, Confid        : string;
  myRect : TRect;
begin

  if RegrType in [2,3,4] then Parameters2;
  if RegrType>4 then Parameters3;
  if ((Xmax=Xmin) or (Ymax=Ymin)) then
  begin
    ShowMessage ('Graph could not be made due to absence of data variation');
    exit;
  end;
  BPbutton.Visible := true;
  BPbutton.Left := 128;
  if not SelectButton.Visible then BPbutton.Left := 244;

  With GraphImage.Canvas do with DMSegReg do
  begin
    Font.Size := 12;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,465);
    FillRect (myRect);
    Textout (45,4,Title1);
    Font.Size := 10;
    TextOut (20,PosY2+49,'Program SegReg at www.waterlog.info/segreg.htm');
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    myRect:= Rect(20,22,605,445);
    FillRect (myRect);
    Font.Color := clWhite;       {for the text}
    if not Color then Font.Color := clblack;
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    if not Color then Pen.Color := clblack;
    Pen.Width := 1;
    Font.Size := 10;

    Textout (45,22,Title2);

    moveto (PosX1,PosY2);        {the axis lines}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    Textout (515,PosY2+25,LegendX);
    TextOut (PosX1,50,LegendY);

    Font.Size := 8;
    Start := 0;
    if ScaleY>10 then Start := ScaleY-10;
    if (MaxY<>MinY) then
    for ii:=Start to ScaleY do                      { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;

    if (MaxX<>MinX) then
    for ii:=0 to ScaleX do                               { horizontal axis }
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    Font.Size := 10;

    if Alfa<1.8 then Confid := '90'
    else
      if Alfa<2.2  then Confid := '95'
      else
        Confid := '98';
                                            {plotting of data}
    Pen.Color := clwhite;
    if not Color then Pen.Color := clblack;
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    for ii:=0 to DMSegReg.NrOfData-1 do
    begin
      if MaxY<>MinY then
         YdatRel := LY*(YData[ii]-MinY)/(MaxY-MinY)
      else
         YdatRel := YData[ii]-MinY;
      RelYdat := PosY2-round(YdatRel);
      if MaxX<>MinX then
         XdatRel := LX*(XData[ii]-MinX)/(MaxX-MinX)
      else
        XdatRel := XData[ii]-MinX;
      RelXdat := PosX1 + round(XdatRel);
      ellipse (RelXdat-2,RelYdat-2,RelXdat+2,RelYdat+2);
(*
//This makes squares
      moveto (relxdat-1,relydat-1);
      lineto (relxdat-1,relydat+1);
      moveto (relxdat-1,relydat+1);
      lineto (relxdat+1,relydat+1);
      moveto (relxdat+1,relydat+1);
      lineto (relxdat+1,relydat-1);
      moveto (relxdat+1,relydat-1);
      lineto (relxdat-1,relydat-1);
*)
    end;

    if DMSegReg.NrOfData > 150 then Pen.Width := 2;
    if DMSegReg.NrOfData > 1000 then Pen.Width := 3;

    if (RegrType in [2,3,4]) and ConfBelt then  {conf. belt RegrType 2, 3, 4}
    begin
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;
      TextOut (425,35,Confid+'% confidence belt is shown');
      Pen.Style := psDash;
      Pen.Color := clYellow;                     {for the conf. lines}
      if not Color then Pen.Color := clblack;

      Plot1RelY := LY*(Y5-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X5-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y6-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X6-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);

      Plot9RelY := LY*(Y13-MinY)/(MaxY-MinY);
      RelPlot9Y := PosY2-round(Plot9RelY);
      Plot9RelX := LX*(X13-MinX)/(MaxX-MinX);
      RelPlot9X := PosX1+round(Plot9RelX);
      Plot10RelY := LY*(Y14-MinY)/(MaxY-MinY);
      RelPlot10Y := PosY2-round(Plot10RelY);
      Plot10RelX := LX*(X14-MinX)/(MaxX-MinX);
      RelPlot10X := PosX1+round(Plot10RelX);

      Plot3RelY := LY*(Y7-MinY)/(MaxY-MinY);
      RelPlot3Y := PosY2-round(Plot3RelY);
      Plot3RelX := LX*(X7-MinX)/(MaxX-MinX);
      RelPlot3X := PosX1+round(Plot3RelX);
      Plot4RelY := LY*(Y8-MinY)/(MaxY-MinY);
      RelPlot4Y := PosY2-round(Plot4RelY);
      Plot4RelX := LX*(X8-MinX)/(MaxX-MinX);
      RelPlot4X := PosX1+round(Plot4RelX);

      Plot5RelY := LY*(Y9-MinY)/(MaxY-MinY);
      RelPlot5Y := PosY2-round(Plot5RelY);
      Plot5RelX := LX*(X9-MinX)/(MaxX-MinX);
      RelPlot5X := PosX1+round(Plot5RelX);
      Plot6RelY := LY*(Y10-MinY)/(MaxY-MinY);
      RelPlot6Y := PosY2-round(Plot6RelY);
      Plot6RelX := LX*(X10-MinX)/(MaxX-MinX);
      RelPlot6X := PosX1+round(Plot6RelX);

      Plot11RelY := LY*(Y15-MinY)/(MaxY-MinY);
      RelPlot11Y := PosY2-round(Plot11RelY);
      Plot11RelX := LX*(X15-MinX)/(MaxX-MinX);
      RelPlot11X := PosX1+round(Plot11RelX);
      Plot12RelY := LY*(Y16-MinY)/(MaxY-MinY);
      RelPlot12Y := PosY2-round(Plot12RelY);
      Plot12RelX := LX*(X16-MinX)/(MaxX-MinX);
      RelPlot12X := PosX1+round(Plot12RelX);

      Plot7RelY := LY*(Y11-MinY)/(MaxY-MinY);
      RelPlot7Y := PosY2-round(Plot7RelY);
      Plot7RelX := LX*(X11-MinX)/(MaxX-MinX);
      RelPlot7X := PosX1+round(Plot7RelX);
      Plot8RelY := LY*(Y12-MinY)/(MaxY-MinY);
      RelPlot8Y := PosY2-round(Plot8RelY);
      Plot8RelX := LX*(X12-MinX)/(MaxX-MinX);
      RelPlot8X := PosX1+round(Plot8RelX);

      Moveto (RelPlot1X,RelPlot1Y);              {X5,Y5}
      Lineto (RelPlot2X,RelPlot2Y);              {X6,Y6}
      Moveto (RelPlot2X,RelPlot2Y);
      Lineto (RelPlot9X,RelPlot9Y);              {X13,Y13}
      Moveto (RelPlot9X,RelPlot9Y);
      Lineto (RelPlot10X,RelPlot10Y);            {X14,Y14}
      Moveto (RelPlot10X,RelPlot10Y);
      Lineto (RelPlot3X,RelPlot3Y);              {X7,Y7}
      Moveto (RelPlot3X,RelPlot3Y);
      Lineto (RelPlot4X,RelPlot4Y);              {X8,Y8}

      Moveto (RelPlot5X,RelPlot5Y);              {X9,Y9}
      Lineto (RelPlot6X,RelPlot6Y);              {X10,Y10}
      Moveto (RelPlot6X,RelPlot6Y);
      Lineto (RelPlot11X,RelPlot11Y);            {X15,Y15}
      Moveto (RelPlot11X,RelPlot11Y);
      Lineto (RelPlot12X,RelPlot12Y);            {X16,Y16}
      Moveto (RelPlot12X,RelPlot12Y);
      Lineto (RelPlot7X,RelPlot7Y);              {X11,Y11}
      Moveto (RelPlot7X,RelPlot7Y);
      Lineto (RelPlot8X,RelPlot8Y);              {X12,Y12}

      Pen.Color := clWhite;
      if not Color then Pen.Color := clblack;
      Pen.Style := psSolid;

    end;                              {end conf. belt RegrType 2, 3, 4}

    if RegrType in [2,3,4] then
    begin                              {plotting relation RegrType 2/3/4}

      Pen.Color := clAqua;
      if not Color then Pen.Color := clblack;
      Plot1RelY := LY*(Y1-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X1-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y2-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(BP-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);
      Plot3RelY := LY*(Y3-MinY)/(MaxY-MinY);
      RelPlot3Y := PosY2-round(Plot3RelY);
      Plot3RelX := LX*(X3-MinX)/(MaxX-MinX);
      RelPlot3X := PosX1+round(Plot3RelX);

      Moveto (RelPlot1X,RelPlot1Y);
      Lineto (RelPlot2X,RelPlot2Y);
      Moveto (RelPlot2X,RelPlot2Y);
      Lineto (RelPlot3X,RelPlot3Y);
      Font.Color := clAqua;
      if not Color then Font.Color := clblack;
      if RegrType=3 then TextOut (450,22,'Relation of Type 3');
      if RegrType=4 then TextOut (450,22,'Relation of Type 4');
      if RegrType=2 then TextOut (450,22,'Relation of Type 2');

    end;                             {end plotting relation RegrType 2,3,4}

    if (RegrType in [2,3,4]) and ConfBlock then   {conf. block RegrType 2,3,4}
    begin
      Pen.Color := clFuchsia;
      if not Color then Pen.Color := clblack;
      Plot1RelY := LY*(PlotY1-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X17-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(PlotY2-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X18-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);

      moveto (RelPlot1X,RelPlot1Y);
      lineto (RelPlot2X,RelPlot1Y);
      if (X18<Xmax) then
      begin
        moveto (RelPlot2X,RelPlot1Y);
        lineto (RelPlot2X,RelPlot2Y);
      end;
      moveto (RelPlot2X,RelPlot2Y);
      lineto (RelPlot1X,RelPlot2Y);
      if (X17>Xmin) then
      begin
        moveto (RelPlot1X,RelPlot2Y);
        lineto (RelPlot1X,RelPlot1Y);
      end;

      Font.Color := clFuchsia;
      if not Color then Font.Color := clblack;
      TextOut (450,50,Confid+'% confidence block');
      TextOut (450,65,'of break-point is shown');

    end;                              {end of conf. block RegrType 2,3,4}

    if RegrType>4 then                {plotting relation RegrType 5,6}
    begin

      Font.Color := clAqua;
      if not Color then Font.Color := clblack;
      if RegrType=5 then TextOut (465,35,'Relation of Type 5');
      if RegrType=6 then TextOut (465,35,'Relation of Type 6');
      if RegrType=7 then TextOut (465,35,'Relation of Type 7');
      if RegrType=8 then TextOut (465,35,'Relation of Type 8');
      Plot1RelY := LY*(Y1-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X1-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y2-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X2-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);
      Plot3RelY := LY*(Y3-MinY)/(MaxY-MinY);
      RelPlot3Y := PosY2-round(Plot3RelY);
      Plot3RelX := LX*(X3-MinX)/(MaxX-MinX);
      RelPlot3X := PosX1+round(Plot3RelX);
      Plot4RelY := LY*(Y4-MinY)/(MaxY-MinY);
      RelPlot4Y := PosY2-round(Plot4RelY);
      Plot4RelX := LX*(X4-MinX)/(MaxX-MinX);
      RelPlot4X := PosX1+round(Plot4RelX);
      Pen.Color := clAqua;
      if not Color then Pen.Color := clblack;

      Moveto (RelPlot1X,RelPlot1Y);
      Lineto (RelPlot2X,RelPlot2Y);
      if (RegrType=5) then
      begin
        Moveto (RelPlot2X,RelPlot2Y);
        Lineto (RelPlot3X,RelPlot3Y);
      end;
      Moveto (RelPlot3X,RelPlot3Y);
      Lineto (RelPlot4X,RelPlot4Y);
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;

     if ConfBelt then                                {conf. belt RegrType 5,6}
     begin
      TextOut (400,50,Confid+'% confidence belts are shown');

      Pen.Style := psDash;
      Pen.Color := clYellow;
      if not Color then Pen.Color := clblack;
      Pen.Width := 1;

      Plot1RelY := LY*(Y5-MinY)/(MaxY-MinY);
      RelPlot1Y := PosY2-round(Plot1RelY);
      Plot1RelX := LX*(X5-MinX)/(MaxX-MinX);
      RelPlot1X := PosX1+round(Plot1RelX);
      Plot2RelY := LY*(Y6-MinY)/(MaxY-MinY);
      RelPlot2Y := PosY2-round(Plot2RelY);
      Plot2RelX := LX*(X6-MinX)/(MaxX-MinX);
      RelPlot2X := PosX1+round(Plot2RelX);

      Plot9RelY := LY*(Y13-MinY)/(MaxY-MinY);
      RelPlot9Y := PosY2-round(Plot9RelY);
      Plot9RelX := LX*(X13-MinX)/(MaxX-MinX);
      RelPlot9X := PosX1+round(Plot9RelX);
      Plot10RelY := LY*(Y14-MinY)/(MaxY-MinY);
      RelPlot10Y := PosY2-round(Plot10RelY);
      Plot10RelX := LX*(X14-MinX)/(MaxX-MinX);
      RelPlot10X := PosX1+round(Plot10RelX);

      Plot3RelY := LY*(Y7-MinY)/(MaxY-MinY);
      RelPlot3Y := PosY2-round(Plot3RelY);
      Plot3RelX := LX*(X7-MinX)/(MaxX-MinX);
      RelPlot3X := PosX1+round(Plot3RelX);
      Plot4RelY := LY*(Y8-MinY)/(MaxY-MinY);
      RelPlot4Y := PosY2-round(Plot4RelY);
      Plot4RelX := LX*(X8-MinX)/(MaxX-MinX);
      RelPlot4X := PosX1+round(Plot4RelX);

      Plot5RelY := LY*(Y9-MinY)/(MaxY-MinY);
      RelPlot5Y := PosY2-round(Plot5RelY);
      Plot5RelX := LX*(X9-MinX)/(MaxX-MinX);
      RelPlot5X := PosX1+round(Plot5RelX);
      Plot6RelY := LY*(Y10-MinY)/(MaxY-MinY);
      RelPlot6Y := PosY2-round(Plot6RelY);
      Plot6RelX := LX*(X10-MinX)/(MaxX-MinX);
      RelPlot6X := PosX1+round(Plot6RelX);

      Plot11RelY := LY*(Y15-MinY)/(MaxY-MinY);
      RelPlot11Y := PosY2-round(Plot11RelY);
      Plot11RelX := LX*(X15-MinX)/(MaxX-MinX);
      RelPlot11X := PosX1+round(Plot11RelX);
      Plot12RelY := LY*(Y16-MinY)/(MaxY-MinY);
      RelPlot12Y := PosY2-round(Plot12RelY);
      Plot12RelX := LX*(X16-MinX)/(MaxX-MinX);
      RelPlot12X := PosX1+round(Plot12RelX);

      Plot7RelY := LY*(Y11-MinY)/(MaxY-MinY);
      RelPlot7Y := PosY2-round(Plot7RelY);
      Plot7RelX := LX*(X11-MinX)/(MaxX-MinX);
      RelPlot7X := PosX1+round(Plot7RelX);
      Plot8RelY := LY*(Y12-MinY)/(MaxY-MinY);
      RelPlot8Y := PosY2-round(Plot8RelY);
      Plot8RelX := LX*(X12-MinX)/(MaxX-MinX);
      RelPlot8X := PosX1+round(Plot8RelX);

      Plot13ARelY := LY*(Y13A-MinY)/(MaxY-MinY);
      RelPlot13AY := PosY2-round(Plot13ARelY);
      Plot13ARelX := LX*(X13A-MinX)/(MaxX-MinX);
      RelPlot13AX := PosX1+round(Plot13ARelX);
      Plot15ARelY := LY*(Y15A-MinY)/(MaxY-MinY);
      RelPlot15AY := PosY2-round(Plot15ARelY);
      Plot15ARelX := LX*(X15A-MinX)/(MaxX-MinX);
      RelPlot15AX := PosX1+round(Plot15ARelX);

      Moveto (RelPlot1X,RelPlot1Y);              {X5,Y5}
      Lineto (RelPlot2X,RelPlot2Y);              {X6,Y6}
      Moveto (RelPlot2X,RelPlot2Y);
      Lineto (RelPlot9X,RelPlot9Y);              {X13,Y13}
      Moveto (RelPlot13AX,RelPlot13AY);          {X13A,Y13A}
      Lineto (RelPlot3X,RelPlot3Y);              {X7,Y7}
      Moveto (RelPlot3X,RelPlot3Y);
      Lineto (RelPlot4X,RelPlot4Y);              {X8,Y8}

      Moveto (RelPlot5X,RelPlot5Y);              {X9,Y9}
      Lineto (RelPlot6X,RelPlot6Y);              {X10,Y10}
      Moveto (RelPlot6X,RelPlot6Y);
      Lineto (RelPlot11X,RelPlot11Y);            {X15,Y15}
      Moveto (RelPlot15AX,RelPlot15AY);          {X15A,Y15A}
      Lineto (RelPlot7X,RelPlot7Y);              {X11,Y11}
      Moveto (RelPlot7X,RelPlot7Y);
      Lineto (RelPlot8X,RelPlot8Y);              {X12,Y12}
    end;                               {end of conf. belt RegrType 5,6}
   end; {if ConfBelt then}

  GraphImage.Visible := true;
  end; {With GraphImage.Canvas do with DMSegReg do}

end; {ShowGraphics2}
{------------------}

{see also SaveGraphpActionExecute in group Menu Items}

{-----------------------------------------------------------------------
 End of Graphics, start of FINISH
 -----------------------------------------------------------------------}

procedure TSegRegForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
     Action := caNone;
     FinishForm.Show;
end; {TSegRegForm.FormClose}

{-----------------------------------------------------------------------
 End of Finish, start of general items
 -----------------------------------------------------------------------}

procedure TSegRegForm.SetInitialDir (AuxDir:string);
begin
      InputOpenDialog.InitialDir:=AuxDir;
      InputSaveDialog.InitialDir:=AuxDir;
      OutputOpenDialog.InitialDir:=AuxDir;
      OutputReadDialog.InitialDir:=AuxDir;
      GraphSaveDialog.InitialDir:=AuxDir;
      GraphOpenDialog.InitialDir:=AuxDir;
end; {SetInitialDir}


{-----------------------------------------------------------------------
 End of general items, start of MENU ITEMS
 -----------------------------------------------------------------------}

procedure TSegRegForm.InputOpenActionExecute(Sender: TObject);
var HlpDir:string;
begin
  inherited;
     if SegRegForm.InputOpenDialog.Execute then
      begin
        DMSegReg.Filename := SegRegForm.InputOpenDialog.Files.Strings[0];
        if FileExists (DMSegReg.FileName) then
           DMSegReg.ReadInputFile
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      PrefComboBox.ItemIndex:=0;
      ExclComboBox.ItemIndex:=0;
      DMSegReg.Option:=3;
      if DMSegReg.NrOfVar=1 then DMSegReg.Option:=0;
      PrefXPanel.Visible:=false;
      PrefZPanel.Visible:=false;
      Exclude1Panel.Visible:=false;
      Exclude2Panel.Visible:=false;
      HlpDir:=ExtractFilePath(DMSegReg.FileName);
      SetInitialDir (HlpDir);
      FilenameEdit.Text := DMSegReg.FileName;
      FilenameEdit.Visible:=true;
      FileNameLabel.Visible:=true;
      GraphImage.Visible:=false;
      BPbutton.Visible :=false;
      HelpForm.Hide;
      SelectButton.Visible :=false;
      GraphSaveMenu.Enabled := false;
      SaveGraphButton.Visible := false;
      SaveBlWhButton.Visible := false;
      SaveBlWhButton.Visible := false;
      ConfButton.Caption:='Remove conf. belt';
      BlockButton.Caption:='Remove conf. block';
      CalcObs_button.Caption:='See calc-obs graph';
      ConfBelt:=true;
      ConfBlock:=true;
      ConfButton.Visible:=true;
      BlockButton.Visible:=false;
      Title1Edit.Text:=DMSegReg.Title1;
      Title2Edit.Text:=DMSegReg.Title2;
      Finish:=DMSegReg.NrOfData;
      InitNrOfData := Finish;
      RefNr:=Finish;
      InitNrOfVar:=DMSegReg.NrOfVar;
      InputOpened := true;
      EnterData (Finish);
      DMSegReg.NrOfValues:=InitNrOfData;
      if DMSegReg.NrOfVar=1 then
         Stringgrid1.ColCount:=3
      else
      begin
        Stringgrid1.ColCount:=4;
        InputImage.Visible:=false;
      end;
      GraphType:=0;
      InputTabsheetShow(Sender);
end; {TSegRegForm.InputOpenActionExecute}



procedure TSegRegForm.InputSaveActionExecute(Sender: TObject);
var k, n : integer;
    NN : array of integer;
    NoRemoval, OutputOk : boolean;
    HlpDir : string;

begin
  inherited;
     if (SetAndVerifySaveName) and not NoSave then with DMSegReg do
      begin
        Title1 := Title1Edit.Text;
        Title2 := Title2Edit.Text;
        if Title1='' then Title1:=' No first title given';
        if Title2='' then Title2:=' No second title given';
        if WeightComboBox.ItemIndex>0 then NrOfData:=InitNrOfData;
        Removed:=false;
        if NrOfData<RefNr then
        begin
          NrOfData:=RefNr;
          Removed:=true;
        end;
        if RefNr>=NrOfData then setlength (NN,RefNr+1)
        else setlength (NN,NrOfData+1);
        for k := 1 to NrOfData do
        begin
          NN[k]:=0;
          NoRemoval := true;
          if (NrOfVar=1) and ((StringGrid1.Cells[1,k]='')
             or (StringGrid1.Cells[2,k]='')) then NoRemoval := false;
          if (InitNrOfVar=2) and ((StringGrid1.Cells[1,k]='')
             or (StringGrid1.Cells[2,k]='') or
             (StringGrid1.Cells[3,k]='')) then NoRemoval := false;
          if not InputOpened then
          begin
            RefNr:=NrOfData;
            SetLength (Yvalue,k+1);
            SetLength (Xvalue,k+1);
            if InitNrOfVar=2 then SetLength (Zvalue,k+1);
          end;
          if NoRemoval then
          begin
            Try
              begin
                Yvalue[k-1]:= StringToFloat(StringGrid1.Cells[1,k]);
                Xvalue[k-1]:= StringToFloat(StringGrid1.Cells[2,k]);
              end;
              Except on E: Exception do
              begin
                Showmessage ('Not all data values in the inputfile are real,'+
                             ' do not use letters or blanks.');
                exit;
              end;
            end;
            if InitNrOfVar=2 then
            Try
              Zvalue[k-1]:= StringToFloat(StringGrid1.Cells[3,k]);
              Except on E: Exception do
              begin
                Showmessage ('Not all data values in the inputfile are real,'+
                             ' do not use letters or blanks.');
                exit;
              end;
            end;
          end {if no Removal}
          else
          begin
            NrOfData:=NrOfData-1;
            NrOfValues:=NrOfData;
            NN[k]:=1;
            Removed:=true;
          end;
        end; {for k := 1 to DMSegReg.NrOfData do}
        AnovaButton.Caption:='Anova table';
      end else
      begin
        Showmessage ('The input data were not saved');
        exit;
      end;

      n:=0;
      if Removed then for k := 1 to DMSegReg.NrOfData+1 do with DMSegReg do
      begin
        if NN[k]=0 then
        begin
          n:=n+1;
          SerialNr[n-1]:=n;
          Yvalue[n-1]:= StringToFloat(StringGrid1.Cells[1,k]);
          Xvalue[n-1]:= StringToFloat(StringGrid1.Cells[2,k]);
          if NrOfVar=2 then
             Zvalue[n-1]:= StringToFloat(StringGrid1.Cells[3,k]);
        end;
      end;
      NrOfDataEdit.Text:=inttostr(DMSegReg.NrOfData);
      StringGrid1.rowcount:=N;
      if Removed then Enterdata (DMSegReg.NrOfData);

    with DMSegReg do
    begin
      WriteInputFile(FileName);
      if ConfComboBox.ItemIndex<1 then Alfa:=1.75;
      if ConfComboBox.ItemIndex=1 then Alfa:=2.1;
      if ConfComboBox.ItemIndex=2 then Alfa:=2.5;
      Option:=3;
      if InitNrOfVar=1 then Option:=0;
      if OptionComboBox.ItemIndex=1 then Option:=1;
      if OptionComboBox.ItemIndex=2 then Option:=2;
      DoCalculations;
      NrOfVar:=InitNrOfVar;
      if NotFit then
      begin
        NotFit:=false;
        exit;
      end;
      AuxFile := ChangeFileExt(FileName,'.inp');
      FileName := ChangeFileExt(FileName,'.out');
      ReadOutputLines (FileName, OutputOk,'.out');
      if not OutputOk then
      begin
        InputTabsheet.Show;
        exit;
      end;
      WaitMemo.Lines.Add(' Filing results ..');
      Sleep(500);
      WaitMemo.Visible:=false;
      ShowMessage ('The input is saved in ' + AuxFile +
                   '   Calculations were done and the output is saved in  ' +
                    DMSegReg.FileName);
      OutputMemo.Lines.Clear;
      for k:=1 to NrOfLines do
          OutputMemo.Lines.Add(OutLine[k-1]);
      OutputMemo.Visible:=true;
      AnovaButton.Visible := true;
      SymbolsButton.Visible := true;
      GraphicsButton.Visible := true;
      CalcObs_Button.Visible:= false;
      CalcObs_Button.Caption:='See calc-obs graph';
      HlpDir:=ExtractFilePath(FileName);
      SetInitialDir (HlpDir);
   end; {with DMSegReg do}
   ConfButton.Caption:='Remove conf. belt';
   BlockButton.Caption:='Remove conf. block';
   CalcObs_button.Caption:='See calc-obs graph';
   if RegrType in [2,3,4] then BlockButton.Visible:=true
      else BlockButton.Visible:=false;
   OutputOpened := true;
   ConfButton.Caption:='Remove conf. belt';
   OutputTabsheet.Show;
end; {TSegRegForm.InputSaveActionExecute}



function TSegRegForm.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.';
      Result := StrToFloat(Str);
    end;
  end;
end; {TSegRegForm.StringToFloat}



procedure TSegRegForm.OutputOpenActionExecute(Sender: TObject);
var k : integer;
    OutputOK : boolean;
    HlpDir : string;
begin
  inherited;
  OutputTabsheet.Hide;
  if OutputOpenDialog.Execute then
     begin
        DMSegReg.Filename := SegRegForm.OutputOpenDialog.Files.Strings[0];
        if FileExists (DMSegReg.Filename) then
        begin
          DMSegReg.ReadOutputLines (DMSegReg.FileName, OutputOK,'.out');
          StatusText ('The output file can be imported into' +
                      ' spreadsheets');
          OutputMemo.Lines.Clear;
          for k:=1 to DMSegReg.NrOfLines do
              OutputMemo.Lines.Add(DMSegReg.OutLine[k-1]);
          OutputOpened := true;
          OutputMemo.Visible := true;
        end
        else
          Showmessage ('File does not exist, please select another one,');
      end
      else ShowMessage('No output file selected');
      HlpDir:=ExtractFilePath(DMSegReg.FileName);
      SetInitialDir (HlpDir);
      AnovaButton.Visible := true;
      SymbolsButton.Visible := true;
      GraphicsButton.Visible := true;
      GraphImage.Visible:=false;
      GraphSaveMenu.Enabled := false;
      SaveGraphButton.Visible := false;
      SaveBlWhButton.Visible := false;
      SelectButton.Visible := false;
      BPbutton.Visible :=false;
      HelpForm.Hide;
      SymbolsButton.Caption := 'Symbols';
      AnovaButton.Caption:='Anova table';
      ConfButton.Caption:='Remove conf. belt';
      GraphType:=0;
      BlockButton.Caption:='Remove conf. block';
      ConfButton.Caption:='Remove conf. belt';
      OutputTabsheet.show;
end; {TSegRegForm.OutputOpenActionExecute}



procedure TSegRegForm.GraphicsButtonClick(Sender: TObject);
begin
  inherited;
      DMSegReg.ReadOutputData;
      if DMSegReg.Stop then exit;
      PictureImage.Visible:=false;
      if DMSegReg.Code = ' Fun' then
      begin
        SelectData;
        MaxMin;
        Legends;
        SaveGraphButton.Visible := true;
        SaveBlWhButton.Visible := true;
        GraphSaveMenu.Enabled := true;
        SelectButton.Visible := false;
        ChoicesPanel.Visible := false;
        if RegrType in [2,3,4] then
           BlockButton.Visible:=true
        else
           BlockButton.Visible:=false;
        GraphIndex := 0;                            {necessary?}
        RegrType := RegrType1;                      {necessary?}
        CalcObs_Button.Visible:= true;
        CalcObs_Button.Caption:='See calc-obs graph';
        if RegrType<2 then
          Showgraphics1                              {BP=0}
        else
          Showgraphics2;                             {BP>0}
      end else
      begin
        CalcObs_Button.Visible:= false;
        CalcObs_Button.Caption:='See calc-obs graph';
        GraphImage.Visible := false;
        BPbutton.Visible :=false;
        ChoicesPanel.Visible := true;
        ConfButton.Visible:=false;
        BlockButton.Visible:=false;
        HelpForm.Hide;
        if DMSegReg.Code =' Y-X' then
        begin
          Y_XRadioButton.Caption := 'Y-X function';
          YXr_ZRadioButton.Caption := 'Residuals-Z function';
          Calc_ObsRadioButton.Caption := 'Calculated-observed';
          Y_ZRadioButton.Caption := 'Y-Z data plot';
          X_ZRadioButton.Caption := 'X-Z data plot';
        end else
        begin
          Y_XRadioButton.Caption := 'Y-Z function';
          YXr_ZRadioButton.Caption := 'Residuals-X function';
          Calc_ObsRadioButton.Caption := 'Calculated-observed';
          Y_ZRadioButton.Caption := 'Y-X data plot';
          X_ZRadioButton.Caption := 'Z-X data plot';
        end;
      end;
     BlockButton.Visible:=false;
     if RegrType in [2,3,4] then BlockButton.Visible:=true;
     if RegrType<2 then CalcObs_Button.Visible:=false;
     if DMSegReg.Code=' Fun' then if RegrType in [2,3,4] then
     begin
       ConfButton.Visible:=true;
       BlockButton.Visible:=true;
       CalcObs_Button.Visible:=true;
     end;

     if DMSegReg.Code<>' Fun' then if GraphType in [0,1,2] then
     begin
       ConfButton.Visible:=false;
       BlockButton.Visible:=false;
       CalcObs_Button.Visible:=false;
     end else
     begin
       ConfButton.Visible:=true;
       if RegrType in [2,3,4] then BlockButton.Visible:=true
       else BlockButton.Visible:=false;
     end;
     GraphOpened := True;
     GraphicsTabsheet.Show;
end; {TSegRegForm.GraphicsButtonClick}



procedure TSegRegForm.OutputReadActionExecute(Sender: TObject);
//is used in MakeGrapButtonClick
var HlpDir:string;
begin
  inherited;
  GraphImage.Visible := false;
  PictureImage.Visible := false;
  GraphSaveMenu.Enabled := false;
  SaveGraphButton.Visible := false;
  SaveBlWhButton.Visible := false;
  SelectButton.Visible := false;
  ChoicesPanel.Visible := false;
  OutputMemo.Visible := false;
  BPbutton.Visible :=false;
  HelpForm.Hide;
  GraphicsButton.Visible := false;
  SymbolsButton.Visible := false;
  SymbolsForm.Hide;
  AnovaButton.Visible := false;
  if OutputReadDialog.Execute then
  begin
    DMSegReg.Filename := SegRegForm.OutputReadDialog.Files.Strings[0];
    if FileExists (DMSegReg.Filename) then
    begin
      DMSegReg.ReadOutputData;
      if DMSegReg.Code = ' Fun' then
      begin
        SelectData;
        MaxMin;
        Legends;
        GraphOpened := true;
        SaveGraphButton.Visible := true;
        SaveBlWhButton.Visible := true;
        GraphSaveMenu.Enabled := true;
        CalcObs_Button.Visible:= true;
        SelectButton.Visible := false;
        BPbutton.Visible :=false;
        HelpForm.Hide;
        GraphType := 0;               {only one independent variable present}
        GraphIndex  := 0;
        RegrType := RegrType1;
        if RegrType<2 then Showgraphics1            {BP=0}
           else Showgraphics2;                       {BP>0}
      end else
      begin
        GraphImage.Visible := false;
        CalcObs_Button.Visible:= false;
        CalcObs_Button.Caption:='See calc-obs graph';
        ChoicesPanel.Visible := true;
        ConfButton.Visible:=false;
        BlockButton.Visible:=false;
        if DMSegReg.Code =' Y-X' then
        begin
          Y_XRadioButton.Caption := 'Y-X function';
          YXr_ZRadioButton.Caption := 'Residuals-Z function';
          Calc_ObsRadioButton.Caption := 'Calculated-observed';
          Y_ZRadioButton.Caption := 'Y-Z data plot';
          X_ZRadioButton.Caption := 'X-Z data plot';
        end else
        begin
          Y_XRadioButton.Caption := 'Y-Z function';
          YXr_ZRadioButton.Caption := 'Residuals-X function';
          Calc_ObsRadioButton.Caption := 'Calculated-observed';
          Y_ZRadioButton.Caption := 'Y-X data plot';
          X_ZRadioButton.Caption := 'Z-X data plot';
        end;
      end;
    end else
        Showmessage ('File does not exist, please select another one,');
  end else
  begin
    ShowMessage('No output file selected');
    CalcObs_Button.Visible:=false;
    exit;
  end;
  HlpDir:=ExtractFilePath(DMSegReg.FileName);
  SetInitialDir (HlpDir);
  CalcObs_Button.Caption:='See calc-obs graph';
  GraphOpened := True;
end; {TSegRegForm.OutputReadActionExecute}



procedure TSegRegForm.GraphOpenActionExecute(Sender: TObject);
var HlpDir, GraphFileName :string;
begin
  inherited;
    CalcObs_Button.Visible:= false;
    CalcObs_Button.Caption:='See calc-obs graph';
    if GraphOpenDialog.Execute then
     begin
        GraphFilename := SegRegForm.GraphOpenDialog.Files.Strings[0];
        if FileExists (GraphFilename) then
          PictureImage.Picture.LoadFromFile(GraphFileName)
        else
        begin
          Showmessage ('File does not exist, please select another one');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No graphics file selected');
        exit;
      end;
      HlpDir:=ExtractFilePath(GraphFileName);
      SetInitialDir (HlpDir);
      GraphOpened :=true;
      PictureImage.Visible := true;
      GraphImage.Visible := false;
      GraphSaveMenu.Enabled := true;
      SaveGraphButton.Visible := true;
      SaveBlWhButton.Visible := true;
      GraphSaveAction.Enabled := true;
      ChoicesPanel.Visible := false;
      OutputMemo.Visible := false;
      GraphicsButton.Visible := false;
      SymbolsButton.Visible := false;
      BPbutton.Visible := false;
      HelpForm.Hide;
      AnovaButton.Visible := false;
      GraphicsTabsheet.Show;
end; {TSegRegForm.GraphOpenActionExecute}



procedure TSegRegForm.GraphSaveActionExecute(Sender: TObject);
var Result : boolean;
    HlpDir, GraphFileName:string;
begin
  inherited;
      Color:=true;
      DMSegReg.ReadOutputData;
      SelectData;
      MaxMin;
      Legends;
      if RegrType<2 then Showgraphics1          {BP=0}
      else Showgraphics2;                       {BP>0}
      if GraphSaveDialog.Execute then with DMSegReg do
      begin GraphFileName := GraphSaveDialog.Files.Strings[0];
        if FileExists(GraphFileName) then
             Result := Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          GraphImage.Picture.SaveToFile(GraphFileName);
          Showmessage ('The graph was saved in  ' + GraphFilename);
          HlpDir:=ExtractFilePath(GraphFileName);
          SetInitialDir (HlpDir);
        end;
      end
      else Showmessage ('The graph was not saved');
end; {GraphSaveActionExecute}


procedure TSegRegForm.SaveBlWhButtonClick(Sender: TObject);
var Result : boolean;
    HlpDir, GraphFileName:string;
begin
  inherited;
      Color:=false;
      DMSegReg.ReadOutputData;
      SelectData;
      MaxMin;
      Legends;
      if RegrType<2 then Showgraphics1           {BP=0}
      else Showgraphics2;                        {BP>0}
      if GraphSaveDialog.Execute then with DMSegReg do
      begin
        GraphFileName := GraphSaveDialog.Files.Strings[0];
        if FileExists(GraphFileName) then
             Result := Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          GraphImage.Picture.SaveToFile(GraphFileName);
          Showmessage ('The graph was saved in  ' + GraphFilename);
          HlpDir:=ExtractFilePath(GraphFileName);
          SetInitialDir (HlpDir);
        end;
      end
      else Showmessage ('The graph was not saved');
      Color:=true;
end; {SaveBlWhButtonClick}


end.





