inherited SegRegForm: TSegRegForm
  Left = 123
  Top = 59
  VertScrollBar.Range = 0
  AutoScroll = False
  Caption = 'SegReg segmented regression analysis'
  ClientHeight = 567
  ClientWidth = 873
  Menu = MainMenu1
  OldCreateOrder = True
  OnClose = FormClose
  OnCreate = FormCreate
  PixelsPerInch = 96
  TextHeight = 16
  inherited StatusBar1: TStatusBar
    Top = 550
    Width = 873
  end
  object PageControl1: TPageControl
    Left = 0
    Top = 0
    Width = 873
    Height = 550
    ActivePage = InputTabSheet
    Align = alClient
    TabOrder = 1
    object IntroTabSheet: TTabSheet
      Caption = '  Intro  '
      OnShow = IntroTabSheetShow
      object IntroMemo: TMemo
        Left = 16
        Top = 49
        Width = 465
        Height = 384
        Color = 14547711
        Lines.Strings = (
          '                INTRODUCTION TO THE SegReg PROGRAM'
          '                                 on www.waterlog.info'
          ''
          
            '   The SegReg program is designed for the segmented linear regre' +
            'ssion '
          
            '   with one dependent variable (Y, e.g. crop yield) and one (X) ' +
            'or  rwo'
          '   (X and Z) independent variables (e.g. crop growth factors).'
          ''
          
            '   The segmentation is done by introducing a break point. Thus o' +
            'ne can'
          '   obtain a broken line.'
          ''
          '   Further, seven types of functions (0 - 6)  are used. '
          ''
          
            '  The selection of the  best breakpoint and function type is bas' +
            'ed  on '
          
            '  maximizing the statistical coefficient of explanation, and  pe' +
            'rforming tests '
          '  of significance.'
          ''
          '  Reference: http://www.waterlog.info/pdf/regtxt.pdf'
          '  Reference: http://www.waterlog.info/pdf/segmregr.pdf'
          ' '
          '  For confidence intervals with breakpoint see:'
          '  http://www.waterlog.info/pdf/confidence.pdf'
          ''
          '  Email: sitemaster@waterlog.info'
          '')
        ReadOnly = True
        TabOrder = 0
      end
      object HelpGroupBox: TGroupBox
        Left = 504
        Top = 72
        Width = 153
        Height = 297
        Caption = 'Details'
        TabOrder = 1
        object TypesButton: TButton
          Left = 8
          Top = 32
          Width = 137
          Height = 33
          Caption = 'Function types'
          TabOrder = 0
          OnClick = TypesButtonClick
        end
        object TestsButton: TButton
          Left = 8
          Top = 84
          Width = 137
          Height = 33
          Caption = 'Significance tests'
          TabOrder = 1
          OnClick = TestsButtonClick
        end
        object SequenceButton: TButton
          Left = 8
          Top = 136
          Width = 137
          Height = 33
          Caption = 'Calculation sequence'
          TabOrder = 2
          OnClick = SequenceButtonClick
        end
        object MethodsButton: TButton
          Left = 8
          Top = 192
          Width = 137
          Height = 33
          Caption = 'Calculation methods'
          TabOrder = 3
          OnClick = MethodsButtonClick
        end
        object BackButton: TButton
          Left = 32
          Top = 248
          Width = 97
          Height = 25
          Caption = 'Introduction'
          TabOrder = 4
          OnClick = BackButtonClick
        end
      end
      object TypesMemo: TMemo
        Left = 24
        Top = 56
        Width = 441
        Height = 337
        Color = 16055551
        Lines.Strings = (
          '               EXPLANATION OF THE FUNCTION TYPES USED'
          ''
          
            '   The relation between the dependent variable Y and the indepen' +
            'dent '
          
            '   variable X or Z is described by one of seven types of functio' +
            'ns:'
          
            '     Type 0 - a single horizontal line without break-point: no r' +
            'elation'
          '     Type 1 - a single sloping line without break-point'
          '     Type 2 - two connected segments with sloping lines '
          '     Type 3 - a horizontal segment followed by a sloping line  '
          '     Type 4 - a sloping segment followed by a horizontal line'
          '     Type 5 - two horizontal segments at different levels'
          
            '     Type 6 - two disconnected segments of which at least one sl' +
            'oping, '
          ''
          
            '   For types 2 and higher two calculation sequences are employed' +
            '.'
          '       In calculating types 2, 3 and 4, two methods are tested. '
          
            '   The best fitting function is found by maximising the statisti' +
            'cal'
          
            '   coefficient of explanation for the different types, sequences' +
            ', methods,'
          
            '   and break points BP (including the correlation coefficient fo' +
            'und when '
          '   omitting BP), followed by significance tests. '
          
            '       There is an option to exclude types from the analysis. Th' +
            'is can help'
          '   to find the next best.'
          '')
        TabOrder = 2
        Visible = False
      end
      object TestsMemo: TMemo
        Left = 32
        Top = 32
        Width = 457
        Height = 425
        Color = 15400951
        Lines.Strings = (
          '             SIGNIFICANCE TESTS FOR THE FUNCTION TYPES USED'
          ''
          
            ' The relation between the dependent variable Y and the independe' +
            'nt '
          'variable'
          
            ' X or Z is described by the best fitting function selected from ' +
            'seven types:'
          
            '       Type 0 - a single horizontal line without break point: no' +
            ' relation'
          '       Type 1 - a single sloping line without break point'
          '       Type 2 - two connected segments with sloping lines '
          '       Type 3 - a horizontal segment followed by a sloping line'
          '       Type 4 - a sloping segment followed by a horizontal line'
          '       Type 5 - two horizontal segments at different levels'
          '       Type 6 - two disconnected segments with sloping lines'
          
            ' Type 0 is used when type 1 has an insignificant regression coef' +
            'ficient '
          '      (RC). '
          
            ' Type 1 is used when its correlation coefficient (CC) is higher ' +
            'than the'
          
            '      the explanation coefficient (EC) of types 2, 3, 4, 5, and ' +
            '6. '
          
            ' Type 2 is used when the two RC'#39's (RC1 and RC2) are significant ' +
            'at 90%'
          '      certainty or higher are significantly different at 90%'
          ' Type 3: the RC value to the left of the breakpoint BP (RC1) is '
          'insignificant,'
          
            '      and the RC value to the right (RC2) is significant at 90% ' +
            'certainty or '
          '      higher. '
          
            ' Type 4: contrary to Type 3, the RC1 is 90% significant and the ' +
            'RC2 is '
          'not. '
          
            ' Type 5 is used when RC1 and RC2 are both insignificant while th' +
            'e '
          
            '      average  Y values to the left and right of BP differ signi' +
            'ficantly at 90% '
          '      or  higher.'
          
            ' Type 6 is used when one or both RC'#39's are significant at 90% or ' +
            'higher '
          
            '     and the lines have significantly different Y-values at BP, ' +
            'while the '
          'value'
          
            '     of Y at BP of each segment is significantly different from ' +
            'the average Y '
          '     value of the other.'
          ''
          
            ' For types 2, 3,and 4 the additional condition is put that the c' +
            'onfidence'
          ' limits of the breakpoint must be well inside the data range.')
        ScrollBars = ssVertical
        TabOrder = 3
        Visible = False
      end
      object SequenceMemo: TMemo
        Left = 40
        Top = 48
        Width = 449
        Height = 353
        Color = 16646128
        Lines.Strings = (
          '               EXPLANATION OF THE CALCULATION SEQUENCES'
          ''
          
            '   When two independent variables (X and Z) are present, two cal' +
            'culation'
          '   sequences are used:'
          ''
          
            '   1 - a segmented linear regression of the dependent variable Y' +
            ' upon the '
          
            '       first independent variable X, followed by the segmented l' +
            'inear '
          
            '       regression of the Y-residuals (YXr) on the second indepen' +
            'dent '
          '       variable Z.'
          
            '   2 - a segmented linear regression of the dependent variable Y' +
            ' upon the '
          
            '       second independent variable Z, followed by the segmented ' +
            'linear '
          
            '       regression of the Y-residuals (YZr) on the first independ' +
            'ent '
          '       variable X.'
          ''
          
            '   There are also seven function types and two calculation metho' +
            'ds involved.'
          
            '          The best sequence is found by maximising the statistic' +
            'al coefficient '
          
            '   of explanation for the different types, sequences, methods, a' +
            'nd break '
          
            '   points BP (including the correlation coefficient found when o' +
            'mitting BP),'
          '   followed by significance tests. '
          '')
        TabOrder = 4
        Visible = False
      end
      object MethodsMemo: TMemo
        Left = 48
        Top = 64
        Width = 441
        Height = 321
        Color = 16773372
        Lines.Strings = (
          '               EXPLANATION OF THE CALCULATION METHODS'
          ''
          
            '   In calculating the function types 3 and 4, two calculation me' +
            'thods are '
          '   used:'
          
            '   1 - the regression line of the sloping segment is intersected' +
            ' with the '
          
            '       vertical line at the break point. From there a horizontal' +
            ' line '
          '       proceeds into the other segment of the function.'
          
            '   2 - a horizontal line is constructed through the central poin' +
            't of the data'
          
            '       in the horizontal segment of the function. This line is i' +
            'ntersected '
          
            '       with the vertical line at the break point. From there a s' +
            'loping line '
          
            '       proceeds through the central point of the data in the oth' +
            'er segnment'
          '       of the function.'
          
            '   The methods for Type 2 are similar, but there is no horizonta' +
            'l segment.'
          
            '   It may happen that the break point and intersection point (Xc' +
            'ross) differ.'
          '       There are also two calculation sequences involved. '
          
            '   The optimal method is found by maximising the statistical coe' +
            'fficient'
          
            '   of explanation (CE) for the different types, sequences, metho' +
            'ds, and '
          
            '   break points BP (including the correlation coefficient found ' +
            'when '
          '   omitting BP),  followed by significance tests. ')
        TabOrder = 5
        Visible = False
      end
      object MoreInfoButton: TButton
        Left = 528
        Top = 392
        Width = 113
        Height = 25
        Caption = 'More info'
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -16
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 6
        Visible = False
        OnClick = MoreInfoButtonClick
      end
    end
    object Figures_TabSheet: TTabSheet
      Caption = 'Figures'
      ImageIndex = 4
      object Types_Image: TImage
        Left = 48
        Top = 0
        Width = 689
        Height = 489
        Picture.Data = {
          0A544A504547496D61676507890000FFD8FFE000104A46494600010101006000
          600000FFE1001645786966000049492A0008000000000000000000FFDB004300
          080606070605080707070909080A0C140D0C0B0B0C1912130F141D1A1F1E1D1A
          1C1C20242E2720222C231C1C2837292C30313434341F27393D38323C2E333432
          FFDB0043010909090C0B0C180D0D1832211C2132323232323232323232323232
          3232323232323232323232323232323232323232323232323232323232323232
          3232323232FFC0001108020C02D503012200021101031101FFC4001F00000105
          01010101010100000000000000000102030405060708090A0BFFC400B5100002
          010303020403050504040000017D010203000411051221314106135161072271
          14328191A1082342B1C11552D1F02433627282090A161718191A25262728292A
          3435363738393A434445464748494A535455565758595A636465666768696A73
          7475767778797A838485868788898A92939495969798999AA2A3A4A5A6A7A8A9
          AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8D9DAE1E2E3E4
          E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FAFFC4001F010003010101010101010101
          0000000000000102030405060708090A0BFFC400B51100020102040403040705
          040400010277000102031104052131061241510761711322328108144291A1B1
          C109233352F0156272D10A162434E125F11718191A262728292A35363738393A
          434445464748494A535455565758595A636465666768696A737475767778797A
          82838485868788898A92939495969798999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6
          B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8D9DAE2E3E4E5E6E7E8E9EAF2
          F3F4F5F6F7F8F9FAFFDA000C03010002110311003F00F7EA28AC5F11DEDC69FA
          6C335B486391AFECA1276839492E62471CFAAB30F6CF1CD006D5145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          400514514005145140051451400514514005145140051451400514514005028A
          05002D1451400514514005145140095CFF008CBFE4096DFF00615D3BFF004B21
          AE82B9FF00197FC812DBFEC2BA77FE9643401D05145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          1451400514514005145140051451400521273C7E54B5CE78BF5A4D1344DDF6E8
          6C67BC956D2DEE67755485DB399097F94EC40EFB5B1BB66DCE58500744A72A0D
          2D79AD978F3FB2BC09E1FBE07FB580D2E3B8D4258DE59A58D5500763B2371B8B
          2CA332346372365B86DBE923DE80168A28A0028A28A0028A28A0028A28A0028A
          28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A
          28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A
          28A0028A28A0028A28A0028A28A00281450280168A28A0028A28A0028A28A004
          AE7FC65FF204B6FF00B0AE9DFF00A590D7415CFF008CBFE4096DFF00615D3BFF
          004B21A00E828A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28
          A0028A28A0028A2A9EA17D069D6725CDCC9E5C498C9C16249380AAA012CC4900
          280492400092050041AA6BDA468AD17F6AEA9656066CF97F6AB848B7E319C6E2
          338C8FCEA90F1DF8471CF8AB43FF00C1845FFC554DA1D8DC2F99AAEA51797AA5
          EC5189A10C0ADBA2EE29082386DA647CBF566663C2ED55DA000A00E7FF00E13B
          F087FD0D5A1FFE0C22FF00E2A8FF0084EFC21FF435687FF8308BFF008AAE828A
          00E7FF00E13BF087FD0D5A1FFE0C22FF00E2A8FF0084EFC21FF435687FF8308B
          FF008AAE828A00E7FF00E13BF087FD0D5A1FFE0C22FF00E2A8FF0084EFC21FF4
          35687FF8308BFF008AAE828A00E7FF00E13BF087FD0D5A1FFE0C22FF00E2A8FF
          0084EFC21FF435687FF8308BFF008AAE828A00E7FF00E13BF087FD0D5A1FFE0C
          22FF00E2A8FF0084EFC21FF435687FF8308BFF008AAE828A00E7FF00E13BF087
          FD0D5A1FFE0C22FF00E2A8FF0084EBC21FF435687FF8308BFF008AAE828A00F3
          EBA9BE1ADED943A7B6BFA5ADBC76AB67B20D6CC4648546D58E42920322804801
          C9FBCDEA73DB69D7D69A9D925DD8DD41756D213B268245746C1C1C32F070411F
          855A201EA296800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A05140A005A28A2800A28A2800A28A28012B9FF00197FC812
          DBFEC2BA77FE96435D0573FE32FF009025B7FD8574EFFD2C86803A0A28A2800A
          28A28020927589E1460E5A57D8BB636600ED2DF31030A30A793819C0EA403329
          27FA52900D14005213838EF4B59FABEAB65A2E9971A96A57096D676EBBA59643
          C28FEA738000C9248039340180BA87896EFC49AD1D3CE9EDA7E9CF0DAADA5C96
          569A5F2C4AEE25553E58DB34630564C98CFDCCE6B5F4ED7ECF51B86B405EDB50
          442F259DD298E6500805829FBE9938DE85909180C69BE17B2B9B1F0EDA25EC7E
          55F4DBEEAEE3C82239E67696555233F287760393C01C9EB56B51D2ACB56B7482
          FAD52744712479E1A2719C3A30E51C64E194820F422802F83914B5CE09B58D08
          06B969F5AB13D648E145BA87B96755DA255EBC4681C6140490B1234F4DD5EC75
          6B769ECAE52645731C9838689C004A3A9C1471919560187702803428A4539A5A
          0028A290920E07A5000C4815CE213E22D584EE47F64584B22223F4B8B98DC297
          23FBB132381BBAB9DC00F2D1DA4D76E26BC74D0EC64912E2E94FDA67858892CE
          DCAB03282318762362739C92C0308D856C5B410DB5B4504112430C2A1238A350
          AA8A060000700018E3B5004EBC0E3A52D0060714500145145001451450014514
          5001451450014514500145145001451450014514500145145001451450014514
          5001451450014514500145145001451450014514500145145001451450014514
          5001451450014514500145145001451450014514500145145001451450014514
          50014514500145145001451450014514500140A281400B451450014514500145
          145002573FE32FF9025B7FD8574EFF00D2C86BA0AE7FC65FF204B6FF00B0AE9D
          FF00A590D007414514500145145001451450015CA78A2DA3D7F50D3BC3EC77DA
          F9AB7DA94651591A08CE5237DC0E37CA108181B96297078C1EA59B6FE59AE7FC
          3B8BED4759D5DFE6F3AEDACE0CF0C90DB3347B481C7FAEFB4303C92AE3278DAA
          01D0AF4A5C51D28A0042A0F51593A968D15F5CA5CC3737763A822845BAB470AD
          B73D1958324806E6C0756DBB891B49CD6BD04668039B1AF5CE9002F892282D20
          E83538E502D58F6DFB8EE899B04E0E50655448CC40AE8B71C9FF000A5C01D057
          387C3EFA3B79BE1AF22C947DFB1977FD95C0E708A0E206273F3A023E762C8E71
          800E90567EA5A8C3A7C0B248B2492C8FE5410440192690824220240CE0139240
          001624282453B0F10C0F731E9B7E0596AA7205B4B902520124C2E40132851B89
          5E402372A13B456D2C9D7752FEDC9706CE3DD1E9B1B72386756B807A7EF01014
          8DDFBBC10C3CD65A00BBA1E992D858B4978637D4AEDC5C5EBC79F2DA628AA420
          2061004555E338504E58927600C522F4FC696800A28A2800A28A2800A28A2800
          A28A28030356D5352B1D7F44B48ADAD5AC2FAE1A0926695BCD0C219A4C040B80
          3F76BF36E3D48DBDEADFF6D59AEAFF00D98ED3C7747EEF9B6D224721DBBB6A4A
          5423B63276AB13856E3E5385D4B4DFB75F69573E718FFB3EE9AE76EDCF999864
          8B6E7231FEB739E7EEE3BD73F1F824A78B6DB5BFB458B791752DCF98F619BC93
          CC8E44F2DEE37F31AF99F2AECE151173C66803B25248E7AD41717115A5BCB717
          12C70C112179259182AA28192493C00077ACED4B5A5B4B85B1B4824BBD4644DD
          1DBA2B05504E034AE0111A70DC9E4EC60AAE46DA86DF437BBB84BED75E3BCB84
          612C36BB55ADED1C1C831654167181FBC6E73B8A88C315A00759EA5A86A5771C
          B6D666DB4C19DD2DDA491CF31008C2C4CAA517247CEE413B080982AF5B8A78E6
          902F1CF3EF4E0314005145140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          005145140051451400514514005028A05002D1451400514514005145140095CF
          F8CBFE4096DFF615D3BFF4B21AE82B9FF197FC812DBFEC2BA77FE9643401D051
          4514005145140051452138A00C9F11EA53697A2C93DB246D76EF1DBDB094129E
          74AEB1C65F1CEC0EEBBB1CE338C9C036347D3A2D1F46B2D2E077921B2823B78D
          A420B15450A324003381E82B2AFDFEDDE31D32D14663D3A27BF9B1C1591C3430
          839EAACA6E49C0C831A9240E1BA3072280168A28A0028A28A0029AD9C8C63F1A
          7563EB9A94B616491D9049352BB736F651CA0EC69B6330DE41184508CCDCE70A
          40CB1008067EB7043E24BD5D0648639EC22749F506650E0323C72450107825F8
          661CE100040F311AA5F2359D10EFB5967D66C0702D6429F6A8FB0D92B32AC8A3
          00624F9CE598C8C4053A7A569F0E99629690B3B8DEF23C92105A491D8BBB9C00
          32CCCCD800019E001815A18A00CBD335CD3F5632ADA4F99A1C79D0488D14D0E7
          3B7CC8DC074C8048DC064723239AD35CE3939F7C5666A5A3DBEA4626679EDEEA
          0C982E6DA531C91E719C11C32E5549460518AAEE5381543FB4B51D11B66B1099
          EC23E3FB56265F957FBF711E06CEA0168F72F0CEC22518001D1D155A0B98AEE1
          8AE6DE58E682550F1C91B06575232194838208EF564500145145001451450014
          5213838AC8D435DB7B2B84B28D24BCD49D7CC4B1B56433327237E19942A707E6
          6217236E4B10080685C4F0DA412DC5C4A91411217924760AA8A0124B13C0000E
          B588750D435E05746CD9D8104FF6A491AC9E7A9E336EBBBEA448E36F0A556456
          C87DBE8D737B731DE6B93A4D2C4C1E0B4B6674B7848391B813FBE7040C3B0006
          C52A88739DF51C73CFBD0067E99A5D96916CD0D8DB242AF21790819695C800BB
          B1E5DCE06598963DC935A1814B8C514005145140051451400514D2707F0A70A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A002814502
          80168A28A0028A28A0028A28A004AE7FC65FF204B6FF00B0AE9DFF00A590D741
          5CFF008CBFE4096DFF00615D3BFF004B21A00E828A28A0028A28A0029ADC1C9E
          D4EAC0F15CD326872DADACB245797ECB636F246C4491B4A7699100E498D4B4A4
          0C71193900640045E1502F6CEE35C71BA4D526696273D3ECA095B70B9E554C78
          9369E8F2C9C2E481D20000C0AAF6B0456B6D15BDBC4914312848E2450AA8A060
          280380001802AC5001451450014514D66C71DE8020B9B88AD2096E279638A189
          0BC923B055451C9624F0001C93593A1C135EB3EBDA845225C5D28FB3412A957B
          3B7214888838C39237BF19DC42E584686A290B788B566B6C83A5584B1C8CE9FF
          002F1731C9BBCB07FBB13221257AB90A48D9223746A411C5002D145140085412
          0E39146052D14018171E1D586E64BED0E48F4DBE918BC9FBB67B79998E59A584
          328673C1DE0ABE554162B95241E2258278ACB5B8A3D36FA4709166467B79D98E
          156398AA8673C8D8407CAB10A54063BE403D6AB5D5B43756F25BDC4293432A98
          E48E450CAEAC305483C107B8A00B0A491CFF00FAE96B9CFECDD4344CC9A34C2E
          34F4E7FB2A4551B57FB96F2646CEA4857DCBC2A2989791A5A7EA2BA8DB3482DE
          EEDDA3631C915CC0636460012327E570338DC8590F382473401A355EE2E22B48
          24B8B8912282242F248EC155140249627A00075AA5A9EAC9A708E34B79EF2EE6
          2C61B4B7D86470B8DCDF332A855C8CB33019206773283521D1AEAEEE63BCD767
          49E58D83C1696CCE96F090770DC0B7EF9C1030EC001B14AA21CE4018750D475E
          18D198DA58633FDA5246B279EA78FF00475DDF522475DBC2955915B234F4DD36
          D74AB7682D524019CBBBCB2BCB248D8032CEE4B31C003249C0503A0157D471CF
          3EF4B8C50026052D145001451450014514500154351D461D32012482496591FC
          B820880324D210484404819C024924000166214120D4751874C8049209259647
          F2E082200C934841211012067009249000059885048AFA6E9D30B96D4B516497
          51910A0F2C931DB46483E547900E3201662017201200088801269D697B1992EB
          509FCCBB9F1BE289C9860519C22038CE3272E4066273F2A8545D2000181D2968
          A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28
          A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28
          A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028145
          0280168A28A0028A28A0028A28A004AE7FC65FF204B6FF00B0AE9DFF00A590D7
          415CFF008CBFE4096DFF00615D3BFF004B21A00E828A28A0028A28A004248AE7
          09FED3F1B9032D6FA45A60FF001A35C4C79F659238D3FDE2B73D81F9B72E678A
          D2092E2E258E182242F24B23055451C9249E00033D6B1FC2B04A347FED1BA8A5
          8AFB547FB75CC722956899D542C441C731C6B1C79C0CECDC4024D006FAE71CD2
          D0063A514005145140084E2B135ABDB9F32DB4BD3E4F2EFEF32CB26D07C98119
          04D2F3C6E50E028C37CEEB952A188B9AB6A30691A6CD7D3A3B244BB9638C02F2
          B7458D012373B121557B920557D234D9ADDEEEFAF8A3EA17AEAF36C24A44AA30
          912123251793CE32CEEDB5776D00172C2CADEC2D12DAD62F2E14CE0162C58939
          2CCC725989249624924924924D5CC62900006052D00145145001451450014601
          A462474AA1A86A96BA5C0B35DB380EFB112289E59246C13858D0167380C7E507
          0149E80900178F0D9C715C96A366BAFEB0B26996E90CD6AFE44DADC723472A6D
          624C51ED1FBE0181DCAE7CA57232B2147416FF00B3F50D770DAB8FB2D8B71FD9
          B1481FCF5EB8B87DBF406343B78605A456DA36ED6DE1B5B68ADADE2486085424
          7146A1551400028038000C71401CCDA06F0B5C5D4D7F62924133EEB8D7226064
          7504E1AE94E1942EEDA0A6E45018E2141B474D05CC575045716D224D04A81E39
          2360CAEA402181070411DEAC6D158371E1D586E64BED0E48F4DBE918BC9FBB67
          B79998E59A584328673C1DE0ABE554162B95201BC296B9F83C442DE78ACB5C8E
          3D36FA47091E6467B79D9880AB1CC554339E46C215F2AC4295C31DE2C7E9C500
          3A8A05140051452138A005AA1A8EA30E9900924124B2C8FE5C10440192690824
          220240CE0124920000B310A090DD47518F4CB759244796491FCB860880324F21
          0484407033C1249C00016240048874DD3A6172DA96A2CB2EA522141B0931DB46
          483E547900E320166201720120008880155123D2525D77C41776B0DC6DD8F33C
          BB60B48D88C451B36382DB7731C176009C0088BA96FA8DADE6D5B5B9826DD0A4
          EBE5C8AF98DF3B5C60FDD38383D0E0E0F159DE28D6B4ED02D2D6F2F96D7CD33F
          97666EA458916628FC991B88C6CDF96EB8C801890A7CF5AFEDB46D4F52BAD2BC
          5304976FA54777690DBBC0D16A972D737B23468A433B2F98C542C6DBB0D8DC5B
          06803D7C52D20E94B4005145140051451400579BEA3E28D620D2EFE54BCC4915
          86BF321F2D387B6BA58E03D3F85491EFDF26BD22BCDF51F0BEB13E977F1259E6
          496C35F8507989CBDCDD2C900EBFC4A09F6EF83401D75D7892D2D2C75EBC922B
          831E89BBED015465F6C0939D9CF3F2B81CE39CF6E6A3B9F12086FEE6DADF4AD4
          6F63B470975716CB1B2C0C515C8285C48E423A36111B3B80196C8181E21D3B5B
          1A7F8C34DD3F4792F5F5B491EDE61711471479B58E12AFB9B7EFCC6C4614A9DC
          9965CB159FC45A75F497F792699A4EA51DFCC80DB6A167A8F956CB2EC0A925C4
          3E62EF2AC0647972E51547CDF7140251E3496D2F75DFED2D22F63B2D3F508AD2
          39E14490BF98200A362C8CECC5A6DE36AFDCC0C6FCAD6949E22748A18D345D46
          5D41D3CC92C23680CB0C7B8A877632F960311F28DE4B738076BEDC5BCD375697
          50D6AD934A9CC373AD586A11DD79B1796D1C46CC38C6FDE180864382B8217824
          900DBF10D95D4FAC6FB9D2F52D5B4B3022C76B6576912AC9B9FCDF391A58D654
          753100ADBC7CAE081B8EE0023F174F75E22D2AC6CF48BB9AD6EE0B969DF31068
          258668E2753990711B3386DA1B395285866AE5AF88E06F0FE8F770477DA8DC5F
          DAC73DBDB85885CCCA51599D865635C061B8E554160A39650707C3FA3EADA25E
          688CFA16C893FB4E0962B29A231DA2CF791C9111B993318453F75770000DA0F1
          56B4AD2753D1F47F0B5E1B292E6EB4CD2069F736314918932EB0EE28CCC10956
          84020B0043120E542B006A5C78B6CEDEDAD5FEC77D2DCDCDD9B2FB1C71869A2B
          811349E5B8DD85E13EF6766195F76C3BEAFE93AB26AD14FF00E8F3DADC5B4BE4
          DC5BCFB77C4FB55C0251994E51D1BE563F7B0704103021D13517D5EC75492DFC
          B69F5A6D42E202EA4DB47F607B650C41C336421217201720160BB8EC68F65716
          9A9F88269E2DB1DD5FA4D01C83BD05B4084F1D3E6461CFA7A6280229FC4D6F05
          CC9FE8B76FA740E63B9D49027D9E17070C1896DE429E19954AA1DDB986C7DB57
          44D5752D4BC5DAE43716F7D059D8CBF66894FD9FC863E5C526E38632F987CC24
          744D857203E6A95D693A93689AB785A2B292483537BC2BA9078C450A5CBC8EDB
          D0B6FDE9E6300AAA436132C9B9B66E68F657169A9F88269E2DB1DD5FA4D01C83
          BD05B4084F1D3E6461CFA7A62802BC9E2A41A95FD941A3EAB75F609563BB9ADE
          1529166349030CB0693E57FBB1867F97EEFCC9BA7B9F105BA98574FB69F589A5
          896758EC1E23889BEEC859DD502B11F2FCD96C12A085623134FD4353B4F1178A
          52D3457BD493538C24A9711A2C6FF63B6CF9BB882A9F74EE4121FBDF2F0374BA
          7E8F7BE13368F6B693EB11C7A5DA698EB6C638A4536FE6624C48EAA55BCC6C8D
          D952AB80C189500D39BC4D6FB2CFFB3ED6EF539AED24923B7B6088E12365590B
          79AC814AB3AA952430271B786C137897CA4B448B49D46E2FAE5647162AB1C72A
          2C6CAB216323AA6159D06431DDB815DCBF3563CDA1CB69A55AA5C69377A84E6E
          2EAE246D26FCDB4D034F3198C6AE5E22F165B04EE19288767F70934DBE3A2E9F
          FDA1A46A57D3C6F385367A8F91796F133E628DA4F313781184573E61CBA29FDE
          7DF001B706B0973AAD85BB25F5B4D71693CA6DA58954298E4891B7F53B817014
          A928C0B1CB0DA6B23C29E2D9B50F0FE893EA9677D17DAED6DC1D4A68923866B8
          645C80036E5DCF90A591518E0293B93749A3E97AB47AC68F777F1C8C90D9DF44
          C65943BC4B24F03411B9C92EE224DACD96C9424B364134347D3B5CB8F0AE81E1
          CD434892C5EC52C5EE2E8DC452447ECED1C81502B6F2E4C6AA72AAAB97219F6A
          EF00D3D3BC4928D318CD14F7F7F25FDF4305ADBAA091E386E64407E62AA15502
          02CC40C95192CC01DBD3B51875380C91AC914B1B98E782500490C800251C0246
          7041041208219495209E3A4F0B5E2C76D7D35A5ECCD6B77A9EEB5B1BE36D33C7
          737665475916440701509466030E4FDE40A7A2F0C69274BB4B976B77B77BCB83
          70629AEA4B9957E44402491DDB73ED419DA768E146EDBBD80127F135BC17327F
          A2DDBE9D0398EE752409F6785C1C30625B790A7866552A8776E61B1F6CB75E24
          B4B4B1D7AF248AE0C7A26EFB4055197DB024E7673CFCAE0738E73DB9AC3BAD27
          526D1356F0B456524906A6F7857520F188A14B9791DB7A16DFBD3CC60155486C
          26593736C83C43A76B634FF1869BA7E8F25EBEB6923DBCC2E228E28F36B1C255
          F736FDF98D88C2953B932CB962A01A963E2B94EA5AF45A969F3DA5969B74218E
          E7E460F98E22A9B55D9DA476972A15790CABF7F2B57A2F102ADA5CCFA969F7DA
          6791B729748AE5C31C2EC3133ABB16F942292F9C7CBF32E7167D2753BABEF105
          B258C8893EA76BA9DA5D49247E4CA604B52223863229668186ED8401CF3C037A
          F63D4BC45A54A8DA5C9A6343716D716E9793465A578665976B7945C221D8ABBB
          2C4658ECF946E00925F154169A7EA173A869F7D61359DA4978D6B3F946492141
          9668CA3B2360F046EC8257700194961F1701711DB7F616B1F69B84692CE13146
          1AEA3523738CB811050C8489BCB3F300016F96B335ED3356F1369FAADCAE953D
          94C345BED3EDAD6E6588C93C938439CA3B22A8312804B64966C850A0B6FDCD94
          F278C74EBF11936D0D85DC323E470EF25B1518EBC88DFF002F7140112F89EDE4
          B0B79ADED6EAE6EE779634B188279FBE2729283B982008C082C5B6E700312CBB
          965F135B0B289E3B5BB96F25B8FB20D3D422CE27086468DB73040422B3E4B6D6
          500A960CBBB9D93C2D78B1DB5F4D697B335ADDEA7BAD6C6F8DB4CF1DCDD9951D
          6459101C054251980C393F79029B516826D742999B45BB9DE7BDFB51B78F5390
          DEC3FBB1186170F2F32ED50182C88A1199417C7EF003A6D3AFDB50819E4B1BBB
          2951CA3C372AA194E01182A59181041CAB11D41C1040A13F89ADE0B993FD16ED
          F4E81CC773A9204FB3C2E0E18312DBC853C332A9543BB730D8FB57C316F7D6D6
          7722EA3BB8606B82D696F7971E7CF0C5B1015924DCFB899048C3E76C2B28C8C6
          D5C7BAD27526D1356F0B456524906A6F7857520F188A14B9791DB7A16DFBD3CC
          60155486C26593736C00BBA26ABA96A5E2ED721B8B7BE82CEC65FB344A7ECFE4
          31F2E29371C3197CC3E6123A26C2B901F3516A77F249AF3E9F79E22934005D23
          B148FC80D7FB80CB06991C310C76796A030C6E6C89131A9A3D95C5A6A7E209A7
          8B6C7757E9340720EF416D0213C74F991873E9E98A8F55BAD42192E2DA6D09F5
          8D3EE536AA5B1841552B8749566914303C9057390482A3682E00FF00B65C68FA
          7EDD4E4FB6CFE6F9369E428F3AF09195053851270DBB042614B9D8B908B0788E
          D3EC7732DEA4F6135AEDF3ED6E14199779C47811960FBCF0BB0B6E6CA8F98151
          CE4BE1199F4A8648ACE4B58A0D4BFB420D22CAE0DB3431180C2618E48D94239D
          CD290A42176652D826422F8788D3AF2F3CA934E967B8B13047AA6A125C4AED05
          C092349246924540EE76284DD8DDBBE62DB14027D73C653C1A36B10269DA8E97
          AB43A45E5FDB9B98E27502255018323BA13B9C7CB9246D3B80057759D560D57C
          3FA64FAB2F88B51BF7B64DE9637515B04BA6E8221E5C2AFBDC90AB83F7997E56
          FBA713C43FDABE24D42FECE2D167B598F86F51B78E19E789A4324C6109BB6332
          22B1460A4BE58A49C00993B575E0ED2F4BBEB1D6B41D074E82FAC5DCB476D6D1
          C4D3C4C855D15B002BFDD65638FBA5372ABB1A00D4BDF102DA5E496F069F7D7D
          E463ED6F668AE2D81008DC0B0666DA776C8C3BE31F2FCC9B92E7C416EA615D3E
          DA7D62696259D63B0788E226FBB21677540AC47CBF365B04A821588C1D4BC3B3
          C5AF6A5771D96A97C75295258DACB5896CE3818449162655957E5FDD86DE8AED
          82C36FCABBA7B5B297C33A8A0B0B4FED2D9A559D94967652247240B119BCB902
          CD27FAB6DD20E5CB0318FBF962A01D068BABC1AEE9C2FED639D216965882CF11
          8DF31C8D1B654F2BCA1E0E0FA8078AD2AE67C0CD3BF85D669D23479EF2F27023
          72E8CB25D4AEAC8C40DE8558156C0DC083DEBA6A0028A28A00281450280168A2
          8A0028A28A0028A28A004AE7FC65FF00204B6FFB0AE9DFFA590D7415CFF8CBFE
          4096DFF615D3BFF4B21A00E828A28A0028A2918E3DA8039EF1366F3FB3B455E7
          FB42E97CF039C5BC7FBD9372F78DF62C2D9E3F7E339CED3D0AF03FFAD5CE6967
          FB43C51ABEA6DCC36DB34EB627E653B7E795D1BA0DCEE23603F8AD864E4617A3
          5E9F8D002D14514005349C1C67F0A524E4631F8D739A837F6FDF4BA1AF1656FE
          549A8483E61264EE16E319077050640DFF002CE45183E66E50034A3FDBB771F8
          81C07B06854E9713F50181CDC11D9A456000396541FC264741D1AF4FC685E466
          9718A0028A28A0028A29AC71F4A007557B8B88AD2092E2E2448A0890BC923B05
          5450092589E8001D6A9EA5ABC1A6189648E79EE66CF916B6F199249318CF0385
          504A82EC4202CBB9864553B7D1AE6F2E63BCD72749A589C3C1676CCE96F09072
          3702DFBE7040C3B0006C52A887390061D4351D78634726D34FEBFDA72C6B279E
          BD336EBBBEA448EBB7852AB22B645FB1D1B4FD3E459E1B7DF731C6605BA9DDA6
          9FCB2DBF6195C972BB8E704E07E15A6A38E79F7A5C628010280300714B451400
          50403D68A280209EDE1BAB792DEE224961954A3C7228657523041078208ED593
          7BA55DA5EBEA1A5DF4F15C100BDACD317B69F03014AB0262E33868F1C9DCCAF8
          C1DDA08CD0061D8EBD1B5D47A7EA30FF00676A7264456F2CAACB70147CCD0B03
          F3A8C138215C0C1645DC33B6A49519AA9A8585A6A566F697D6B0DD5B498DF04F
          1AC88F8391956E0E0807F0AC8FB2EB1A211FD96E352B00726CEEE776B95EEDE5
          CEEC77F4E124C72C7F78AA02800E889C565EA5A9FD89E182DE2FB4DFDC6E16F6
          C1B6EE2319666C1D91AEE1B9B07190002CCAAD44F8B74FBA616DA6B7DA7547E1
          34F90343327FB72A380F14607259979046D0C594368697A5FD87CDB89E6373A8
          5C60DC5C95DBBB19C228C9DB1AE4ED5C9C6492599999800D3B4CFB30173752FD
          AF506DE5EE5971B776DDC91AE4F969F220DA0FF082C59B2C74C0C500628A0029
          36814B450014514500145145001451450015512FECE48ADA44BB81A3BBC7D99D
          64044D952E361CFCDF282DC7604F4AB75E676DA66AB7316A905B248B3F87DE7F
          ECB81250A9F6869DE68A23CE020B7FB2C6305408EE254C8C90A01DCCDAC5A417
          92C525E58A470472C9705EE42BC3B046C72B8FBA1640CCC48DBB93821B2312CB
          E206877E9A75CC77B6B1D85D5949752DCCD748A2D591A01E549C90AFFE90B905
          B8200E73599E1AFDEF88F48D40FCDFDA169AB5E24A7EF4D0C9756C6063DFFD4F
          94003CAA855C0DB814FC193E9FA9BF80E4B796D2EDECBC3D3A1646590DBCC16C
          95864676B856208E0E188EF401E8D6F710DD5BC57104B1CD04A81E3911832BA9
          190411C104739ACF1AF69D6FA6DBDEEA1A969D6C935B89F7FDAD4C454EC0591D
          B6EE4DD2200D819DCBD320556F077FC816E7FEC2BA97FE96CD5CDF85A08A593E
          1E3CB146EF0F866578D994128DB6CD72A7B1DACC323B123BD0076B2EABA75B69
          8BAA4FA85A45A79457174F32AC455B1B4EF2718391839E722A869FE238B52BB9
          A3B736A608EF56D6398DC8FF004856B54B80F18030C70FF773F7559B3C62B99D
          2E78B4FB9B1D4B519638349B7BDD695E79D808A1B86BD2236627842504EA1CE0
          7CE5739701ABE97358DCF8996E74E09F6597C58EE8D1C7B1642DA492CE381B83
          312DB870D9DC09072403BE9355D360D4E2D325D42D23BF9937C568D32895D79E
          5533923E56E40EC7D2A2BAD7748B2D460B0BBD56CADEF67DBE4DB4D7089249B8
          ED5DAA4E4E482063A9AC1D26FB4CB292E748D66483FB5EE3549A75B59577CD38
          3705ADE555E4BAAC622C38C88C458257CB21795F146AB09F0DF8B2D5F5CB5D32
          674BE274A823125FCEC03A0694B976313A287F9635D9194C3844C900EE21F186
          9177A8DFE9D697F64D7D63771DB4D14B76884E4C619971927065080103320D9C
          75AD4BCD5B4ED3EE6DADEF750B4B69EEDF65B4734CA8D33640C20272C72C0607
          A8F5AE1B50BFB3FED1F1169E6EA1FB77FC249A54FF0066F30799E5E74F5DFB73
          9DB9E33D335AEF7DA5E99ACF8822F10BC09FDA12A2DAC572BBCDDDB08235F2A3
          5E4C9FBCF3BF74A09CC99DBFBC058036AF356D0F43799AF751D374F795D1E669
          A6488BB329542C491925622013D44640FBBC6BD70DE12B1B883C40ADAAC7BB56
          B7F0DE990CF2C8C2490397B8F306FE7396404E0F2541E78A7E930DF5CFC15B18
          34B2E2FE4F0F4696A639363094DB80986C8DA77639C8C50074916BBA3CDF6EF2
          B54B293FB3F3F6DDB7087ECD8CE7CCE7E4C6D6EB8FBA7D2B3FC39E2BB3D7FC3F
          26B7E7D8C56232FBD2F049E4C7B03FEF8E008A400FCC99217FBC6A825F697A9E
          B3E1F8BC3CF03FF67CAEB7515B2EC3696C60917CA917831FEF3C9FDD300731E7
          6FEEC95D1F027FC93DF0D7FD82AD7FF452D004DE1EF13E91E29D3A3BCD2AFA09
          F31472C90ACA8D241BC642C8AA4ED6E08C1EE0FA53EEBC49A158233DDEB5A75B
          A23EC6696E91006DCEB8249EBBA39063D5187F09C705A1EB31695E0DF0F78834
          AF2F5223488B4DBDB7B69036668EDCCB02330DDB1C485A20B8059AE57392154D
          FD35B46F0778B648357BFB58A78B43B287FB42E9444267335CB4A4C8DC079186
          F2A5B2C413F36D24007757F7F69A659BDE5FDDC1696B1E37CD3C82345C900658
          9C0C9207E3525BDC43756F15C412C73412A078E4460CAEA46410470411CE6BCE
          99351D2E2D0EF5EEED349D36DDF5131CBA9DB33C16CB24E0DA829E647E49F237
          22962360631E0170B5D3783E398596A172F7697515DDEB4F0CB0DB1820652880
          B4486473B19C3BEE246F6666190C198034D75DD21F518EC1754B26BE977F976C
          2E10C8FB0B2B617393828E0FA156F43567EDB67F67F3BED70793E6F91E679A36
          F99BFCBD99CFDEDFF2E3AEEE3AD7091C10C1E0D9DE38A3469BC59BE565500BB7
          F6B85CB1EE76AA8C9EC00ED55E7D56CADF43FEC592E506A7FF00093AC8D68399
          6346D5448AEEA39442ACA433601DE983F32E403BA5D77487D463B05D52C9AFA5
          DFE5DB0B84323EC2CAD85CE4E0A383E855BD0D549BC4FA736949A8E99756BA9C
          06F6DECD9ADAE15D55A59A38F965C8CA890363BF1D339AE55EC2CE5F02DCC725
          A40D1DDF8A4FDA51A3044D9D5821DE31F37CA02F3D801D293C662DCEB1AC8BC8
          7CFB631684268BC932EF4FED09772EC0097C8C8DA01CF4C1A00EEB4DD574ED66
          DDAE34CBFB5BD815CA3496D32CAA1B00E0952467041C7B8A2CF56D3B50B9B9B7
          B2D42D2E67B47D9731C332BB42D9230E01CA9CA9183E87D2B90D5AE5BC453DFD
          CF84EF12EDFF00B0EF2D5AEAC6E1429B96319B64F301C175FDF11CE537E4EDF3
          06E669123EA3AF68C96DAC695751E9DBD64B6D2B4B6B77B588C4C9E54DBA76F2
          977797FBA2BB8B46BF2E2362A01D959EABA76A4D22586A36B72F1AC6EEB04CAE
          555D7721201E032F20F71C8ABF5CCFC3E822B6F877E1C48228E343A6DBB95450
          A0B346198E0772C4927B924D74D4005145140051451400541716F0DD5BCB6F3C
          51CD04A85248DD432BA9182083C104718A9E8A00A1A6E95A768D6ED6FA6585AD
          940CE5DA3B6856252D803242803380067D855FA28A002B3753D0B48D6BCAFED5
          D2AC6FFC9CF97F6AB749766719C6E0719C0E9E82B4A8A0028A28A0028A28A002
          81450280168A28A0028A28A0028A28A004AE7FC65FF204B6FF00B0AE9DFF00A5
          90D7415CFF008CBFE4096DFF00615D3BFF004B21A00E828A28A002B3F56D421D
          234DB8BE9D2474857708E200BCADD1634191B9D988555EE481DEB42B9CD789BE
          D6F44D1F00A3CCDA84EA4E03C76FB4A807AEE13496EE070084604E38600B7E1C
          D3A7D2F41B5B5B928F760192EA48C9DB25C392F2B8C81C348CE7180067800600
          D8C62917BFD696800A28AA9A85FDBE9BA7DCDF5D4BE5DBDB44F34AFB49DA8A09
          6381C9C007A50052D6F509AD2016F60A926AB728E2CE1704AEE0397931822252
          54B1F700659955A7D2F4D834DB14B588BB857791E4908DEF23B177738C005999
          890001CF000C0AABA4D8DC4B773EAFA8C7B6EE6F96DE16218DA4185FDDE47CBB
          99977B95EA485DCEB1A1ADB000E940051451400514D638FA566EA5AC41A6F94B
          224F3DCCD9F22D6DE3324B26319E070AA0B282EC422965DCC32280349891C0AE
          77FB56F35D223D08F9764C76C9AA4AA5703D6DD1971371D243FBBF9948F370CA
          03A2DD6B243F893C89603C7F654444B6B91D19CB20695BA9C300832BF29640E7
          A20A0F6E739A00CCD3346B5D304D244824BAB823ED379228335C919C1918019C
          64E00C2A83B540000AD4DA3D2968A0028A28A0028A28A0028A28A0028A2909C5
          0023566EA5A98B268ADE08BED37D71B85BDB6EDBB88C6599B07646B91B9B0719
          0002CCAAC9A96A7F627860B78BED37F71B85BDB06DBB88C6599B07646BB86E6C
          1C64000B32AB3B4AD2CD979B717137DA6FEE306E2E4AEDDD8CE11464ED8D7276
          AE4E32492CCCCC4033BFE114B59C9BCBC732EB44E46A91C612685BB0889CEC8C
          74F2FE65233BF79672C7DBF54D0BE5D4E29F52B4FE1BDB3B6CC8807004B1212C
          EC7E5F9E2520927291AAE4F47814B814015EDEE61BBB78A7B6952682540F1C91
          B0657523208238208F4AB02B02E3C370C77525EE8F3BE9579231790C0A0C33B9
          3926584FCAC5881B9C6D908500381496DAFBC13C56BAEDAA699713308E090DC2
          C96F70E4F091C84292FC8F95D5189DDB43052400741452039A5A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A00CBD47494D4E6B533DCCE2DE095666B64DA125746578CB1DBBB
          E575561B5973D1B70E2A54D3618F5AB9D4D5A4F3EE2DE1B77538DA163691948E
          339CCAD9E7B0E9DEFD1400514514005145140051451400514514005145140051
          4514005145140051451400514514005145140051451400514514005028A05002
          D1451400514514005145140095CFF8CBFE4096DFF615D3BFF4B21AE82B9FF197
          FC812DBFEC2BA77FE9643401D051451400D66C1C573BA17FC4C355D5F5A63F2C
          B27F67C48383E5DB3C8A4B0FEF195A7E870502700E6BA4C0AA961616FA769D6D
          636B1F956F6D12C3126E276A28000C9E4F007279A00B4A303D7D4FAD2D1484E2
          8010920F1E9D2B9E90FF006FEB888096D334C94485872B7572BB94A1CF05623B
          58E01FDE6DC15689819F5BBDBA135B697A7C9B2FEF32CAFB41F2604641349CF1
          B94380A30D9675CA950C46869F656FA6E9D6D61691ECB6B68961893716DA8AA1
          5464E49E00E4D005A5C60E3D79A7518C521245002D35891C0ACDD4759B5D2CC6
          933992EA7C8B5B3888335C118C845246719193C2A83962002450FECAB8D74EED
          7E281EC4FCD1E9250301E86E1B256523A850022927FD615470009FDAB79AE911
          E847CBB263B64D52552B81EB6E8CB89B8E921FDDFCCA479B8651A1A668D6DA58
          964893CCBAB820DCDE48019AE08CE0C8C00CE3270061541C2800015A41411D3B
          F7A750026D19CE39A5A28A0028A28A0028A6B92071D7159BA9EBDA4E8BE57F6A
          EA9656026CF97F6AB848B7E319C6E2338C8CE3A645006A515CE7FC2576F727FE
          255A76A9A99FBC0C16A638D93FBE934C6389D4F18DAE720E4023242193C577B9
          78C699A4A0F9916E15EF24707A0708D1AC6C3A10AD2024F0DF2E5803A266C301
          D8D51D4755D3B48B74B9D5350B5B2819F62C97332C4A5B04EDCB1033C138F6F6
          ACC3E1BB8B939D4FC41AA5C863B9A1B79059C68FEA8610B2ED19202BC8E30467
          7100D5DD3BC39A36933B5D586996B0DDBA1492E8460CF282413BE43F33924024
          B1249E4E4D00521E2EB09B8D260BDD599BFD5B58DB334327AEDB86DB01C739FD
          E0E411CB7147DAFC517D8FB3E9965A6C4FF725BE9CCD3478FEF4117C873C8189
          B80413C82B5D1600ED4B8A00CCD2F4CFB179B713CDF69BFB8C1B8B965DBBB19C
          228C9D91AE4ED5C9C6492599998E9818A0003A514005145140063355EE2DA0B9
          B692DAE214960950C72452282AEA460A907820838C558AA77B746CED5E7104D3
          B0C058A04DCEE490001D00C92392428EA48009A00C83A46A1A31CF879E06B5EA
          DA75EC927960F4021906E30281FC015930AA15532CC772DE5796DE391E092066
          40CD14854B2123EE9DA48C8E9C123D09AA3A56ACBAAC53B7D9E6B6B8B697C89E
          DA6DBBE27DAAE0128594E55D1B2AC46186704103517A5002D145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005028A05002D14514
          00514514005145140095CFF8CBFE4096DFF615D3BFF4B21AE82B9FF197FC812D
          BFEC2BA77FE9643401D05145140051451400535C1EA3B74A7518CD0063E8DA64
          D6892DD6A0C92EA574E5E7914921577131C4A4E329186DA38193B9F019DAB5C0
          006050000303A52D00213CE338AE706B973AC811F870C32C27AEAD2012DA823A
          AA2AB8695BA0C82107CD972C850EEDC5BC3776F2DBCF124B0CA85248E450CAEA
          460A9078208E08A9B68E7DE803334BD22DB4C323A34D3DCCC419AEAE25324921
          19C73D1572CC42285452CDB5464D69ED14B54EFAFA3B0B492E65499A38C8CAC3
          0BCCFC9C70880B1EBD87E9CD005C031D3A52138AE77FB6F58BC38D37C397010F
          CCB36A77096D1BA762027992AB1E0ED78D4819CED23690D8788EF4FF00A66B70
          D9467E709A65A032467FBA6598BABA8C9E44484900FCA32A403A0DC49EA2B1AF
          3C53A2E9F76F673EA30B5F26336501F3AE7919188532E7839E17A64F419A8078
          434E9C6ED567BED55DBFD6ADF5C33432FA6EB75DB01C718FDDF500FDEE6B62CB
          4FB4D32CD2D6C2D20B5B68F3B2182311A2E4E4E14600E4934018C7C497374BFF
          0012BD0754B907E5F3EE221691A3FA3898ACBB46412CB1B8C1E3710453BCAF15
          DEFF00ADBAD2F4B8CFC8E9046F77263BBA4AFE5AAB60F01A27008C9DC0ED1D08
          007414B8A00E73FE117FB41FF8996BBAE5F6DFF57FE97F64D9EBFF001EC22DD9
          C0FBD9C638C64E7434CD0749D144A74BD2ECAC7CDC799F65B748B7E338CED033
          8C9C67A64D69E01A2801303D28C0A5A2801368F4A5A28A0028A28A0028A28A00
          28A28A002B2F5BB8D46D74A9A5D32D05D5E0DA238B2BDC805B0CCA1B6825B6EE
          5CEDC6E19CD6A51401E73AAE8B77A968F6F6F2E81A8B44D70F35DA4C9A7CF793
          CFB5424C7CD6787660BA9C618623550A8315D7F86A2BEB6F0BE930EA5E61D423
          B3852E8CB2798C650803E5B2771DD9E7273EB5AD81E94B400514514005145140
          0514514005145140051451400514514005145140051451400514514005145140
          0514514005145140051451400514514005145140051451400514514005145140
          05145140051451400514514005145140051451400514514005028A05002D1451
          400514514005145140095CFF008CBFE4096DFF00615D3BFF004B21AE82B9DF19
          6FFEC24648679BC9D42C6674821795F625D44EE42202C70AA4F00F4A00E8A8AE
          7C78CB4CFF009F5D73FF000457BFFC668FF84CB4CFF9F5D73FF0457BFF00C668
          03A0A2B9FF00F84CB4CFF9F5D73FF0457BFF00C668FF0084CB4CFF009F5D73FF
          000457BFFC66803A0A2B9FFF0084CB4CFF009F5D73FF000457BFFC668FF84CB4
          CFF9F5D73FF0457BFF00C66803A0A2B9FF00F84CB4CFF9F5D73FF0457BFF00C6
          68FF0084CB4CFF009F5D73FF000457BFFC66803A0A2B9FFF0084CB4CFF009F5D
          73FF000457BFFC668FF84CB4CFF9F5D73FF0457BFF00C66803A0A4201EB581FF
          00099699FF003EBAE7FE08AF7FF8CD1FF099699FF3EBAE7FE08AF7FF008CD007
          41814981C7B5607FC265A67FCFAEB9FF00822BDFFE3347FC265A67FCFAEB9FF8
          22BDFF00E33401BE000303A52D73FF00F099699FF3EBAE7FE08AF7FF008CD1FF
          00099699FF003EBAE7FE08AF7FF8CD007414573FFF00099699FF003EBAE7FE08
          AF7FF8CD1FF099699FF3EBAE7FE08AF7FF008CD007414573FF00F099699FF3EB
          AE7FE08AF7FF008CD1FF00099699FF003EBAE7FE08AF7FF8CD007414573FFF00
          099699FF003EBAE7FE08AF7FF8CD1FF099699FF3EBAE7FE08AF7FF008CD00741
          4573FF00F099699FF3EBAE7FE08AF7FF008CD1FF00099699FF003EBAE7FE08AF
          7FF8CD007414573FFF00099699FF003EBAE7FE08AF7FF8CD1FF099699FF3EBAE
          7FE08AF7FF008CD007414573FF00F099699FF3EBAE7FE08AF7FF008CD1FF0009
          9699FF003EBAE7FE08AF7FF8CD007414573FFF00099699FF003EBAE7FE08AF7F
          F8CD1FF099699FF3EBAE7FE08AF7FF008CD007414573FF00F099699FF3EBAE7F
          E08AF7FF008CD1FF00099699FF003EBAE7FE08AF7FF8CD007414573FFF000996
          99FF003EBAE7FE08AF7FF8CD1FF099699FF3EBAE7FE08AF7FF008CD007414573
          FF00F099699FF3EBAE7FE08AF7FF008CD1FF00099699FF003EBAE7FE08AF7FF8
          CD00741456259F89ACAFEEE3B5861D5124909C34FA4DD4283009E5DE30A3A773
          EDD6B694EE193400B45145001451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          140A281400B45145001451450014514500252100F519A5A2800C518AC4D7B55B
          CD35F4D86C2D21BAB9BFBA36E8B71706145C4524A49608E7A444631DFB510EB7
          F6792383599B4CB2B893CA54856FF7B34923385401D109C84F978CB10E31F2E4
          806DE28C5625C789F48B79ED23FB6C127DA2FCE9DBA3950AC570119FCB73BBE5
          6F936EDEBB994639A9EEB5DD26C350834FBAD56CA0BDB8DBE55B4B7089249B8E
          D5DAA4827241030393401A98A315972EBDA4C5757566FAA58ADD5A4467B984DC
          26F8630012EEB9CAAE181C918E47AD47A66BF63ACDD5F5BD8DC472BD9491AC85
          1D5832C912C8922E09CA10F8078C956C74A00D8C518AC397C45666F6C6DED258
          6EFED37EF63298A756FB3C890C92B06C67E61E58057823767EA0F167878E9DFD
          A075FD2BEC3E6F93F69FB647E5F998DDB376EC6EC738EB8E6803731462B19B5F
          D3D24DF26A3A7C768D024F1CBF6B5CBAB091F760E004D913306C9C857E005C95
          BBF12E87A7DBDADC5EEB5A75B41749BEDE49AE911665C039424E186194E47A8F
          5A00D8C518AAC6E625B84B632209DD59D23246E6552033019CE0165C9FF687AD
          5183C4BA1DCDF47656FAD69D2DDCAA1E3823BA4691D4A6F0428392367CD9F4E7
          A5006BE28C56726AFA7BAA3A6A368CAEB13A9132E19656DB11073D1C8217FBC4
          719A80F8974444BD73ACE9DB2C5C25DB1BA4C5BB162A164E7E42581001C73C50
          06C628C5605E78A74EB5F10E9DA1C5756D3DFDCDC18A5B75B85F361510C92EF2
          9C9C7C8A39C7DF073EBBC0FAF5A005C518A28A00314628A2800C518A28A00314
          628A2800C518A28A00314628A2800C518A28A00314628A2800C518A28A003146
          28A2800C0CD00606074A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A00281450280168A28A0028A28A0028A28A004A28A280303C43A043AF4
          DA425DDBDADCDA5ADE19EE20BA50EB227932A001482090F221E7D33D40ACD9BC
          2D38F18D86A96A2D20D3ECD2DD1604CA9558A2BC421542E00FF498F03D01E980
          0F60541EA338A5201EB401C458785F51B6BAB39DFF00B394D8DE23C3145B8EE8
          4452C4CA188DC883CF77484EF08414126D61E5C7AF697AB6A9E20D76CAD6DA01
          63A968B059CD793CAE9E565EE958A008448CA2404A964FE1E46723BA2A08C119
          1EF46D1E9401E6DE23F056BDAD5D5C2F9D0C81CDD94B99B52B80312DBCF1469F
          66D8624D9E6A2EF53B8842D8CB915D8E99A6CB63AA6AF31646B7BEB88EE50838
          64610A44C85718C01129CE79DE4606D05B670290228E8050079D5DF80F50D46C
          3EC3349A7DAC5BA4891E046631C2D6B7108DB900840F71B9602CC2305C09082A
          AAFD4F4CF11B78934BD6FF00B3AC9EF4DD450FD963BA91A148E3B7BDF9DE6F24
          15C9B8DB8D98C85E7E7F97D0B038E3A74A0281401E7D67E06BC4D7ACB51BB6B2
          9614BA17B34592FB64DF7F26172BF36C7BB8F6B704F965B0A702B235DD2B56D3
          21D734EB1B337D77AE5A5CDBED58AE024624B8BA922225585A3DC45CE087640B
          B396C36E1EB38149B471C74A00C0D5B4FD465D5EC753D31ED7CF82DE7B665B9D
          C15565689BCD1B41DE54C23E4CAEEDC7E75C73C9786FC33AE5BDACDA14F6D6B1
          D95BDEE9F24979E73EE66B6B7B42447198F0E8CD0EDDC5C632DC65707D3719A4
          C03DA80381B2F014B6ABA6A35EBBA5BDC2472AF9A4836B6EC8D6CA06DFBC1ADE
          2241F9419AE4AE378C53FF0084335E9F57B4BBBB9E291A0F2FCCB897519E56B9
          65BBB59D9C42C9B20CAC0FF246480582F45CD7A56D1C71D28C0A00E32DB40D5A
          DF57D362D962DA5D9EA975A8FDA04EE267F3D6E3E4F2B66D186B8C6779C84CE0
          6703B307229703D2800018140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          00514514005145140051451400514514005028A05002D1451400514514005145
          1400945145001451450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          45001451450014514500140A281400B451450014514500145145002514514005
          145140051451400514DD84631D3EB4056EF8EBEB400EA28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A05140A005A28A2800A28A2800A28A280128
          A28A00AD7573159DBC9713CC90C31A179249582AA28192493C000024D5807233
          581E3A1FF16FBC4BFF0060ABAFFD14D5D00E940051451400B4514C662081C500
          2A92473D683C0CD0BD283401C53F8B354B4D3356B9BFB4B58A6B0D62D6CCC56A
          D25C8F2A536DB8821559DB13BE30A390061B193D4E9BAA5A6AB034D68F2108C5
          1D2589E29236E0E1D1C0653820E08190C08E08358F7FE169AE6DF5616F7E914F
          7BA95B6A31BC9019162684418523702C09B71DC7DEF6E74343D2A6D345ECD777
          2971797B71F68B878A23147B846918DA859881B635EAC79C9C8040001AB45145
          0014514500145145001451450014514500145145001451450014514500145145
          001451450014514500145145001451450014514500145145001451450014554B
          BBEB7B08566B97291B4B1C41B04E5E475441C7AB328FC7D2ADD0014514500145
          14500145145001484E3B7D3DE96B1FC4B2DEC1E19D5E7D31643A84767335B794
          9BD8CA1094C2E0EE39C6060D006BEEE714A2B88B3D79B45B1D526D56E35879ED
          56091ED7537B08992391D955D5E3291619830F99F394E9C8DDD268BAC59EBFA4
          5BEA760E5E097700770386562AC32A4AB6181195254E3209183401A745145001
          4514500145145001451450014514500145145001451450014514500145145001
          451450014514500145145001451450014514500140A281400B45145001451450
          01451450025145140181E3AFF927BE25FF00B055D7FE8A6ADF1D2B03C75FF24F
          7C4BFF0060ABAFFD14D5BE3A5001451589717F3D87896D219A4DD61A84461857
          68FDD5C461E4238193BE3DC79C05F23D5E8036EB1F578AF835ADFD817792D598
          CD6A1F68B988AE19064ED0E0856563DD36EE557635B00E4504668029E9D7B0EA
          7A75BDF5B3F996F731ACD0BE08DC8C0329C1E4704706AE573921FEC0D7159411
          A66A72AC65070B6F74C5C9739E02CA4AA9C63F79B7019A5623A2072280118907
          820562B6AF2D8EA06D3558F62CD36DB4BA8E36F25C336151DB911C8090A37101
          C95DA72C513708CD56B9B686E6DE48278127865428F148A195D48C1520F0411D
          8F1401614E452D737E7DE7874E6F2E3ED5A327027704CD66BD8CCE58F989D8C9
          80C8002FBC17917A35391400B591A96A57FA7DCAC8BA5C97761B3324B6D26F9A
          36C9C930903720519F9199C920043D6B5E8201EB4019FA6EAB63AB5BBCF6372B
          32A318DC0E1A2718251D4F28E3232AC030EE2B405646A7A0D8EA572B76E1EDEF
          D10225EDB3F9732A824852C3EFA6E39F2DC3213D54D5253E21D23BFF006F5A8E
          3FE59C178BFF00A0C52649FF00A65B557FE5A35007494565E99AE586AE251673
          E66871E75BC88D1CD0E73B77C6E03A67048DCA32391C735A6A72280168A28A00
          28A28A0028A28A0028A28A006B360803AFBD21623AF4A56CF4ED5E7E8906964E
          B9E1EB486DECE431D8A4C413F6F927B88916EA4E774AB1E58AB33664F32420A8
          21DC03D0572473D696B2F489AEDE19E1BDB9B2B8B9B797CB792CC15072AAC372
          31628D861C6E6C8DAD91BB0352800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A28039FF001871A3DB9EFF00DABA70FF00C9C87FC6BA01D2B9FF0018
          FF00C816DBFEC2BA6FFE96C35D050014668AC19F43D4279E5953C57AC408EE59
          628E2B42A809FBA37404E074E493EA4D006F668CD73FFF0008F6A9FF004396B9
          FF007E6CBFF91E8FF847B54FFA1CB5CFFBF365FF00C8F401D0668CD73FFF0008
          F6A9FF004396B9FF007E6CBFF91E8FF847B54FFA1CB5CFFBF365FF00C8F401D0
          66AB5CDBA5DDBCB6EE5C24AA518C6EC8C011838652083EE0E45647FC23DAA7FD
          0E5AE7FDF9B2FF00E47A3FE11ED53FE872D73FEFCD97FF0023D0040DE0F8E463
          753EAFA8CDA986468B5061089620AB22850823111189A61F3213FBC3CF0BB753
          46D29746D3859A5CCD73FBD96679A709BDDE491A462762AAFDE63D00AA5FF08F
          6A9FF4396B9FF7E6CBFF0091E8FF00847B54FF00A1CB5CFF00BF365FFC8F401B
          F9A5CD73FF00F08F6A9FF4396B9FF7E6CBFF0091E8FF00847B54FF00A1CB5CFF
          00BF365FFC8F401D0668CD73FF00F08F6A9FF4396B9FF7E6CBFF0091E8FF0084
          7B54FF00A1CB5CFF00BF365FFC8F401D0668CD73FF00F08F6A9FF4396B9FF7E6
          CBFF0091E8FF00847B54FF00A1CB5CFF00BF365FFC8F401D066937738C5607FC
          23DAA7FD0E5AE7FDF9B2FF00E47A43E1ED53FE871D70FF00DB1B2FFE47A00E84
          7228AC5F0A5EDCEA3E0FD16FEEE4F32E6E2C209A67C01B9DA352C70300724F4E
          2B6A800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A05140A005A28A2800A28A2800A28A280128A28A00C0F1D7F
          C93DF12FFD82AEBFF45356F8E9581E3AFF00927BE25FFB055D7FE8A6ADF1D280
          0ACBD774CFED7D2A6B3498C12B159209F66EF266460F1C9B72036D7556C1E0E3
          07835A94D61C8A00CED1352FED6D261BC687C899B724F06FDFE4CC8C5248F760
          6EDAEACB91C1C64706B4EB9CB5CE91E269EC8F165AA16B9B6FEEA5C01FBD8C74
          037AE250A32588B8635D12F4EB9A00AF73043776F25B5C4492C32A1492291432
          BA9182A41E0820F4AC8D1AE27B19CF87EEE579AE2DA0492DEEA4625AEE1CEDDC
          C4F264521439191F3A371BF62EF900F51599AB699FDA31C0D149E45DDA4BF68B
          69F6EF11C9B597E65C8DCA55DD48C8386382A70C0034D4E475E94100F5ACCD1F
          543AAE9E92490FD9EE9309756A5B735B4B805A3270338C820E30CA55865581AD
          307340060573BF6293C3589B4E49E6D2C7FAEB156695A01D9E0072428180615E
          368050060564E8E8201A00A565A85A6A76A97961770DD5ABE424D6F20911B070
          705720E0823F3ABA2B0EFB4FBDB6BC7D4B46F23ED32E3ED36D71234715CF180C
          582B149140037053B946D238464B5A6EA90EA36C648C491344DE54D04A009209
          0004A38E704020E4120821812A41201A5480003006050B9239EB4B40197A9E89
          A66B0627D42C609DE1C986564FDE404E3E68DC7CC8DC03B948208041E2B3D6DB
          5ED1C036538D5AC94FFC7ADDB6DB88D7D239BA3E00002CA033124B4A2BA4C669
          0003B50062D9789B4DBBBB8EC5E7FB26A726716177FBA9C9032DB54FFAC51823
          7A6E53B5B0C715B4A723AE6AA5FE9F67A95A3DA5F5AC1756D263CC8678D5D1F0
          7232A7838201FC2B2069BABE92B9D1AFBED96E3FE5C754999F1FEE5C61A45E49
          63BC4B9C055D839A00E8E8AC4B2F10A4F751DA5E69F7DA65D4A4F9515DA2912E
          0670B246CD196C063B376FC231DB819ADA19C73400B4514500145145000466B1
          2D7C29E1CB1F3BEC9A06956FE7C4D0CDE559C6BE646DD51B0395381907835B2C
          71F4AC9D435A16B70B636B04979A8C89BA3B74042A83901A59002224E1B96E4E
          C60A1D86DA00BB616169A659A5A58DB416D6D1E764304611172727007032493F
          8D5BA456DC38FA52D00145145001451450014514500145145001451450014514
          50073FE31FF902DB7FD8574DFF00D2D86BA0AE7FC63FF205B6FF00B0AE9BFF00
          A5B0D74140051451400514514005145140051451400514514005145140051451
          40051451400530F24E7F3F4A7D31B9C83FE1FAD0053D1F4F8748D16C74DB7676
          86CEDE3B78D9F058AA2850491C6702AFD60F83669AE7C0FE1FB89E679E6974EB
          77924918B33B18949249E49279C9ADEA0028A28A0028A28A0028A28A0028A28A
          002B9FBFF114B69AC4BA65AE8BA86A13456F1DC48D6CD02AA2BB3AA83E64A9CF
          EEDBA7B57415C478BF411A9DCDCCD6BE1D4BAD52E2CFECF67AB0923DD6520DE5
          1CEF21A30AD2060F16E7383C0DA9B803A7D3B528B53B66B882390225C4F6E77E
          01DD14AD1B742782C871ED8CE3A568579E687E1DBAB4D7E29D340FB05C47AA5F
          5CDDEA5FB81F6DB791E731C7B918C8DCC90B6D7500797EAAA0FA181800500145
          145001451450014514500140A281400B45145001451450014514500251451401
          81E3AFF927BE25FF00B055D7FE8A6ADF1D2B03C75FF24F7C4BFF0060ABAFFD14
          D5BE3A50014601A28A00C3F12D95D5D69664B28FCCBDB3963BBB650C159DE360
          C630E4FC9E62EE88B740B236720915A1A75F5BEA5A7DBDFDA49E65ADCC4B342F
          B4AEE4600A9C1008C823AD5A6383D70315CEE967FB275FBCD209C5BDD799A959
          60740CE3ED09DCF123ABE49E7ED185184E003A4A4201EA285C91CD2D0073FABC
          32E9F7A35EB189E5976476F790221732DB8727728193BE3DF2380A0EF1B97049
          42BB16D710DE5B47716F2A4D04AA1E392360CAEA4641047506A66EA3DAB9DB52
          7C3BA80B2388F459F625931E56DA6248F249FE18DB29E58E81B72657312100E9
          28A45248E7AD2D0018AC8D47497B9B85BEB2BC6B1D4113679C88AEB2A82488E5
          53F7D0124F055865B6B2EE6CEBD04668032B4ED53EDAB25BCD0FD9AFEDF68B8B
          62D9DB9FBACA481BD1B076B60670410ACACABA80D666A7A45A6AA219654F2EEE
          DF26DAEE35026B6638C98D8838CE00239561C3065241AF69AB5D47769A7EAD6F
          E45D9CAC37098105D95058F97F312ADB46E31BE0F0DB4BAA33D006E5148A491C
          D2D0018068C51450053BFD3ED352B37B4BEB586EADA4C6F8278C488D8391956E
          0E0807F0AC85D2757D307FC49F5612DB8F9BEC9AA6F9FA73B527DDE62EE24E59
          FCDC646D5006D3D1E01A3028039FB7F13431DC4767AC412697792308E3139CC3
          3B938022987CAC49CED43B6420125056F6E3FA545716F0DDDBC96F711A4D0CA8
          5248DD432BA9182083D4107A561FFC239269C03E83A8CDA7BFFCFBCC5AE6D48E
          CA22660515413B56268C74C82005A00E8C5358919C573A3C4A74EC27886CCE94
          071F6AF33CDB33FF006DB0367551FBD58F2C70BBB147DB6E3C423CAB2F3EDF49
          6C97D415C29BA4F480A9DCAA79CCA7076E0C7BB70910027BCBFBDB9BC7D37476
          845CC58FB4DD4F19922B6C8C852A194BC8C0821770DAA4331E515EE69BA6C361
          6C63467964958BCF3CA4192790800BB91C138006060000280154012D8585A69B
          6896963690DADB479D90C1188D1727270A0003924FD49AB94005145140051451
          4005145140051451400514514005145140051451401CFF008C7FE40B6DFF0061
          5D37FF004B61AE82B9FF0018FF00C816DBFEC2BA6FFE96C35D050034B85CE69C
          2ABDC5BC37504B05C44B2C32A9478E450CAEA460823A1041C7358FFF00082784
          3FE855D0FF00F05D0FFF0013401D0515CFFF00C209E10FFA15743FFC1743FF00
          C4D1FF000827843FE855D0FF00F05D0FFF0013401D0515CFFF00C209E10FFA15
          743FFC1743FF00C4D1FF000827843FE855D0FF00F05D0FFF0013401D0515CFFF
          00C209E10FFA15743FFC1743FF00C4D1FF000827843FE855D0FF00F05D0FFF00
          13401D0515CFFF00C209E10FFA15743FFC1743FF00C4D1FF000827843FE855D0
          FF00F05D0FFF0013401D0515CFFF00C209E10FFA15743FFC1743FF00C4D1FF00
          0827843FE855D0FF00F05D0FFF0013401BFBBE623D296B9BFF00847DF471E678
          6CC16407DED3E40FF659075C2229C40C4E7E64047CCC591CE31734FD72DEFA73
          6524725A6A4ABE63D85D3209C2640DE02332B21C8F99495C92A48604000D8A29
          BBFDA9C3A50014C3C67DE9F4D3D4D0056D3EC6DF4DD3AD6C6D63F2EDEDA24862
          4C93B51400A3279380075AB7581E05FF00927BE1AFFB055AFF00E8A5ADFA0028
          A28A0028A28A00C4D7757BCD35F4F86C6CA1BAB9BEBA36CAB3DC185171149296
          2CA8E7A444631DC545F6CF17FF00D00B43FF00C1CCDFFC8B526B3637175AAE81
          3451974B4BF79666C8F950DB4E99E7AFCCE83F1FAD6E0E9401CFFDB3C5FF00F4
          02D0FF00F07337FF0022D1F6CF17FF00D00B43FF00C1CCDFFC8B5D051401CFFD
          B3C5FF00F402D0FF00F07337FF0022D27DABC5F9CFF61E87FF008399BFF916BA
          1A28039EFB578BFF00E807A1FF00E0E65FFE45AD1D366D4A5B763A9DA5ADACC1
          F0AB6D72D3A15C0E77346841CE4631DBAF357CB0071CD378C93DF3DE801F4503
          A0A2800A28A2800A28A2800A05140A005A28A2800A28A2800A28A280128A28A0
          0C0F1D7FC93DF12FFD82AEBFF45356F8E9581E3AFF00927BE25FFB055D7FE8A6
          ADF1D2800A28A2800C739EF581E258268608758B389E4BBD31CCDE5C40979A12
          3134400E5894F9957201912227A56FD35BAE7BFAD00436D710DCDB457104A92C
          12A078E4460CAEA46430238208E73562B9BF0D9FB0497DA09EB652996DF07E53
          6B333B441472155089210B9E9083850CA2BA31DE801700D52D42C6DF50B57B6B
          A8F7C2C4138255948390CAC39560402181054804104022ED1819CD0061E897B7
          397D2B5093CCD52C628CCF305016E15B7059801C2EF28F94E0AB291CAED66DB5
          248E462B275AD3A6BB486EAC4A47A8DA3078246C80CBB94BC4C403F23AAED3C3
          6D3B5C29645C4FA56A316ABA6417D0ABA24EBB8C6E0078DB38647009C3A9CAB0
          CF0411DA803428A05140063354B50B382FED1ED6E630F0BE33F3152A41054A90
          41560C010C08208041040ABB450060417BA86913C76DAC4F1DC5BCCC23B6BE58
          BCBF9C9C2C7300480EDC61D405662576A1D81F794E41E73CD57B9B686E2DE482
          7892586552924522865752305483C107B8EF58A0CFE19000FB6DEE8E7FEBADDD
          C5AB7FE3D24B1B7E2C84F743FBB00E8E8AAF6D7115DDB45716F2A4D0CAA1E392
          360CAEA46410470411DEAC5001451484E28016AA6A17F69A659BDDDF5CC16B6D
          1E37CD71208D1727032C7819240FC6A1D47528F4DB759244796491FCB8208803
          24D210484407009C0249240014B12002453B3D3EF6E2F63D4B59F23ED51645B5
          AC121922B6C8C160CCAA5E46191B8A8DAA4A81CBB380402D6E7C4844D7A27B6D
          29B85B0640AD749D737191B9549C6220471912677346A2F856CAC4F99A01FEC5
          9C73E5DA4605BBF7C4907DC392172CBB6421400E05746071CF34B81E9401CE0D
          76F34B961B7D76CCC6B2CA90457F660C904AEEC11032FDF89998F4219172A3CC
          24E2BA253919AA7A8D95B6A5A6DCD85D27996D730BC32C7B8AEE460558647238
          27A74AA1E1FBDBAB8D3E4B6D424DFA8584A6D2EA4DA0798EA0159300606F468E
          4C0C85DFB4F2A6803728A45C91CF5A5A0028A28A0028A28A0028A28A0028A28A
          0028A28A0028A28A00E7FC63FF00205B6FFB0AE9BFFA5B0D7415CFF8C7FE40B6
          DFF615D37FF4B61AE82800A28A2800A28A2800A28A2800A28A2800A28A2800A2
          8A280136F3FF00D6ACFD474BB6D52DD21BB49308E1D248A578A48DB046564421
          94E095241190C47426B468A00E73ED3A9E8271A879FA9E9E0FFC7E4716FBB427
          B3C314603AE7F8A3191B9414C2B495B56F730DD5BC5716F2A4B0CAA1E3911832
          BA9190C08EA0FAFA54ECBB8560DCE892595C4D7BA1325A5C48E659AD76AADBDE
          3939264C292AE724798B8392A5848142D007414C3C67DEB2F4ED696E6E1ACAEA
          092D3528D37490383B58020168A420095395391C8DEA182B1DA3509073F4E680
          2BE9F636FA6E9D6B636B1F976F6D124312649DA8A005193C9C003AD5BAC5F0A5
          94FA6783F44B1BA4F2EE2D6C208654C83B5D6350C32383820F4ADAA0028A28A0
          028A28A00CCD4352FB05F6936FE4876D42E9AD8B6EC7978865973D39FF00578C
          71F7B3DB074EB1358B3B8BAD57409A18CB25A5FB4D336E036A1B69D33EFF0033
          A8FC7EB5B62800A28A4271DA8016ABDC5C436B6D2DC5C4B1C304485E491D82AA
          28192493C000739AAFA86A7169B02C9209259247F2E082219927720908A0E067
          009C920000B310A09142DF4D9B53B98B51D611D191C3DB69FE71F2E1C1C83205
          3B6593386E772A155D9C82EE01A57B0CF3DA4B1DADD7D96672079E1039419192
          01E376DCE09040382430183C941E2F4D2347BABBD4A69EF2DE2BFF00B2DBCD74
          F6F6770EA61590F9AB2B4215B7170176A92A11B690779EBAEECFEDB69241F689
          EDD9B056581F6BA30208233907040E082A4704104838A3C231238BA8756D462D
          4CBBB4BA8AF9265943AC6ACACA63318188611F2A03FBB1CE4B6E00DBB0BEB7D4
          F4DB6BFB493CCB6B9892685F695DC8C015383823208EB56EA8693A645A3E8D63
          A5C0EED0D9C096F1B484162A8A14124003381E957E800A28A2800A28A2800A05
          140A005A28A2800A28A2800A28A280128A28A00C0F1D7FC93DF12FFD82AEBFF4
          5356F8E9581E3AFF00927BE25FFB055D7FE8A6ADF1D2800A28A2800A31451401
          CE789BFE25C6D7C44A71FD99BFED5C67368F8F3BFEF9D892F00B1F2768FBC6BA
          253919AAF73045750496F710A4B04AA5248E44DCAEA460820F0411C60FAD63F8
          72E2786DE7D22F65792F34E71099256CBCF09E61949272C597E566C60C89201C
          2D00743452039A5A00302B9CD4BFE243A8CBAE20CD95C7951EA11818F2F0768B
          81DBE50C0485BFE59A29C8F2F6B7474D6FA67DA801546071D3B52D737A49FEC2
          BB87C3EE76D82C4A34C95F82554366DC9EEC8AA082705909E18C6EE7A3049CE6
          80168A28A00300D2601A5A280302E2CEFB49B996E7468127B6998C97160D288F
          E7272D24248203B73946DAACC436E43BCBE9595F437F6B15D5B49E642D900ED2
          AC08382ACA7055810415201041040231574806B0EFF47916F5F53D2A4106A070
          5D1E56105C80305645E40621540942975DABF7954A3006D16239EDF4AC8D4758
          16B702CADA17BBD4644DD1DBA06DAA092034B2004449C372793B1B68761B6A98
          D765D57FD0B479A1B7D5139BA8AF62691ACC0ED22210371380A0BA86525D4B85
          E7574ED3A1D36DD92369249646324F3CA7324F2100177200E700000000001540
          500000AFA6E8A96D3BDEDD4F25E6A5229592E1CB0550482562424889385185E4
          EC52C5986EAD7C0A5000E945001451450018AE735D1FD937F67E204F9628B16D
          A87BDBB1E243EBE53E1B731C2C6D39EA6BA3AAD730C3730496D711473432A149
          2291432BA9182083C1046460F5A00B0BD296B9FD0279EDDAE742B995A69F4E58
          F65C4AC59EE2DD9488E573CFCFB92446E724C65B0A19456F8EF400B451450014
          5145001451450014514500145145001451450073FE31FF00902DB7FD8574DFFD
          2D86BA0AE7FC63FF00205B6FFB0AE9BFFA5B0D74140051451400514514005145
          14005145140051451400514514005145140052150DD6968A00A1A869565AADB2
          C37D6E93AA3F99196E1A27C101D18728E3270CA411D88ACF846B7A55C4504CEF
          AC5A48E104C1238AE20C9E5E4E55244E4F28AACB851B6424B0DFA660027A9CD0
          0627847556D6BC1BA2EA325D477335C5944F3CA857065DA049F7780436E040E8
          4638ADE07201F5AE4349F0ADD691A269AB6578969AB5BD9416F3B80F2DB4EC91
          AA12F16E40C7E5003FCAF85419DA0A9D8D3B5CB7BFB86B3747B2D4913CC7B1BA
          641304C81BC05660C8723E65246495243020006BD14D0C09C77A750014514500
          666A1A97D82FB49B7F243B6A174D6C5B763CBC432CB9E9CFFABC638FBD9ED83A
          7599A869BF6EBDD26E7CDF2FFB3EE9AE76EDCF9998658B19CF1FEB739E7A63BE
          46896C1C628002FC918E9591A96A934138B2D3AD52F35164F33C9925F2A38A32
          48DF23856DA1882AA0025883818576582E2F6FB55BA96D747291DB23986E7516
          6C98DC1F996142A448EB82A4921518F472AE83474FD26CB49B6682C6DD204773
          2485465A572002EEC7977381966249EE4D0056D3F4486D6E0DFDC14B9D5A55C4
          D7C6301B69C1F2D3A9488606101ED92598B31D7DBEE6968A0028A28A0028AAD7
          37505A5B4B71712A45044A5E496460AA8A064924F000F7A658EA169A9DAA5D58
          DD41756CE4849A0903A360907047070411F81A00B9451D68A0028A28A0028145
          0280168A28A0028A28A0028A28A004A28A280303C75FF24F7C4BFF0060ABAFFD
          14D5BE3A56078EBFE49EF897FEC1575FFA29AB7C74A0028A28A0028A28A00315
          CEEAF9D33C43A6EB038824CE9D76471FEB5D7C876C72DB641E5818E3ED0CD900
          367A2AA7A8D8DBEA5A7DD585DA7996D730B432A6E2BB91810C32391C1ED4016C
          63B7AD2D61F876F2E6E2C64B6BE7F3351B094DADDBED0BE63280564C0181BE36
          49368C85DFB739535B60E6801690807AD2D14019FAA69D0EA9626D263220DE92
          A3A11BA3911C3A3AE41195655600820E304119155F48D4A7B98E6B5BE11C5A8D
          AB949E35F9432EE611CAA09384902EE1CB60EE424B2356C100F51587AC58DC47
          3A6ABA5C60DFC5B16488103ED5086CB4672402C016284918723E60ACE18036C1
          CD2D51B1BF82FE069AD9F7C6B2CB116008F9E376471823B3291EFD6AF0A0028A
          2A9DEDF41A6DABDD5D48638500DC4296249380A00C9662480146492400093401
          6C9C1AC0B8D4AEF549A5B2D215D234631CFAA610C711538758C1277C80F19DA5
          14EEC9664319244BFD7582896EF4DD2C22B164FDDDC5D6E0095391BA14009070
          164DD9C14080C9B16F6D0DADBC76F04491431288E38E350AA8A0600007400700
          500633E81069B6C92E8505ADBDE42ED2169507FA4EE037ACB2105F2FB5099325
          B72231DF82AD734DD5935012C6D04D69790E0CD6B7017CC8C3676B1DACCACA70
          70CAC46430C82AC06A60565EA9A4C5A998DD6E27B4BB849F2AEEDF6F9881B1B9
          7E656565600655811C29C6554800D45248E696B0E0D67EC7F67B6D6DE0B4BB96
          530432676C574DF2EDD8493B59B7711B1DD957DBBD5779DB5390280168A28A00
          28C03DA8A28039FF0010DBCD0496DAEDA42F35C69C9299218D4B49716EC01922
          41CFCFB92375E3968C2E543135B16D710DCDB477104B1CD04AA1E392360CAEA4
          6430238208E722A66FFF0057D6B9DD1CFF00625DBE8937C96EF2B3E96DFC2632
          37983B05643BF6A600F29536EED8FB403A4A2A8DEDC4D6B6AF7115A4D7AEB8C5
          BC0503BF38E0BB2A8C75E48E87A9C563DEF8E344D37416D56FEED2D4049F16B3
          488B3BC9092B2448A5B0EE194AFCA482718241048074D452039EB4B400514514
          00514514005145140051451401CFF8C7FE40B6DFF615D37FF4B61AE82B9FF18F
          FC816DBFEC2BA6FF00E96C35D050067EA336A315BA9D32D6D6E67DF864B9B968
          542E0F3B963724E71C63D79E2B3FED9E2FFF00A01687FF008399BFF916B7F6D2
          D0073FF6CF17FF00D00B43FF00C1CCDFFC8B47DB3C5FFF00402D0FFF0007337F
          F22D741450073FF6CF17FF00D00B43FF00C1CCDFFC8B47DB3C5FFF00402D0FFF
          0007337FF22D741450073FF6CF17FF00D00B43FF00C1CCDFFC8B47DB3C5FFF00
          402D0FFF0007337FF22D741450073FF6CF17FF00D00B43FF00C1CCDFFC8B47DB
          3C5FFF00402D0FFF0007337FF22D741450073FF6CF17FF00D00B43FF00C1CCDF
          FC8B47DB3C5FFF00402D0FFF0007337FF22D741450073FF6CF17FF00D00B43FF
          00C1CCDFFC8B47DB3C5FFF00402D0FFF0007337FF22D741450073FF6CF17FF00
          D00B43FF00C1CCDFFC8B47DB3C5FFF00402D0FFF0007337FF22D741450073FF6
          CF17FF00D00B43FF00C1CCDFFC8B4D379E2E193FD87A1FD3FB625FFE45AE8A9A
          46491401C3F856FF00C5D71E10D126FECCD2AE7CCB081FCF9F5894492E635F99
          BFD1DB0C7393C9E4F53D6ADEA36DE25D560586EB40D1F08E1D1E2D7678A48DB0
          4651D2DC329C12A48232188E84D6EE87FD9DFF0008FE99FD919FECCFB245F64F
          BDFEA760D9F7BE6FBB8EBCFAD69500700DAC78EB42817FB4F43D3F5388BB66EA
          D2F252628C0017CD8D2DCB3B939CB4498E492A8A2B62DF55F13DD5B453DBE93A
          0CD0CA81E3923D6A5657523218116DC83D722BA62B939CF358171A24965712DE
          E84E969712399A6B50AAB6F78E4E49930A4AB9C91E62E0E4A9612050B4007DB3
          C5FF00F402D0FF00F07337FF0022D1F6CF17FF00D00B43FF00C1CCDFFC8B5674
          FD696EA66B1BA824B3D4A35DD25BB862AC060168A420095395E5791BD430463B
          43F51D6AD34C5892562F773E45B59C6419AE18632235246719192701472C5402
          40071BE29D5F5DD3AF7C3B79A9D8E81650C5A93112CBACBAC7B8DADC280CCD6E
          368C1383CF200C73913C87C65E2148DAE345D220D1E54264B09B5099259FE638
          F30F91C46C3693195563D1CE0B21B37D69A8FF00C245E17BED52EE2798EA522C
          76F6BB960854DA5C92393FBD7CE06F20703E544CBEEED360EA28039AB76F14DB
          DB4505BF87B418A0890247126AF2AAA28180A00B5E001C62A7177E2F030342D0
          FF00F0732FFF0022D741450073FF006CF17FFD00B43FFC1CCDFF00C8B47DB3C5
          FF00F402D0FF00F07337FF0022D741450073FF006CF17FFD00B43FFC1CCDFF00
          C8B4B0DDF8A3ED31FDA747D1E380B8123C7AACAECAB9E48536E012064E3233EA
          2B7E931C75A00E73C65F2E80B21042C37F653CCD9E238D2EA277763D95555896
          3C00093C0A67856786F2F3C437D6D2A4F6773A92BC13C2C1A39545B5BA128C38
          601D1D723BA91D41AE97663BD1B390726801D451450014514500140A281400B4
          514500145145001451450025145140181E3AFF00927BE25FFB055D7FE8A6ADF1
          D2B03C75FF0024F7C4BFF60ABAFF00D14D5BE3A500145145001451450014628A
          28039BD557FB23C4365AC28FDC5D04D3AF4FA6E73F677EE7891CC78039F3F731
          C475D18C638F5AA3AC69D16AFA3DEE99399161BCB792DE468C80C15D4A92320F
          383E86AB681A94DA8E96A6ED238EFE07682F228C101665E18A839211B874CF25
          1D0F7A00D8A2814500149B46738E7D6968A00E7352FF008906A32EB8BCD95C79
          51EA118E3CBC1DA2E476F94301216FF9668A723CBDAFD0038518E9F9D38F502B
          8D8B5093C37A81F0F5B5A7DB0BE25D393CF4884424329313E4FCA91EC3B7682C
          63C8447F25CD00745A8EA3169B02C9209249247F2A082200C93484121101C0CF
          04E49000059885048A965A7DE4F771EA1ACCB0CD731826DADEDD488AD77020E3
          71CBC98257CC217E5C80A9B9C34BA768B15A5C36A171B6EB57914A4D7AD1056D
          A483E5A7529102061013D324B31663AF814008A381DF1400146052D1400518A2
          8A00AF736F0DD5BC96F710A4D04AA51E291432BA9182A41E0823B1AC3FB65C78
          77F757BE7DCE94BCA5FB3866B54FEEDC163B881918940276E4C98D8647E8C807
          AD211C8FE5400A33CE7D696B9BFB2DC7873F7962D3DCE92BC3582A076B54EBBA
          0C0DCCA39CC4493B7023C6C11BEDC17115D5BC7716F2A4D04A81E392360CAEA4
          6430238208C608F5A00B345028A000807AD646BDA6CBA8E9C56D1923D42DD85C
          59CAC4A85997950C402423728F8E4A330EF5AF460673DE80398BFBAD4BC41E1C
          B3B8D05638FED2E0DC457170D6D2A261B7C5BD15CC7207015B0372E1C02AC030
          C7D5BC39AE5CE97A9436161A3C0DA9E9234B92D85DBA4568A86608D1910FCE31
          3F2BB536ECC02D9C8EFF00149814000E94B474A2800A28A2800A28A2800A28A2
          800A28A28039FF0018FF00C816DBFEC2BA6FFE96C35D0573FE31FF00902DB7FD
          8574DFFD2D86BA0A0028A28A0028A2937738FCA80168A4DC327DA941C806800A
          28A2800A28A2800A28A2800A28A2800A28A2800A6E79CD3A9879C8FF00F5D005
          7B0B2B7D374DB5B0B38F65ADB4490C2BB8B6D450028C9C93C01C9AB7583E0D9A
          6B9F03E81713CB24D34BA75B3C9248C599D8C6A4924F2493DCD6F50014C23390
          471CE2A2B9B986D2DE49EE2548A1894BC9248C155140C9624F40077AC365BBF1
          17CD3C57BA6E94BCE3CC305C5D7753943BE28C70704AB93C3040A438025FDCCD
          AE9B9D274F8775A36F82EEFA5447857B491A2B67CC907DDE54C6A4B6E2CC8632
          D8F4EBDF0E492CBA64326A3612B8796D19F75DF9980BBC4F2B812001546D90E4
          0CE1F0A91D6FDBDAC36D6D15BC1124504481238E350AA8A0600503A0038C54DB
          3A7E5D28039D6F12473DCE8DF606DF1DDDF3DA5C2CF0BC52C58B796600C6DB59
          58EC43F32F2AC081820D7495C678B3488AE7C41E19B985DAD3507BF7816FE18A
          333A462D6E5B6067461B723A107A93D791A96DADDCD9DCC567AEC2B0CB2B88E0
          BBB70ED6F312768DC48FDCB938C23120EF50AF21CE0037E8A6EFE7039A775A00
          28A28A0028A29370C91E9400B45626A9AFB69BA85A58C3A5DF6A1737514B32A5
          B34436A465031264741D655E064F5E38AD3B795A7B78A49209217740CD1C8577
          2123953B49191D0E091EE6802C514039028A0028A28A00281450280168A28A00
          28A28A0028A28A004A28A280303C75FF0024F7C4BFF60ABAFF00D14D5BE3A560
          78EBFE49EF897FEC1575FF00A29AB7C74A0028A28A0028A28A0028A28A0042A0
          9048E95CEDC7FC4A7C5D69347C41AC66DA541DAE23479124C7BC6922B31C93B2
          103001AE8EB335BD38EAFA4CF66B2F932B6D9209B6EEF266460F1C9B72376D75
          56DA7838C1E0D006928C0C63A52D66685A8FF6BE8F6F78D0F93336E49E0DFBFC
          99918A489BBF8B6BAB2EE1C1C64706B4E800A6B1239ED4AC715CE1B8BBF11FCB
          647ECFA23F5BD49489AE17B88768F951B38F3776E2036C00324B400FB8D55F54
          B9934ED16E959E390C7797D1E1D6D0838283AA99BFD93C270CE0FCA924ADE1DB
          47D224B2324ECD24A972F7648333CEACACB3138DA583221031B0050BB7600B5A
          96D6F0DADB456F6F0A43044A1238A350AA8A060280380074C0A9F031D28031F4
          7D4A6B949AD6F5628B51B57293C69950CBB98472A824E1240BB860B60EE424B2
          356C039AC4D66CAE1275D534C8776A116C5923040FB5401B2D19C900B0058A12
          46D723E60ACE0E8585EC1A859C7736CFBE17CE0ED2A41070CACA402AC0820A90
          08208201045005CA28A2800A28A2800A300D1450021507A8CD60CDA536937126
          A1A25B209247325DD9C6022DD92725C138026F462407FBAE7EEBA6FD2606738E
          68033F4ED52D75281A6B467288FE5BA4B1BC5246C00387470194E0A919032181
          E8413A0B9239EB591A969734D7097DA7DD2596A4ABE5999E232472C7C9D92206
          52C0124AE181524E0E198359D32F26BBB763756B25ADCC4E639626CB2EE001CA
          3E06F420821801D7042B0650017E8A28A0028A28A0028A28A0028A28A0028A28
          A0028A28A0028A28A00E7FC63FF205B6FF00B0AE9BFF00A5B0D7415CFF008C7F
          E40B6DFF00615D37FF004B61AE82800A28A2800AE7FC5B6BA85F787E4B6D2848
          6EDAE2DF84BA6B62D189D0C83CD5F9946C0F92B938CE013C56F1700F3C7D6AAD
          ED841A85B4B6D77199217C7018A9520821948C15604060C0E410082081401C0D
          85EEAB6BE26B7D334CB5DD756F15EADEDADEEB7732C25F164EAE92BA3BB61255
          00145C16931EADDE68FA8C5ABE8B63A9C01D62BCB78EE231200182BA8619C719
          C1ACB6F0668D2794765F24D179989E3D46E1267DFB376F91640EFF00EAE31F31
          3808A070056DDBC10DADB4505BC49143128448E350AA8A06000070001D85004F
          45145001451450014514500145145001451450014D650C0838C1EBC53A90B01F
          4A00E7FF00E105F080FF00995343FF00C1743FFC4D51D47C31E0BD36DD647F0A
          6912C92388E1822D361324D2104845040E7009C92028059885048DCD4F51FB11
          8EDE084DCEA172185B5B06DBBB18DCCCD83B235CAEE6C1C6400199955A2D3B44
          86D6E3EDF7052EB569536CB7CD180DB4907CB4EBB22040C203DB24B3166201CF
          E9FE00D09AE1AFF53F0DE8292B2F971D9DB5AC6F044BC12771453239C6771501
          47000F9D9F5FFE104F08121BFE116D13239FF907C5FF00C4D741B7DE968039FF
          00F8413C21FF0042AE87FF0082E87FF89A3FE104F087FD0ABA1FFE0BA1FF00E2
          6BA0A280389D53C01A03EA1A23DA785F475862BD66BBDB650A8311B79946E18F
          98798D1F1CF383DB2357FE104F089C7FC52DA263FEC1F17FF13536B17D716DAA
          E810C2E563BBD41A198000EE416D3BE39E9F3221C8E78C56D8E9401C04FF000F
          F48D32796EB4FF000D68FA8DB48ECF258DCDB42AD10CEE26090A7249DDFBB91B
          6F2A03C6AB83A1A7786BC0FAADB34D69E18D1C84728E92E92913C6D8070E8E81
          94E08382064107A106BAEDBC9E7E9ED593A8F87ECB52B85BB3E65BDFA2EC8EF6
          D9FCB990024852C3EFA0639D8FB909EAA6802AFF00C20DE10FFA15343FFC1745
          FF00C4D2FF00C209E10FFA15743FFC1743FF00C4D47FDB571A27C9E23F223807
          23568C08AD4E7A2B8676689BA8CB1287E5F9F73841D16EC76E940183FF000827
          843FE855D0FF00F05D0FFF00135359F84FC3DA6DDC77561A0E996B73167CB9A0
          B48D1D320838603232091F89ADAEB450072FE28D2ACEFE7B3B9BCF0B26BDE4AC
          B1AA1313345B8A1C849595083B396DDB97000043363969BC33E205D474396E6D
          E7BAD46C4D843FDA36BF662862431FDA3CD965C5C6E3FBFE10ED656504125C57
          A8119EE693674E781400E1D051451400514514005028A05002D1451400514514
          0051451400945145006078EBFE49EF897FEC1575FF00A29AB7C74AC0F1D7FC93
          DF12FF00D82AEBFF0045356F8E9400514514005145140051451400521CE452D1
          8068039CB7FF0089578B6EE0723C8D648B98A43FF3F11C6B1BC64F0398923755
          192764C4F0056B5F5F41A759C973732797120033B492C49C2AA8009662480140
          249200049C551F13595CDDE892C9631EFD4ED0FDAAC46E0A4CE9CAAEE38C2BF3
          1B72328EC323355F43B7BAD492CF5AD654ADD34425B7B1F2CA0B2DEB92AC0925
          A500942E71C0215537386004FB1BF890F9BA845347A61FF5162CCD134C3FBF70
          A30769190216E3693E602C4247D105071919C7AD281C7273EF4A063A74A0000C
          5145140084035CEDCB1F0EEAB1DC4636E937D288EE231C886E647558DD476576
          621F19F9991B033231E8EABDD410DCC125B5C451CB04AA51E391432BA9E0A907
          820E718A009D4E473D696B9FD22E66B0BDFEC2BD95E6976CB3D9CECC5CCB6EAE
          0156279DF1F991A12C497055F24970BBE093400B451CD1CD001451CD1CD00145
          1CD1CD0004668A39A39A0028A39A39A0028A39A39A0028A39A6962180F6A0075
          148A7233907D314B400514514005145140051451401CFF008C7FE40B6DFF0061
          5D37FF004B61AE82B9FF0018FF00C816DBFEC2BA6FFE96C35D0500145158371E
          15D3EE6E659A4B8D5D5E472EC23D62ED141273C2ACA028F60001DA802C6A1E1A
          D0B57B95B9D4F45D3EF675408B2DCDAA48C141240058138C927F1AAA3C09E100
          3FE455D0FF00F05D17FF001347FC21BA5FFCFD6B9FF83DBDFF00E3B47FC21BA5
          FF00CFD6B9FF0083DBDFFE3B4007FC209E10FF00A15743FF00C1743FFC4D1FF0
          827843FE855D0FFF0005D0FF00F1347FC21BA5FF00CFD6B9FF0083DBDFFE3B47
          FC21BA5FFCFD6B9FF83DBDFF00E3B4007FC209E10FFA15743FFC1743FF00C4D1
          FF000827843FE855D0FF00F05D0FFF001347FC21BA5FFCFD6B9FF83DBDFF00E3
          B47FC21BA5FF00CFD6B9FF0083DBDFFE3B4007FC209E10FF00A15743FF00C174
          3FFC4D1FF0827843FE855D0FFF0005D0FF00F1347FC21BA5FF00CFD6B9FF0083
          DBDFFE3B47FC21BA5FFCFD6B9FF83DBDFF00E3B4007FC209E10FFA15743FFC17
          43FF00C4D1FF000827843FE855D0FF00F05D0FFF001347FC21BA5FFCFD6B9FF8
          3DBDFF00E3B47FC21BA5FF00CFD6B9FF0083DBDFFE3B4007FC209E10FF00A157
          43FF00C1743FFC4D1FF0827843FE855D0FFF0005D0FF00F1347FC21BA5FF00CF
          D6B9FF0083DBDFFE3B47FC21BA5FFCFD6B9FF83DBDFF00E3B4007FC209E10FFA
          15743FFC1743FF00C4D1FF000827843FE855D0FF00F05D0FFF001347FC21BA5F
          FCFD6B9FF83DBDFF00E3B47FC21BA5FF00CFD6B9FF0083DBDFFE3B40087C0BE1
          01FF0032A687FF0082E8BFF89AC19FC3DE17D46E25B1F0F787BC3724F0B91737
          4FA7452C36AC0FFAB2176EF94918D9B86D1F3311F22BEF7FC219A667FE3EB5BF
          FC1E5EFF00F1DAD982DA1B5B78ADEDE2486189422471A8554503000038007A50
          073965F0F3C25676B1DB9F0F697705725A59ECA2667627249F970324F40028E8
          A00000B7FF000827840FFCCABA1FFE0BA1FF00E26BA01C0A28039FFF008413C2
          1FF42AE87FF82E87FF0089A3FE104F087FD0ABA1FF00E0BA1FFE26BA0A28039F
          FF008413C21FF42AE87FF82E87FF0089A3FE104F087FD0ABA1FF00E0BA1FFE26
          BA0A280312CFC25E1DD3AEE3BBB1D074BB5BA8F3B2682CE3475C8C1C305C8E09
          1F435B745140051451400DDBD793D73D6B9DFECABBD13E7D10F9D66BCCBA5C8C
          5B8E805BBB3011614F1191E59DAA07979673D2521504E79A00CCD3758B4D53CC
          8A262B770605CDA48409AD98E7024504E33838232AC3952548274C367E9599A9
          E916FAA344EF24F05C405BC9B9B794C72464E33CF465C852518323155DCA7159
          EDA9DEE87FBBD6F125929C47A9C6A4F03BDC22A622E3AC83F77F2B31F2F2AB40
          1D25149B8014A0E40340051451400514514005028A05002D1451400514514005
          1451400945145006078EBFE49EF897FEC1575FFA29AB7C74AC0F1D7FC93DF12F
          FD82AEBFF45356F8E9400514514005145140051451400514514008541EA28C0A
          5A2800A28A2800A28A2800A0807A8A28A00A1A8E91A76B1025BEA5616B7B0230
          758EEA159543608CE181E7048CFB9ACEFF008413C21FF42AE87FF82F8BFF0089
          AE828A00E7FF00E104F087FD0A9A1FFE0BA2FF00E268FF008413C21FF42A687F
          F82E8BFF0089AE828A00E7FF00E104F087FD0A9A1FFE0BA2FF00E268FF008413
          C21FF42A687FF82E8BFF0089AE828A00E7FF00E104F087FD0A9A1FFE0BA2FF00
          E268FF008413C21FF42A687FF82E8BFF0089AE828A00E7FF00E104F087FD0A9A
          1FFE0BA2FF00E268FF008413C21FF42A687FF82E8BFF0089AE828A00E7FF00E1
          04F087FD0A9A1FFE0BA2FF00E268FF008413C21FF42A687FF82E8BFF0089AE82
          8A00E7FF00E104F087FD0A9A1FFE0BA2FF00E268FF008413C21FF42A687FF82E
          8BFF0089AE828A00E7FF00E104F087FD0A9A1FFE0BA2FF00E2696DF4AF0C786E
          E1EE2D6C348D2E6F21DDE48E18A06F254A9724803E407664F41C67B56F31C7D2
          BC77C563505F10F886FAFF004ABA8A59FC3DAADBC53192128B6D188BCB236C9B
          88DC5DCE54303385E426E001EC4BD296B94F0BEA86F350BFB6B5D6FF00B6F4E8
          6385E3BFCC2DFBD632078B742AA876AA44D8C6E1E664920803AB0722800A28A2
          800A28A2800A28A28039FF0018FF00C816DBFEC2BA6FFE96C35D0573FE31FF00
          902DB7FD8574DFFD2D86BA0A0028A28A0028A28A0028A28A0028A28A0028A28A
          0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A
          0028A28A0028A28A00E5F57D5F51D3759B54171A7986E6E23821D3F6B35D5C29
          64592556DC0288C3976508FF002A1259777C87847C556FE22D274F965DF16A13
          D947712C4F6D2C2AC4A8DE623201E62066032A580DCBCFCC336752D16FB53BD4
          57D4D3FB2FED105C35B35B7EF43C4EAEA1240C0042C8A48646272C0300576D4F
          0DF856EF473A77DBF5182F3FB32C3FB3ED7C8B4307EECF97B8C9991F737EE63C
          63681F3707230017ECB414D2AEE36D226FB1E9FCEFD35225FB38247DE8C000C6
          D9DA480761F98EDDCC5EB6E8A2800A28A2800A28A2800A05140A005A28A2800A
          28A2800A28A280128A28A00C0F1D7FC93DF12FFD82AEBFF45356F8E958FE24D3
          26D6BC37A869505CADB35E5BBDB999E1320557055BE50CBCED271CF071C1E86B
          0B4F179FF98EE87FF82697FF0092A803A1A2B9FF00B278BFFE83BA17FE09A5FF
          00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF00B278BFFE83BA17
          FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF00B278BF
          FE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF
          00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803
          A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF
          0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85F
          F82697FF0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00
          FA0EE85FF82697FF0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3E
          C9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF
          00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF00B278BFFE83BA17
          FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF00B278BF
          FE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803A0A2B9FF
          00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF0092A803
          A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85FF82697FF
          0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00FA0EE85F
          F82697FF0092A803A0A2B9FF00B278BFFE83BA17FE09A5FF00E4AA3EC9E2FF00
          FA0EE85FF82697FF0092A803A0C526D1E9581F64F17FFD07742FFC134BFF00C9
          547D93C5FF00F41DD0BFF04D2FFF00255006FE05281818AE7FEC9E2FFF00A0EE
          85FF0082697FF92A90DAF8B87FCC7344FC34797FF926803A1A2901CD2D001451
          45001451450073DE313FF124B71FF515D3BFF4B61AE83359BAD692BAD69AD66F
          733DB7EF629926836EF478E459148DCACBF7907506A90F0EEA606078CB5CC7FD
          71B2FF00E47A00E833466B9FFF00847B54FF00A1CB5CFF00BF365FFC8F49FF00
          08FEA7FF004396B9FF007E6CBFF91E803A1CD19AE78E81A98CFF00C565AE7FDF
          AB1FFE47A5FF00847B53FF00A1CB5CFF00BF365FFC8F401D0668CD73FF00F08F
          6A9FF4396B9FF7E6CBFF0091E8FF00847B54FF00A1CB5CFF00BF365FFC8F401D
          0668CD73C7C3FAA0FF0099CB5CFF00BF365FFC8F4A3C3DAA1FF99CB5CFFBF365
          FF00C8F401D0668CD73C740D507FCCE5AE7FDF9B2FFE47A5FF00847B543FF339
          6B9FF7E6CBFF0091E803A0CD19AE7FFE11ED53FE872D73FEFCD97FF23D1FF08F
          6A9FF4396B9FF7E6CBFF0091E803A0CD19AE7BFE11FD5338FF0084CB5DFF00BF
          365FFC8F4A3C3DAA11FF002396B9FF007E6CBFF91E803A0CD19AE7FF00E11ED5
          3FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF007E6CBFF91E803A0C
          D19AE7FF00E11ED53FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF00
          7E6CBFF91E803A0CD19AE7FF00E11ED53FE872D73FEFCD97FF0023D1FF0008F6
          A9FF004396B9FF007E6CBFF91E803A0CD19AE7FF00E11ED53FE872D73FEFCD97
          FF0023D1FF0008F6A9FF004396B9FF007E6CBFF91E803A0CD19AE7FF00E11ED5
          3FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF007E6CBFF91E803A0C
          D19AE7FF00E11ED53FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF00
          7E6CBFF91E803A0CD19AE7FF00E11ED53FE872D73FEFCD97FF0023D1FF0008F6
          A9FF004396B9FF007E6CBFF91E803A0CD19AE7FF00E11ED53FE872D73FEFCD97
          FF0023D1FF0008F6A9FF004396B9FF007E6CBFF91E803A0CD19AE7FF00E11ED5
          3FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF007E6CBFF91E803A0C
          D19AE7FF00E11ED53FE872D73FEFCD97FF0023D1FF0008F6A9FF004396B9FF00
          7E6CBFF91E80378B629D591A7695776572D2DC6BFA8DFA95DA22B98EDD541C8F
          98797121CF18EB8E4F1D31AF400514514005028A05002D145140051451400514
          51400945145000403D68C51450021AF3BF0B6BB3DC786F4FD5AFB5DD7AE259D6
          C1268A5D3A286312CF2463F765A04DE992412ACD8462473B4D7A213839CF0056
          247E1CB54F0EE9DA2AC93FD9AC3ECBE5B161BCFD9DD1D371C60E4C633803A9C6
          2802AD8F8C6DB504D2648B4ED4506A36E2E5034684C7131011C85625812C99D9
          BB6075326C041A8B4FF154CFE04D2BC457D6131B8BC8ADB36B6FB373C933222E
          CDCFB42967046E6C85233839153DBF84ACE08B46852EEF441A545147147E60DB
          2796A5519B8CAB619B250AEF0C55F72FCB4CD4BC32D2F84EDF43D32E9EDE3B79
          ED5A191CA968628A78E40AB95209544DABB81CE06E27924022BDF1B5A69DA549
          7B776B3C1247742D27B69E7B685E190C62400B3CAB19CA156F95C9C30E321B10
          0F1B8BED474E8F49B39EE6D2E2FE2B57B875551224968D72190170C36AF965B7
          28E090033702D2F8422493ED30EADA8C7AA1791A4D4544265943AC6ACA54C662
          036C308F9501FDD8F56DCBA678374ED26D2DA0B49EE736D3C37114ACEA595A3B
          74B7C7DDC10D126D391FC648C1DA400685DEB90DA6B16DA71B6BA9249D0B9922
          8C1544DC1431E7730DCCA0940DB320BEC0C09C2F0EF8D3ED3A1E90D790DD4EF2
          41671DEDFA246228EE678E365465DC1F2C658F9542A3CC19230DB776F7438AFB
          53B4BD92E6E90DB38710C72008CC376D3D32A46F604A15DE0957DCBC565D8F82
          6C74F8AD2082F2F7EC509B7692D0B465279605458E476D9BC30F262E15954941
          9072DB80208BC716D7F616334967AA69CB7DF669ACD9D6066B88E49A14C8C3B8
          55CCD1860DB5B6B9DBC83B64B4F1FE9F77616F77F63D4604BBB749ECD668951A
          EB73C69B506EE0879A24CBED53BC30253E6AAFA378145B68DA45B6ADA8DD5EDD
          58C16D1A106311C3E5C90C8C91ED8D4B233C11E4BE5B0BC1049CD9BFF0842344
          D3ADEC03CB71A5D92DA5909AE3CA185781D646711BFCCA6DE361F29524104107
          800BF69E28B6974FD52F2FAD2EF4D4D29D96F12E423346162594B0F299C11B1D
          4F073D78AC88FC5F789E23BCB5BBD2751849B7B45B3D398DB996595CDCB3B2B2
          C8531B21CFCEE3FD59C0C91BAD685E1AB94D1757B5F104A6F1F58959EE93CC04
          8468521D9BD123CFCB18E4226338E71B8AFF00C21A1AF1EFE7D73549B51FDD79
          578EB6E1E0F2C4A06D558821CADC4A0EE56E1B8C1008003FE13BD282C866F3E1
          68BCA12ABEC0636696589C1F9B1FBB36F333904A844660580CD324F1FE9C935E
          27D835174B15796EE55897643124D342F231DDD0340E768CBB290555B0C16D43
          E0FD2525864960FB4958A78E5F3D11C4ED2B1677906DC16CBCD8C61409E50000
          D8A8E3F06E9F1E957F6026BA297DA72E9D3C85D7CC751E6932676F32B34F2333
          1C82DCE3AE401973E3BD26D21B9924F3F16F15E4AE984DDFE8CEE8CA06EFBCFE
          54AC838CAC4E78DA6A3D5BE20693A36AF7BA7DDF98B35A4124D88E685DA4D909
          99944624F314EC5620BAAAF1D7E65CDBB8F07E91702ED65873F6AB98EE5FE45F
          976FDE8D7E5E237CCBB97F8BCF9BFBE6AA6A3E04B3D4C4B049A9EA31D8B35C48
          2C62688468F3C72A48C098CBE4F9D2360B100B74C0028022D63C5576891C363A
          7DF47226A1656D773B79052D9A59A12F13E5C92DE5CA06515946F186E091D9A9
          DCB9FF0026B9DBEF0AC37BA83DCA6A17B0452DD4179716B098FCB9E688C65198
          B2338FF551821594617A64927A25E45002D14514005145140051451400514514
          005145140051451400514514005181451400018A28A2800A28A2800A28A2800A
          28A2800AE5FC5DAE4DA1C3A5F977FA769E9757BF6796EF5052D144BE4CB27204
          89C931A8E5BF8BBD7515997FA5FDBAFB48B9F3BCB36174D73B76E7CCCC32C58E
          BC7FADCE79E98EF9A00CBB4F11C16F716B697DAB5ADE5C5DAC1E47D82C650B21
          94CCC8C087906C291139CE06C66270C0057F19E9BF69D361B4F32E45EDEADAEE
          48DF2A1A295D2551B73246C6220483E423736EC29A92E7C326E7C5B6BAF1BC2B
          E4793FB8F2F3BBCB4BA4FBD9EFF6ACF4FE0F7E2B5AF84EE209A19E4D57CD920B
          FF00B5C2A2DC2A728F1C8594363CC7595CB15DA9BF0C2304B8700D0BFF0013E9
          7A5EA06CAEA49D2458D269196D6578E18D8B00F248AA5235F91F962000A49C0E
          68BEF13E97A5CF7315F4B3DBFD9E2799E496D6558D9550C8C124DBB6460A09DA
          A4B615B8F94E31F59F0EEA9ABF88B5654B882DB48D434B82C6E59E0324920DF7
          1BC4643808C1651CB2B0CB0E0E0834758F86BFDAD7D733FDBAC63F3BED47ED0F
          A76FBC3E7432C5B1E7F306E8D3CDF95768C2A22E78CD00749A3EBD1EB37FAA5B
          25BCF10B196340F2C4E9BD64863941F9946D6FDE60A755DA09C6E02B3BC3FE39
          D3752F0ED8DFDDDD225CC9650CF32C713EC7760A1961E0F9A448C10AA1621995
          4FCC403B563A5FD8352D4EE6397725FCB1CEC857E65916358CFCD9E54AC71F18
          C83B8E4EE01704F81C1D3743B55D47F79A3E9E96B149E471248925B4A8EC377D
          DDD6C32A0E48620302334016AFBC65A42D8CAC978F0CC60B89713D84E4C02145
          6769A3C2B2801D0ED6DA583AEDCEE19B0FE2DD220BE9ED2692EA19A14672B2D9
          4E8240AEA87CB2C80484B4880042C58BAE01C8AC8B8F02CB7A9A8CB75AA27DB7
          51B3BCB69DE2B6291869E38230C885C90152D97E52C72589CAF00587F0A6A134
          DA835C6AD6D28B9B88EE6093EC4C258DA2984B023B194868D3182AAA85B2CD90
          CCCC402E3F8D3448DA143733FDA26127976A6D66FB4314D9B97C9DBBC3012236
          0AE761DFF741345978B6CAEDF57658E7920D3A58544D6B0C9702749628E4574F
          2D0EEFF598217380031C02299A678625B3D78EB5777C93DDCAB389C456E628D9
          A416CA0A02EC5405B55C825B2589C81C565DB7C3FF00B26829A52DFC13C6BF66
          768EF2CFCD826922B75B73E645BC6F8CAA46E1320AC8A1B730C2800DAD2B5E5D
          575EBCB6B6313DA43676D32BED2B2077927474707EE953081B48054EE079E074
          03A0AE57C2BE113E1879DC5D41299A211F976F6BE4471E2E2E26C22EE6C2FF00
          A46D0B9E0275E78EA8702800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A05140A0
          05A28A2800A28A2800A28A280128A28A0028A28A00300D26D18031C0A5A28013
          68CE71C9A303D2968A0030290A834B45001807B526D1C7038A5A28010A83D451
          807B52D1400981E9D28C0A5A2801368208C7068201EB4B45002607A51814B450
          018028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A006EDE
          49EE7DA9DD28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A05140A005A28A2800A28A2800A28A280131462968A004C
          518A5A280131462968A004C518A5A280131462968A004C518A5A280131462968
          A004C518A5A280131462968A004C518A5A280131462968A004C518A5A2801314
          62968A004C518A5A280131462968A004C518A5A280131462968A004C518A5A28
          0131462968A004C518A5A280131462968A004C518A5A280131462968A004C518
          A5A280131462968A004C518A5A280131462968A004C518A5A280131462968A00
          4C518A5A280131462968A004C518A5A280131462968A004C518A5A2801314629
          68A004C518A5A280131462968A004C518A5A280131462968A004C518A5A28013
          1462968A004C518A5A2801314B45140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451401FFD9}
      end
      object Conf_Image: TImage
        Left = 192
        Top = 32
        Width = 521
        Height = 217
        Picture.Data = {
          0A544A504547496D616765012C0000FFD8FFE000104A46494600010101006000
          600000FFE1001645786966000049492A0008000000000000000000FFDB004300
          080606070605080707070909080A0C140D0C0B0B0C1912130F141D1A1F1E1D1A
          1C1C20242E2720222C231C1C2837292C30313434341F27393D38323C2E333432
          FFDB0043010909090C0B0C180D0D1832211C2132323232323232323232323232
          3232323232323232323232323232323232323232323232323232323232323232
          3232323232FFC000110800E3021303012200021101031101FFC4001F00000105
          01010101010100000000000000000102030405060708090A0BFFC400B5100002
          010303020403050504040000017D010203000411051221314106135161072271
          14328191A1082342B1C11552D1F02433627282090A161718191A25262728292A
          3435363738393A434445464748494A535455565758595A636465666768696A73
          7475767778797A838485868788898A92939495969798999AA2A3A4A5A6A7A8A9
          AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8D9DAE1E2E3E4
          E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FAFFC4001F010003010101010101010101
          0000000000000102030405060708090A0BFFC400B51100020102040403040705
          040400010277000102031104052131061241510761711322328108144291A1B1
          C109233352F0156272D10A162434E125F11718191A262728292A35363738393A
          434445464748494A535455565758595A636465666768696A737475767778797A
          82838485868788898A92939495969798999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6
          B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8D9DAE2E3E4E5E6E7E8E9EAF2
          F3F4F5F6F7F8F9FAFFDA000C03010002110311003F00F7FA28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2801BDBA52521C6335CAEB3E37D3EC2692D2CA29B54D423049B6B352E5482
          47CC470A37000F523238A52925B974E8D4AAED05767564F5E6B9AD77C67A4689
          20B59267B8BE660AB676CBBE524E3031D8FCC08C919ED9ACFF00ECFF0014F888
          13A85D1D0AC8FF00CBAD9BEF9DBFDE93A2F201F947218835B3A3785F46D0031D
          3AC238A46C8321CB3907191B98938E0719C545E52F874F5FF23A3D951A5FC57C
          CFB2DBE6F6FBAFEA7371C1E2FF0014DC41717133F876C2375952185B7CF270BF
          7B3C6396E1875FBC8DC576763651D859C76D119DA38C9C19A7799CE493CBB92C
          7AF73C74E9570AFBE69474AB8C5231AD59D5B7BA925B25FD5DFCD8FA28A29990
          5145140051451400514514005145140051451400514514005145140051451400
          51451401CFB78A3485D54E9925E793784FCB1CF13C5BFE6DA369700364F0304E
          7A8ADC0D919C5666A5A169BACC7E5EA36515C00182B3A82CA1BAED3D54F1D463
          A0AE77FE11AD7B45E7C3BAD6EB65E52C2FD3CC41DB6871F32AA8C6179E475E4D
          66DC93DAE8E98D3A3512B4ACFCF67E8D7EABE676B9E3A52E7271815C641E378E
          D265B6D7F4BBAD2242C17CD9577C05C9E1448BC124739380307278AEB60B886E
          6249A091248DD432BA364303D083DC55C669EC67530F5295B9D7CF75F26B42CD
          14514CC828A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A006FE1499F6A696555C9E9EB5C95DF8D609AE5ACFC3F6D26B5763EF080
          81147C0237487E51901B18CE48238A4E496E694A854AAFDC5B6FD97ABD91D693
          85C9E3EB5CADEF8DF4F12A5AE90AFABDFBA82B0599DCA339019DFEEAAE70093C
          8C838AAABE15D4F5B2AFE2AD4BCF8B3FF20FB32D1C3FF023F79F90ADCE369CE3
          8AE9EC74CB2D360F22C6CE0B68C9DC56240A33C7381C678FD2A2F396DA1BF2D0
          A5F13E77E5A2F9BDDFF5A9CC2E85AF788FE7D7EF8D9D931CFF006759311B97D2
          493AB705959570A7008C5747A6E8DA7E916C2DB4FB58EDE2E0E10609200193EA
          78192724F7AD3DB8C5291C552824EE65531339AE5D9765A21D45145518851451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514015A7B786E6278678D248DD4AB23AE4303D411D
          C57253F8223B499AE740D4EEB4890B16F2A23BE02E4F2C636E09238C0C018181
          C57678C9CE6931C70693827B9AD2C454A57E47F2DD3F54F438BFF848F5ED1C01
          E22D1336C87125FD839910679DC633F32AA8CE58E795E0722BA3D3758D3F57B5
          5B9B1BB8E789B03729E8700E08EC7047079E6B4793E86B98D4BC0FA36A172F79
          1C5259DF924FDAACA431B824E49E3824E48248248359F2CD6CEE6DCF42AFC6B9
          5F75AAF9A6FF0027F23A8CF15CE1B4F11E9BFF001EB7B06B1193CC7A895B7914
          FA89618F695181F218B3924EFC00B59A66F18F87C96B8860D76C53EF3C0BE55C
          E3A96D9F74E304055E4FCBEF5A9A578BB47D599228EED23BADC51AD26FDDCA8C
          06594A9E491CE71C707D2A94D3767A3267859C57347DE5DD6BF7ADD7CD213FE1
          2FD320C2EB066D19C1C37F692795183D944E0985D88E76AB938CE402AC06DDBD
          C43756D15C41324D04AA1E3911832BA9190411C104739AB21811C1AE7A7F0B69
          0F712DDDA45269D772C8647B9D3E436ED239390F205C2CC41C90240E393C10C4
          1B398E8A8AE73FB3BC49687FD135C82FA31F314D4ED17CC73FDC12C251514E07
          262720927E61850875AD66D4E351F0EDC151F334DA65C25CC689DC90FE5CACC3
          04ED48DB2318DC4ED001D2515CDFFC26BE1C8F8BBD5E0D3E4CE445A906B3908F
          EF04982B15EA37018C8233906BA4A0028A28A0028A28A0028A28A0028A28A002
          8A28A0028A28A0028A28A0028A28A0028A2A96A17F69A65949797D7505ADB478
          DF34F208D172401963C0C9207E3401768AE6BFE130D1E70069B24FABB1E14E9B
          03DCC65FB219501891BA7DF75C0209201CD3BFB47C49767FD134382C633F297D
          4AED7CC43FDF11421D5D4647065424823E5186201D074354352D574FD1EDD6E3
          52BFB5B2859C22C97332C6A5B04E0162067009C7B1AC3BAB7BF4B733EBBE2A6B
          68701654B1863B589909C6199CC922B1CE37248BDB6E08C9E7ECEEF7CCD3F82B
          C3C2EA7902C526B77DBB73A1619CC92132CAA3690467E5D8A00200152E6A3A33
          6A587A956ED2B25D5E8BEF7F91D25C78AC5C42EFA3D9C976880BB5DDCEEB5B45
          41CEFF0039D7E7420121A259074C95043564DBF8C355D4965B6D2AD20D4EEDA4
          6CDC428D1DA5A8E9B59D8E652A4824A85DEA7202F4AB7078364D4674BAF13DFB
          6A5202192D57E4B688F50028FBE465865BAA9C115D65BDBC36D124304491C68A
          1551000140E8001D054FBF2F25F89ADE852FEFBFB97F9BFC0E40782EEF54612F
          89757B8BDDFF007ECE07315B01D42ED1F336D6E431209C0CF4AEA6CEC2D6C2DD
          60B4B78ADE15CED8E340AAB9E4F038EE6AEE68AA8C12D518D5C44EA24A4F45D1
          68BEE43A8A28AA320A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          39EFF84EFC21FF00435E87FF0083187FF8AA3FE13BF087FD0D7A1FFE0C61FF00
          E2ABA1A28039EFF84EFC21FF00435E87FF0083187FF8AA3FE13BF087FD0D7A1F
          FE0C61FF00E2ABA1A28039CFF84EBC23FF004356879FFB0843FF00C55636ADA9
          FC3AD6C37F686B3E1E958A85F30DF441C00720060C0819E783DCFAD775F8518F
          4E28693566542A4A9BE68369F91E52BAE43E1FDF2E93F10347D52DB3B8D96A1A
          8445C8C0CED9777DE246002028DDCF4ABFA47C5CF0FDE8963BE996D2E2362192
          27FB4A1C3119574072300738039E33D6BD1874A42A0F6159F235F0B3A5E26353
          F8D14DF75A3FCADF3B5CE47FE166F84BBEA8DFF80D27FF00134BFF000B37C25F
          F4143FF80F27FF00135A171E17B46B9927D36E6E748B8958BCAF64502CA49CB1
          689D5A32E4E3326DDFC01BB1C543F6DD634BF9352D2D75084726F74B5030BD58
          BC0EDBC601E046D2B36D270090A55AA7F32FBBFE08F9F07FC92FFC097FF2255F
          F859BE12FF00A09B7FE0349FFC4D73DFDB1F0CE3FF008F376D373F7FFB296E2C
          7CCF4DFE46CDF8E71BB38C9C6326BBED3F52B0D56D9E7B19A29D11CC72051868
          9C004A3A9E51C646558023B815A1E5AFF717F2A76A9DD7DDFF000439F09FC92F
          FC097FF22798FF00C253E1D8C08ECFC75AEDADB8FBB0F92B3EDF5FDE4F03C879
          C9F998E33818000083C7CA802C7E31D35917856B8D0A76918762E525552DEA55
          5467A0038AF4FF002D7FB8BF951E5AFF00717F2A2D53BAFBBFE0873E13F925FF
          00812FFE44F32FF85AA633B3FE24D3EDE3CEFB4DD45E67FB5B3ECEFB33D76EE6
          C74DC7AD4BFF000BAB44FF00A03EB5FF007EE0FF00E3B5E91E5AFF00717F2A3C
          B5FEE2FE545AA7F32FBBFE08FDA613F925FF00812FFE44E4BFE167784FFE8267
          FF0001E4FF00E268FF00859DE13FFA099FFC0793FF0089AEB7CB5FEE2FE54796
          BFDC5FCA8B54EEBEEFF822E7C27F24BFF025FF00C89C81F89BE13FFA099FFC07
          93FF0089A77FC2CDF097FD04DBFF0001A4FF00E26BADF2D7FB8BF951E5AFF717
          F2A2D53BAFBBFE0873E13F925FF812FF00E44E4BFE166F84BFE826DFF80D27FF
          00134DFF00859BE14CE7FB508FFB7793FF0089AEBFCB5FEE2FE54796BFDC5FCA
          8B54EEBEEFF821CF84FE497FE04BFF0091392FF859DE13FF00A099FF00C0793F
          F89A3FE167784FFE8267FF0001E4FF00E26BADF2D7FB8BF951E5AFF717F2A2D5
          3BAFBBFE0873E13F925FF812FF00E44E22F3E29F862DED1E586E67BB91718860
          8183B6480705C2AF19CF2474ACA6F8CBA64EA52D74DBD8A63F75EF4A4710F5DC
          D1991C71D308DCE3381923D33CB5FEE2FE54796BFDC5FCA8B54FE65F77FC11FB
          4C27F24BFF00025FFC89E647E2835D7C9F6DD1B4DC73E76CBABDCFFB3B3CB871
          EBBB71E98DA7390D1E39B69FE4BBF1B47046390DA668EF1484FA13319976F5E0
          2839C720641F4FF2D7FB8BF951E5AFF717F2A2D53BAFBBFE08B9F09FC92FFC09
          7FF227997FC24BE13B8FF90978C35DBEDBFEAFE792D367AFFC7B245BB3C7DEDD
          8C718C9CCD67E23F87163771DEC0626BE8C9C5F4F6B2CD727208E6675321E0ED
          E5BA71D38AECB54D634AD2042350BDB7B796624410B11E64E4632B1A0F9A46E4
          0DAA0924800648AA2D3EB5AC71636C349B36FF0097ABB8C35CC8BEB1C3D23C82
          086909652086868B54EEBEEFF821CF84FE497FE04BFF009129FF00C2CCF0960F
          FC4CDB3FF5EF27FF00135CDEA5F145350B996C743BBD36C42F0D7DAA5DA42064
          360AA13B8F4041C1EBCA8EB5DE69BE1FB1D3A76BA08F717CE0AC97972DE64CC0
          904AEE3F714B0DDE5A054049C28AD803D2972CDFC52FB97FC160ABE1A1EF429B
          6FCDDD7DC923CBAC20F02FDACDFEBBE31D2359BEE7E6B8BF8B628CB70A9BB007
          CDD0E403C8C57623C71E0F0303C53A1E3DB5087FF8AAE8179A71AB8C547630AD
          5EA5669CDDFB765E8B6473FF00F09DF843FE86BD0FFF000630FF00F1547FC277
          E10FFA1AF43FFC18C3FF00C55743455191CF7FC277E10FFA1AF43FFC18C3FF00
          C551FF0009DF843FE86BD0FF00F0630FFF00155D0D1401CF7FC277E10FFA1AF4
          3FFC18C3FF00C551FF0009DF843FE86BD0FF00F0630FFF00155D0D1401CF7FC2
          77E10FFA1AF43FFC18C3FF00C551FF0009DF843FE86BD0FF00F0630FFF00155D
          0D1401CF7FC277E10FFA1AF43FFC18C3FF00C556A69F7F69A9D94779637505D5
          B499D934120911B0483861C1C1047E15768A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A00C5D4BC3FA5EAD74B73
          716286F1102C77B19314F1AE49C24C843A8E4E406190C47426AA98FC47A51DF1
          DCC3AD5AA758A78D6DEE88EA48917113B750A9B2307232E304B749450061D9F8
          86CEEAF23B1B949F4DD4A4CECB3BE508F260127CB604A4B85E4F96CDB723760F
          15B954B50B0B4D4ECA4B3BEB582EADA4C6F8678C488D8208CA9E0E0807F0AC83
          A05E69C40D0753FB14278FB1DD446E6D907FD335DEAF1E0050155C46A01C264E
          6803A4A2B9BFF848E4D3C14D7B4EB8B06EA6E6056B8B523A9632AA831AA82373
          4AB181CE0B052D5B56F710DD5B457104C93412A878E4460CAEA46410470411CE
          6802D514514005145140051451400514514005158579E27D36D2F64B0497ED7A
          9478CE9F69FBD9F2402BB947FAB5395F9DF6A0DCB9619A816D75DD679BE9FF00
          B26CDBFE5D6D1C35CC8BE924DD23C824158C16520159A802CEA5E20D2F49BA5B
          6B8BE4178E81A3B28C1967917246521405D87072429C0527A0355BFE2A2D5BFE
          A056A7FEB9CF78DFFA1431723FE9AEE56FE0615A7A7E9565A4DB3C1636D1C08E
          E6490AF2D2B90017763CBB9C0CB3124F726B468032B4DD134FD24C8D656FB669
          B1E74F23B4B34D8CEDF325725DF0090371381C0C0AD5A28A0028A28A0028A28A
          0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A
          0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A
          0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A
          002B9F9FC2FA79B896F34E126937F2B9792EB4FDB1B4AC4F264520A4A796C191
          5B1B89182735D051401CD7DB7C43A57CDA95B41A9DAF569F4C89A2922F5CC0EE
          C5D4004E51CB9240119EB5A1A6EB7A7EAC655B2B8DD3438F3A0911A29A1CE76F
          991380E990091B80C8E46456AD656A7A269FAB18DAF6DF74D0E7C99E3768A687
          38DDB25421D32000769191C1C8A00D5A2B9AFB178874AF974DB98353B5E8B06A
          72B45245E989D118BA8000C3A172492643D29A9E2DB359E4B6B9B0D5ED6FD155
          A5B51A7CB3B22B13B496855D08386C15623823A8602E14E737682BFA05EC74F4
          57311F8B22D450C7A2E9DA8DF5C0764FDE5A4B6B12152549792550301861826E
          71CE10ED2048DA1DEEA8437882F3CD84F3FD9B684C76C07F7643F7E7E0B29DC5
          63718CC40D4CA2E2DC64ACD00B3F89AC85C3DB584375AB5DC4E6368AC62DEAAE
          A7E64698E224718C957753D38C9505174BD6357F9B59BE3676E7FE5C74B99D33
          FEFDC61646E4061B0458C956DE2B66DEDE1B5B68ADE085218225091C68A15514
          0C0000E00038C55AA4052D3EC2D34CB28ECEC6D60B5B68F3B2182311A2E49270
          A3819249FC6AED14500145145001451450014514500145145001451450014514
          500145145001451450014514500145145001451450014514500637896FE6D27C
          2DAB6A76EB199ECECA6B88C480952C885803820E323D4572B278CEF21B0D5E7B
          5D6344D6FEC9A5DCDF09F4D88AC76F2440148E5026933E66E623953889F19EAB
          D76BDA69D6BC3FA9695E7793F6EB596DBCDDBBB66F42BBB1919C6738C8ACFD73
          C35FDAB6BA9436B786CBFB4ED65B5BC1E56F4937445164DB918917E51BB3F328
          DA73842801D2D1595A6C5AC45E68D56F6C6EB38F2FEC968F6FB7AE73BA57CF6E
          98C60F5CF1AB4005145140051451400551BDB28EFAD24B695A748E4232609DE1
          71820F0E8430E9D8F3D3A55EA28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF
          0084374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF
          0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9
          FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF0007B7BFFC7ABA1A28039E
          FF0084374CFF009FAD73FF0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7
          ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF
          0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF0007B7BFFC7A8FF84374
          CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8
          FF0084374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73
          FF0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CF
          F9FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF0007B7BFFC7ABA1A2803
          9EFF0084374CFF009FAD73FF0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00
          C7ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73
          FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF0007B7BFFC7A8FF843
          74CFF9FAD73FF07B7BFF00C7ABA1AA5A85FDA6996525E5F5D416B6D1E37CD3C8
          2345C900658F032481F8D0065FFC21BA67FCFD6B9FF83DBDFF00E3D504FE17D1
          ED6DA5B89EFF00588A0890BC9249AF5EAAA281924933600039CD3FFB6AFF0054
          3E568BA64EAA786BCD4E192DA38CF7C44E04B230C838DAA8C323CC523152C1E1
          B8A4B98AF357B89355BC8DC49199C01040E0E418A11F2A9539DAE774801C1722
          8039C36561A80D9A041E23BF63C8B99B5ABFB6B503A8612B39322B0076B44B20
          3C64A860D56F47F09EB9A1DF5DDDDAF88619E5BB8E34985EDB4F72A9B0BED119
          7B82EAA43E48666E4B1040381DC515A53A92A6DF2F5F24FF003135738293E1FD
          C3C0258FC45A9457DF689E79441737315A4CD2C85CE604981017771B1D79E5B7
          722A11A6C1A71FF89FDB6B9650F5FB65A788AFAE6D907FD346DEAF1E00625990
          46A00CBE4E2BD0E8A99CDCE4E72DD8D6872761E1ED0753B24BCB1D5355BAB693
          3B2683C4378E8D8241C309B070411F855BFF0084374CFF009FAD73FF0007B7BF
          FC7AA5BCF0F59DD5E497D6CD3E9BA9498DF7962C11E4C000798A414970BC0F31
          5B6E4EDC1E6AB893C47A51D925B43AD5AA74960916DEE88E8018DB113B742CFB
          E30727083003480FFF0084374CFF009FAD73FF0007B7BFFC7A8FF84374CFF9FA
          D73FF07B7BFF00C7AA6D37C41A5EAD74D6D6F7C86F110B496520314F1AE40CBC
          2E03A8E46095190C0F422B6E8039EFF84374CFF9FAD73FF07B7BFF00C7A8FF00
          84374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF00
          07B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9FA
          D73FF07B7BFF00C7A8FF0084374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF
          0084374CFF009FAD73FF0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7AB
          A1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF00
          07B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF0007B7BFFC7A8FF84374CF
          F9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF
          0084374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF
          0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9
          FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF0007B7BFFC7ABA1A28039E
          FF0084374CFF009FAD73FF0007B7BFFC7A8FF84374CFF9FAD73FF07B7BFF00C7
          ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8FF0084374CFF009FAD73FF
          0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73FF0007B7BFFC7A8FF84374
          CFF9FAD73FF07B7BFF00C7ABA1A28039EFF84374CFF9FAD73FF07B7BFF00C7A8
          FF0084374CFF009FAD73FF0007B7BFFC7ABA1A28039EFF0084374CFF009FAD73
          FF0007B7BFFC7AB5A0816DADE3B7532148D0229924676200C72CC4963EE4927B
          D5BA2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28ACAD4F5BD3F4931ADEDC6
          D9A6CF930468D2CD3631BB64480BBE0104ED07039381401AB59DA86AB65A4DB2
          4F7D731C08EE238C372D2B90484451CBB9C1C2A824F606B33ED5E20D57F770DA
          7F615BFDD79AECC735C9F5F2D23668D78390ECCD82A418C8E6ADE9BA05969D70
          D78049717F229492F6E5BCC9D94904AEE3F710B0DDE5A054049C28A00AADAA6B
          1ABFCBA3589B3B73FF002FDAA42E99FF0072DF2B23720A9DE62C6432EF153D9F
          87ACED6F23BEB969F52D4A3CECBCBE60EF1E4107CB50024595E0F96ABBB03764
          F35B9450014514500145145001451450014514500676A1A5596AD6C905F5B473
          A2389232DC344E0101D18728E3270CA411D88ACC3A76B7A5FCFA6EA3FDA108E0
          596A840C2F45093A2EF18079322CACDB40C824B1E928A00E6FFE12DB2B438D6E
          29F4227EE9D4CC691B8ED89919A2DC79F937EFC293B71CD74945735FF08C258E
          7FB06FA7D200E45AC0AAF68C47406160422E725844632DB8927382003A5A2B9A
          FED9D4F4D1E5EADA34F2A29E6FB4C5F3E323A026107CE5627F815640A08CB901
          88D8D3EFED353B28EF2C6EA0BAB6933B268241223609070C3838208FC2802ED1
          4514005145140051451400514514005145140051451400514514005145140051
          4514005145140051451400514514005145140051451400514514005145140051
          45140051451400555B8170B04AD6E91C938525124728ACD8E016009033DF071E
          86AD51401CF7DB3C5FFF00402D0FFF0007337FF22D1F6CF17FFD00B43FFC1CCD
          FF00C8B5D0D1401CF7DB3C5FFF00402D0FFF0007337FF22D1F6CF17FFD00B43F
          FC1CCDFF00C8B5D0D1401CF7DB3C5FFF00402D0FFF0007337FF22D1F6CF17FFD
          00B43FFC1CCDFF00C8B5D0D1401CEFDB3C5DFF00402D13FF0007137FF22D06F3
          C5DFF403D0FF00F07137FF0022D6E96555C93815C95D78DADE4B8367E1FB4975
          9BC046EF21808933CFCD21F94646EC633C8238A52928EE6B4A854AAED05EBD97
          ABD9179AF3C5D904E87A18FF00B8C4DFFC8B5C9CFF0011B553A88D2F4CD234ED
          46F1C1E6C2FE5B858C9DA159B30A82B971921801CE4AD5C8FC29E20F13149BC5
          9A97936B956FECBB23B50FDC6C3B64E79560465B1D55856AD96ADE12F0FA3697
          A5CD6ED2C0FB66B4D3636BB9D594042D22441A4C8DA14BB0EB804E48ACEF29ED
          A2FC4DF96850D64F9E5D968BE6F77F2B7A992CFF0012F51D370174BD32693B8C
          B491E1BFE069C81EFC1EC7A47A6E91E33D24CAD6967E1F59A6C79D3C8F3CB34D
          8CEDF324725DF0090371381C0C0AE906B3ACDD1C69DE1EB8087E659B53B84B68
          DD3B1013CC9558E41DAF1AE0673B48DA57FB3FC49767FD2B5B82C633F304D36D
          17CC43FDC32CC5D5D464F222424807E51952FD9F9BFBC5F5B5FC91FB8CBF37E2
          27F73C3FFF0091AA19EEFC7B6D6F2DC5C3F872286252F248ED2AAA2819249270
          001CE6B6BFE113B124B4F7FADCD29E5DFF00B5EE63DEDDCED49151727B2AAA8E
          8001C53A2F06F862DAE23B8B7F0E69114D13878E48EC625646072082172083CE
          68E4F37F78BEB4BF917DC713FF0009C6BD27CB6DAD784AF653F760B2965B999F
          D76C71EE76C0E4E01C0049E01A913C51E3E9CEDB3D26DEEA51C98CE9F756F81E
          BBA7F2D4F38E012DCE718048F51E28E297B3F37F78FEB8BF923F71E6F6DAA7C4
          EB9B848A5D074FB6524E66998145C0279092B373D3807AFA735A9E67C45FF9E7
          A07FE46AED334668F67E6FEF078B5FC91FBBFE09C5F99F117FE79E81FF0091A9
          BE67C45FF9E7A07FE46AEDB34669FB3F37F787D6D7F247EE38BCFC453DBC3EBF
          F7FA9367C45FEFE81FF91ABB5FA5047147B3F362FADFF723F71C5ECF88BFDFD0
          3FF237F851B3E237F7FC3FFF0091BFC2BB5C0A3028F67E6FEF0FADBFE48FDC70
          37727C4782D5E68E0D1AEA452310C2583B6481C172ABC75E48E9EBC565FF006D
          FC50405E6F0EDBC71AF2EFF23ED1DCED49599B03B2AB31E8013C57A96051814B
          D9F9BFBC7F5C7FC91FB8F2A3E2EF15A8DD733E9B6710FBD3DF69F7B6D0AFA6E9
          658D517278192324803922ADE9DE21F136AF70D6FA66BDE0FBE9954BB476B74D
          2B05C819214938C9033EE2BD2B02B3F51D274ED66DD6DF52B1B5BC815C3AC773
          0ACAA1B0464060467048CFB9A3D9F9BFBC3EB6FF00923F71CD6CF88DFDFF000F
          FF00E46FF0AC8BBF0C78C2E6F9F5058BC3F6BA8B919BEB5F3629CE000A1980FD
          E28C2FC8FB90ED5CA9C5757FF08568119FF42D3C69B9FBFF00D9734965E67A6F
          F21937E39C6ECE32718C9A6FFC23B736D83A56BBAADAA8F98437120BC8DDFD5C
          CC1A5DA78055644E071B492D4FD9F9BFBC3EB6FF00923F71CFBAFC48B482DDBC
          CD3AEBC874695613B64B85180C0975DAB9E492318EDE94C8BE20EA62F64B4BED
          274DD36E109F9351D4A484B2838DC1BC8284139C618F438E39AE904DE2BB3CF9
          B6BA5EA918F99A48247B4931DD1226F3159B8E0B4A809383B40DC69DF6B1A5DD
          43E4788B42BDB350DBF17B6427890723CC6962F322403E6C96652A324E0104AE
          492D53FBCA789A75172D4A6979AD1FF93FBAFE65D17FE2C6E9A2E867FEE3337F
          F22D02F3C5C0FF00C80F43FF00C1C4DFFC8B581A6E8A8607BBF02F89E236A8E4
          1B512ADD5BEF501B606C964CEECB6093F37B0AB6BE359747610F8AB4F974F61C
          0BA895A58243FEC9504A93862148C803934FDA5BE356FCBFAF527EABCFAD1973
          796CFEEEBF2B9ADF6CF177FD00F43FFC1CCDFF00C8B47DB3C5FF00F402D0FF00
          F07337FF0022D69D9DF5BDFDBA4F6B7114F13676C9138656C1C1C11C750455DA
          D0E5945C5D99CFFDB3C5FF00F402D0FF00F07337FF0022D1F6CF17FF00D00B43
          FF00C1CCDFFC8B5D0D1408E7BED9E2FF00FA01687FF8399BFF009168FB678BFF
          00E805A1FF00E0E66FFE45AE868A00E7BED9E2FF00FA01687FF8399BFF009168
          FB678BFF00E805A1FF00E0E66FFE45AE868A00E7BED9E2FF00FA01687FF8399B
          FF009168FB678BFF00E805A1FF00E0E66FFE45AE868A00E7BED9E2FF00FA0168
          7FF8399BFF00916BA1A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A006F6A3F9D
          52BBBEB6D3EDCDC5DDC47042BF79E570A064F727A73815CB1F195E6AEDE5786F
          4AB9BCDDF72F2E10C56D8E85B71E5B6B7550013838E952E69686B4B0F3AA9B8A
          D1757A2FBD9D7CF7115B44F34F22C71A296676380A0724927A0AE42EFC6B717D
          E741E16D3A6D5E740C0CC311C0AC33C6E62039E57804020E411525BF8365D4A6
          4BBF145F3EA32860CB689F25B447AE028FBE412C37375070457536F6F0DB431C
          30C491C51AED4455002803000038000E2A7DF9792FC4DBF714BFBEFEE5FE6FF0
          3CCA7D2FFB435274F15EAB73AC5EC4DC68FA446EF1C2C776C5959461370752AD
          218FA1CB32826BABB4B6D666812D2C34DB5F0F58762C565B851921808907948C
          492C1F7C83A6E43B881D5602D1B71D2AA308AD8CAAE26AD5B293D16CB64BE473
          BFF0886993E1B58136B2E4E5BFB49FCD8C9ECC2000428C071B9501C672496627
          6EDEDE1B5B78ADE08638608942471A28554503000038000E3156A8AA310A28A2
          800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2
          800A28A2800A28A28031F50F0EE8DAB4C2EEFF004BB59EED1364772620278802
          48D920F9D08249054820F2306A8B689A969EBBF4AD5E796353C58EA6DE7C6475
          204C479CAC4FF1B34814138420281D351401E750F856596F9CDB585EF872F157
          CC6B9D3EEA392CE6718DA3612ACD8CF20C6833BC64F04DCFED8F146840C7AA69
          3FDAB6E9D6F2C0E1CAF41988F25B3C9DA7033ED5DB03C52150466A3D9A5AAD0E
          A58B935CB5129AF3DFE4D6BF2BDBC8C8D23C43A66BD09934DBB8E755C6E19C32
          F2472A7046707191CD6C7EB5CEEAFE0ED1B5A9FED53DB797780E56EADD8C722B
          6000D91D48C0C6738C565FD9BC63A071692C1ADD8A72B1DC1F2AE71D02EFFBA7
          0304B3727E6F6A5CD25F12FBBFC87EC68D5FE14ACFB3D3F1D9FCEC76E39A074E
          95CBE97E35D275097ECF2CAD617A1955AD2F17CA9016CED183D49E0F19E08F5A
          E954820B62AE2D3D51CF52954A6ED356FEBA12D14514C80A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28ACDD41B5116A069B1DB34EEFB59EE5D82C4A41F9C2A825
          C838F93299E7E65A007DEDFDB69F6CF7177709044B8DCF210A17270324F1D481
          5CB1F156A7AF131F85B4FF00362FFA08DE031C03FDD1F79FA329C01838EC69FA
          7F806CA1314DAC5D5CEB57118001BD90BA2B11862A849183E8DBB181CF19AEC4
          0C74159DA52DF43AF9E852F8573BEEF45F775FC3D0E4AD7C1304D722F3C41772
          EB57633B7CF50228F3C1DB18F94646339CF201E2BAD0A1570060528F7A53CD5C
          6296C6356BD4AAEF37B6DD97A2D90EA28A299905145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          14514005145140051451400514514005145140191AA687A66B516DD42CA1B855
          0CA0BAE5973C1DA7AAF41C823A573CDE18D7347CFF00C23BAD136CA729617E86
          48C76DA241F32A818C2F3D3AF26BB5C647349B477A99534DDFA9B53C4D4A6B95
          3BAECF55F73FCCE361F1B2DA4E96FE21D2EEF4894909E6C837C058F40245E092
          393D00C1C9E2BABB7B88AEE149ADE45922750C8E872AC0F20823A8A74F045730
          B433C6B244EA55D1802083C1041EA2B929BC070DA5DC977E1ED42E347B87C129
          161E16393CB46DC1E09006401C607153EFC7CFF335FF0067ABBFB8FEF5FE6BF1
          3B30DEF4BDB8AE1A3F11F88744F3078934757B50DFF1FDA712E8830092C84EF0
          A3E625BDBA773D0E93AFE99AF4265D32F23B8518DC012197923E6538233838C8
          E69C6A26EC67570B529AE6DD775AAFBD7E46D514515660145145001451450014
          5145001451450014514500145145001451450014514500145145001451450014
          5145001451450014514500145145001451450014514500145145001451450014
          5145001451450014514500145145001451450014514500145145001451450014
          514500145145001451450014514500145145001451450033191CD624DE19D224
          99EE0584515C3B1633DB8F2A5C93927CC4C364F39E79C9078ADDED4DA4D27B8D
          4A4AF676B952CEDE5B7B38EDE4BD9EEE452733CE103BE493C84555E3A70074F5
          E6AF514531051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          400514514005145140051451401FFFD9}
        Visible = False
      end
      object Methods_Image: TImage
        Left = 176
        Top = 40
        Width = 505
        Height = 329
        Picture.Data = {
          0A544A504547496D61676542430000FFD8FFE000104A46494600010101006000
          600000FFDB004300080606070605080707070909080A0C140D0C0B0B0C191213
          0F141D1A1F1E1D1A1C1C20242E2720222C231C1C2837292C30313434341F2739
          3D38323C2E333432FFDB0043010909090C0B0C180D0D1832211C213232323232
          3232323232323232323232323232323232323232323232323232323232323232
          32323232323232323232323232FFC00011080192021303012200021101031101
          FFC4001F0000010501010101010100000000000000000102030405060708090A
          0BFFC400B5100002010303020403050504040000017D01020300041105122131
          410613516107227114328191A1082342B1C11552D1F02433627282090A161718
          191A25262728292A3435363738393A434445464748494A535455565758595A63
          6465666768696A737475767778797A838485868788898A92939495969798999A
          A2A3A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6
          D7D8D9DAE1E2E3E4E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FAFFC4001F01000301
          01010101010101010000000000000102030405060708090A0BFFC400B5110002
          0102040403040705040400010277000102031104052131061241510761711322
          328108144291A1B1C109233352F0156272D10A162434E125F11718191A262728
          292A35363738393A434445464748494A535455565758595A636465666768696A
          737475767778797A82838485868788898A92939495969798999AA2A3A4A5A6A7
          A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8D9DAE2E3
          E4E5E6E7E8E9EAF2F3F4F5F6F7F8F9FAFFDA000C03010002110311003F00F7FA
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28AC3F19
          5CDDD8F82B5BBDB0BA92D6EED6CA5B88A6454621914B8187041076E0F1D09C60
          E0800DCA2B83D6AEEFACF5ABAB55D46EDC449A0AEF2FB4B17BF912462140505D
          400D80011C631C56A378C76786F40D63FB32797FB5A212FD9ADDBCC913FD164B
          8DA83037B7EEF601F2E4B67DA803A8A2B83BCF17EAF79E1DFB6E931E8D34ABA9
          D9DB99ACF551716ECB24E88C9BC4590FF300C0A0C2C8195988DB5A9A4F89754D
          434CBFBFBAD2AC6C2DECFED5134B36A5F234B0C8C84EEF2FE587E43976C30C1F
          908C3100EA28AF3BB9F1EDF5FE9D3268FF00D8D35FDB5EE9EB2BD9EA7F68B731
          4F71E5EDF33CAC872559586DF955C3024FCB5A90F89F54935ABCD1EDF4F826D4
          D2562639EF76411A2416ACE124584B1F9EE570194E7E6395F952803B0A2B8FB2
          F17EA9AB5FCD61A6685049716D107B87B8BFF2E14713CF03A0611B337CF6E4A9
          D832A496D84056D493C4B0B784ECB5EB5B79244BE4B636D0CA421DD70C891872
          33B46E917711BB03380DD0806E515C1F88BC41AF0D3AE74D161696DA9ADC582C
          BE46A2FB0DBDCDC18BE597CA0EAE4A3A9C282A183AB161B6B435C9B55F0F7847
          4F1A54719BBFB6D9C32ADD5FC93604B708AEA25911DDC12FB32402158900150A
          403ACA2B938FC6CB15C5A58EA3691DB6A0D7AD69770C7334AB6E32811C3EC1BC
          334F683180479F938D8F82CFC57A96B251746D26D2526DD6F375DDF342AD6F2C
          92AC0EBB62724BAC45CAB052BB947273800EB28AC39FC4B0AF8165F14DBDBC92
          4034C3A8C704842332F95E6052464038E3BE3DEB2EF3C65A8D87F687DA740F2F
          FB3ED06A575FE98A7CBB43BF0385E6E3F74FFBB198FE5FF5BC8C807614570FFF
          000B1ECFFB6BEC9BF4AF27FB43FB3FC9FED31F6EF33CEF233F66D9F777F39DF9
          D9F3633F2D65E93E20F17DDF886C966B0B49DDD3568D234D459623E55E4480CB
          FBA1808A0A2B2ABB36EC90B962003D328AE4ED3C57A96AF33DAE93A4DA49776C
          84DE2DDDF34488C269A1C46CB13971BEDE5E4AA71B0E32485C7D6FC63A96B5E0
          7D7751F0F59471DA43A633B5CDC5EB4171133DAACE0A22238255254E77AFCC08
          E000C403D128AE6F4EF14B6A1E25B8D296DAD1442F22347F6D5FB5C610E3CC92
          DCA82B131036B066243C67680C76F49400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          0051451400514514005145140051451400514514005145140051451400514514
          00514514005145140051451400567EB9A4A6BDA1DEE932DCCF6F0DE44D0C9241
          B77EC6E180DCAC39191D3BF183835A159FACEA7FD91631DCF93E6EFBBB6B6DBB
          B6E3CE9922DD9C1E9BF38EF8C71D68029CFE17B6BA98CF7377772CEE962AF212
          80B9B599A6462028196663BB000C740B54E2F03D9C6D60AFAA6AB25AE9DB96C6
          D85C08D2DD0C4F0EC531AAB1C23F0ECC5C6D0430CB6E35EF17FF0062EA37367F
          6583F7515B49F6ABABAF22DE3F34CE3F7B26D6F2D479180D83B9E445C0CE6B3E
          F7E2125ACB6D6E7FB0EDAE24B44BA63A8EB4B043223B3AA34122A3F9AA7CB66C
          90B8564C8CB15500D81E1382482EFED9A8DF5EDDDC793FE9B3794B247E4B9921
          DA11153E490B38CA9C9386DCB815243E17B68BC3A7477BBBB981B86BBFB53941
          289CCE67127CAA132243B80DBB780082320F2FADF8C752D6BC0FAEEA3E1EB28E
          3B4874C676B9B8BD682E2267B559C14444704AA4A9CEF5F9811C0018F61AFDFB
          69BA7453A1932D7B6907C8CA0E24B88E33F7958630FCF19C67054E180067AF83
          6D89BE96E752D4AEEEEF12DC3DCCD226E4782469227455408A55981DA1769DA0
          9524B160F83E25BA92FA0D5F52835291CB3DEA7925D818A18DD76B46530DF678
          98E172083820122ABE89E2EBED4E1D0AEEF3468ECACF5A4516A45E79B28730B4
          DF3A040A10AC6F860C4FDCCAA92429E20D63C4763E2AB2B4D1F4EB4BE81F4CBA
          B836D2DE790D2C91BC20007CB60080F819201DE73B76824035347F0DD9E89753
          DCDBC93C935C44B1CCD2B03BD84B34ACF8006199E7909C617A00140C50BE1BB3
          4F0BD9E80B24E2DECE2823826DC3CC4684A98DFA6D2C1915B91B491C82322B1E
          4F1D7DA6E6D1344D3BFB4A0BB961B782733F920C925B4973F3065C8558D61627
          04E25380590A9AF7DF107FB3A7FECFBC874AB2D4D2592397EDBAA79169F2242F
          F24C63DCCC56E22C2941D24E7E505803617C2703ACAD7BA8DF5F5D4B2DAC8D73
          3794AFB6DE5F3A24C468ABB43EECFCBB8EF233C0C6A6A9A6C3AB5835A4CD2202
          E922491901A3911C3A38C8232ACAAD820838C10464553D1759FF00848FC38351
          B07823924F3624901F3E11223B4659482BE647B94907E52CB8FBA4F197A35F5D
          C7E2A6D2CEABA96A100B799A66D4ED12DD924478D57C9DB14625421DF7328703
          11F2BB86E00B971E10B0BBFB6493CB3BDD5DDA25BBDD6235911D7FE5BA10A02C
          C4AC44B01D608B006C1525CF86623711CFA5EA177A3BADBC76AC2C121DAD1465
          8C69B648DC285DEF8DA07DEE73818DCA28032E7D02C66F0ACBE1C45920D3DEC8
          D8AAC6D96488A6CC02D9E42F739F7CD47A9786ECF54FED7F3E49D7FB574F5D3E
          7D8C06D8C79B82B9070DFBE6E4E47038EB9D8A28030E1F0D0B6BD3241AB6A515
          91B86B93A7A346B11919CC8C7704F37064258AEFC1C95C6CF968B1F0BDB69FAF
          1D521BBBB2025C2C568C50C5119E4596565F97792CE81BE6620648000C01B945
          00736BE0F8AD66927D3757D4B4E9E6791A7920F25CCA1E69660A4491B8015A69
          71B40386E4B6062BDCFC3FD366D36E74BB6BED4AC74BBAB7104F676B32857DB1
          2C2AC5D94C808448C6036D3B06E0DB9B7759450063AF87D3FB623BF9B50BEB88
          E095E7B7B499D5A382565656653B7CC3C3C802B39501F0000176EC5145001451
          4500145145001451450014514500145145001451450014514500145145001451
          450014553B2D4A1BEBAD46DE25903D85C0B794B0182C628E5CAF3D36C8A39C72
          0FD4DCA0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0
          028A28A0028A28A0028A28A0028A28A0028A28A0028A28A002A9EA9A6C3AB583
          5A4CD2202E922491901A3911C3A38C8232ACAAD820838C1046455CA28039B8FC
          2022B8B9BD5D7B59FED1B84855EF0CB1EE1E59936E1367958C4AC0AECDBC06C0
          7F9C91F83E2B5224D3757D4B4FB8742B733C3E4BB5C9323CBB9C491B283BE595
          BE40A3E723180A0749450072FA8F81ECF50B5BEB31AA6AB6D637F1797776F0DC
          03E73794220ED23AB49BB6A203F3ED6D9F306DCDBB7353D361D56D52DE769151
          2E20B80508077452ACAA39078DC801F6CF4EB5728A00C7B5F0DD9DA58681671C
          9398F44DBF662CC32FB607806FE39F95C9E31CE3B71562F7494BCD46CAFD2E67
          B6BAB4DCA1E1DA77C4C54BC4C19586D631A648C30DBC30C9CE851401C1C3E14D
          40691E1C8E01269770BA9C97D76D6BE497B35782755886E0C8E230F1400853F2
          A0C05006DD81E0F8A371750EAFA945AA177697525F24CB28758D59594C662031
          0C23E5407F7639E5B7749450053874E58F4B36125CDDCE1D19649DE7612B96C9
          66DEB82A724E36ED0BC050A00029E9FA09B4D445FDDEAB7DA9DD244D0C2F7621
          5F291CA9700451A03B8A27DECE368C63273B1450014514500145145001451450
          0145145001451450014514500145145001451450014514500145145001451450
          014514500145145001451450073FE1EFF90E78B3FEC2B1FF00E915AD7415CFF8
          7BFE439E2CFF00B0AC7FFA456B5D050014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          145145001451450014514500145145001451450073FE1EFF0090E78B3FEC2B1F
          FE915AD7415CFF0087BFE439E2CFFB0AC7FF00A456B5D0500145145001451450
          0145145001451450014514500145145001451450014514500145145001451450
          0145145001451450014514500145145001451450014514500145145001451450
          0145145001451450014514500145145001451450014514500145145001451450
          01451450014514500145145001451450014514500145145001451450073FE1EF
          F90E78B3FEC2B1FF00E915AD7415CFF87BFE439E2CFF00B0AC7FFA456B5D0500
          1451450014514500145145001451450014514500145145001451450014514500
          65CFA94D178AB4FD2D563F22E2CAE6E1D883B8346F02A81CE31895B3C761D3BE
          A573F79FF250F46FFB055FFF00E8DB4AE82800A28A2800A28A2800A28A2800A2
          8A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A2
          8A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A2
          8A2800A28A2800A28A2800A28A2800A28A28039FF0F7FC873C59FF006158FF00
          F48AD6BA0AE7FC3DFF0021CF167FD8563FFD22B5AE82800A86EAEA1B2B39EEEE
          1F641046D248D8276AA8C9381CF4153557BEB38F50B46B6999844CCA5C29FBE0
          30254E7AAB63691DC123BD277B68356BEA62DB6B7796B65709A8DBE350492129
          0EF18C5C3ED8C16518015CB4648C92222D8F980352EF54D5ED1FC4171710C51C
          96BA6433470C1765940DD3EE60CD1E03E17A1420ED5CF1D351BC2DA5027EC96E
          B620A8CADA22C6A5C3ABA3900619919015CE472C08209AA9A96852A69BAA2412
          5E5FDEEA96DF6379669230B18C4815C8F942A8DFC8404F70A4924E2D54B7F5E6
          6A9C2FFD7917BFB6FF00E259F6DFB3FF00CBFF00D8F66FFF00A79F237671FF00
          02C7E19EF59173E27BCB9F0FEB173630DAA4F6D68F326DBA0F25B9009DB34657
          2920193B7E61946048E09D493C3904B20CDEDE2DB2DCADDA5AABA88D65120909
          FBBB9816C921891F37006170F1E1FB77F396EEE2EAF23781ED952771FBB89F1B
          903280C73B57E662CDF2F5C9396D547A09382322F3C69FD9D2DD477A9A5C3259
          FF00C7C42DA96256F943FEE90C63CCCAB0C676E5B23A0DC66D4B56D46E6DD25B
          5B78A2B11A9C36E67FB532CC76DD2C6E3604C6090C3EFF002A79F4ABC9E1F746
          908D67511E7B6EB9DA625339C05C9223054ED555F90AF0A08F9B249278720964
          19BDBC5B65B95BB4B557511ACA241213F777302D9243123E6E00C2E15AA3BDDF
          E43BD35625D565923D474454919564BD6570A70187D9E6383EA3201FA8158D61
          E2BBC9F4692FC69DBED6CE08E5B99A5B901D94C11CCDB15530CE039C83B14F18
          3C90BD2DCD9C7753D9CCECC1AD66332053C1251D39F6C39FC7159D6DE1AB2B5D
          0EF349496736F750885D9986E004290F0718CED407A75CFD2AA519DFDD7FD589
          8B85B528FF00C2656FFDA7F67DD61E5FDAFEC7E5FDB47DAB7F99E567C9DBD377
          3F7BEEFCD8CF15B9A96A30E9766D733ACAC833C4685BB13C9E8A38FBCC428EE4
          5568F4510DC978B50BC4B63334C6D159047BCB172776DDF82E4B11BB1CE31B7E
          5AD4A7153B3BB149C6EAC8A3A65CDD5EC3F6A99208EDE5556B748A4F318A9E77
          330F972411C2E40C1C33678E774FD6AE8EAB1896F2F2549351B8B59526B4D96F
          0C6AF2AC6565118058B2C69CBB64B918CF4EA2DEC2D6D269E5B6816169DB7CA1
          38576E72C474DC73CB753819270319D1F87512421B50BC92D7ED2D75F646F2FC
          B12190CA39081F01F903776C1C8E294A33D2C34E3A991E1AD4B50BE8F499BEDB
          A8DDB5C42AF78B75642286306327746E2340C77EC030CD90C4E0E323B0AAFA7D
          9C7A769B6B630B33456D0A4285CE5885000CE3BF1562AA9C5C6366C53926F433
          E6D33CDF10D96ADE763ECD693DB795B7EF79AF0B6ECE78C7938C639DDDB1CE85
          67CDA9F95E21B2D27C9CFDA6D27B9F3777DDF29E15DB8C739F3B39CF1B7BE78D
          0AB2028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A
          28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A
          28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A
          28A00E7FC3DFF21CF167FD8563FF00D22B5AE82B9FF0F7FC873C59FF006158FF
          00F48AD6BA0A00299299042E614579429D8AEDB549EC0900E07BE0FD29F45006
          4FDA3C43FF0040BD2FFF0006527FF18A3ED1E21FFA05E97FF83293FF008C56B5
          153CAFBFE5FE45732EC64FDA3C43FF0040BD2FFF0006527FF18A3ED1E21FFA05
          E97FF83293FF008C56B51472BEFF0097F90732EC64FDA3C43FF40BD2FF00F065
          27FF0018A3ED1E21FF00A05E97FF0083293FF8C56B51472BEFF97F90732EC64F
          DA3C43FF0040BD2FFF0006527FF18A3ED1E21FFA05E97FF83293FF008C56B514
          72BEFF0097F90732EC64FDA3C43FF40BD2FF00F06527FF0018A3ED1E21FF00A0
          5E97FF0083293FF8C56B51472BEFF97F90732EC64FDA3C43FF0040BD2FFF0006
          527FF18A3ED1E21FFA05E97FF83293FF008C56B51472BEFF0097F90732EC64FD
          A3C43FF40BD2FF00F06527FF0018A3ED1E21FF00A05E97FF0083293FF8C56B51
          472BEFF97F90732EC7177DA95ED978E749B8D534E2A834DBD51FD9ECF764032D
          AE599422B632147CAAC7E6C9C004D75B677B69A8DAA5D58DD43736D26764D048
          1D1B0707047079047E15957504CDE3AD26E16290C09A65EA3C814ED56696D4A8
          27A0242B103BED3E953DE787ED2E2E9EF6DA49B4FD41F1BEEECD823C98181BD4
          8292607037AB6DC9DB83CD6D054DAB49B4FBFF009AFD57DC4B7D8D5A2B0FFB56
          FB48E35E484DB76D42D237F2C773E6C7F318540FE32CCB8525993201D88278AE
          608E782549619543C7246C195D48C8208E0823BD13A5286BD3BF4FEBCB712663
          F8D3FE444F10FF00D832E7FF0045357303CDF0E3EB57D0E8BA4E893D86957134
          76966C5A2BFC05712B6123C88CA94C72C3CD3F743297EFE7822B982482789258
          65529247228657523041078208ED4490452BC4F2448EF136F8D994128D82B91E
          870CC33E848EF5D34316A953E46AEAEFF4F974EA9DAF75A89C6EEE7072EADE20
          D3E74B795F538E3BAF2E3F3753362658D9EE6087742B01E70B33925D580611FA
          90C4F7FAC41E304D02D7C4D34EAD2DBACD24D0DBBC90EF86F1D94044501B10C4
          C3703838243292A7AB8FC3BA559585EDB699A569967F6B88C7205B35F2E4E081
          E622EDDEBC9E3238246466AA687E188B4B9DAE674D3DA60A91C2967642DE1815
          0CA41442CC43133CB960790D8C0E49EA58AC3F249F2ABDB4F756FA6BD6D6D7AE
          A4F2B39FD5356F104171ACFD8DF5398691B638E506C52DA5616F1CA5AE0C855C
          64B9DC63DA02E31839356E7D6355B5BEBA964D4122476BA8AD5EE3C96D38B46B
          232AEE43E723288C990BFCA0A4A075423A7B9D174ABDBF86FEEB4CB29EF20DBE
          55C4B02B491ED391B588C8C1248C77A7C7A5E9F16A52EA51D8DB25FCABB24BA5
          8544AEBC705F1923E55E33D87A565F5BA3CA97B35B765BE9FF000F7B795BA8F9
          5F73927D42F63B196D6EE6BD6B98EFB4D6F275482D9A54492ED5376E8731953B
          5B6F01D5949CF298A1A86BBADD87832C7C409AB4D24FA9D8CB3181E187CAB673
          672DC031E1037CAD18037B37CA4E72791DCDAE8BA558DA9B5B4D32CADED8CAB3
          186181513CC0410F8031B815520F5F947A5469E1ED1639EEA74D1F4F59AED5D2
          E6416C81A6573960E719604F507AD547194137785F5BECBB5ADE5AEBD7F50E57
          DCA368FA8D8F896DAC2EF527BE4BCB39EE1F7C488B13C6F08C46140214F9ADC3
          973F2AFCDD4967882E67B7BF4FECABABD6D54C431651402789D3270D2066458F
          FE5A60F991EE2B8CBED0B5BE6089A749CC48664564590A8DCAAC41201EA012AB
          91DF03D2A4AE455D2929F2EB6D76B3F95ADDBFE1CAB1CE78A1EEDFE1D6BCD7D0
          C30DC9D32EB7C704C6541FBB6C618AA93C63F847F5AE4759B1974E59F4C9344D
          26D61D45AC5E0D3AD262D6AED15EC4B2193F74A14B89E25242364273D00AF4D9
          E08AE609209E24961954A491C8A195D48C1041E0823B551B3F0F68BA7A48965A
          3E9F6C92323BAC36C881990EE4270392A7907B1E45746171B1A31B35D6F6FB9F
          7E96F3ED75B9328DCA3E1CD165D2E7BC98D8E9FA64332C6AB61A7B9685594B93
          2E7620DCC1954FCBD235E4F41D051457155AB2AB37396E52560A28A2B3185145
          1400514514005145140051451400514514005145140051451400514514005145
          1400514514005145140051451400514514005145140051451401CFF87BFE439E
          2CFF00B0AC7FFA456B5D0573FE1EFF0090E78B3FEC2B1FFE915AD741400557BD
          7BD4841B1B7B79E5DDCACF398940F5C846E7A718FC6AC514313327ED1E22FF00
          A05E97FF0083293FF8C51F68F117FD02F4BFFC1949FF00C62AF5EEA165A74226
          BEBBB7B5899B6879E408A4F5C649EBC1FCA9D6B756F7B6E971697115C40F9DB2
          44E1D5B07070471D411516D6DCDF9116D6DCDF97F919FF0068F117FD02F4BFFC
          1949FF00C628FB4788BFE817A5FF00E0CA4FFE315AD453E57DFF0021F2BFE67F
          87F9193F68F117FD02F4BFFC1949FF00C62B95D72C2F359F1A68D06ABE1DD0EF
          5534EBD78E0B9B932C79F32D416F9A0E1867038E8C791DFD02B3F53D0B47D6FC
          AFED6D2AC6FF00C9CF97F6BB749766719C6E0719C0E9E828E57DFF0020E57DDF
          E1FE47196DA4CDA2F8F74D3A5F863C3FA7CB2E9979B96D27312C804B6BCB1580
          7233C0C1FBC791DFADFB4788BFE817A5FF00E0CA4FFE3149A7787FC3BA2DF6ED
          3348D2EC2F2589866DADA38A478C15DDF7402573B73DB38F6AD7A395F7FC8395
          FF0037E5FE464FDA3C45FF0040BD2FFF0006527FF18A3ED1E22FFA05E97FF832
          93FF008C56B51472BEFF009072BFE67F87F9193F68F117FD02F4BFFC1949FF00
          C628FB4788BFE817A5FF00E0CA4FFE3157AF750B2D3A1135F5DDBDAC4CDB43CF
          204527AE324F5E0FE550DC6B5A559C304D73A9D94115C2EE85E59D55641C1CA9
          2791C8E9EA2A5E9BCBF225E9BCBF2FF22BFDA3C45FF40BD2FF00F06527FF0018
          A3ED1E22FF00A05E97FF0083293FF8C569C52C73C293432249148A191D0E5581
          E41047514FAAE57DFF0022B95FF33FC3FC8C9FB66BB17CF368F6B2463AADADF1
          790FD03C68A7F161C67A9E0CB6BADD8DCDC25A34BF67BE6CE2D2E3F7729C0C9C
          29FBE060FCCB953838271505CDF5C47E32D32C164C5ACDA7DDCD226D1F33A496
          C14E7AF0247FCFD85695D5ADBDEDBBDBDDDBC53C0F8DD1CA81D5B072320F1D40
          345A4B666F4DC147966BE7D7FC9FE1EA4D58D3F87A28E792EF499DF4CBB918C9
          2180030CCC4E499623F2B1271B9C6D908180E053FF00B0FECDCE997F75658E44
          5BFCD84E3EEAEC7CEC41D36C6538E3230307DBF54B3E2FB4CF3E31D67B07DFC0
          EACD1B6187A854F30F51C9C66E15A74F6D3F15FD7AA2FD829FF0E57F5D1FF97D
          CD90FF006EBE95FBBF112C3683F82FA32DF6671D32EC46216271F2B923E650AE
          E738DCAA963A9D9EA3E60B69B32478F32275292479CE372300CB9C64640C8E47
          159DFF0008EFD83E6F0FDD7F667FD3AF97E65A1FFB6391B3AB1FDDB2658E5B77
          4AD53A5535F85FDEBFCD7E3AF646328CA0F964B53728AC6835E58278ECF5A893
          4EBC918247F3978262C7E558E62AA198F4D8407CAB614AE18ECD44E9CA1F1225
          3B8514515030A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800A28A2800A28A2800A28A2800A28A2800A28A28039FF0F7FC873C59FF0061
          58FF00F48AD6BA0AE7FC3DFF0021CF167FD8563FFD22B5AE82800A28A28030FC
          42B70F77A12DA4B14539BF6DAF2C66451FE8F3672A1949E33DC561DE4F776962
          7ED33451DE4F7EAFAA8370F690A2F925519651B99232628F0D9F99B2A7692C8B
          DC5159CA9DF5B98CA97336EE7096B788CD0AEA7AAA43A3334E629A1D4E5F2C38
          10EC5FB49D8D21C99CE324751FC1859BC2E1F51D4A7F32FB526B6B65DF0C325C
          4AA722EEE954BEE3BC90A8AA558E0818607031D6DEDB4B7508486F6E2CD8367C
          C81632C47A7CEAC31F8678A2C6CA3B0B45B7899D86E676773F33BB3166638C0C
          9624F000E78007150A93E6D488D16A69BD8E134ABED42E16DCAEA3143A835BBB
          5EF977D35E4C8DE53139B4D9B63224DA703182360FBD83612F91B4D9FCBD4112
          D9268CC8EBABCB35B3E43FCBF6BDBBE26C852474E231FF002D4E7BBA28549A5B
          8D50696FFD7F5F7F5387BBD46E3ECFA598AE6EA3B77B797CE633961E50BAB746
          712704A08D9CACA70DB0EEC8249A3CD4B9D6AD2CB4BD5AEA5D265B88C34D0DEB
          4DB9CC374644F34963D122C807E5C861B4906BB8A29FB277BDC3D8BBDEFD8C9D
          10B4736AB69E6CB2436B762387CD91A465530C4E4166258FCCEC7927AE3A002A
          9EA56B7CD78CFA824B7DA5F3FB8B33B368C9FF00591FDE946DC820310D903CA3
          D6BA2A2AF934B1A3A775639DF15DC7D91F459FEDB6B65B6FCFEFEE86634CDBCC
          391B97AF4EA3923E958DA59BD9B59B58F4FBEB2728B7ECB7BE41921B80F2DBCA
          C514483003C853EF37DC3DFA777454CA9DDDEE4CA8F34AF7FEB4FF0022A69B63
          FD9F642032798E6492591F6ED05DDD9DB039C0DCC70327031C9EB56E8A2B44AC
          AC8D5249591CFDE7FC943D1BFEC157FF00FA36D2BA0AC7B9B1B893C65A65FAC7
          9B5874FBB8647DC3E57792D8A8C75E446FF97B8AD8A630A28A2802A5F69763A9
          7966F2D6299E2CF95232FCF1138E51BAA9E072083C0F4AA9FD957D6BFF0020ED
          5E554E821BE4FB4A28EE436564273FDE720648C74C6B5152E29EA6B1AF522B96
          FA767AAFB9E862CFA8B8824B6D67459FC9914C721823FB6432023EEE146F208C
          E7746075193C66A59DA2AC26E3C29ABC12DAA36D364F2F9F6D91CED4604B4271
          B400A4A28E91926BA5AA37BA3D8DFCC279A265B80BB3CF8257865DBD76EF421B
          6E4E76E719E715A42A54A7A2775D9FF5FA0DBA33F8972FA6BF83D7F120B3D760
          96E934FBD5FB16A6D902DA5240948192617200954019CAF2011B829E06AD615E
          691A84B6AF6D2CD69AC5A3E0BDAEA9028F30E781BD1768008046636391D7918C
          9FB75EE89CC52DD5BC039FB2EBAC5A351D88BC4F3366493C4A5C921554202337
          7A53DBDD7D9EDF27D3D1FCD87B09BF81F37A6FF73B3F9D8ECE8AE7C78D7435B1
          37335C490B858D8DB342CD310EEA8A51101322977550F1EE424F0C6A39FC73A2
          DADBCB717116B30C112179249344BD554503249262C000739A8942507692B189
          D251451520145145001451450014514500145145001451450014514500145145
          0014514500145145001451450014514500145145001451450014514500145145
          0014514500145145001451450073FE1EFF0090E78B3FEC2B1FFE915AD7415CFF
          0087BFE439E2CFFB0AC7FF00A456B5D050014514500145145001451450014514
          50014514500145145001451450014514500577BEB78F5186C1A4C5D4D1493469
          B4FCC885031CF4E0C89F9FB1AB15CFDE7FC943D1BFEC157FFF00A36D2BA0A002
          8A28A0028A28A0028A28A0028A28A00E1FC7BE18D26EB478A64B6FB2DD36AB62
          7ED168C61903BDD46864CAF05C077C31048DC71D4D55F13E9DE22D23C05E21B7
          6D521D5F4FFECCBB1BAF018EE614F2B0A37A8225C286CEE009273BABBABEB0B3
          D4ECE4B3BFB482EED64C6F8678C488D8208CA9E0E0807F0AC7FF008413C1FF00
          F42A687FF82E87FF0089A69B4B956C6BEDA4FE2D7D7FCF7FC4769DE32D0B51B9
          FB18BD16B7E3CB0F657AA609919C65576BE327E99EDEA2B7AB3B56D0B4CD7211
          1EA368B36D5654901292206E182BA90CA180C1C1191C1C8E2B9DFEC2D53C3BFB
          DB0BB966B34E4F94B89235EA7FD1D47952824E4889617C29C176639B5052F81E
          BD9FE8F67F3B76571FEEA5DE3F8AFF0035F733B3A2B9ED3F5CBDB981A58A0B7D
          56246F2DDEC2411CA926012B243291E59507054B9607195192069D9EB1A7DFCC
          60B7BA5372ABB9ADA40639907AB46D8651C8EA3B8F515937CAF964ACFCC1D09A
          5CCB55DD6BF7F6F9D8BD451453310A28A2800AA9A9DF7F6769D2DC88FCD90612
          28B76DF3246215133DB7315193C0CE4F156EAA5FE9B6FA9A4515DAF990249BDA
          1600A4BF29003A91860090D8F5553DA94AF6D0D297273AE7DBA9912EAB796DE1
          4D4A573E6EA1A6472473B6E119628A1BCC1F2B282C85640B820160A7A1AB9FDB
          7FF12CFB6FD9FF00E5FF00EC7B37FF00D3CF91BB38FF008163F0CF7AA7A9E851
          5BE91A959E9165E5FF0068C06DBC9802470C4C55C79A578FEF00C4658855C038
          AB327872096419BDBC5B65B95BB4B557511ACA241213F777302D9243123E6E00
          C2E32F7FF03B9FD55A4DFF0035FE5657564F4D6F6F2BEA65DCF89EF2E7C3FAC5
          CD8C36A93DB5A3CC9B6E83C96E40276CD195CA48064EDF986518123824BCF1A7
          F674B751DEA6970C967FF1F10B6A5895BE50FF00BA4318F332AC319DB96C8E83
          71D71E1FB77F396EEE2EAF23781ED952771FBB89F1B903280C73B57E662CDF2F
          5C93962787DD1A42359D4479EDBAE769894CE70172488C153B5557E42BC2823E
          6C929AABDCD235303B38E9F3F2EBF27BADDE9A5D94752D5B51B9B7496D6DE28A
          C46A70DB99FED4CB31DB74B1B8D813182430FBFCA9E7D2BA7AC693C3904B20CD
          EDE2DB2DCADDA5AABA88D65120909FBBB9816C921891F37006171B35A414AF76
          71E22749C5469F77DFCAD7BF5EF6D3B051451567285145140051451400514514
          0051451400514514005145140051451400514514005145140051451401CFF87B
          FE439E2CFF00B0AC7FFA456B5D0573FE1EFF0090E78B3FEC2B1FFE915AD74140
          0514514005145140051451400514514005145140051451400514514005145140
          1CFDE7FC943D1BFEC157FF00FA36D2BA0A28A0028A28A0028A28A0028A28A002
          8A28A0028A28A0028A28A00CDD4343B2D4275BA2AF6F7E8BB23BDB66F2E65009
          21770FBCA09CEC6DC84F5535997B1DCC108875FB1835AD311B2B3A5A192643D1
          4BC015B79F578F1CBFFAB5505874B456AAAB6B966AEBFAD9F4FCBC9826E2F9A2
          ECCC2B3B459ED52F340D7A492D9F253CC9BEDB04873824B31DE7A630B20008E9
          D419FF00B56FAD7FE423A44AA9D4CD62FF0069451D815C2C84E7FBA840C839EB
          85BCF0FDA5C5D3DEDB49369FA83E37DDD9B0479303037A90524C0E06F56DB93B
          7079A83FB56FB48E35E484DB76D42D237F2C773E6C7F318540FE32CCB8525993
          2013D8465FC17F2EBFF07E566FB1B7D61BFE2A4FCFAFDFDFD6E6A59DFDAEA109
          96D2759555B6381F791BBAB03CAB0C8CA9C11DC558ACD9B4DD2B58586FBCA866
          778C186F607DB26C3C8D92A10C01C9E870413D8D47F62D52C7E6B1BEFB646381
          6D7E7181D82CAABB863B971216C0E41C9AC1F3474687C94A7F04ACFB3FF3FF00
          3491AD597AFCB243A744D148C8C6F6D149538383711823E84120FB1A6FF6E7D9
          B8D4EC2EACB1C197679B09C7DE6DE99D883AEE90271CE060E2C48B65AE69F134
          372B35B19A39925B79032B18E40C3046411B9307F1A4DA92696E5429CA94E339
          AF76EB5DD7DFB3326CB5ED42F2EEE6CECF4F59E4859D9A5B9BA11A81E7CD185F
          9509CFEEB8F94F19C9C805A9CDE3EB258DAE13EC696F1C2933C7757A22B960D1
          ACBFBB8B690E76B803E61960476C9DFD3F46B7D36EAE6E217959EE33BC39040C
          CB2CBC607F7A661F403DC9A96DE198ACA04B7B4D46FEDEDC471A4B1C6C83CED8
          8B1E4B6CDCA4A228CA15E99183CD676AB656675AA9817525CD0D34B6AD7ADF7F
          9686B5D7DA3ECEE6D3CAF3C60A8973B5B9E41239191919E719CE0E3068E97AD4
          7A8CD35B185A3B9819925087CD8832E010245F97393F75B6BE392A2AF5D5AC37
          96EF6F709BE17C6F4C9018673838EA0F420F04641C82453E28A382148618D638
          A350A88830AA0700003A0AD5A7738232A6A9B4D6BF97F9FA5BE672577AD5D5B6
          B7A8137979E5DB5EC11083EC99B6585922323BCA23F94A8791B9718C0C8C704B
          2D4B50B8BB6315EEA33DC0D46584DB359016C2159D90FEF7CB1CAC6091FBCE58
          639FBA75EE7C3A9733DF336A17896D7CD9B9B55F2FCB906C58C8C942E015500E
          181F4C568D959C76103431331569A598963CE647673F8658E3DAB2509B96AF4F
          EBFAFD0EF9E230F1A494629CB4E8BB6BD3BF6D7FBC58A28A2B73CB0A28A2800A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A28039FF000F7FC873C59FF6158FFF0048AD6BA0AE7FC3DFF21CF167FD8563
          FF00D22B5AE82800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A28039FBCFF009287A37FD82AFF00FF0046DA57415877504CDE3A
          D26E16290C09A65EA3C814ED56696D4A827A0242B103BED3E95B940051451400
          514514005145140051451400514514005145140051451400514514018D3F87A2
          8E792EF499DF4CBB918C92180030CCC4E499623F2B1271B9C6D908180E0533FB
          75F4AFDDF88961B41FC17D196FB338E99762310B138F95C91F32857739C6E515
          BAADCDA54575F8FDFF00E7715BB05675D68B677170F749E6DB5DB60B4F6B218D
          9881852E0712631C070C3A8C60906A7FC23BF60F9BC3F75FD99FF4EBE5F99687
          FED8E46CEAC7F76C996396DDD29F06BCB04F1D9EB51269D7923048FE72F04C58
          FCAB1CC554331E9B080F956C295C3152A0A6AF4FDEFCFEEFF26FCEC5C2ACA9BB
          C5D87F97AD58F293C5A9C0BFF2CE54114E475277AFC8C7B05DA83919618249FF
          00091D8C3C6A3E6E98E3AFDB97CB4CF6025C98D891CE1589EBE871AD4573F2B5
          B335F6B097F123F769FA5BF0BF9851593FF08F5A5BF3A5C92E944FDE1621151B
          EB1B294CF4F9B6EEE00CE38AD0B55B84B745BB96296719DCF1466353CF1852CC
          4718EE684DF5444E304AF195FE567FAAFC49A8A28AA330A28A2800A28A2800A2
          8A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A2
          8A28039FF0F7FC873C59FF006158FF00F48AD6BA0AE7FC3DFF0021CF167FD856
          3FFD22B5AE82800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A
          28A2800A28A2802333C2B7096ED2C627746748CB0DCCAA40620752016504F6DC
          3D6A4AE7EF3FE4A1E8DFF60ABFFF00D1B695D050014514500145145001451450
          0145145001451450014514500145145001451450014514500151CF0457304904
          F124B0CAA5248E450CAEA460820F0411DAA4A284EDAA030FFB16EF4CF9B42BCF
          2A21FF0030FBA264B723D10FDE87A051B494519C464D4F67AEC12DD269F7ABF6
          2D4DB205B4A481290324C2E4012A803395E40237053C0D5A82F2CAD351B57B5B
          EB586E6DA4C6F8678C3A360E4641E0F201FC2B7F6AA7FC557F3EBFF07E7AF9A1
          5ADB13D1587FD9BAAE97CE937BF6B807FCB96A72B363FDC9F0CEBC924EF12670
          146C15B1048D2C11C8F0BC2EEA19A29082C848FBA7692323A7048F73513828EB
          1775F8FCD7FC3AF304C928A28ACC614514500145145001451450014514500145
          1450014514500145145001451450014514500145145001451450073FE1EFF90E
          78B3FEC2B1FF00E915AD7415CFF87BFE439E2CFF00B0AC7FFA456B5D05001451
          45001451450014514500145145001451450014514500145145001451450065CF
          A6CD2F8AB4FD515A3F22DECAE6DDD493B8B48F03291C631889B3CF71D7B6A553
          9352862D66DB4B6593CFB8B79AE11801B42C6D1AB03CE7399571C763D3BDCA00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          E7FC3DFF0021CF167FD8563FFD22B5AE82B93827D5746D775F65F0DEA57D05ED
          EA5C433DACB6C14A8B68232089265604346DDBD2AE7FC243AA7FD099AE7FDFEB
          2FFE48A00E828AE7FF00E121D53FE84CD73FEFF597FF002451FF00090EA9FF00
          4266B9FF007FACBFF922803A0A2B9FFF00848754FF00A1335CFF00BFD65FFC91
          47FC243AA7FD099AE7FDFEB2FF00E48A00E828AE7FFE121D53FE84CD73FEFF00
          597FF2451FF090EA9FF4266B9FF7FACBFF00922803A0A2B9FF00F848754FFA13
          35CFFBFD65FF00C9147FC243AA7FD099AE7FDFEB2FFE48A00E828AE7FF00E121
          D53FE84CD73FEFF597FF002451FF00090EA9FF004266B9FF007FACBFF922803A
          0A2B9FFF00848754FF00A1335CFF00BFD65FFC9147FC243AA7FD099AE7FDFEB2
          FF00E48A00E828AE7FFE121D53FE84CD73FEFF00597FF2451FF090EA9FF4266B
          9FF7FACBFF00922803A0A2B9FF00F848754FFA1335CFFBFD65FF00C9147FC243
          AA7FD099AE7FDFEB2FFE48A002F3FE4A1E8DFF0060ABFF00FD1B695D057173EA
          1AD4BE2AD3F545F07EB3E45BD95CDBBA99ECB71691E06523FD2318C44D9E7B8E
          BDB53FE121D53FE84CD73FEFF597FF00245007414573FF00F090EA9FF4266B9F
          F7FACBFF009228FF00848754FF00A1335CFF00BFD65FFC91401D0515CFFF00C2
          43AA7FD099AE7FDFEB2FFE48A3FE121D53FE84CD73FEFF00597FF24500741457
          3FFF00090EA9FF004266B9FF007FACBFF9228FF848754FFA1335CFFBFD65FF00
          C91401D0515CFF00FC243AA7FD099AE7FDFEB2FF00E48A3FE121D53FE84CD73F
          EFF597FF00245007414573FF00F090EA9FF4266B9FF7FACBFF009228FF008487
          54FF00A1335CFF00BFD65FFC91401D0515CFFF00C243AA7FD099AE7FDFEB2FFE
          48A3FE121D53FE84CD73FEFF00597FF245007414573FFF00090EA9FF004266B9
          FF007FACBFF9228FF848754FFA1335CFFBFD65FF00C91401D0515CFF00FC243A
          A7FD099AE7FDFEB2FF00E48A3FE121D53FE84CD73FEFF597FF00245007414573
          FF00F090EA9FF4266B9FF7FACBFF009228FF00848754FF00A1335CFF00BFD65F
          FC91401D0515CFFF00C243AA7FD099AE7FDFEB2FFE48A3FE121D53FE84CD73FE
          FF00597FF245007414573FFF00090EA9FF004266B9FF007FACBFF9228FF84875
          4FFA1335CFFBFD65FF00C91401D0515CFF00FC243AA7FD099AE7FDFEB2FF00E4
          8A3FE121D53FE84CD73FEFF597FF00245007414573FF00F090EA9FF4266B9FF7
          FACBFF009228FF00848754FF00A1335CFF00BFD65FFC91401D05159FA66A3757
          FE6FDA746BED376636FDADE06F3339CE3CA91FA63BE3A8C679C6850014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450014514500145791D8F8CF578FC206F4EABA94F7171E1CB8BD33DFE9C2
          048AF1215911206F2512404199B1FBCC88810700E7B0F0EDE5F4DAC98A3BED67
          50D3FECEED3CBAB69DF6468A50C9E5AC7FB98B70653296E1B1B1795CFCC01D65
          1451400514514005145140051451400514514005145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          1451401C7AFC3DB57D163D1EEF5AD56F2C20B47B5B68A6F217ECE1A168372948
          949611BBA8DC587CD9209008EC28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A280383D2754BE37162D
          AA6B9ACDAEA123C6B756775A4EDB0495880F124DE4AE46E25636F39B2DB39933
          86AF6FF1674D7852F25FECD92D26B796E2286C75259EF1152179F12C1B544676
          46C0E1DB0E55790770E907858B4B0ADCEBBAADDD8C32A4A9653B42C80C6C1E3C
          B88C4ADB5954E59C93B7E62D9398E1F06DB2591D367D4B52B9D1C5BB5AC7A6BC
          88914711431ECDD1A2C8C0212A37BB7663960180061F89FC53E20D3238ACAF2D
          20D364B9F2A44BAD32E5AF24541776D148046F6E32C56E0E301B91D338A92CBC
          58DA7E93AA6A725F5DEA3A4C0F04105E6A90AD9B0B9699A1911FF771ED891BCA
          25F61233272C57688ECFC337FACEBF6D7DAB0D7238ED62C6FD4A6B5DEEC2E2DE
          78C225B9318506DDB712031DEA32401B3A8D43C37677F2DC49E64F035C796F20
          85800668D91A29B0411E62145C1E8C000E182A8001CFD8FC41FED19FFB3ECE1D
          2AF75379638E2FB16A9E7DA7CE933FCF308F72B05B7972A10F58F9F9895D8D37
          5CD52F22D4239748816FAC7508AD24860BCF310A3AC2ED207644FBA9313B76F3
          B300F22ABEA1E1F9A2D38DCB6A1AE6A7A9412ACB6D346F6CB34470C9FBB46548
          3EECB264B2E486EA4AA6D8FC37A0DDC765A935E4BA95ABDEEA715F0F3AE11AE7
          E44801123216401DA16CAA1DBB1C280BF75403635FBF6D374E8A743265AF6D20
          F91941C49711C67EF2B0C61F9E338CE0A9C30E2EDFC4579A7EA9A6492CB3DCC7
          2DDEA96CD13CC403BB56B7B78D8F5CEC590E0761C0C035DE6A7A6C3AADAA5BCE
          D22A25C41700A100EE8A55954720F1B9003ED9E9D6B1E6F0569B308C99EED5E2
          7B992270EB94926B94BADE3E5C1292C68541C8C0C306CD0047AF78BFFB1751B9
          B3FB2C1FBA8ADA4FB55D5D7916F1F9A671FBD936B796A3C8C06C1DCF222E0673
          58FAD78CB5DD3E5B3D46DB4EB19AC068979A8CF0FF00680C4BE4B45F3C722C4D
          B976B650FCBB849F3042A056E47E10115C5CDEAEBDACFF0068DC242AF78658F7
          0F2CC9B709B3CAC625605766DE03603FCE63D43C0B617FA38D3C5EDF5BB18AE6
          19AE6168FCC992E1B7CE1B72151BDC063B54608C2ED1C50049A9788AFB4AD196
          FEFEDF46D39E4B811C71EA5ABF90BB0A9237388D809783945DC382439C565E9F
          E2DD535BD7F433A6416326997569786E3FD3320BC371144EF1B088EF51925395
          DE1F2C13033D26ABA28D4AE2DEEE1BFBBD3EF2DD1E34B9B51196F2DCA9742244
          75C1288738CFCA3040241A765E11B3D356C7EC5797D149672CEEB2B4A2579126
          97CD9627322B6E5660BF37DFF947CD924900C3D3BC737D3F85CEB3169B1CF616
          1650CFA84B7179B6E326DA3B87D88916C73B245EA6305B230A306B421F175F48
          0DDC9A34716969A9B69AD39BCCCACFF6936CAE9184C142DB73B9948F9F01B0A5
          C8BC03656FA6FF0065DBEA7A945A6C96F1DBDDDA2988ADDAAC4B092EC632EA5A
          34453B193A6460926B53FE11BB3FECAFECEF327F27FB43FB4376E1BBCCFB57DA
          71D3EEEFE31D76F7CF34006ADAB5E5AEA369A6E9B6505D5F5CC52DC017372608
          D638CC6ADF32A39DD9953036E31BB91800F2F73A9EA7E26D7F45B14B6F2AC1E2
          BC376916AB35B389ADEE238242AF1206755CB6D04A87DF9608545759AAE8A352
          B8B7BB86FEEF4FBCB7478D2E6D4465BCB72A5D08911D704A21CE33F28C100906
          3B0F0DD9E9D7567731493BCD6D15CC7B9D87EF5AE25496576000F98BA67E5C28
          DC400060000CBF106B1E23B1F15595A68FA75A5F40FA65D5C1B696F3C869648D
          E10003E5B00407C0C900EF39DBB4131C9F10B4E93ED3F604FB5FFA2452D8F2D1
          FDAE693CBDB172BF27FC7CDA7CCDC7EFFF00D87C7417BA4A5E6A3657E9733DB5
          D5A6E50F0ED3BE262A5E260CAC36B18D3246186DE1864E73EDFC1BA3DB7D8FCB
          871F64BB7BA4F953E6DDF7636F9798D3116C5FE1FB3C3FDC14015FFE129BCDFF
          006CFECC83FB1BFB43FB3FCFFB59FB4799F68FB367CAF2F6EDF37BF999D9CE33
          F2D686BDACDC692DA64569A7FDB6E350BB36B1A1984410F95249B98907E51E5F
          3804E092031014D7FF00844E0FB567FB46FBFB3FED7F6DFECDFDD793E779BE76
          EDDB3CDFF5BFBCC6FC678C6DF96B52F74D86FAEB4EB895A40F61706E220A460B
          18A48B0DC74DB231E31C81F4201CBC9E3E6B3B26D4350D1E486C11EEADD9E2B8
          591DA7B6495E508B800C588240AEC55890328A0EEACBD43E225C4FA1EB91E9D2
          E8726A76FA55C5F5BC9A6EAC2F122116D0C5F310DAC3782ABB487DAC095C66BA
          8B9F0769779A7476173E7CB6AB777574C85F1BCDC09C48A4800EDC5C3E318230
          BCF0732278684B6F776FAAEADA96AD05D5BBDB3C774D1C6A2371870042918248
          C0DC72473B48CB64039BB5F12F8834E93C577BA869503DAE9B77E75D6DD499D6
          1896D207296E0C60BB637315611AEE71863962363FE129BCDFF6CFECC83FB1BF
          B43FB3FCFF00B59FB4799F68FB367CAF2F6EDF37BF999D9CE33F2D588FC2707F
          62EB7A6DD6A37D79FDB3BFED5733794B27CD0AC3F2EC45518445C7CBD7AE68FF
          00844E0FB567FB46FBFB3FED7F6DFECDFDD793E779BE76EDDB3CDFF5BFBCC6FC
          678C6DF968039FBBF14EB138F0D6B234CD9A45D4B25D451D9DDBCB75731FD8AE
          2548DA1F2D5771C29DA1D8060A067A8E93C35AFB6BF6F3CA469AE9138513E99A
          82DE40C7192BBF6A90E382415C6194827242D38BC0F671B582BEA9AAC96BA76E
          5B1B6170234B74313C3B14C6AAC708FC3B3171B410C32DBB534AD1469B717177
          35FDDEA17970891BDCDD08C3796858A2011A22E017739C67E639240000053FF8
          49FF00E247FDA5F63FF98AFF0066F97E6FFD3EFD977E71FF0003C63DB3DEB1E3
          F8889FD997B7F35B58C70C1E50DA35252F6AF248B1A25E29506DDB2DF363CCDB
          B24E72A036A4DE0DB69E619D4B524B35BD5BF8EC52445896713098B6426F60CF
          B89566651B8E002A85493C1B6D704B5DEA5A95D3C6812CDE6910B59812248363
          6CCB90F0C2732F984F96339CB6E00CBB1F883FDA33FF0067D9C3A55EEA6F2C71
          C5F62D53CFB4F9D267F9E611EE560B6F2E5421EB1F3F312BA9E14BAD4AEAF3C4
          635458E39E2D4D51618AE1A68E25FB2DBB6119954E0962C46D1CB1EBD4C8FE16
          3344AD71AEEAB3DF452896DEF5DA10F010AE9F2A08C45CAC92024A1277727E54
          DB7345D0E1D105E98EEAEEE64BDB8FB4CF2DD481D9A4F2D1091800004460ED03
          0324280A02800E7F4DF15EAFA8EA17BA6E9BA4C7752DB3CAED3DE5F089028BBB
          9842FC91139FDC02BF29E33B9B2017B9AE7886E24F8637BE24D117CB99F4A6BE
          B6F3C8531831EF048C302CA39DBC82463201CD68691E1BB3D16FEF6F2DA49DE4
          BBCF98246040CCF3CFC600FE2B871F40BDF24C90681630F8562F0E3AC93E9E96
          42C59646C33C41366095C7257B8C7B628032E3F14DE4579FD99A8699043ABB5D
          C11456D05D995258640CC651218D71B562B93B4804F938FE35CE7C5E3FB88740
          B0D7F55D13ECBA65F5A35C4222BB134F95B77B821936850A5227DA7792729955
          CB05D4B6D0A75F155B5E5D3C97496564516F6E162F32E65776C6422A85312075
          53B79172E063E6DD97E1FF000297F0A69161E23BDBEBC5834F585B4F99A158ED
          DDA030B85689158E11E441976E1B3C9018005CF0EF8D61D6F593A5B4BA34B3B5
          BBDC23693AA0BD55546456127C88509322EDE0E70DD31CC7E30BCD47488AE350
          8758BE8E4589DECED21B156B56645040B994C6DB14B1E5CBC4A17D0AB39DCD37
          489ECAE1A7BAD6F52D49F614417462554048270B122024E072C091838C65B35F
          55F0D0D59EE125D5B528EC6ED365D58A34662994AED619746740CBC111B2F723
          0C4B100DCA2ABDBDAFD9E7BB97ED13CBF69944BB257DCB1611536A0FE15F9376
          3FBCCC7BD58A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028
          A28A0028A28A0028A28A0028A28A00FFD9}
        Visible = False
      end
      object Figures_Button: TButton
        Left = 752
        Top = 360
        Width = 81
        Height = 41
        Caption = 'All types'
        TabOrder = 0
        OnClick = Figures_ButtonClick
      end
      object Conf_Button: TButton
        Left = 752
        Top = 408
        Width = 81
        Height = 49
        Caption = 'Confidence belt'
        TabOrder = 1
        WordWrap = True
        OnClick = Conf_ButtonClick
      end
      object Methods_Button: TButton
        Left = 752
        Top = 464
        Width = 81
        Height = 49
        Caption = 'Methods type 3 or 4'
        TabOrder = 2
        WordWrap = True
        OnClick = Methods_ButtonClick
      end
      object Conf_Memo: TMemo
        Left = 200
        Top = 264
        Width = 505
        Height = 120
        Lines.Strings = (
          
            'The confidence belt of the regression line RL corresponds to the' +
            ' curved lines.'
          'Ref.: http://www.waterlog.info/pdf/regtxt.pdf (page 12, 13)'
          ''
          
            'In SegReg, the curves are approximated by straight lines shown i' +
            'n red color.'
          ''
          
            'The small square shows the central point of the regression line ' +
            'given by (Xav, Yav)')
        TabOrder = 3
        Visible = False
      end
    end
    object InputTabSheet: TTabSheet
      Caption = '  Input  '
      ImageIndex = 1
      ParentShowHint = False
      ShowHint = True
      OnShow = InputTabSheetShow
      object FileNameLabel: TLabel
        Left = 24
        Top = 20
        Width = 20
        Height = 16
        Caption = 'File'
      end
      object Title1Label: TLabel
        Left = 24
        Top = 44
        Width = 32
        Height = 16
        Caption = 'Title1'
      end
      object Title2Label: TLabel
        Left = 24
        Top = 70
        Width = 32
        Height = 16
        Caption = 'Title2'
      end
      object NrOfDataLabel: TLabel
        Left = 72
        Top = 99
        Width = 62
        Height = 16
        Caption = 'Nr. of Data'
      end
      object NrOfVariablesLabel: TLabel
        Left = 256
        Top = 99
        Width = 161
        Height = 16
        Caption = 'Nr. of independent variables'
      end
      object ConfLabel: TLabel
        Left = 544
        Top = 99
        Width = 133
        Height = 16
        Caption = 'Minimum confidence %'
      end
      object InputImage: TImage
        Left = 324
        Top = 200
        Width = 157
        Height = 201
        Picture.Data = {
          0A544A504547496D61676598260000FFD8FFE000104A46494600010101006000
          600000FFE103464578696600004D4D002A000000080004510000040000000100
          00000051010003000000010001000051020001000003000000003E5103000100
          00000100000000000000000000000000400000800000FF002000002040002080
          0020FF0040000040400040800040FF0060000060400060800060FF0080000080
          400080800080FF00A00000A04000A08000A0FF00C00000C04000C08000C0FF00
          FF0000FF4000FF8000FFFF2000002000402000802000FF202000202040202080
          2020FF2040002040402040802040FF2060002060402060802060FF2080002080
          402080802080FF20A00020A04020A08020A0FF20C00020C04020C08020C0FF20
          FF0020FF4020FF8020FFFF4000004000404000804000FF402000402040402080
          4020FF4040004040404040804040FF4060004060404060804060FF4080004080
          404080804080FF40A00040A04040A08040A0FF40C00040C04040C08040C0FF40
          FF0040FF4040FF8040FFFF6000006000406000806000FF602000602040602080
          6020FF6040006040406040806040FF6060006060406060806060FF6080006080
          406080806080FF60A00060A04060A08060A0FF60C00060C04060C08060C0FF60
          FF0060FF4060FF8060FFFF8000008000408000808000FF802000802040802080
          8020FF8040008040408040808040FF8060008060408060808060FF8080008080
          408080808080FF80A00080A04080A08080A0FF80C00080C04080C08080C0FF80
          FF0080FF4080FF8080FFFFA00000A00040A00080A000FFA02000A02040A02080
          A020FFA04000A04040A04080A040FFA06000A06040A06080A060FFA08000A080
          40A08080A080FFA0A000A0A040A0A080A0A0FFA0C000A0C040A0C080A0C0FFA0
          FF00A0FF40A0FF80A0FFFFC00000C00040C00080C000FFC02000C02040C02080
          C020FFC04000C04040C04080C040FFC06000C06040C06080C060FFC08000C080
          40C08080C080FFC0A000C0A040C0A080C0A0FFC0C000C0C040C0C080C0C0FFC0
          FF00C0FF40C0FF80C0FFFFFF0000FF0040FF0080FF00FFFF2000FF2040FF2080
          FF20FFFF4000FF4040FF4080FF40FFFF6000FF6040FF6080FF60FFFF8000FF80
          40FF8080FF80FFFFA000FFA040FFA080FFA0FFFFC000FFC040FFC080FFC0FFFF
          FF00FFFF40FFFF80FFFFFFFFDB00430002010102010102020202020202020305
          03030303030604040305070607070706070708090B0908080A0807070A0D0A0A
          0B0C0C0C0C07090E0F0D0C0E0B0C0C0CFFDB004301020202030303060303060C
          0807080C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C
          0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0CFFC000110800C800950301
          2200021101031101FFC4001F0000010501010101010100000000000000000102
          030405060708090A0BFFC400B5100002010303020403050504040000017D0102
          0300041105122131410613516107227114328191A1082342B1C11552D1F02433
          627282090A161718191A25262728292A3435363738393A434445464748494A53
          5455565758595A636465666768696A737475767778797A838485868788898A92
          939495969798999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7
          C8C9CAD2D3D4D5D6D7D8D9DAE1E2E3E4E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FA
          FFC4001F0100030101010101010101010000000000000102030405060708090A
          0BFFC400B5110002010204040304070504040001027700010203110405213106
          1241510761711322328108144291A1B1C109233352F0156272D10A162434E125
          F11718191A262728292A35363738393A434445464748494A535455565758595A
          636465666768696A737475767778797A82838485868788898A92939495969798
          999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4
          D5D6D7D8D9DAE2E3E4E5E6E7E8E9EAF2F3F4F5F6F7F8F9FAFFDA000C03010002
          110311003F00FDFCA28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A2BE3BFDBFBFE0AB
          1FF0C41F188F85BFB1BE1B6A1E4786E1F118B7D7FE20FF00C23FAD6BC64B99E0
          163A3D8FD867FED0BBFDC711996105A58D4901B70F6BD5FF006E0F86BE1FF893
          E29F095EEB5A8DB6B3E06D3FFB53C46C742BF6B0D060FB32DD2B5D5EAC26D626
          685B722B4A1A4DAE10332300A324E1ED16DAFF00E4BA4BEE1C9353F66F7D3F1B
          35F7DD5BEEDCF59A2BC5EC7F6FCF877AA7C3CBBF12DA41F12AF2D74FD49349BC
          D3ADFE1A78926D72CA7787CE433696B606FA289A3C32CCF0089B20072480794F
          15FF00C1473C21A178DBC09AAC7ADE991FC2EF137847C41AFDE6A773617716A3
          0DDE9F7FA459456696CC1665B869AFE681AD1A0370D70B1C4A824CA35257972F
          F5F0B97E49DBB8417334A3ADF6F3E9A7CCFA4E8AF14D6BFE0A19F09BC3DF14A7
          F06DE6BBADC1ADD96A365A45F93E16D58D8E91777B15B4B690DEDE0B6FB359B4
          EB776E23FB44B1EF793CB19756516BC31FB7AFC2CF187C671E03D3F5FD464D72
          5D46E747B6B993C3FA943A2EA17F6EAED71656DAA3DB8B0B9BA8C472EF8219DE
          45304C0A8314814516ED6EBFF03FCD7DEBB89E8B99EDA7E376BEF49B5E8CF61A
          2BE7DBEFF82917C3CF017813C25A8F8CB5192D756F1A45AA5C695A6786347D67
          C4B2DFC5A7DC2C374D0C70582DCBF94248DDC1B75DA0C8C37471B4959BFF000F
          4AF86D1FC66D47C3ECDAE49E16B3F0359F8F21F17DAE83AA5DE8D73653ADC4A0
          8B98ED1ADC279302B23F9C7CD92430A29950A54C5A92BAF3FC149BFC232FB9F6
          1B4D4799EDFF000547E7AC92F2B9F4A515C77C16F8E7A27C7BF0BDC6B1A1D8F8
          C6C6D2D6E5AD5E3F11F84B55F0DDD338556256DF51B6B799D30E3122A1424300
          C4AB01C4785BFE0A05F0C7C503C4A1EF7C5FE1E97C27A2DC788B5083C4FE08D7
          3C3B70DA7DBFFAFB9B78AFED207BA8E2F9439B7126D32460E0C89B9CBDDBA969
          657F95AF7F4B6B7EDA845392BC75D52F9B764BD5BD12EFA1ED1457856A7FF052
          1F84DA4780B45F134BA8F8C5B49F1025C5C58187C09AF4D7135A4010CBA81B74
          B333258289623F6D7416C448844A43027DBEC2FE0D56C20BAB59E1B9B5B98D65
          86689C3C72A30CAB2B0E08208208E0834DC5ABDFA10A7176B3DC9A8A28A45051
          45140051457977C7FF008A7E23D23C65E10F01F8164D12DFC69E33FB6DF0BDD5
          EC65BEB2D134BB248CDCDF3DBA4D6E6E7FD22E34FB410A5C46E1B50598078EDE
          55333928ABB36C3D09569F247CDFA24AEDFC926F4BBEC9B3D468AF13FF008662
          F88BA67FA4D8FED1DF146EEFADFF007B6F06B3A1F862E34D9A45E552E62B6D2A
          DA79202400EB0DC4123296092C4C43AF51FB37FC5BD4BE2778735DD3FC45058D
          AF8CBC0DADDC7873C410D92325B34F1AC73DBDCC4ACCFB12EEC6E2CAF16112CA
          6017821791E48A43511A977669AFBBF466F5706A307529D48CD2DEDCDA5FABBC
          5697D2FD1B49EE8F2FFDACFF00626F1AFC7DF881E29BFF000CFC41F09F85B42F
          1FF8257C0BE23B1D5BC1726B9732D9F9978CD2DA4C2FEDE2865297B228F3A0B8
          4CAA928C3286D788BFE09D5A0F8B3E09FC63F005FEB97B71A07C5AB1B5D3F2F6
          E925C6971DBE956BA7A3333965B86CDAACA7722AB162A548C93D9FC5CFDB0BC3
          3F062EFE26C3AA58EBB70DF0A7C13178F35636B0C4E2E2C643A8858E0DD22EE9
          FF00E25B3E55F62FCF1FCFCB6DE2FC4FFF000526F0EF85BE33EABE1397C09F13
          2E34DF0F789348F0A6B3E2A834FB43A1E957DAAC36525823B1B917122C8D7F6F
          13182093CA76CCBE5C6C923690A575EC62BE3D3D6F276D7FC536979CACB739E7
          29C67ED65BAD7EE8C3A75F7792FA6AAD73CB6FBFE09049A87C0AB3F0A25BFECD
          5A3CD67E264F104FA6E8BF04C58783BC448B672DB245AB68CBAA937AF1B4CD34
          721B945492385BCB25065DA07FC11874AD27E1EFC2DD2CF8D21B2D67E105AF88
          A5F0CEADA2F8721D2CE8DAA6A7AA5AEA105EDA409218A08EDBECEF6E6D8068E7
          82E248DB6A1646DFF1DFFC1462E3C41FB40FC31D23C37A078CB45F015F78F756
          F0FEABE31BDB5D39B41D7E2D3B48D65EEEDE0613C97717957964A7CC9208164F
          B2C9E5C9221F9F03C13FF05F3F81BF10BE19F8CFC51A5B6A17569E0E874FBB30
          C5AEF87A66BFB6BEBB1696F39963D4DADEC14CAC9BD75396CE48C38DE8BC8151
          9372528FC4ECD5B7BF2F2C5A4B54ED7E5B6BA392D55CCE50F6728C5F44D6BB59
          CA49A77D1EB74EF75EF24DDDD8D48FF61FF8A9F11FE31FC588F5EF1AE8FA0FC3
          BF1A78D744D76FECE1F0EA4F7DE218EC348D155A4B3B81787EC11C977632C524
          73C370FE5C5FBB68CB095BAAF067EC0BE27F0F7C40F0FDA5FF00C47D2F52F855
          E0EF17DEF8DB44F0F2F857C9D652FAE24BA9C4573A91BA68A6B68A7BC9DD163B
          3865F9600D336C73277963FB466AFAA78BFE165A6A1E1CD6BC09378EA4D516E7
          41D72CECAFB508C5ADBBC884DD58EA32DB4190A24053ED3BD5954885B24792F8
          BBFE0B29F0FF00E1EFECF5A1FC4AF11F84BC67E16D0BC61A8A69DE178FC43A8F
          87F4497C484C324D24D0C979A9C56F0451AC5265AEE580C842F942512465D392
          8349EF0E5F3D572A8BF54E29AB7C2EEE292B897EF22D2D9AB7CB95DFCECD5EFD
          F4BDF43D13E0D7EC4FFF000A93C5FF000F755FF849BFB43FE104D07C47A2795F
          D9DE57DBBFB5F51B2BDF373E6B6CF27EC7B36E1B7F99BB29B769E23C1FFF0004
          ECF137C2EF07787344F0F78DBC0BA8D8587C2EB2F867ADDA78AFC0B2EB365AE4
          5671CEB0CFE426A300489DAE25F3ADDCCA2442103C7CB1E43F69BFF82B8699A8
          7EC83E2CF13FC1CD07C71E2BD4C7C33B8F1AA6BBA2DAE997569E0B59E1BA5B2B
          8BD59EE479C7CFB59C94B58EEC05B67665F2D919FED5D2277BAD26D6590EE792
          146638C649504D57B36A1CBD15D7FE969FFE973D7CF4D95ABDAB518C53D25AFF
          00E03C925F9C5AEBDFCFC5BF62FF00D92F5BFD97BE1AF89341D5FC6916B635CD
          41AEAC2D344B0BAD2F45F0ADBFD9E2852CF4BB4BBBDBE7B4B75F2CBAC093F911
          96C450C4A369F9FF00E067FC114D7E10CBE2B91FC57F0FA3B9F11FC3BD53E1F3
          6A1E1FF8729A36A7AA7DB7C92755D5EECDECD2EA77F98773C8C62591A4760B19
          662DF78D1532F7A4E6F76B97E5CAE36FB9B5DFE62849C2DCBD1F37CEF7BFDEAE
          7CA9FB61FF00C130F4AFDA8BC5BE03F11F91F09B57D6FC15A1CFE1E36FF11BE1
          DA78D347B9B695ADE4F363B53776AD05CABDB8DB2ACC46C9655646CAB27D41E1
          FD1E1F0F68365A7DBC1696D6F636F1DBC50DA40208225450A1638C121100180A
          0F0001DAADD155CEECD746DBF9B6DBFC5B7F3666A9C55ACB6497C92497E092F4
          41451454961451450015E77F1E3E0AEA5F11EFFC37E20F0B6B963E16F1C783EE
          66974BD4EEF4D6D42D2682E21686E6CAEE08E6B7967B59018E6F296E221F69B3
          B295B7F90118FDA97E2DEA5F05BE109D5B4682C66D5F52D6F45F0E58BDEA3496
          D673EA9AADA6991DCCB1A3234A90B5D899A1592332888A09222DE62FCF1FB4E7
          FC1502FF00F666FF0082786A1F12AFF4ED12F7C7C3C4FAA780349B4F2EE23D37
          56D5AC754BED3E4BBD8A5DE180C5A7DCDF7D9DE6C854FB38B8672B2B7262B134
          69424EB3B28AE67E88FA0C8B24CCB1D88A34F2D87354AB515282D3594B44ACF4
          B34F5BE96DF43D7FFE12DFDA3B55FF0045FF00857FF04B41FB4FEEBFB4FF00E1
          606A9AB7F676EE3CFF00B1FF00635B7DA76677793F6983CCDBB7CE8B76F5EDBE
          027C1DFF008531E0DBAB6BBD47FB77C43AEEA573AE6BDABB5BF92DA9DF5C3EE7
          214B3BAC11208ADADE392495A1B5B5B684C9208831FC2BD17FE0BD3FB51E8FF1
          1DFC412F8E342D52C9E79A71E1BBDF0D598D191640E16106158EF7CB8B70299B
          B2F98D3CC7906E0FFABDA37ED9979FB5CFECF1FB3D6BFE07D62FBC0F1FC72D7A
          4D1B54BDD3E282EF50F0E4B6BA46AF7B776F6CD796CF048F1DEE946D5A592D9D
          1E232B46AA5A3953C5C9F88F03984A5F5793728F4692766ED75D37F9A3F4CF11
          BC19E28E0FA543FB5A953852AD7F7A9C9CA2A518B938CDBBC9351BB495E2ECED
          769DBACFDAAFFE09E7A17ED5BE22D7EFEEBC73F11BC189E31F0ABF82FC4B69E1
          BBDB3860F10E9B9B868A39BED16B3BC6D135DDC957B76859BCE6590C89851D0E
          B9FB1578575FB4F174335FF88157C67E2FD0FC697A5278418AF3491A58B68E3C
          C4710B7F64DB798ADB98EF976B265766DFEC87F16F52F8FDFB277C2FF1DEB305
          8DB6AFE35F09695AF5F43648C96D14F756714F22C4AECCC10348428666200192
          4F35E895F4B46A592943D57FE04A5FFA524FD4FC6B134E74EB4A153E28B6BEEB
          47F28A5E891F39787BFE09A1E14D07E21D86A9278BFE206A5E1AD1BC45A9F8A3
          49F075DDDD91D0B4BBCD461BE8AF7604B55BA96397FB42E9B64F712AC6D27EEF
          CB5F94E9FC3DFD89B5CF853F0A26F06787FE3DFC63B0D1ADA0B4B1D08BDB786A
          E67F0C59DBE552DADA49B48733218F646CD79F6894AC6A43872CEDEF5452B7BB
          CBD2C97ADB6BF7B6B6BEC9B5B366327CD2E67BFF009BBBB76BB7776DDEACF0AF
          D9EFFE09F1E0AFD9AFC2FE00D2B41BDD7248BE1E5EEADA8591916CEDA3BA9F52
          F30DCB3DBDADBC36F0A66562915AC5046A7A27272ED6BF60CD066F837F0E3C29
          A178B3C6BE11D47E1432B786BC4DA5BD8C9ABD97FA3496B2061736B35A4AB2C1
          2C88EB25BB2F2ACA15D1197DCE8A727CCEEFCBF0DBEEEDB5B41474BF9DEFD6F7
          DEF7DDBEAF7EA7CD7F193FE09A3A4FC713AAB6ADF143E2B5A4BE2DF0947E0CF1
          949A7DC6956CDE35B28D6E046F778B1C43329BAB83BAC45A86121565640107D2
          1696CB656914284958902027A90062A4A29F33B5BE7F7FF5B6CBA09ABB4DF4FF
          0024BF24B5F24145145218514514005145140051451401E27FB7FF00FC909D07
          FECA4780FF00F52FD1EBF21BFE0B29FF0024EFE0E7FD8F9F193FF5335AFD79FD
          BFFF00E484E83FF6523C07FF00A97E8F5F90DFF0594FF9277F073FEC7CF8C9FF
          00A99AD7C7718FFB857FF02FFD2D1FD1FF0046FF00F92B72AFFB089FFEA3CCF8
          62BF503FE0869FF247FE177FD9C8EADFFAADEF6BF2FEBF503FE0869FF247FE17
          7FD9C8EADFFAADEF6BF39E02FF00919FFDBBFF00B744FECFFA5AFF00C910BFEB
          EFFEE1AC7E907FC134BFE51C7FB3FF00FD937F0EFF00E9AEDABDB2BC4FFE09A5
          FF0028E3FD9FFF00EC9BF877FF004D76D5ED95FB8E1FF851F45F91FE58E6DFEF
          D5BFC72FCD8514515B1E78514514005145140051451400514514005145140051
          451401C4FED0BF077FE17AFC2F97418F51FEC8BEB7D4B4DD734EBC6B7FB44505
          F69D7F6FA85A19A2DC86583ED16B109635923678CBAAC9131122FCF1FB5E7FC1
          2DD3F68DFF00827FDEFC2D875CB193C6B6DAF5E78DF4CD6AEE096DAC535EBBBF
          BBBEBBC431BBB456B29BFBDB7457370D04570AC7ED12C419BEBDAF00FF008296
          7FC9BAF873FECAAFC38FFD4E342AE7C46129578CA1555D4934FD19ECE51C418F
          CAEBD1C4E06A724E94D548B56D271D9FE1B6CFAA3F1D345FF820B7ED47AC7C47
          7F0FCBE07D0B4BB249E6807892F7C4B66746758C39598085A4BDF2E5DA0266D0
          3E644F31231B8A7EC3FC26FF008279E81F08FF0064CF867F0CF48F10EB7A2EA7
          F0BDC6A5A5F8A3484852F62D5A58AE63BEBF482F16EADC7DA45FDF830CA92C71
          ADDB08C2B4713A781FFCE3AFFEEEABFF007B7D7D01FF0004D3FF009375F11FFD
          955F88FF00FA9C6BB5E3E51C3381CB5CE5874EF2EADDDDBB2EDDFBF99FA27889
          E37F14F1A430F4B38A9150A376A308F2C5C9AB394936F99B5756F86CDA51D5DF
          D93E1A7C39D1BE0FFC38F0FF0084BC3967FD9DE1EF0B69B6DA469769E6BCDF65
          B5B78962863DF2333B6D4451B998B1C649279ADBA28AF7D249591F924E729C9C
          A4EEDEEC28A28A6485145781FC7BFDB7DFE06F887E2968EDE137D5B58F04783E
          CBC53A059C5A8189FC5B25D4F756B1D9A1311585FED70C1116CC98FB5C6C5470
          0C4E718272979BFB936F4EB649BF445462DEDE5E4B5692BBD96AD2D7B9EF9457
          CF5F0F3FE0A13A178FED3C21AB7F67C1A7785B58F870FF00117C41ABDCEA0027
          85E02D0AC36D247E5E6477637A0B1D9B7EC2E36B16C2FA4FC10FDA4BC2BFB456
          81AA5F785E6D6D5F469FECB7D65ADF87F50D0751B390C6B22799677F0C1708AE
          8EACAE630AE0E549C1C5D6FDDC652974BDEDAFC2DC5FE316BCEDA684296C9E97
          B6FA6E94BAF5B34EDBABEA779457CBBFB10FFC1503C17FB51FC0EF0D6A37D7B7
          A3C733F8261F16EAFA6E9DE16D5960BB09145F6DFECADD0B7F68AC13C82164B3
          7B874919236FDE3007BCF06FEDFF00F0B7C6B13797AB788746B98F57D3F4392C
          7C45E13D5F40BF86E6FD992CB7DADF5AC332433C8AD1C73B2085A45640FB8151
          A4E9CA33E4DDDEDA75F7B955BBDE5EEAEEF4DC73F76FCDA5AF7F2B2BBBFA2D5F
          96BB1ECD4578C7C40FF8281FC2AF866B70751D6B5CB9369A85F69D3A693E16D5
          B567B77B131ADECCEB696D295B581A54492E8816E8E763481C151D1FC74FDABB
          C05FB38784FC3FADF8B35A9ADF4FF15EA09A568A74ED36EF569B57BB92DE5B88
          A0B786D2296496492382428A8A4B90AABB99D54E49A71525B3B7E3B7DFD3B8ED
          AB8F557BFCB7FBADAF6EA7A2515E19AAFF00C1487E10699E00F0CF88E1D7B5FD
          66D3C5FF006C3A658E89E12D6358D61C59C862BC32E9B6B6B25EDB8B69479531
          9A1410CACB1BED760A7D73C01E3FD17E2AF81F48F12F86F53B3D6B40D7AD23BF
          D3EFED24124177048A1924461D41520D572BD7CB47E5BFF93FB99375A799AF45
          14521857807FC14B3FE4DD7C39FF006557E1C7FEA71A157BFD78FF00EDD1F077
          C55F1C7F67F4D23C151787EE3C4FA5F8AFC31E27B2B7D6F509B4FB0BBFEC9F10
          69DAAC9049710C171245E64766E81D61930CEB95C66803E60FF9C75FFDDD57FE
          F6FAFA03FE09A7FF0026EBE23FFB2ABF11FF00F538D76BCFFF00E18EFE29FF00
          C3BFFF00E111FB2FC3FF00F859BFF0B57FE166FF0067FF00C24179FD85FF0025
          03FE129FB0FF00687D83CFFF008F7FDC79BF62FF0059CF97B79AF5FF00D85FE0
          EF8ABE077ECFEFA478D62F0FDBF89F54F15F89FC4F7B6FA26A136A16169FDADE
          20D47558E08EE2682DE497CB8EF110BB431E591B0B8C5007B051451400578FFE
          D0BFB5B4BF03BE29F84BC15A47C35F881F133C4FE30D2B54D6EDECBC312E8F07
          D92CF4E9B4F86E259A4D4AFECE3FF59A9DAAAAA33B1CB9C00B9AF60AF00F88DF
          F294DF837FF64ABC79FF00A77F065005FF0084DFB67DF78F7E3EE9DF0E7C4BF0
          7FE287C31D6F5AF0FEA3E24D367F125C681736B7F6F6173A7DBDCA2B69BA9DE3
          AC8AFA9DA9024440C0B6189522A3FDA83F6278BF694F8E5F0AFC64DE259F4483
          E1F5F34FA9E9A962B3C7E25B6173697D0DB48E5D7CAF2AFAC2CE70FB5F88DD70
          3CC2C2A7C46FF94A6FC1BFFB255E3CFF00D3BF832B94F8EBFB73EBBFB397ED73
          E3DD2EF3C23E3DF1CF823C35F0FF0044F13DCC1E1AB0B094F87D5EF35A4BDBE9
          9A79E09255315A5B810426698F94C6384FCE48A4A338D4BD9C5DD3ECD6B7FBAF
          7E96BDF4B95C8E54E765756B35D5F3351B2F3BC95BAF6D6C55D07FE093FA1AFC
          2CF8FBE13D7BC5575ADD8FC6B373636920D32285FC2FA4BCD75736DA7A02CEB7
          096F757D792297550CB2AC6C984C9F46FD89BF64287F649F006B3A40D23E0B69
          573ABDD8B891FE1BFC395F04D94EA2308A67B717975E74A0EEFDE6F51B4850A3
          19393E2CFF008290F83BC1BADFC446BDF0FF008C13C1FF000B3494D63C45E323
          15947A1DAC7258C57D0C68D25CADC4D24914AA02C703056C798630F1B3F9EF87
          BFE0B69F0B7C5DFB39EBFF001274BD36EAF74EF0AEB76FA1EB368BE34F0720D3
          9EE21F36199F507D68694C8FC2044BD69839C18860E224972CA12EB149F7B5EC
          BCEF7EBBBDDF726FCEE325ADDB6BCDB577E56B6CB65B2B6C6FCDFF0004D0925F
          821E02F06C5F10752D3A4F03FC26D57E17AEA9A7D87D9EE6737B16991FF68467
          CE26168FFB373E582C4F9DC48A532DC7FC1BFF00823CD8FC37F87DF16F489754
          F869A1DC7C4DD3F4A86D23F87FF0E63F09695E1DBED3259E7B3D412D16F2769A
          75B892194B493659A05190A42ABEF7FE0ACDE17D7BC63F053C59A16A1AADE782
          3E287853C4F269FE1AB3B7B4BCD5FC47AE596A1A45ADBD95A18A478E6990CB7C
          BBA0B836A630F3B4A608FCF4F4CF13FF00C146747F09FC4BD7B41BAF875F135B
          4BF07EB9A6F87BC4BE248EDB4E6D2740BAD42DEC66B7129FB67DA254FF008984
          08ED6D0CDE510ECFB63DB23744B9E6DDDEB2E64FA7FCBC95F55A27CEEF74F4E6
          8ED748A949CA319BD52F797E1D3E4B4EB67D99E61F157FE08E9A4FC40D07E1AC
          EF3FC27F1678A3C0FA3DF697A95C7C47F86B1F8BB48D725BEB98EF2EEF92C4DE
          5BB5ADD3DDAC8E1D676012E254657F9597E8FF00885FB3CC3E37D6FE12DD5BDE
          DA68D6FF000AF5EFEDA8ACED2C02C176BFD937FA68B78D43810228BDDE31BF02
          1098F9B72F0FE15FF8287F87FC51F14B4ED14F82BE2169DE16D77C4175E14D1B
          C71796B64BA06B1AADBB4C925AC6AB74D7D1E64B6B98D259ED638647848491B7
          C464E7ED3FE0A31FD85E10F0140BE08F1EFC4FF16F8F2CB5DD46CACFC23A259D
          86E834ABD8ADE73225E6A5E541817116D2F7244A5580DB23C709C955E5826B44
          DB7E57D66FD2C9B935A593BECC4A0DCDC3ED72B8F9B4D72BD7ADECE37D5DD593
          BA238BF607F1A7C37D76C7C47F0DFE26E83A078B6DB50F15493CFAF7841F59D3
          6E6C75CD65B56683ECD15F5ACAB3DBCA2254985C6C6559374277AF97EDBFB37F
          C0FB2FD9B7E05785FC0D617B75A9DBF86EC56D4DEDCA46935F4992D24EEB1854
          567919DC850002D815E3FF00033F6FBD47F682FDA934EF0E7877C05E24BBF86B
          E21F00E91E34D2FC56EB636F1A2DF1BA7569E292F45D2A32C51C4A8B6A5D6559
          0B62328E7E97AB709423CAD5B756ED694935E5EF5DB5D5EAFA1339295594DFC4
          F56FBB9252BBEFA35E9B2B20A28A2A0614514500145145001451450015E1FF00
          B477ECE3E3EF1EFC7DF02FC46F873E3AF07F83F5BF07F87F5CF0DCF07893C217
          3E21B5BFB7D4EE749B867558351B178A48DF498C025DC3099BE504035E01F013
          C67E21BCFF0082E37C50D3EE3C55E30BBD10DA7886CA3D12E35FBD9B46B54B3D
          17E1A5C5B986C1E536B0C8B2EB1A9B19238D5D8DE49B998600FE6FB41FF8290F
          ED1F7BA1594D2FED17FB403492C08EE7FE1646B4324A824FFC7CD7EA7E167845
          9C71F62ABE0F27AB4A12A315297B594E29A6EDA72427AFAA470E3B30A7858A95
          44DDFB7FC3A3FAB1F85FFB347C53FF0086A7D07E267C4CF88DF0FF00C51FF08B
          F85359F0C69BA6F863C0979E1FFF009095E693732CF34B71AB5F6FD9FD931AAA
          2A27FAD7258E00A7FED17FB00699FB43FC44D7BC47FF000B13E26782E6F16F86
          ED7C23AF5A7872F2C62B6D5F4B825BD97ECEFF0068B499E36737D32B4D03C732
          A8511C91E5CBFF002ABFF0F17FDA33FE8E27F680FF00C393ADFF00F24D7EE3F8
          A3E2FF008DB5BF82FF00F04EFD5A5F1EFC408B50D5FE1FF8535BD5E5B6F146A1
          6DFF000905E5C78ABE1B584F2EA2239945FF00996BAB6A31B2DD0954FDB256C6
          E21875F8AFE09E77C01F55FEDAAB46A7D63DA72FB294E56E4E4E6E6E7A70D1AA
          89595EEAE9E9B997E690C4A92A3756B5FA75BAB59F46934FA349A3F41357FD8A
          7C0FAF782BE267872EE1D4A5D0FE2AC30DBEAB682E0462D122B082C2316CCAA1
          E32B15BC6C18B33071B811C01CD788BF613D43C67E13F0FDBEB5F1BFE2E6ABE2
          8F086B8DAF681E2C9ADBC389AAE8F2359CB66F12449A4AD8C91B433CE099ED64
          901958ABAE171F40515F9136DB6DBDEDF87F5F3D9E8772492514B4575F26ACD7
          A5BA1F330FF82537C39BDF01787741D5756F1AEBA3C3165ADDBD96A37DA8C475
          14B9D5354B5D564D444E90AB25EC179670CB04B1EDF2C8248638233B4EFF0082
          6F5F7897E357C40D73C59F11BC653F857C57E2AD275F6F0EE9F796A967E225D3
          F4BD2ADE27D4B366258E417760F232594D0C72A18D650EBFBA5FAAA8A71938BB
          AFF81AC94B6DB75F976562FA5BCADE7AEBBEFF00F0EFBB3C07C1FF00F04F7D0B
          C1FF001574FD713C71F112FBC2FA1EBF77E29D1BC13757764741D2353BA3334B
          731B25AADF4837DCDCC8B0CF772428D392B1AEC8847D2FC33FD8DFC31F0AFC47
          E0ED4F4FBFD7A6B8F04693ADE8D62B71344C92C3AADEDADE5C34A163525D64B4
          8C2152A02B3860C4823D668A8E55CAA3D35FC572BF5BC74BEF6B2E8877F79CFA
          FF00C1BFDD76DDBBB6FAB3C4FE0CFEC37A2FC02F127812FF00C33E2CF195A5B7
          81FC1F67E087D3E46B19ADBC416168B20B56BC2D6A6512C4D2C8E1ADA480333E
          1D5D4051ED94515729B96B2F37F7B6DFE2DB13D64E4F776FC124BF0490514515
          201451450014514500145145007C01FB3EFF00CA75FE26FF00DCDDFF00A8F7C2
          2AFE59FC2FFF0022CE9DFF005EB17FE802BFA98FD9F7FE53AFF137FEE6EFFD47
          BE1157F2CFE17FF91674EFFAF58BFF004015FDBDF422FF0091E667FF005EA1FF
          00A59F35C4BFC387AB2FD7F415A8FF00C9BAFF00C138BFEC957833FF00538F84
          D5FCFAD7F415A8FF00C9BAFF00C138BFEC957833FF00538F84D5F41F4E6FF992
          7FDCCFFEEB9970CFFCBCF97EA7EBF514515FC027D50514514005145140051451
          40051451400514514005145140051451401E5FE16FD8DBE1DF82FF006A0F107C
          64D3B47D421F885E27B492CB50BE7D72FE6B574922D3A194C764F31B4864923D
          274D47922855DC59C4198E39FE64746FF8371BF6DBD3B47B4B77F80D7A5E0852
          362BE30F0E6090A01C7FC4C2BFABEAF903F6B1FDB13E29FC28FDAD66F0F785AE
          BE1FC3E09F0D7FC2B7FED7B4D57C3F7979AAEABFF094F8B6F7429FECF771DFC3
          15AFD9E1B659537DB4FB9D883818AFD17C3AF14B3DE08C4D6C564528A9558A8C
          B9A2A5A27756BEDA9C78BC0D2C4A51ABD0FC09FF008874BF6D9FFA20B7FF00F8
          587873FF009635FD037ECD7FF04E4F0CF88FF647FD95ECFE2D7863504F885F02
          BC15A0584305BF88AEEDA3D3AFED62D26E268665B2B85B7BD8D2FF0049B29424
          DE7425ECE36507A9CFFDAC7F6C4F8A7F0A3F6B59BC3DE16BAF87F0F827C35FF0
          ADFF00B5ED355F0FDE5E6ABAAFFC253E2DBDD0A7FB3DDC77F0C56BF6786D9654
          DF6D3EE7620E062BEBFAEAF123C5EE21E39FABFF006F4A12F61CFC9CB151F8F9
          79AF6DFE056EDA8B0797D1C35FD975FD028A28AFCC0ED0A28A2800A28A2800A2
          8A2800A28A2800A28A2800A28A2800A28A2800AF803F6E6FF93C3F883FF76F9F
          FAB3F56AFBFEBE00FDB9BFE4F0FE20FF00DDBE7FEACFD5A800FDB9BFE4F0FE20
          FF00DDBE7FEACFD5ABEFFAF803F6E6FF0093C3F883FF0076F9FF00AB3F56AFBF
          E800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A
          2800AF883F6CEF81DF133C5FFB66DF5C786FE1B7883C49E18F187FC2A6DFE23B
          4D4F4982C344FF008473C6F7FAC6A5F6A8EE2F22BB38B3B889A3FB3C136F6257
          822BEDFA2803E20FDB3BE077C4CF17FED9B7D71E1BF86DE20F127863C61FF0A9
          B7F88ED353D260B0D13FE11CF1BDFEB1A97DAA3B8BC8AECE2CEE2268FECF04DB
          D895E08AFB7E8A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2803FFD9}
      end
      object FileNameEdit: TEdit
        Left = 72
        Top = 16
        Width = 617
        Height = 24
        ReadOnly = True
        TabOrder = 0
      end
      object Title1Edit: TEdit
        Left = 72
        Top = 40
        Width = 449
        Height = 24
        Hint = 'General information'
        TabOrder = 1
      end
      object Title2Edit: TEdit
        Left = 72
        Top = 64
        Width = 401
        Height = 24
        Hint = 'Details about the variables and units'
        TabOrder = 2
      end
      object InputOpenButton: TButton
        Left = 734
        Top = 483
        Width = 97
        Height = 25
        Action = InputOpenAction
        Caption = ' Open input file'
        TabOrder = 3
      end
      object InputSaveButton: TButton
        Left = 622
        Top = 483
        Width = 105
        Height = 25
        Action = InputSaveAction
        Caption = ' Save-Calculate '
        TabOrder = 4
      end
      object NrOfDataEdit: TEdit
        Left = 160
        Top = 96
        Width = 57
        Height = 24
        Hint = 'Between 6 and 900'
        TabOrder = 5
        Text = '15'
        OnExit = NrOfDataEditExit
      end
      object HelpOpenButton: TButton
        Left = 534
        Top = 483
        Width = 81
        Height = 25
        Caption = 'Symbols help'
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -11
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 6
        OnClick = HelpOpenButtonClick
      end
      object HelpMemo: TMemo
        Left = 72
        Top = 144
        Width = 345
        Height = 185
        Color = 15138559
        Lines.Strings = (
          ' '
          ' SegReg does the segmented regression with breakpoint  '
          '  of one dependent variable (Y) on one (X) or two (X,Y)'
          '  independent variables who determine the value of Y.'
          ''
          '  Example : Y = crop yield'
          '                  X = depth of the water table'
          '                  Z =  soil salinity'
          ''
          '  SegReg handles a maximum of 2000 data sets.')
        TabOrder = 7
      end
      object StringGrid1: TStringGrid
        Left = 104
        Top = 144
        Width = 220
        Height = 337
        Hint = 'Y = dependent variable, X, Z independent'
        ColCount = 3
        DefaultRowHeight = 20
        Options = [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goRangeSelect, goEditing, goTabs]
        TabOrder = 8
        OnSetEditText = StringGrid1SetEditText
      end
      object OptionComboBox: TComboBox
        Left = 480
        Top = 144
        Width = 257
        Height = 24
        Enabled = False
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 9
        Text = '      Use both independent variables       '
        Visible = False
        OnChange = OptionComboBoxChange
        Items.Strings = (
          '      Use both independent variables       '
          '      Use 1st independent variable only    '
          '      Use 2nd independent variable only   ')
      end
      object PasteMemo: TMemo
        Left = 136
        Top = 208
        Width = 241
        Height = 137
        Lines.Strings = (
          'Spreadsheet columns (e.g. in Excel) '
          'may be copied into the input table.'
          'Select and copy the columns and then '
          'paste them in the table by right clicking '
          'twice on the first cell and using "paste".'
          'It may occur that the first cell seems '
          'empty, but by clicking on another cell'
          'the value will appear.')
        TabOrder = 10
        Visible = False
      end
      object PasteButton: TButton
        Left = 454
        Top = 483
        Width = 75
        Height = 25
        Caption = 'Paste help'
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -11
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 11
        OnClick = PasteButtonClick
      end
      object ClearButton: TButton
        Left = 374
        Top = 483
        Width = 75
        Height = 25
        Caption = 'Clear data'
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -11
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 12
        OnClick = ClearButtonClick
      end
      object ConfComboBox: TComboBox
        Left = 696
        Top = 96
        Width = 41
        Height = 24
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 13
        Text = '90'
        OnChange = ConfComboBoxChange
        Items.Strings = (
          '90'
          '95'
          '98')
      end
      object NrOfVarComboBox: TComboBox
        Left = 440
        Top = 96
        Width = 37
        Height = 24
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 14
        Text = '1'
        OnChange = NrOfVarComboBoxChange
        Items.Strings = (
          '1'
          '2')
      end
      object PrefComboBox: TComboBox
        Left = 480
        Top = 194
        Width = 257
        Height = 24
        Enabled = False
        ItemHeight = 16
        TabOrder = 15
        Text = '           Preference: best of all'
        Items.Strings = (
          '           Preference: best of all'
          '    Preference for a regression type        ')
      end
      object WeightComboBox: TComboBox
        Left = 480
        Top = 144
        Width = 257
        Height = 24
        Enabled = False
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 16
        Text = '         No weight factors required    '
        Items.Strings = (
          '         No weight factors required    '
          '         Weight factors are needed    ')
      end
      object WaitMemo: TMemo
        Left = 520
        Top = 0
        Width = 137
        Height = 129
        Color = clBlue
        Font.Charset = ANSI_CHARSET
        Font.Color = clYellow
        Font.Height = -13
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 17
        Visible = False
      end
      object ExclComboBox: TComboBox
        Left = 480
        Top = 240
        Width = 257
        Height = 24
        Enabled = False
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 18
        Text = '      No exclusion of regression types'
        Items.Strings = (
          '      No exclusion of regression types'
          '       Yes, exclude a regression type')
      end
      object Exclude2Panel: TPanel
        Left = 608
        Top = 290
        Width = 137
        Height = 178
        TabOrder = 19
        Visible = False
        object Exlude2RadioGroup: TRadioGroup
          Left = 8
          Top = 12
          Width = 121
          Height = 150
          Caption = '    Z variable  '
          Font.Charset = ANSI_CHARSET
          Font.Color = clNavy
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 0
        end
        object ExclZ2RadioButton: TRadioButton
          Left = 16
          Top = 40
          Width = 105
          Height = 17
          Caption = 'Exclude type 2'
          TabOrder = 1
        end
        object ExclZ3RadioButton: TRadioButton
          Left = 16
          Top = 64
          Width = 105
          Height = 17
          Caption = 'Exclude type 3'
          TabOrder = 2
        end
        object ExclZ4RadioButton: TRadioButton
          Left = 16
          Top = 88
          Width = 105
          Height = 17
          Caption = 'Exclude type 4'
          TabOrder = 3
        end
        object ExclZ5RadioButton: TRadioButton
          Left = 16
          Top = 112
          Width = 105
          Height = 17
          Caption = 'Exclude type 5'
          TabOrder = 4
        end
        object ExclZ6RadioButton: TRadioButton
          Left = 16
          Top = 136
          Width = 105
          Height = 17
          Caption = 'Exclude type 6'
          TabOrder = 5
        end
      end
      object Exclude1Panel: TPanel
        Left = 464
        Top = 290
        Width = 137
        Height = 178
        TabOrder = 20
        Visible = False
        object Exclude1RadioGroup: TRadioGroup
          Left = 8
          Top = 12
          Width = 121
          Height = 150
          Caption = '    X variable  '
          Font.Charset = ANSI_CHARSET
          Font.Color = clNavy
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 0
        end
        object ExclX2RadioButton: TRadioButton
          Left = 16
          Top = 40
          Width = 105
          Height = 17
          Caption = 'Exclude type 2'
          TabOrder = 1
        end
        object ExclX3RadioButton: TRadioButton
          Left = 16
          Top = 64
          Width = 105
          Height = 17
          Caption = 'Exclude type 3'
          TabOrder = 2
        end
        object ExclX4RadioButton: TRadioButton
          Left = 16
          Top = 88
          Width = 105
          Height = 17
          Caption = 'Exclude type 4'
          TabOrder = 3
        end
        object ExclX5RadioButton: TRadioButton
          Left = 16
          Top = 112
          Width = 105
          Height = 17
          Caption = 'Exclude type 5'
          TabOrder = 4
        end
        object ExclX6RadioButton: TRadioButton
          Left = 16
          Top = 136
          Width = 105
          Height = 17
          Caption = 'Exclude type 6'
          TabOrder = 5
        end
      end
      object PrefXPanel: TPanel
        Left = 472
        Top = 312
        Width = 129
        Height = 157
        TabOrder = 21
        Visible = False
        object PrefXRadioGroup: TRadioGroup
          Left = 8
          Top = 4
          Width = 113
          Height = 145
          Caption = '    X variable   '
          Font.Charset = ANSI_CHARSET
          Font.Color = clBlue
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 0
        end
        object PrefX3RadioButton: TRadioButton
          Left = 16
          Top = 52
          Width = 97
          Height = 17
          Caption = 'Prefer type 3'
          TabOrder = 1
        end
        object PrefX4RadioButton: TRadioButton
          Left = 16
          Top = 74
          Width = 97
          Height = 17
          Caption = 'Prefer type 4'
          TabOrder = 2
        end
        object PrefX5RadioButton: TRadioButton
          Left = 16
          Top = 100
          Width = 97
          Height = 17
          Caption = 'Prefer type 5'
          TabOrder = 3
        end
        object PrefX2RadioButton: TRadioButton
          Left = 16
          Top = 28
          Width = 97
          Height = 17
          Caption = 'Prefer type 2'
          TabOrder = 4
        end
        object PrefX6RadioButton: TRadioButton
          Left = 16
          Top = 124
          Width = 97
          Height = 17
          Caption = 'Prefer type 6'
          TabOrder = 5
        end
      end
      object PrefZPanel: TPanel
        Left = 608
        Top = 312
        Width = 129
        Height = 157
        TabOrder = 22
        Visible = False
        object PrefZRadioGroup: TRadioGroup
          Left = 8
          Top = 4
          Width = 113
          Height = 145
          Caption = '    Z variable   '
          Font.Charset = ANSI_CHARSET
          Font.Color = clBlue
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 0
        end
        object PrefZ3RadioButton: TRadioButton
          Left = 16
          Top = 52
          Width = 97
          Height = 17
          Caption = 'Prefer type 3'
          TabOrder = 1
        end
        object PrefZ4RadioButton: TRadioButton
          Left = 16
          Top = 76
          Width = 97
          Height = 17
          Caption = 'Prefer type 4'
          TabOrder = 2
        end
        object PrefZ5RadioButton: TRadioButton
          Left = 16
          Top = 100
          Width = 97
          Height = 17
          Caption = 'Prefer type 5'
          TabOrder = 3
        end
        object PrefZ2RadioButton: TRadioButton
          Left = 16
          Top = 28
          Width = 97
          Height = 17
          Caption = 'Prefer type 2'
          TabOrder = 4
        end
        object PrefZ6RadioButton: TRadioButton
          Left = 16
          Top = 124
          Width = 97
          Height = 17
          Caption = 'Prefer type 6'
          TabOrder = 5
        end
      end
      object ExtraMemo: TMemo
        Left = 480
        Top = 288
        Width = 241
        Height = 49
        Color = clGradientInactiveCaption
        Font.Charset = ANSI_CHARSET
        Font.Color = clGray
        Font.Height = -11
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          ' The amplified SegrRegA software with enabled'
          ' weight, preference and  exclusion options can '
          ' be made freely available on request')
        ParentFont = False
        ReadOnly = True
        TabOrder = 23
      end
      object PartMemo: TMemo
        Left = 480
        Top = 352
        Width = 241
        Height = 49
        Color = clGradientInactiveCaption
        Font.Charset = ANSI_CHARSET
        Font.Color = clGray
        Font.Height = -11
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          'The PartReg program does a partial regression '
          'to find a horizontal segment (a range of no '
          'effect). Freely available on request.')
        ParentFont = False
        TabOrder = 24
      end
    end
    object OutputTabSheet: TTabSheet
      Caption = '  Output  '
      ImageIndex = 2
      OnExit = OutputTabSheetExit
      OnShow = OutputTabSheetShow
      object OutputMemo: TMemo
        Left = 8
        Top = 32
        Width = 689
        Height = 433
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -13
        Font.Name = 'Courier New'
        Font.Style = [fsBold]
        ParentFont = False
        ScrollBars = ssBoth
        TabOrder = 0
      end
      object AnovaButton: TButton
        Left = 615
        Top = 479
        Width = 89
        Height = 33
        Caption = 'Anova table'
        TabOrder = 1
        OnClick = AnovaButtonClick
      end
      object ResultButton: TButton
        Left = 718
        Top = 479
        Width = 113
        Height = 33
        Action = OutputOpenAction
        TabOrder = 2
      end
      object SymbolsButton: TButton
        Left = 502
        Top = 479
        Width = 97
        Height = 33
        Caption = 'Symbols'
        TabOrder = 3
        Visible = False
        OnClick = SymbolsButtonClick
      end
      object GraphicsButton: TButton
        Left = 390
        Top = 479
        Width = 97
        Height = 33
        Caption = 'See graph'
        TabOrder = 4
        OnClick = GraphicsButtonClick
      end
    end
    object GraphicsTabSheet: TTabSheet
      Caption = ' Graphics '
      ImageIndex = 3
      OnShow = GraphicsTabSheetShow
      object GraphImage: TImage
        Left = 10
        Top = 0
        Width = 623
        Height = 465
      end
      object PictureImage: TImage
        Left = 16
        Top = 8
        Width = 609
        Height = 465
      end
      object SeeGraphButton: TButton
        Left = 751
        Top = 489
        Width = 89
        Height = 25
        Action = GraphOpenAction
        Caption = 'Open graph'
        TabOrder = 0
      end
      object ChoicesPanel: TPanel
        Left = 160
        Top = 136
        Width = 225
        Height = 153
        TabOrder = 1
        Visible = False
        object GraphicsRadioGroup: TRadioGroup
          Left = 16
          Top = 8
          Width = 169
          Height = 129
          Caption = 'Select graph'
          TabOrder = 0
        end
        object Y_XRadioButton: TRadioButton
          Left = 24
          Top = 32
          Width = 153
          Height = 17
          Caption = 'Y-X function'
          Checked = True
          TabOrder = 1
          TabStop = True
        end
        object YXr_ZRadioButton: TRadioButton
          Left = 24
          Top = 52
          Width = 153
          Height = 17
          Caption = 'Residuals-Z function'
          TabOrder = 2
        end
        object Calc_ObsRadioButton: TRadioButton
          Left = 24
          Top = 72
          Width = 153
          Height = 17
          Caption = 'Calculated-observed'
          TabOrder = 3
        end
        object Y_ZRadioButton: TRadioButton
          Left = 24
          Top = 92
          Width = 113
          Height = 17
          Caption = 'Y-Z data plot'
          TabOrder = 4
        end
        object GoButton: TButton
          Left = 184
          Top = 63
          Width = 33
          Height = 25
          Caption = 'Go'
          Font.Charset = ANSI_CHARSET
          Font.Color = clWindowText
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 5
          OnClick = GoButtonClick
        end
        object X_ZRadioButton: TRadioButton
          Left = 24
          Top = 112
          Width = 97
          Height = 17
          Caption = 'X-Z data plot'
          TabOrder = 6
        end
      end
      object MakeGraphButton: TButton
        Left = 647
        Top = 489
        Width = 89
        Height = 25
        Caption = 'Make graph'
        TabOrder = 2
        OnClick = MakeGraphButtonClick
      end
      object SaveGraphButton: TButton
        Left = 520
        Top = 489
        Width = 112
        Height = 25
        Action = GraphSaveAction
        Caption = 'Save color graph'
        TabOrder = 3
      end
      object SelectButton: TButton
        Left = 248
        Top = 489
        Width = 95
        Height = 25
        Caption = 'Select graph'
        TabOrder = 4
        Visible = False
        OnClick = SelectButtonClick
      end
      object CalcObs_Button: TButton
        Left = 646
        Top = 352
        Width = 146
        Height = 25
        Caption = 'See calc-obs graph'
        TabOrder = 5
        Visible = False
        OnClick = CalcObs_ButtonClick
      end
      object BPButton: TButton
        Left = 128
        Top = 489
        Width = 105
        Height = 25
        Caption = 'Confidence help'
        TabOrder = 6
        OnClick = BPButtonClick
      end
      object SaveBlWhButton: TButton
        Left = 360
        Top = 489
        Width = 145
        Height = 25
        Caption = ' Save black-white graph'
        TabOrder = 7
        OnClick = SaveBlWhButtonClick
      end
      object ConfButton: TButton
        Left = 646
        Top = 400
        Width = 145
        Height = 25
        Caption = 'Remove conf. belt'
        TabOrder = 8
        OnClick = ConfButtonClick
      end
      object BlockButton: TButton
        Left = 648
        Top = 440
        Width = 145
        Height = 25
        Caption = 'Remove conf. block'
        TabOrder = 9
        OnClick = BlockButtonClick
      end
    end
  end
  object MainMenu1: TMainMenu
    Left = 16
    Top = 504
    object FileItem: TMenuItem
      Caption = '&File'
      object InputOpenMenu: TMenuItem
        Action = InputOpenAction
        ShortCut = 16457
      end
      object OutputOpenMenu: TMenuItem
        Action = OutputOpenAction
        ShortCut = 16463
      end
      object GraphOpenMenu: TMenuItem
        Action = GraphOpenAction
        Caption = 'OpenGraph'
        ShortCut = 16455
      end
      object InputSaveMenu: TMenuItem
        Action = InputSaveAction
        ShortCut = 16467
      end
      object GraphSaveMenu: TMenuItem
        Action = GraphSaveAction
        Caption = 's&Ave graph'
        ShortCut = 16449
      end
      object ProgramExit: TMenuItem
        Action = FileExit1
        Caption = 'program e&Xit'
        ShortCut = 16472
      end
    end
    object Edit: TMenuItem
      Caption = '&Edit'
      object Copy: TMenuItem
        Action = EditCopy1
      end
      object Cut: TMenuItem
        Action = EditCut1
      end
      object Paste: TMenuItem
        Action = EditPaste1
      end
    end
  end
  object ActionList1: TActionList
    Left = 56
    Top = 504
    object EditCut1: TEditCut
      Category = 'Edit'
      Caption = 'Cu&t'
      Hint = 'Cut|Cuts the selection and puts it on the Clipboard'
      ImageIndex = 0
      ShortCut = 16472
    end
    object EditCopy1: TEditCopy
      Category = 'Edit'
      Caption = '&Copy'
      Hint = 'Copy|Copies the selection and puts it on the Clipboard'
      ImageIndex = 1
      ShortCut = 16451
    end
    object EditPaste1: TEditPaste
      Category = 'Edit'
      Caption = '&Paste'
      Hint = 'Paste|Inserts Clipboard contents'
      ImageIndex = 2
      ShortCut = 16470
    end
    object EditDelete1: TEditDelete
      Category = 'Edit'
      Caption = '&Delete'
      Hint = 'Delete|Erases the selection'
      ImageIndex = 5
      ShortCut = 46
    end
    object FileExit1: TFileExit
      Category = 'File'
      Caption = 'E&xit'
      Hint = 'Exit|Quits the application'
      ImageIndex = 43
    end
    object InputSaveAction: TAction
      Caption = 'Save input'
      OnExecute = InputSaveActionExecute
    end
    object InputOpenAction: TAction
      Caption = 'Open input'
      OnExecute = InputOpenActionExecute
    end
    object OutputOpenAction: TAction
      Caption = 'Open output'
      OnExecute = OutputOpenActionExecute
    end
    object GraphOpenAction: TAction
      Caption = 'OpenGraphAction'
      OnExecute = GraphOpenActionExecute
    end
    object GraphSaveAction: TAction
      Caption = 'SaveGraphAction'
      OnExecute = GraphSaveActionExecute
    end
    object OutputReadAction: TAction
      Caption = 'OutputReadAction'
      OnExecute = OutputReadActionExecute
    end
  end
  object InputOpenDialog: TOpenDialog
    DefaultExt = 'inp'
    Filter = 'Input files (*.inp)|*.inp'
    Left = 224
    Top = 456
  end
  object InputSaveDialog: TSaveDialog
    DefaultExt = 'inp'
    Filter = 'Input files (*.inp)|*.inp'
    Left = 16
    Top = 456
  end
  object OutputOpenDialog: TOpenDialog
    DefaultExt = '.out'
    Filter = 'Output files (*.out)|*.out'
    Left = 136
    Top = 456
  end
  object GraphOpenDialog: TOpenDialog
    DefaultExt = 'bmp'
    Filter = 'Graph files (*.bmp)|*.bmp'
    Left = 100
    Top = 459
  end
  object GraphSaveDialog: TSaveDialog
    DefaultExt = 'bmp'
    Filter = 'Image files (*.bmp)|*.bmp'
    Left = 60
    Top = 459
  end
  object OutputReadDialog: TOpenDialog
    DefaultExt = 'out'
    Filter = 'Output files (*.out)|*.out'
    Left = 180
    Top = 459
  end
end
